{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit frmCommentsForm;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmComments = class(TForm)
    panBottom: TPanel;
    Image1: TImage;
    btnOK: TButton;
    btnCancel: TButton;
    panTop: TPanel;
    lblTitle: TLabel;
    Image2: TImage;
    meComments: TMemo;
    procedure meCommentsKeyPress(aSender: TObject; var aKey: Char);
  private
    function GetComments: string;

  public
    constructor Create(const aComments: string; const anObjectDescription: string = ''); reintroduce;

    property Comments: string read GetComments; 
  end;

implementation

{$R *.lfm}

constructor TfrmComments.Create(const aComments: string; const anObjectDescription: string = '');
begin
    inherited Create( Application.MainForm );

    if anObjectDescription <> '' then
    begin
        lblTitle.Caption := 'Comments for ' + anObjectDescription;
    end
    else
        lblTitle.Caption := 'Comments';
        
    meComments.Lines.Text := aComments;
end;

function TfrmComments.GetComments: string;
begin
    result := meComments.Lines.Text;
end;

procedure TfrmComments.meCommentsKeyPress(aSender: TObject; var aKey: Char);
begin
    // Escape is consumed by the memo otherwise...
    if aKey = #27 then
        modalResult := mrCancel;
end;

end.
