{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit frmInsertFramesForm;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, unit_Scene;

type
  TfrmInsertFrames = class(TForm)
    panTop: TPanel;
    lblTitle: TLabel;
    Image2: TImage;
    panBottom: TPanel;
    Image3: TImage;
    OKButton: TButton;
    txtNumberOfFrames: TEdit;
    lblNumberOfFrames: TLabel;
    procedure txtNumberOfFramesKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  private
    fScene: TScene;
  public
    constructor Create(AScene: TScene); reintroduce;
  end;

implementation

uses unit_Animation, unit_Skeleton, unit_AnimationFrame;

{$R *.lfm}

procedure TfrmInsertFrames.txtNumberOfFramesKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in ['0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

constructor TfrmInsertFrames.Create(AScene: TScene);
begin
    inherited Create(nil);
    fScene := AScene;
end;

procedure TfrmInsertFrames.FormShow(Sender: TObject);
begin
    txtNumberOfFrames.SetFocus;
end;

procedure TfrmInsertFrames.OKButtonClick(Sender: TObject);
var selectedAnimation: TAnimation;
    skeleton: TSkeleton;
    animationFrame: TAnimationFrame;
    i, index, numberOfFrames: integer;
begin
    if fScene.SelectedAnimations.Count=0 then begin
        MessageDlg('Please select an animation.',mtError,[mbOK],0);
        ModalResult := mrOK;
    end else begin
        selectedAnimation := fScene.SelectedAnimations[0];

        skeleton := TSkeleton(selectedAnimation.Skeleton);
        index := selectedAnimation.SelectedFrameIndex;
        numberOfFrames := StrToInt(txtNumberOfFrames.Text);

        for i := 0 to numberOfFrames-1 do begin
            animationFrame := TAnimationFrame.Create;
            animationFrame.Assign(skeleton.BaseFrame);
            animationFrame.Animation := selectedAnimation;
            selectedAnimation.AnimationFrames.AddAnimationFrame(animationFrame, index);
        end;

        //selectedAnimation.SelectedFrame := selectedAnimation.AnimationFrames[index];
        selectedAnimation.HasChanged := TRUE;
        fScene.JointGeometryUpdater.Execute(nil);
        ModalResult := mrOK;
    end;
end;

end.
 
