{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }

// NOTE JCC: the main form currently serves as a kind of controller. It contains
// a lot of methods to update the state of the program and its objects. This should
// be improved some day. For example: use some sort of MainController class.

unit frmMainForm;

{$MODE DELPHI}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, StdCtrls, ExtCtrls,
  ValEdit, ActnList, Math, IniFiles, Grids, FileUtil, StrUtils, dglOpenGL,
  ShellAPI, frmOGLForm, frmOGLContextForm, frmDockableForm,
  frmViewPortForm, frmFlatViewPortForm, frmOptionsForm, frmAboutForm,
  frmDeleteFramesForm, frmInsertFramesForm, frmHotKeysForm, frmHintsForm, frmRM,
  frmInspectorForm, frmCreateEditForm, frmSceneInspectorForm,
  frmMaterialsForm, frmSkeletonAnimationEditorForm, frmMaterialEditorForm,
  frmVisibilityForm, frmPluginsForm, frmRaytracingForm, frmScriptingMain,
  fraMaterial, fraCreatePropertiesDefault, fraCommandPropertiesDefault,
  unit_Options, unit_Versioninfo,
  unit_Enums, unit_Messages, unit_Scene, unit_Variables,
  unit_Functions, unit_Types,
  unit_Primitives, unit_Lights, unit_ParamList, unit_Materials,
  unit_RecentFiles, unit_Constants,
  unit_ViewPortManager, unit_Lightmapper, unit_PluginVars, unit_PluginManager,
  unit_RaytracingThread, unit_PrimitiveClipBoard,
  unit_SkeletonClipBoard, unit_AnimationFrameClipBoard, unit_Paths;

type
  TfraCreatePropDefaultClass = class of TfraCreatePropDefault;
  TfraCommandPropDefaultClass = class of TfraCommandPropDefault;

  { TfrmMain }

  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileExit: TMenuItem;
    ctlBar_Toolbars: TControlBar;
    tlbMisc: TToolBar;
    tbCut: TToolButton;
    tbCopy: TToolButton;
    tbPaste: TToolButton;
    FileNew: TMenuItem;
    FileOpen: TMenuItem;
    FileSave: TMenuItem;
    FileSaveAs: TMenuItem;
    N1: TMenuItem;
    ExportPrefab: TMenuItem;
    N2: TMenuItem;
    Edit1: TMenuItem;
    PluginsItem: TMenuItem;
    ViewItem: TMenuItem;
    InfoItem: TMenuItem;
    tbNew: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    tbOptions: TToolButton;
    tbSeperator1: TToolButton;
    tbSeperator3: TToolButton;
    AboutItem: TMenuItem;
    ActionList1: TActionList;
    actOpen: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    mnuUndo: TMenuItem;
    mnuCut: TMenuItem;
    mnuCopy: TMenuItem;
    mnuPaste: TMenuItem;
    mnuSelectAll: TMenuItem;
    mnuDeselectAll: TMenuItem;
    mnuDeleteSelection: TMenuItem;
    TileItem: TMenuItem;
    CascadeItem: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    BarsItem: TMenuItem;
    OptionsItem: TMenuItem;
    N8: TMenuItem;
    WireframeItem: TMenuItem;
    TexturedItem: TMenuItem;
    MiscTBar: TMenuItem;
    actCopy: TAction;
    actPaste: TAction;
    actCut: TAction;
    actSelectall: TAction;
    actDeselectall: TAction;
    actToggleSnap: TAction;
    imgStandard: TImageList;
    imgCommands_disabled: TImageList;
    imgCommands_normal: TImageList;
    imgCommands_hot: TImageList;
    imgZoom_normal: TImageList;
    imgZoom_hot: TImageList;
    imgZoom_disabled: TImageList;
    tlbZoom: TToolBar;
    tbZoomAll: TToolButton;
    tbZoomOut: TToolButton;
    tbZoomIn: TToolButton;
    tbCameraReset: TToolButton;
    actSave: TAction;
    mnuClone: TMenuItem;
    tbSaveAs: TToolButton;
    actSaveAs: TAction;
    actNew: TAction;
    ZoomTBar: TMenuItem;
    actExportPrefab: TAction;
    GroupSubmenu: TMenuItem;
    GroupObjects: TMenuItem;
    UngroupObjects: TMenuItem;
    actOpenOptions: TAction;
    actToggleCulling: TAction;
    actZoomAll: TAction;
    actToggleGrid: TAction;
    RegroupObjects: TMenuItem;
    actResetCameras: TAction;
    actOpenMaterialEditor: TAction;
    mnuDeleteSubmenu: TMenuItem;
    mnuDeleteSystemPolygons: TMenuItem;
    actOpenReplaceMaterial: TAction;
    tbTextureManager: TToolButton;
    tbMaterialReplace: TToolButton;
    N4: TMenuItem;
    HintsItem: TMenuItem;
    N10: TMenuItem;
    actToggleLockView: TAction;
    actClone: TAction;
    actObjectsDelete: TAction;
    actPolygonDelete: TAction;
    actPolygonDeleteSystemPolygons: TAction;
    N9: TMenuItem;
    MaterialPickerItem: TMenuItem;
    actToggleMaterialPicker: TAction;
    actObjectsGroup: TAction;
    actObjectsUngroup: TAction;
    SolidItem: TMenuItem;
    actToggleAABB: TAction;
    actDeleteItems: TAction;
    mnuLockViews: TMenuItem;
    HelpItem: TMenuItem;
    mnuDeleteNonSelection: TMenuItem;
    actDeleteNonSelected: TAction;
    FileMerge: TMenuItem;
    actToggleMouse: TAction;
    tlbXYZUV: TToolBar;
    tbX: TToolButton;
    tbY: TToolButton;
    tbZ: TToolButton;
    N7: TMenuItem;
    RecentFile1: TMenuItem;
    RecentFile2: TMenuItem;
    RecentFile3: TMenuItem;
    RecentFile4: TMenuItem;
    RecentFile5: TMenuItem;
    N11: TMenuItem;
    XYZUVTBar: TMenuItem;
    StatusbarItem: TMenuItem;
    actToggleStatusbar: TAction;
    ObjectInspectorItem: TMenuItem;
    actToggleObjectInspector: TAction;
    tbFullscreen: TToolButton;
    PluginInformationItem: TMenuItem;
    N3: TMenuItem;
    tbUndo: TToolButton;
    tbSeperator2: TToolButton;
    actUndo: TAction;
    N12: TMenuItem;
    mnuLightmapSubmenu: TMenuItem;
    mnuLightmapSelection: TMenuItem;
    mnuLightmapScene: TMenuItem;
    LightMappedItem: TMenuItem;
    N13: TMenuItem;
    SupportItem: TMenuItem;
    WikiItem: TMenuItem;
    actToggleLights: TAction;
    mnuVisibilityToolItem: TMenuItem;
    N14: TMenuItem;
    GetDeleDPROitem: TMenuItem;
    actToggleGrid3DView: TAction;
    mnuTest: TMenuItem;
    N15: TMenuItem;
    actToggleSkyBox: TAction;
    actToggleFog: TAction;
    actToggleSelection: TAction;
    actConnect: TAction;
    actObjectsMerge: TAction;
    mnuRemoveLightmaps: TMenuItem;
    actFill: TAction;
    actHide: TAction;
    actUnhide: TAction;
    actPolygonMerge: TAction;
    actMerge: TAction;
    N16: TMenuItem;
    mnuChangeViewPort: TMenuItem;
    mnuPerspectiveView: TMenuItem;
    mnuTopView: TMenuItem;
    mnuFrontView: TMenuItem;
    mnuSideView: TMenuItem;
    mnuAddViewPort: TMenuItem;
    mnuAddPerspective: TMenuItem;
    mnuAddTop: TMenuItem;
    mnuAddFront: TMenuItem;
    mnuAddSide: TMenuItem;
    mnuRemoveViewPort: TMenuItem;
    mnuReverseSelection: TMenuItem;
    actSelectionReverse: TAction;
    mnuAddUV: TMenuItem;
    mnuUVView: TMenuItem;
    N17: TMenuItem;
    tlbViews: TToolBar;
    tbPerspectiveView: TToolButton;
    tbTopView: TToolButton;
    tbFrontView: TToolButton;
    tbSideView: TToolButton;
    tbUVEditor: TToolButton;
    actSetDrawModeWireFrame: TAction;
    actSetDrawModeSolid: TAction;
    actSetDrawModeTextured: TAction;
    actSetDrawModeLightmapped: TAction;
    actEdgeTurn: TAction;
    tbHideSelection: TToolButton;
    tbShowHiddenObjects: TToolButton;
    tbSeperator4: TToolButton;
    pcLeft: TPageControl;
    pcRight: TPageControl;
    CreateEditWindowItem: TMenuItem;
    SceneInspectorItem: TMenuItem;
    actToggleCreateEdit: TAction;
    actToggleSceneInspector: TAction;
    panBottom: TPanel;
    stbMain: TStatusBar;
    panDockBottom: TPanel;
    actToggleObjectInspectorViaMainMenu: TAction;
    actObjectsOptimize: TAction;
    actChangeToTopView: TAction;
    actChangeToFrontView: TAction;
    actChangeToSideView: TAction;
    actChangeToPerspectiveView: TAction;
    actChangeToUVView: TAction;
    N18: TMenuItem;
    N19: TMenuItem;
    DownloadMoreItem: TMenuItem;
    mnuRedo: TMenuItem;
    tbRedo: TToolButton;
    actRedo: TAction;
    actPolygonFlatten: TAction;
    mnuSelectEdgeLoop: TMenuItem;
    mnuSelectEdgeRing: TMenuItem;
    RaytracingItem: TMenuItem;
    actToggleRaytracing: TAction;
    Selection1: TMenuItem;
    N20: TMenuItem;
    mnuGrowSelection: TMenuItem;
    mnuShrinkSelection: TMenuItem;
    actSelectionGrow: TAction;
    actSelectionShrink: TAction;
    N21: TMenuItem;
    actSelectionEdgeLoop: TAction;
    actSelectionEdgeRing: TAction;
    actSnapScene: TAction;
    actSnapSelection: TAction;
    actToggleGizmo: TAction;
    actAverage: TAction;
    HotkeysItem: TMenuItem;
    ToolButton1: TToolButton;
    tbU: TToolButton;
    tbV: TToolButton;
    SkeletonAnimationEditorItem: TMenuItem;
    actToggleAnimationEditor: TAction;
    actJointsDelete: TAction;
    actAnimationsDelete: TAction;
    actSkeletonsDelete: TAction;
    mnuAnimation: TMenuItem;
    mnuSetKeyFrame: TMenuItem;
    mnuCopyKeyFrame: TMenuItem;
    mnuPasteKeyFrame: TMenuItem;
    mnuResetKeyFrame: TMenuItem;
    mnuPasteKeyFrameBefore: TMenuItem;
    mnuPasteKeyFrameAfter: TMenuItem;
    mnuCutKeyFrame: TMenuItem;
    N22: TMenuItem;
    mnuSelectPolygonsByMaterial: TMenuItem;
    N24: TMenuItem;
    mnuDeleteFrames: TMenuItem;
    mnuInsertframes: TMenuItem;
    N25: TMenuItem;
    actJointFlip: TAction;
    actJointSplit: TAction;
    ToolsItem: TMenuItem;
    ScriptingIDEItem: TMenuItem;
    N23: TMenuItem;
    OrthographicDistanceShadingItem: TMenuItem;
    procedure FileExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tbCutClick(Sender: TObject);
    procedure tbCopyClick(Sender: TObject);
    procedure tbPasteClick(Sender: TObject);
    procedure tbUndoClick(Sender: TObject);
    procedure tbExitClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FileNewClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure tbNewClick(Sender: TObject);
    procedure tbOpenClick(Sender: TObject);
    procedure tbSaveClick(Sender: TObject);
    procedure TileItemClick(Sender: TObject);
    procedure CascadeItemClick(Sender: TObject);
    procedure mnuCopyClick(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure actPasteExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actCutExecute(Sender: TObject);
    procedure mnuPasteClick(Sender: TObject);
    procedure mnuCutClick(Sender: TObject);
    procedure mnuSelectAllClick(Sender: TObject);
    procedure actSelectallExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure mnuDeselectAllClick(Sender: TObject);
    procedure actDeselectallExecute(Sender: TObject);
    procedure mnuDeleteSelectionClick(Sender: TObject);
    procedure actToggleSnapExecute(Sender: TObject);
    procedure WireframeItemClick(Sender: TObject);
    procedure TexturedItemClick(Sender: TObject);
    procedure tbZoomOutClick(Sender: TObject);
    procedure tbZoomInClick(Sender: TObject);
    procedure tbCameraResetClick(Sender: TObject);
    procedure OptionsItemClick(Sender: TObject);
    procedure tbOptionsClick(Sender: TObject);
    procedure tbSaveAsClick(Sender: TObject);
    procedure actSaveAsExecute(Sender: TObject);
    procedure FileSaveAsClick(Sender: TObject);
    procedure FileSaveClick(Sender: TObject);
    procedure actNewExecute(Sender: TObject);
    procedure actExportPrefabExecute(Sender: TObject);
    procedure GroupObjectsClick(Sender: TObject);
    procedure UngroupObjectsClick(Sender: TObject);
    procedure EnablebackfacecullingItemClick(Sender: TObject);
    procedure ctlBar_ToolbarsGetSiteInfo(Sender: TObject; DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
    procedure MiscTBarClick(Sender: TObject);
    procedure ZoomTBarClick(Sender: TObject);
    procedure actOpenOptionsExecute(Sender: TObject);
    procedure mnuUndoClick(Sender: TObject);
    procedure tbZoomAllClick(Sender: TObject);
    procedure actToggleCullingExecute(Sender: TObject);
    procedure actZoomAllExecute(Sender: TObject);
    procedure actToggleGridExecute(Sender: TObject);
    procedure stbMainDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure ActionToggleUVExecute(Sender: TObject);
    procedure mnuCloneClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure actResetCamerasExecute(Sender: TObject);
    procedure actOpenMaterialEditorExecute(Sender: TObject);
    procedure RegroupObjectsClick(Sender: TObject);
    procedure mnuDeleteSystemPolygonsClick(Sender: TObject);
    procedure actOpenReplaceMaterialExecute(Sender: TObject);
    procedure tbTextureManagerClick(Sender: TObject);
    procedure tbMaterialReplaceClick(Sender: TObject);
    procedure HintsItemClick(Sender: TObject);
    procedure OnIdleHandler(Sender: TObject; var Done: Boolean); //AppEventsActivate(Sender: TObject);
    procedure actToggleLockViewExecute(Sender: TObject);
    procedure actCloneExecute(Sender: TObject);
    procedure actObjectsDeleteExecute(Sender: TObject);
    procedure actPolygonDeleteSystemPolygonsExecute(Sender: TObject);
    procedure actPolygonDeleteExecute(Sender: TObject);
    procedure MaterialPickerItemClick(Sender: TObject);
    procedure actToggleMaterialPickerExecute(Sender: TObject);
    procedure actObjectsGroupExecute(Sender: TObject);
    procedure actObjectsUngroupExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SolidItemClick(Sender: TObject);
    procedure actToggleAABBExecute(Sender: TObject);
    procedure actDeleteItemsExecute(Sender: TObject);
    procedure mnuLockViewsClick(Sender: TObject);
    procedure HelpItemClick(Sender: TObject);
    procedure actDeleteNonSelectedExecute(Sender: TObject);
    procedure mnuDeleteNonSelectionClick(Sender: TObject);
    procedure FileMergeClick(Sender: TObject);
    procedure actToggleMouseExecute(Sender: TObject);
    procedure tbXClick(Sender: TObject);
    procedure tbYClick(Sender: TObject);
    procedure tbZClick(Sender: TObject);
    procedure tbUClick(Sender: TObject);
    procedure tbVClick(Sender: TObject);
    procedure RecentFile1Click(Sender: TObject);
    procedure RecentFile2Click(Sender: TObject);
    procedure RecentFile3Click(Sender: TObject);
    procedure RecentFile4Click(Sender: TObject);
    procedure RecentFile5Click(Sender: TObject);
    procedure XYZUVTBarClick(Sender: TObject);
    procedure StatusbarItemClick(Sender: TObject);
    procedure actToggleStatusbarExecute(Sender: TObject);
    procedure ObjectInspectorItemClick(Sender: TObject);
    procedure actToggleObjectInspectorExecute(Sender: TObject);
    procedure tbFullscreenClick(Sender: TObject);
    procedure PluginInformationItemClick(Sender: TObject);
    procedure actUndoExecute(Sender: TObject);
    procedure mnuLightmapSelectionClick(Sender: TObject);
    procedure mnuLightmapSceneClick(Sender: TObject);
    procedure LightMappedItemClick(Sender: TObject);
    procedure SupportItemClick(Sender: TObject);
    procedure WikiItemClick(Sender: TObject);
    procedure actToggleLightsExecute(Sender: TObject);
    procedure mnuVisibilityToolItemClick(Sender: TObject);
    procedure GetDeleDPROitemClick(Sender: TObject);
    procedure actToggleGrid3DViewExecute(Sender: TObject);
    procedure actToggleSkyBoxExecute(Sender: TObject);
    procedure actToggleFogExecute(Sender: TObject);
    procedure actToggleSelectionExecute(Sender: TObject);
    procedure mnuTestClick(Sender: TObject);
    procedure actConnectExecute(Sender: TObject);
    procedure actObjectsMergeExecute(Sender: TObject);
    procedure mnuRemoveLightmapsClick(Sender: TObject);
    procedure actFillExecute(Sender: TObject);
    procedure actHideExecute(Sender: TObject);
    procedure actUnhideExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actPolygonMergeExecute(Sender: TObject);
    procedure actMergeExecute(Sender: TObject);
    procedure mnuPerspectiveViewClick(Sender: TObject);
    procedure mnuTopViewClick(Sender: TObject);
    procedure mnuFrontViewClick(Sender: TObject);
    procedure mnuSideViewClick(Sender: TObject);
    procedure mnuAddPerspectiveClick(Sender: TObject);
    procedure mnuAddTopClick(Sender: TObject);
    procedure mnuAddFrontClick(Sender: TObject);
    procedure mnuAddSideClick(Sender: TObject);
    procedure mnuRemoveViewPortClick(Sender: TObject);
    procedure mnuReverseSelectionClick(Sender: TObject);
    procedure actSelectionReverseExecute(Sender: TObject);
    procedure mnuAddUVClick(Sender: TObject);
    procedure mnuUVViewClick(Sender: TObject);
    procedure actSetDrawModeWireFrameExecute(Sender: TObject);
    procedure actSetDrawModeSolidExecute(Sender: TObject);
    procedure actSetDrawModeTexturedExecute(Sender: TObject);
    procedure actSetDrawModeLightmappedExecute(Sender: TObject);
    procedure actEdgeTurnExecute(Sender: TObject);
    procedure tbHideSelectionClick(Sender: TObject);
    procedure tbShowHiddenObjectsClick(Sender: TObject);
    procedure stbMainDblClick(Sender: TObject);
    procedure pcLeftGetSiteInfo(Sender: TObject; DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
    procedure pcLeftDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
    procedure CreateEditWindowItemClick(Sender: TObject);
    procedure SceneInspectorItemClick(Sender: TObject);
    procedure actToggleSceneInspectorExecute(Sender: TObject);
    procedure actToggleCreateEditExecute(Sender: TObject);
    procedure panDockBottomGetSiteInfo(Sender: TObject; DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
    procedure panDockBottomDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
    procedure panDockBottomUnDock(Sender: TObject; Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
    procedure pcLeftResize(Sender: TObject);
    procedure actToggleObjectInspectorViaMainMenuExecute(Sender: TObject);
    procedure actObjectsOptimizeExecute(Sender: TObject);
    procedure actChangeToTopViewExecute(Sender: TObject);
    procedure actChangeToFrontViewExecute(Sender: TObject);
    procedure actChangeToSideViewExecute(Sender: TObject);
    procedure actChangeToPerspectiveViewExecute(Sender: TObject);
    procedure actChangeToUVViewExecute(Sender: TObject);
    procedure ExportPrefabClick(Sender: TObject);
    procedure DownloadMoreItemClick(Sender: TObject);
    procedure mnuRedoClick(Sender: TObject);
    procedure actRedoExecute(Sender: TObject);
    procedure tbRedoClick(Sender: TObject);
    procedure actPolygonFlattenExecute(Sender: TObject);
    procedure mnuSelectEdgeLoopClick(Sender: TObject);
    procedure mnuSelectEdgeRingClick(Sender: TObject);
    procedure actToggleRaytracingExecute(Sender: TObject);
    procedure RaytracingItemClick(Sender: TObject);
    procedure actSelectionGrowExecute(Sender: TObject);
    procedure mnuGrowSelectionClick(Sender: TObject);
    procedure actSelectionShrinkExecute(Sender: TObject);
    procedure mnuShrinkSelectionClick(Sender: TObject);
    procedure mnuSelectPolygonsByMaterialClick(Sender: TObject);
    procedure actSelectionEdgeLoopExecute(Sender: TObject);
    procedure actSelectionEdgeRingExecute(Sender: TObject);
    procedure actSnapSceneExecute(Sender: TObject);
    procedure actSnapSelectionExecute(Sender: TObject);
    procedure actToggleGizmoExecute(Sender: TObject);
    procedure actAverageExecute(Sender: TObject);
    procedure HotkeysItemClick(Sender: TObject);
    procedure SkeletonAnimationEditorItemClick(Sender: TObject);
    procedure actToggleAnimationEditorExecute(Sender: TObject);
    procedure actJointsDeleteExecute(Sender: TObject);
    procedure actAnimationsDeleteExecute(Sender: TObject);
    procedure actSkeletonsDeleteExecute(Sender: TObject);
    procedure mnuSetKeyFrameClick(Sender: TObject);
    procedure mnuCopyKeyFrameClick(Sender: TObject);
    procedure mnuPasteKeyFrameBeforeClick(Sender: TObject);
    procedure mnuPasteKeyFrameAfterClick(Sender: TObject);
    procedure mnuResetKeyFrameClick(Sender: TObject);
    procedure mnuCutKeyFrameClick(Sender: TObject);
    procedure mnuDeleteFramesClick(Sender: TObject);
    procedure mnuInsertframesClick(Sender: TObject);
    procedure actJointFlipExecute(Sender: TObject);
    procedure actJointSplitExecute(Sender: TObject);
    procedure ScriptingIDEItemClick(Sender: TObject);
    procedure OrthographicDistanceShadingItemClick(Sender: TObject);
  private
    InitialShowToolWin: boolean;
    frmOGLContext: TfrmOGLContext;
    frmCreateEdit: TfrmCreateEdit;
    frmSceneInspector: TfrmSceneInspector;
    frmMaterialPicker: TfrmMaterials;
    frmSkeletonAnimationEditor: TfrmSkeletonAnimationEditor;
    frmObjectInspector: TfrmInspector;
    frmRaytracing: TfrmRaytracing;
    fScene: TScene;
    fPrimitiveClipBoard: TPrimitiveClipBoard;
    fSkeletonClipBoard: TSkeletonClipBoard;
    fAnimationFrameClipBoard: TAnimationFrameClipBoard;
    fParamList: TParamList;
    fViewPortManager: TViewPortManager;
    fRaytracingThread: TRaytracingThread;
    fHasDisplayedLoadingMaterialsMessage: boolean;
    fPluginManager: TPluginManager;
    fRecentFiles: TRecentFiles;
    fRenderOptions: TRenderOptions;
    fCameraOptions: TCameraOptions;
    fControlOptions: TControlOptions;
    fAnimationOptions: TAnimationOptions;
    fCSGOptions: TCSGOptions;
    fScriptingIDE: TfrmScriptMain;
    //procedure Test1;
    procedure Test2;
//    procedure BreakScene;
    procedure UpdateCaption;
    procedure UpdateEditContext;
    procedure UpdateViewToolbar;
    procedure UpdateStatusText;
    procedure UpdateMenuBasedOnEditMode;
    procedure ChangeEditModeForSelection;
    // primitive event handlers
    procedure OnSelectPrimitiveHandler(Sender: TObject);
    // scene inspector form event handlers
    procedure OnHideSceneInspectorHandler(Sender: TObject);
    // create/edit form event handlers
    procedure OnSelectEditModeHandler(Sender: TObject);
    procedure OnSelectEditCommandHandler(Sender: TObject);
    procedure OnSelectDefaultPrimitiveHandler(Sender: TObject);
    procedure OnHideCreateEditHandler(Sender: TObject);
    // scene change event handler
    procedure OnSceneCollectionChangeHandler(Sender: TObject);
    procedure OnSceneSelectionChangeHandler(Sender: TObject);
    // scene inspector form event handlers
    procedure OnSelectSceneItemHandler(Sender: TObject);
    // animation editor form event handlers
    procedure OnSelectFrameHandler(Sender: TObject);
    // joint selector event handlers
    procedure OnSelectJointHandler(Sender: TObject);
    // material form event handlers
    procedure OnSelectMaterialHandler(Sender: TObject);
    procedure OnOpenMaterialHandler(Sender: TObject);
    procedure OnHideMaterialHandler(Sender: TObject);
    procedure OnShowMaterialHandler(Sender: TObject);
    // animation editor event handlers
    procedure OnHideAnimationEditorHandler(Sender: TObject);
    procedure OnShowAnimationEditorHandler(Sender: TObject);
    // object inspector form event handlers
    procedure OnHideObjectInspectorHandler(Sender: TObject);
    // raytracing form event handlers
    procedure OnHideRaytracingHandler(Sender: TObject);
    // undo event handlers
    procedure OnUndoRedoChangeHandler(Sender: TObject);
    // plugin event handlers
    procedure OnBeforeExecuteHandler(Sender: TObject);
    procedure OnAfterExecuteHandler(Sender: TObject);
    // load prefab event handler
    procedure OnLoadPrefabHandler(Sender: TObject);
    // docking functions
    function GetComponent(AParent: TComponent; AControlName: string): TComponent;
    function ControlExists(AParent: TComponent; AControl: string): boolean;
    procedure DockForm(AForm: TForm; ADockSite: string);
    procedure DockForms;
    // various stuff
    procedure RepaintForms(AImmediatePaint: boolean = false);         // could be renamed to UpdateGUI
    procedure ReadINI;              // should be part of an Options/Settings class
    procedure WriteINI;
    procedure LoadDefaultMaterialList;
    procedure SetDefaultMaterials;
    procedure ResetScene;
    procedure UpdateRecentFileMenu;
    function GenerateBackupFileName(AFileName: string): string;
    function SaveFile: integer;
    procedure OpenFile(AFileName: string; AShouldMerge: boolean);
    procedure SetDimension(AnEditDimension: TEditDimension);
    procedure SetUVDimension(const anEditUVDimension: TEditUVDimension);
    procedure SetDrawMode(ADrawMode: TDrawMode; ADoAllPerspectiveViews: boolean = false);
    procedure SetAction(AnEditTool: TEditTool; ASetting: integer = -1);
    procedure SetEditMode(AnEditContext: TEditContext; AEditMode: TEditMode; AUpdateGUI: boolean = true);
    procedure SetPrimitive(AObjectType: TObjectType);
    procedure AddView(AView: TViewMode);
    procedure RemoveActiveView;
    procedure ChangeActiveView(AView: TViewMode);
    property Scene: TScene read fScene write fScene;
    
    property PluginManager: TPluginManager read fPluginManager write fPluginManager;
    property RecentFiles: TRecentFiles read fRecentFiles write fRecentFiles;
    property AnimationOptions: TAnimationOptions read fAnimationOptions write fAnimationOptions;
    property CSGOptions: TCSGOptions read fCSGOptions write fCSGOptions;
  protected

    procedure WndProc(var msg: TMessage); override;
    function HandleCreateException: boolean; override;
  public
    property ViewPortManager: TViewPortManager read fViewPortManager write fViewPortManager;
    property CameraOptions: TCameraOptions read fCameraOptions write fCameraOptions; //
    property ControlOptions: TControlOptions read fControlOptions write fControlOptions;//
    property RenderOptions: TRenderOptions read fRenderOptions write fRenderOptions; //   
    function IsShortCut(var aMessage: TWMKey): boolean; //!!! override;
  end;

var frmMain: TfrmMain;

implementation

uses
     frm3dView,
     frmSplashScreenForm,
     frmUVEditorForm,
     unit_HtmlHelp,
     unit_Math,
     unit_Skeleton,
     unit_Joint,
     unit_Animation,
     unit_DMLReader,
     unit_XMLSceneReader,
     unit_XMLSceneWriter,
     unit_DMFSceneReader,
     unit_DMFSceneWriter,
     unit_AnimationFrame;

{$R *.lfm}
{$IFNDEF DELED_TEST}
{$R '..\Resources\hints.res' '..\Resources\hints.rc'}
{$R '..\Resources\lights.res' '..\Resources\lights.rc'}
{$R '..\Resources\gizmo.res' '..\Resources\gizmo.rc'}
{$R '..\Resources\animation.res' '..\Resources\animation.rc'}
{$R '..\Resources\luts.res' '..\Resources\luts.rc'}
{$R '..\Resources\images.res' '..\Resources\images.rc'}
{$R '..\Resources\raytracer.res' '..\Resources\raytracer.rc'}
{$ENDIF}

// ### PLUGIN CALLBACK FUNCTION ################################################

// function:    CallbackProc
// purpose:     called by plugins, used to send data from plugin to DeleD and vice versa
// needs:       data structure
// returns:     cardinal containing error information
// note:        uses methods from the PluginManager to get/set data
function CallbackProc(var ACallBackRecord: TCallBackRecord): Cardinal; stdcall;
begin
    Result := PE_NOERROR;
    try
        case ACallBackRecord.RequestID of

            PR_GETMEM:      // plugin asks how much memory is needed to get specific data
                begin
                    Result := frmMain.PluginManager.GetMem(ACallBackRecord)
                end;

            PR_GETDATA:     // plugin asks to fill a memoryblock with specific data
                begin
                    Result := frmMain.PluginManager.GetData(ACallBackRecord)
                end;

            PR_SETDATA:     // plugin sends specific data to DeleD; read and fill objects (primitives/lights/etc)
                begin
                    Result := frmMain.PluginManager.SetData(ACallBackRecord)
                end;

            else
                begin
                    Result := PE_UNKNOWNREQUEST;
                    raise Exception.Create('Unknown request in callback structure.');
                end;
        end;

    except
        on E: Exception do MessageDlg('CallBackProc: '+E.Message,mtError,[mbOK],0);
    end;
end;

// ### FORM FUNCTIONS ##########################################################

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    // NOTE JCC: all keystrokes should be shortcuts really. Let's make additional
    // Actions and provide each on with their respective shortcut. See actConnect
    // for an example. In a distant future, we could make the shortcuts editable too.
    case Chr(Key) of
        '1':    SetEditMode(editContext, emVertex);
        '2':    SetEditMode(editContext, emEdge);
        '3':    SetEditMode(editContext, emPolygon);
        '4':    SetEditMode(editContext, emFace);
        '5':    SetEditMode(editContext, emObject);
        '6':    SetEditMode(editContext, emSkeleton);
        'N':    frmCreateEdit.EditTool := etNoiseTool;
        'M':    frmCreateEdit.EditTool := etMove;
        'S':    if (ssShift in Shift) or not ControlOptions.UseWSAD then
                    frmCreateEdit.EditTool := etScale;
        'R':    if (editMode in [emObject,emFace,emVertex]) and (editContext in [ecScene,ecUV]) then
                    frmCreateEdit.EditTool := etRotate;
        'E':    if (editMode in [emPolygon,emEdge]) and (editContext in [ecScene]) then
                    frmCreateEdit.EditTool := etExtrude;
        'U':    SetUVDimension(edU);
        'V':    SetUVDimension(edV);
        'F':    begin
                    fParamList.Add(integer(mmPlanar),'mapMethod',true);
                    fParamList.Add(true,'fitToFace');
                    Scene.ToolExecuter.Execute(ptFaceMapper,taModification,fParamList);
                end;
        'X':    SetDimension(edX);
        'Y':    SetDimension(edY);
        'Z':    SetDimension(edZ);
    end;

    if Key=VK_ESCAPE then begin                                                 // escape=deselect

        userSelect := false;

        case editMode of
            emVertex:
                begin
                    if Scene.SelectedVertices.Count>0 then
                        Scene.VertexSelector.DeselectAll
                    else
                        Scene.PrimitiveSelector.DeselectAll;
                end;
            emEdge:
                begin
                    if Scene.SelectedEdges.Count>0 then
                        Scene.EdgeSelector.DeselectAll
                    else
                        Scene.PrimitiveSelector.DeselectAll;
                end;
            emPolygon, emFace:
                begin
                    if Scene.SelectedPolygons.Count>0 then
                        Scene.PolygonSelector.DeselectAll
                    else
                        Scene.PrimitiveSelector.DeselectAll;
                end;
            emObject:
                begin
                    Scene.PrimitiveSelector.DeselectAll;
                end;
            emSkeleton:
                begin
                    // deselect all joints from selected skeletons;
                    // then deselect all selected skeletons; this will
                    // deselect all selected animations too
                    //
                    // this differs from, e.g, deselecting stuff while
                    // in vertex mode; then, we first deselect vertices
                    // and on a second ESC we deselect primitives;
                    // the same should apply to joints and skeletons...
                    Scene.JointSelector.DeselectAll;
                    // if SelectedJoints.Count>0 then clear joints
                    // else if SelectedAnimations.Count>0 then clear animations
                    // else if SelectedSkeletons.Count>0 then clear skeletons
                end;
        end;

        if (editContext=ecBackground) or ((Scene.SelectedPrimitives.Count=0) and (editMode in [emVertex,emEdge,emPolygon,emFace])) then
            SetEditMode(ecScene,emObject);

        // default select the Object editMode if no objects are selected anymore
        //if ((Scene.SelectedPrimitives.Count=0) and (editMode in [emVertex,emEdge,emPolygon,emFace])) then
        //    SetEditMode(ecScene,emObject);
    end;

    if Key=VK_DELETE then begin
    end;

//    if ( GetAsyncKeyState( VK_SHIFT )) then
//        ShowMessage('Whahoeee, this click was shifted!');


//    if ssShift in KeyboardStateToShiftState then
//        ShowMessage('Whahoeee, this click was shifted!');

    if Key=VK_SUBTRACT then begin
        if (ssCtrl in Shift) then
            ViewPortManager.ZoomCamera(-zoomSpeed)
        else begin
            gridSize := gridSize*2;
            if gridSize>4096 then gridSize := 4096;
            stbMain.Panels[0].Text := 'GRIDSIZE: '+IntToStr(gridSize);
        end;
    end;

    if Key=VK_ADD then begin
        if (ssCtrl in Shift) then
            ViewPortManager.ZoomCamera(zoomSpeed)
        else begin
            gridSize := gridSize div 2;
            if gridSize<1 then gridSize := 1;
            stbMain.Panels[0].Text := 'GRIDSIZE: '+IntToStr(gridSize);
        end;
    end;

    if Key=VK_SPACE then begin
        if (editMode in [emObject,emSkeleton]) then
            actClone.Execute;
    end;

    RepaintForms;
end;

procedure TfrmMain.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    // TODO: might want to call RepaintForms only here?
    // Originally from AppEvents: Form_OnKeyUp won't catch F1,F2 etc keys
    // No, F1,F2 etc are cought OK in FormKeyUp. What's up?
    if Key in [VK_F1..VK_F12] then begin
        stbMain.Invalidate;
        stbMain.Update;
    end;
    // Originally from AppEventsShortCut.
    //!!!if Key=VK_DELETE then begin
    //!!!    Handled := frmObjectInspector.Active;
    //    SendMessage(frmObjectInspector.Handle,VK_DELETE,0,0);
    // somehow, the Object Inspector must receive the Del key and use it to delete characters in a valuelisteditor on the OI form
end;

procedure TfrmMain.WndProc(var msg: TMessage);
var fileCount,fileNameLength,index: Integer;
    fileName: String;
begin
    if msg.Msg = WM_PROPERTIES then begin                                       // hide/unhide object inspector
        actToggleObjectInspector.Execute;
    end else

    if msg.Msg = WM_DROPFILES then begin
        fileCount := dragQueryFile(msg.wParam, $FFFFFFFF, nil, 0);
        for index := 0 to fileCount - 1 do begin
            fileNameLength := dragQueryFile(msg.wParam, index, nil, 0 );
            setLength(fileName, fileNameLength);
            dragQueryFile(msg.wParam, index, pChar(fileName), fileNameLength+1);
            if SaveFile<>mrCancel then
                OpenFile(filename, false);
        end;
        dragFinish(msg.wParam);
    end else

    if msg.Msg = WM_PAINT then begin
        RepaintForms(TRUE);
    end else

    if ( msg.Msg = WM_MDIACTIVATE ) and not (csDestroying in ComponentState) then begin
        UpdateEditContext;
        UpdateViewToolbar;
        UpdateStatusText;
    end else

    if ( msg.Msg = WM_MDIDESTROY ) and not (csDestroying in ComponentState) then begin
        UpdateViewToolbar;
    end else

    if msg.Msg = WM_SETMATERIAL then begin
        frmMaterialPicker.SelectedMaterial := TMaterial(msg.WParam);
    end else

    if (msg.Msg = WM_SETACTION) or (msg.Msg=WM_USER+105) then begin             // action set
        if Assigned(frmCreateEdit) then
            frmCreateEdit.EditTool := TEditTool(msg.WParam);
    end else

    if (msg.Msg = WM_SETMODE) then begin                                        // mode set
        SetEditMode(TEditContext(msg.WParam),TEditMode(msg.LParam));
    end else

    if (msg.Msg = WM_CHANGEVIEW) then begin                                     // change view
        ChangeActiveView(TViewMode(msg.WParam));
    end else

    if (msg.Msg = WM_REMOVEVIEW) then begin                                     // remove view
        RemoveActiveView;
    end else

    if msg.Msg = WM_USER+103 then begin                                         // update scene GUI
        frmSceneInspector.UpdateGUI;
    end else

    if msg.Msg = WM_USER+106 then begin                                         // update object inspector
        frmObjectInspector.UpdateGUI;
    end else

    if msg.Msg = WM_USER+110 then begin                                         // materials hidden
        actToggleMaterialPicker.Execute;
    end else

        inherited WndProc(msg);
end;

function TfrmMain.HandleCreateException: boolean;
begin
    // INFO, PJ: If something goes wrong during mainform construction, we want to
    //           display the error and !stop!. As nothing will be properly initialized,
    //           continuing the program initalisation is an AV disaster.
    Application.HandleException(self);

    Halt(0);

    Result := TRUE;
end;

procedure TfrmMain.FileExitClick(Sender: TObject);
begin
    Close;
end;

procedure TfrmMain.RecentFile1Click(Sender: TObject);
begin
    if SaveFile<>mrCancel then
        OpenFile(Recentfiles.Strings[0], false);
end;

procedure TfrmMain.RecentFile2Click(Sender: TObject);
begin
    if SaveFile<>mrCancel then
       OpenFile(Recentfiles.Strings[1], false);
end;

procedure TfrmMain.RecentFile3Click(Sender: TObject);
begin
    if SaveFile<>mrCancel then
        OpenFile(Recentfiles.Strings[2], false);
end;

procedure TfrmMain.RecentFile4Click(Sender: TObject);
begin
    if SaveFile<>mrCancel then
        OpenFile(Recentfiles.Strings[3], false);
end;

procedure TfrmMain.RecentFile5Click(Sender: TObject);
begin
    if SaveFile<>mrCancel then
        OpenFile(Recentfiles.Strings[4], false);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
    // create OpenGL rendering context form, in order to share textures with other
    // forms in the application that might need them (e.g 3D forms, Prefab form)
    frmOGLContext := TfrmOGLContext.Create(self);
    // create main objects
    fScene := TScene.Create;
    Scene.OnCollectionChange := OnSceneCollectionChangeHandler;
    Scene.OnSelectionChange := OnSceneSelectionChangeHandler;
    Scene.OnLoadPrefab := OnLoadPrefabHandler;
    //Scene.OnAddPrimitive := OnAddPrimitiveHandler;
    Scene.JointSelector.OnSelect := OnSelectJointHandler;       // we might want to move handlers such as this one to the TScene class
    Scene.PrimitiveSelector.OnSelect := OnSelectPrimitiveHandler;

    fViewPortManager := TViewPortManager.Create( self );

    // create Options objects
    fRenderOptions := TRenderOptions.Create;
    fAnimationOptions := TAnimationOptions.Create;
    fCSGOptions := TCSGOptions.Create;
    fCameraOptions := TCameraOptions.Create;
    fControlOptions := TControlOptions.Create;

    fRecentFiles := TRecentFiles.Create;

    fPrimitiveClipBoard := TPrimitiveClipBoard.Create(Scene.Primitives,Scene.SelectedPrimitives);
    fSkeletonClipBoard := TSkeletonClipBoard.Create(Scene.Skeletons,Scene.SelectedSkeletons);

    fAnimationFrameClipBoard := TAnimationFrameClipBoard.Create;

    fParamList := TParamList.Create(false);

    // read initial values
    ReadINI;

    // setup gizmo; we do this here so we can provide the OpenGL context
    Scene.SetupGizmo(frmOGLContext);

    // create plugin manager and set its event handlers
    fPluginManager := TPluginManager.Create(Scene, _versionnumber, @CallbackProc, dir_plugin);
    with PluginManager do begin
        OnBeforeExecute := OnBeforeExecuteHandler;
        OnAfterExecute := OnAfterExecuteHandler;
    end;

    Scene.UndoRedoManagerEx.OnChange := OnUndoRedoChangeHandler;

    // set opendialog and savedialog properties
    OpenDialog1.InitialDir := dir_scenes;
    OpenDialog1.Filter := 'All Supported File Formats|*.dxs;*.dmf|DeleD XML Scenes (*.dxs)|*.dxs|DeleD Map Files (*.dmf)|*.dmf';
    SaveDialog1.InitialDir := dir_scenes;
    SaveDialog1.Filter := 'DeleD XML Scenes (*.dxs)|*.dxs|DeleD Map Files (*.dmf)|*.dmf';

    // set other properties
    FileMerge.ShortCut := ShortCut(Ord('O'), [ssCtrl, ssShift]);                // not available in the design time shortcut list, ugh.
    mnuGrowSelection.ShortCut := ShortCut(Ord('G'), [ssAlt]);
    mnuShrinkSelection.ShortCut := ShortCut(Ord('H'), [ssAlt]);
    mnuSelectEdgeLoop.ShortCut := ShortCut(Ord('L'), [ssAlt]);
    mnuSelectEdgeRing.ShortCut := ShortCut(Ord('R'), [ssAlt]);

    actChangeToTopView.ShortCut := ShortCut(Ord('T'), [ssShift]);
    actChangeToFrontView.ShortCut := ShortCut(Ord('F'), [ssShift]);
    actChangeToSideView.ShortCut := ShortCut(Ord('S'), [ssShift]);
    actChangeToPerspectiveView.ShortCut := ShortCut(Ord('P'), [ssShift]);
    actChangeToUVView.ShortCut := ShortCut(Ord('U'), [ssShift]);

    actConnect.ShortCut := ShortCut(Ord('C'),[]);

    dragAcceptFiles(handle, true);
    toggleLockViews := false;
    editDimension := edAll;
    editUVDimension := edBoth;
    stbMain.Panels[0].Text := 'GRIDSIZE: '+IntToStr(gridSize);
    stbMain.Visible := togglestatusbar;
    mnuClone.ShortCut := ShortCut(32, []); //!!! TextToShortCut('Space');
    StatusbarItem.Checked := togglestatusbar;
    UpdateRecentFileMenu;

    RayTracingItem.Visible := true;

    // material preview LUT loading
    materialPreviewLUT := LoadLUTFromResource(MATERIAL_PREVIEW_LUT_NAMES[materialPreviewLUTIndex]);

    // Raytracing thread.
    fRaytracingThread := TRaytracingThread.Create;
    fScriptingIDE := nil;

    // setup path up vector variables
    defaultPathUpVectorLength := 50;
    defaultShowPathUpVector := True;

    // Some things are delayed for OnIdle.
    InitialShowToolWin := true;
    Application.OnIdle:=OnIdleHandler;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
    FreeAndNil(fScriptingIDE);
    FreeAndNil(frmCreateEdit);
    FreeAndNil(frmMaterialPicker);
    FreeAndNil(frmSkeletonAnimationEditor);
    FreeAndNil(frmSceneInspector);
    FreeAndNil(frmObjectInspector);
    FreeAndNil(frmRaytracing);
    if Assigned(frmOGLContext) then frmOGLContext.Release;
    FreeAndNil(fViewPortManager);
    FreeAndNil(fPluginManager);
    FreeAndNil(fRecentFiles);
    FreeAndNil(fRenderOptions);
    FreeAndNil(fAnimationOptions);
    FreeAndNil(fCSGOptions);
    FreeAndNil(fCameraOptions);
    FreeAndNil(fControlOptions);
    FreeAndNil(fParamList);
    FreeAndNil(fPrimitiveClipBoard);
    FreeAndNil(fSkeletonClipBoard);
    FreeAndNil(fAnimationFrameClipBoard);
    FreeAndNil(fraytracingThread);

    FreeAndNil(fScene);
end;

procedure TfrmMain.FormShow(Sender: TObject);
var pluginMenu: TMenuItem;
    frmHints: TfrmHints;
    hints: THints;
begin
    ViewPortManager.OGLContext := frmOGLContext;    // viewport manager knows the OGL context form, so it can pass it to 3D forms
    ViewPortManager.CreateViewPorts(IniFileName, Scene, RenderOptions, CameraOptions, ControlOptions);

    // plugin menu
    pluginMenu := MainMenu1.Items.Find('Plugins');
    if pluginMenu = Nil then
      pluginMenu := MainMenu1.Items.Find('&Plugins');
    if Assigned(PluginManager) and PluginManager.LoadDLLFiles then
        PluginManager.UpdateMenu(pluginMenu)
    else
        pluginMenu.Enabled := false;

    // set materialmanager properties
    with Scene.MaterialManager do begin
        Textures.OGLContext := frmOGLContext;                                   // textures are uploaded to the specified form's rendering context
        Lightmaps.OGLContext := frmOGLContext;
        Textures.AutoUpload := true;                                            // all textures are automatically uploaded to the shared OGL context form
        Lightmaps.AutoUpload := true;                                           // all lightmaps too
        TextureDirectory := dir_texture;
    end;

    // create Create/Edit form
    frmCreateEdit := TfrmCreateEdit.Create(nil,Scene,frmOGLContext,CSGOptions);
    with frmCreateEdit do begin
        Height := heightCreateEdit;
        Width := widthCreateEdit;
        Top := topCreateEdit;
        Left := leftCreateEdit;

        OnSelectEditMode := OnSelectEditModeHandler;
        OnSelectEditCommand := OnSelectEditCommandHandler;
        OnSelectDefaultPrimitive := OnSelectDefaultPrimitiveHandler;
        OnHide := OnHideCreateEditHandler;
    end;

    // load material picker form - order is important, do this _after_ ResetScene
    frmMaterialPicker := TfrmMaterials.Create(nil,Scene.MaterialManager,Scene);
    with frmMaterialPicker do begin
        Caption := 'Materials';
        Height := heightMaterialPicker;
        Width := widthMaterialPicker;
        Left := leftMaterialPicker;
        Top := topMaterialPicker;
        Align := alNone;
        OnSelect := OnSelectMaterialHandler;
        OnOpen := OnOpenMaterialHandler;
        OnHide := OnHideMaterialHandler;
        OnShow := OnShowMaterialHandler;
        Title := ' Material Picker';
        UpdateGUI;
        //CreateCategories;
        //FillCategory;
    end;

    // create scene inspector form
    frmSceneInspector := TfrmSceneInspector.Create(Scene);
    with frmSceneInspector do begin
        Height := heightSceneInspector;
        Width := widthSceneInspector;
        Top := topSceneInspector;
        Left := leftSceneInspector;
        OnHide := OnHideSceneInspectorHandler;
        OnSelect := OnSelectSceneItemHandler;
    end;

    // create object inspector
    frmObjectInspector := TfrmInspector.Create(Scene);
    with frmObjectInspector do begin
        Height := heightObjectInspector;
        Width := widthObjectInspector;
        Left := leftObjectInspector;
        Top := topObjectInspector;
        OnHide := OnHideObjectInspectorHandler;
    end;

    // load animation form
    frmSkeletonAnimationEditor := TfrmSkeletonAnimationEditor.Create(Scene);
    with frmSkeletonAnimationEditor do begin
        //Height := heightAnimation;
        //Width := widthAnimation;
        //Left := leftAnimation;
        //Top := topAnimation;
        //Scene := fScene;
        AnimationOptions := fAnimationOptions;
        OnHide := OnHideAnimationEditorHandler;
        OnShow := OnShowAnimationEditorHandler;
        OnSelectFrame := OnSelectFrameHandler;
        Enabled := false;
    end;

    frmRaytracing := TfrmRaytracing.Create(Scene, fViewportManager, fRaytracingThread, CameraOptions);
    with frmRaytracing do begin
        Height := heightRaytracing;
        Width := widthRaytracing;
        Left := leftRaytracing;
        Top := topRaytracing;
        OnHide := OnHideRaytracingHandler;
    end;

    DockForms;
    ResetScene;
    LoadDefaultMaterialList;
    SetDefaultMaterials;

    // reload last loaded map if needed
    if toggleloadlast then begin
        SetSplashScreenStatus( 'Loading most recent file...' );
        if not FileExistsUTF8(Recentfiles.Strings[0]) then
            MessageDlg(Recentfiles.Strings[0]+' does not exist.',mtError,[mbOK],0)
        else
            OpenFile(Recentfiles.Strings[0], false);
    end;

    UpdateCaption;

    // show hints if needed
    if FileExistsUTF8(ExtractFilePath(Application.ExeName) + 'DeleD.ini') then begin
        hints := THints.Create(ExtractFilePath(Application.ExeName) + 'DeleD.ini');
        if hints.ShowHints then begin
            frmHints := hints.GetHintsGUI;
            frmHints.ShowModal;
        end;
        hints.Free;
    end;

    // load DMF if supplied on commandline
    if length(Paramstr(1))>0 then
        OpenFile(Paramstr(1), false);

    HideSplashScreen;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    // quick and dirty: we need to stop the animationplayer of the
    // skeletonanimation form...
    frmSkeletonAnimationEditor.Stop;

    // save changes if wanted
    if Scene.HasChanged then begin
        case MessageDlg('Do you want to save your scene?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
            mrCancel: CanClose := false;
            mrYes: actSave.Execute;
        end;
    end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    // update ini file
    WriteINI;
    ViewPortManager.SaveViewPorts(IniFileName);

    // free stuff
    //if Assigned(frmOGLContext) then frmOGLContext.Release;

    // free the scenemanager instance
    //FreeAndNil(fScene);
end;

procedure TfrmMain.FormPaint(Sender: TObject);
begin
    RepaintForms;
end;

// ### STATUSBAR ###############################################################

procedure TfrmMain.stbMainDblClick(Sender: TObject);
var p: TPoint;
    x, i: Integer;
begin
    GetCursorPos(p);
    p := stbMain.ScreenToClient(p);
    x := 0;
    for i := 0 to stbMain.Panels.Count - 1 do begin
        if p.x < x + stbMain.Panels[i].Width then
            Break;
        Inc(x, stbMain.Panels[i].Width)
    end;
    case i of
        1:  RenderOptions.PerformCulling := not RenderOptions.PerformCulling;
        2:  RenderOptions.RenderGrid := not RenderOptions.RenderGrid;
        3:  RenderOptions.RenderAABB := not RenderOptions.RenderAABB;
        4:  toggleSnap := not toggleSnap;
        5:  toggleSelection := not toggleSelection;
        6:  toggleMouse := not toggleMouse;
        7:  RenderOptions.RenderLights := not RenderOptions.RenderLights;
        8:  RenderOptions.RenderSkeletons := not RenderOptions.RenderSkeletons;
        9:  RenderOptions.RenderGizmo := not RenderOptions.RenderGizmo;
        10: AnimationOptions.Loop := not AnimationOptions.Loop;
    end;
    stbMain.Invalidate;
    RepaintForms;
end;

{
// we should really have customized Hints on our statusbar to improve usability
procedure TfrmMain.stbMainHint(Sender: TObject);
var p: TPoint;
    x, i: Integer;
begin
    GetCursorPos(p);
    p := stbMain.ScreenToClient(p);
    x := 0;
    for i := 0 to stbMain.Panels.Count - 1 do begin
        if p.x < x + stbMain.Panels[i].Width then
            Break;
        Inc(x, stbMain.Panels[i].Width)
    end;
    case i of
        4: stbMain.Hint := 'Cull polygons in 3D views';
        5: stbMain.Hint := '';
        6: stbMain.Hint := '';
        7: stbMain.Hint := '';
        8: stbMain.Hint := '';
        9: stbMain.Hint := '';
        10: stbMain.Hint := '';
    end;
    stbMain.Invalidate;
    RepaintForms;
end;  }

procedure TfrmMain.stbMainDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
var color: TColor;
    rectangle: TRect;
begin
    rectangle := Rect;

    stbMain.Canvas.FillRect(rectangle);

    color := clBlack;
    case Panel.Index of
        1:  if RenderOptions.PerformCulling then
                color := clBlack
            else
                color := clGray;
        2:  if RenderOptions.RenderGrid then
                color := clBlack
            else
                color := clGray;
        3:  if RenderOptions.RenderAABB then
                color := clBlack
            else
                color := clGray;
        4:  if toggleSnap then
                color := clBlack
            else
                color := clGray;
        5:  if toggleSelection then
                color := clBlack
            else
                color := clGray;
        6:  if toggleMouse then
                color := clBlack
            else
                color := clGray;
        7:  if RenderOptions.RenderLights then
                color := clBlack
            else
                color := clGray;
        8:  if RenderOptions.RenderSkeletons then
                color := clBlack
            else
                color := clGray;
        9:  if RenderOptions.RenderGizmo then
                color := clBlack
            else
                color := clGray;
        10: if AnimationOptions.Loop then
                color := clBlack
            else
                color := clGray;
    end;

    stbMain.Canvas.Font.Color := color;
                                                                     //DT_SINGLELINE
    DrawText(stbMain.Canvas.Handle,PChar(Panel.Text),-1,rectangle,DT_NOCLIP or DT_VCENTER or DT_CENTER);
end;

// ### MISC TOOLBAR ############################################################

procedure TfrmMain.tbExitClick(Sender: TObject);
begin
    Close;
end;

procedure TfrmMain.tbNewClick(Sender: TObject);
begin
    actNew.Execute;
end;

procedure TfrmMain.tbOpenClick(Sender: TObject);
begin
    actOpen.Execute;
end;

procedure TfrmMain.tbSaveClick(Sender: TObject);
begin
    actSave.Execute;
end;

procedure TfrmMain.tbSaveAsClick(Sender: TObject);
begin
    actSaveAs.Execute;
    RepaintForms;
end;

procedure TfrmMain.tbCutClick(Sender: TObject);
begin
    actCut.Execute;
    RepaintForms;
end;

procedure TfrmMain.tbCopyClick(Sender: TObject);
begin
    actCopy.Execute;
end;

procedure TfrmMain.tbPasteClick(Sender: TObject);
begin
    actPaste.Execute;
    RepaintForms;
end;

procedure TfrmMain.tbUndoClick(Sender: TObject);
begin
    actUndo.Execute;
end;

procedure TfrmMain.tbRedoClick(Sender: TObject);
begin
    actRedo.Execute;
end;

procedure TfrmMain.tbOptionsClick(Sender: TObject);
begin
    actOpenOptions.Execute;
end;

procedure TfrmMain.tbTextureManagerClick(Sender: TObject);
begin
    actOpenMaterialEditor.Execute;
end;

procedure TfrmMain.tbMaterialReplaceClick(Sender: TObject);
begin
    actOpenReplaceMaterial.Execute;
end;

procedure TfrmMain.tbFullscreenClick(Sender: TObject);
begin
    pcLeft.Visible := not pcLeft.Visible;
    pcRight.Visible := not pcRight.Visible;
    if pcLeft.Visible then
        tbFullscreen.ImageIndex := 21
    else
        tbFullscreen.ImageIndex := 20;
    if not ViewPortManager.IsMaximized then
        ViewPortManager.Tile;
end;

procedure TfrmMain.tbHideSelectionClick(Sender: TObject);
begin
    actHide.Execute;
end;

procedure TfrmMain.tbShowHiddenObjectsClick(Sender: TObject);
begin
    actUnhide.Execute;
end;

// ### GRID+ZOOM TOOLBAR #######################################################

procedure TfrmMain.tbZoomAllClick(Sender: TObject);
begin
    actZoomAll.Execute;
end;

procedure TfrmMain.tbZoomOutClick(Sender: TObject);
begin
    ViewPortManager.ZoomCamera(-zoomSpeed);
end;

procedure TfrmMain.tbZoomInClick(Sender: TObject);
begin
    ViewPortManager.ZoomCamera(zoomSpeed);
end;

procedure TfrmMain.tbCameraResetClick(Sender: TObject);
begin
    ViewPortManager.ResetCamera;
    RepaintForms;
end;

// ### editDimension TOOLBAR ###################################################

procedure TfrmMain.tbXClick(Sender: TObject);
begin
    SetDimension(edX);
end;

procedure TfrmMain.tbYClick(Sender: TObject);
begin
    SetDimension(edY);
end;

procedure TfrmMain.tbZClick(Sender: TObject);
begin
    SetDimension(edZ);
end;

procedure TfrmMain.tbUClick(Sender: TObject);
begin
    SetUVDimension(edU);
end;

procedure TfrmMain.tbVClick(Sender: TObject);
begin
    SetUVDimension(edV);
end;

// ### ACTIONLIST EVENTS #######################################################

procedure TfrmMain.actNewExecute(Sender: TObject);
begin
    if SaveFile<>mrCancel then begin
        ResetScene;
        LoadDefaultMaterialList;
        SetDefaultMaterials;
        RepaintForms;
    end;
end;

procedure TfrmMain.actOpenExecute(Sender: TObject);
begin
    if SaveFile<>mrCancel then begin
        OpenDialog1.InitialDir := dir_scenes;
        OpenDialog1.Title := 'Open DeleD Scene';
        if (OpenDialog1.Execute) and (FileExistsUTF8(OpenDialog1.FileName)) then
            OpenFile(OpenDialog1.FileName, false);
    end;
    RepaintForms;
end;

procedure TfrmMain.actMergeExecute(Sender: TObject);
begin
    OpenDialog1.InitialDir := dir_scenes;
    OpenDialog1.Title := 'Open DeleD Scene';
    if (OpenDialog1.Execute) and (FileExistsUTF8(OpenDialog1.FileName)) then
        OpenFile(OpenDialog1.FileName, true);
    RepaintForms;
    Scene.UpdateGUI;
end;

procedure TfrmMain.actObjectsOptimizeExecute(Sender: TObject);
begin
    try
        Screen.Cursor := crHourGlass;
        try
            Scene.ToolExecuter.Execute(editTool,editMode,nil);
        finally
            Screen.Cursor := crDefault;
        end;
    except
        on E: Exception do MessageDlg(e.Message, mtError, [mbOK],0);
    end;
    Scene.UpdateGUI;
end;

procedure TfrmMain.actObjectsMergeExecute(Sender: TObject);
begin
    if Scene.SelectedPrimitives.Count<2 then
        MessageDlg('Please select two or more objects to merge together.',mtWarning,[mbOk],0)
    else begin
        if MessageDlg('Merge objects?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
            try
                Screen.Cursor := crHourGlass;
                Scene.ToolExecuter.Execute(editTool,editMode,nil);
            finally
                Screen.Cursor := crDefault;
            end;
        end;
    end;
    Scene.UpdateGUI;
end;

procedure TfrmMain.actEdgeTurnExecute(Sender: TObject);
begin
    try
        Scene.ToolExecuter.Execute(editTool,editMode,nil);
    except
        on E: Exception do MessageDlg(E.Message, mtWarning, [mbOK],0);
    end;
    Scene.UpdateGUI;
end;

procedure TfrmMain.actPolygonMergeExecute(Sender: TObject);
begin
    Scene.ToolExecuter.Execute(editTool,editMode,nil);
    Scene.UpdateGUI;
end;

procedure TfrmMain.actPolygonFlattenExecute(Sender: TObject);
begin
    Scene.ToolExecuter.Execute(editTool,editMode,nil);
    Scene.UpdateGUI;
end;

procedure TfrmMain.actConnectExecute(Sender: TObject);
begin
    try
        case editMode of
            emPolygon:
                Scene.ToolExecuter.Execute(ptPolygonConnector,taModification,nil);
            emEdge:
                Scene.ToolExecuter.Execute(ptEdgeConnector,taModification,nil);
            emVertex:
                Scene.ToolExecuter.Execute(ptVertexConnector,taModification,nil);
        end;
    except
        on E: Exception do MessageDlg(E.Message, mtWarning, [mbOK],0);
    end;
    Scene.UpdateGUI;
end;

procedure TfrmMain.actFillExecute(Sender: TObject);
begin
    if editMode=emVertex then begin
        if Scene.SelectedVertices.Count>2 then begin
            fParamList.Add(Scene.MaterialManager.SelectedMaterial, 'selectedMaterial', true);
            Scene.ToolExecuter.Execute(editTool,editMode,fParamList);
        end;
    end else if editMode=emEdge then begin
        if Scene.SelectedEdges.Count>2 then begin
            fParamList.Add(Scene.MaterialManager.SelectedMaterial, 'selectedMaterial', true);
            Scene.ToolExecuter.Execute(editTool,editMode,fParamList);
        end;
    end;
    Scene.UpdateGUI;
end;

procedure TfrmMain.actSaveExecute(Sender: TObject);
var dmfSceneWriter: TDMFSceneWriter;
    xmlSceneWriter: TXMLSceneWriter;
    fileExtension: string;
begin
    try
        Screen.Cursor := crHourGlass;
        if Scene.FileName = NEW_SCENE_FILENAME then
            actSaveAs.Execute
        else begin
            if toggleCopyToBak then
                CopyFile(PChar(Scene.FileName),PChar(GenerateBackupFileName(Scene.FileName)),false);

            fileExtension := UpperCase(ExtractFileExt(Scene.FileName));
            if fileExtension='.DXS' then begin
                xmlSceneWriter := TXMLSceneWriter.Create;
                try
                    xmlSceneWriter.WriteToFile(Scene,Scene.FileName,ViewPortManager);
                finally
                    FreeAndNil(xmlSceneWriter);
                end;
            end else if fileExtension='.DMF' then begin
                dmfSceneWriter := TDMFSceneWriter.Create;
                try
                    dmfSceneWriter.WriteToFile(Scene,Scene.FileName,false);
                finally
                    FreeAndNil(dmfSceneWriter);
                end;
            end;
        end;
        Scene.HasChanged := FALSE;
        UpdateCaption;
    finally
        Screen.Cursor := crDefault;
        RepaintForms;
    end;
end;

{
procedure TFrmMain.BreakScene;
var i, j: integer;
    primitive: TBasePrimitive;
    vertex: TVertice;
begin
    for i := 0 to Scene.Primitives.Count - 1 do begin
        primitive := Scene.Primitives[i] as TPrimitive;
        for j := 0 to primitive.NumVertices - 1 do begin
            vertex := primitive.Vertices[j];

            if random(100) = 10 then vertex.Free;
        end;
    end;
end;
}
procedure TfrmMain.actSaveAsExecute(Sender: TObject);
var fileName, fileExtension: string;
    dmfSceneWriter: TDMFSceneWriter;
    xmlSceneWriter: TXMLSceneWriter;
    shouldSave: boolean;
begin
    try
        Screen.Cursor := crHourGlass;
        SaveDialog1.InitialDir := dir_scenes;
        SaveDialog1.Filter := 'DeleD XML Scenes (*.dxs)|*.dxs|DeleD Map Files (*.dmf)|*.dmf';
        fileName := ChangeFileExt(Scene.FileName, '');  // remove the file extension
        SaveDialog1.FileName := fileName;

        if SaveDialog1.Execute then begin
            fileName := SaveDialog1.FileName;

            case SaveDialog1.FilterIndex of
                1: fileName := ChangeFileExt(fileName, '.dxs');
                2: fileName := ChangeFileExt(fileName, '.dmf');
            end;

            shouldSave :=
                (not FileExistsUTF8(fileName)) or
                (MessageDlg(fileName+' exists, overwrite?', mtConfirmation, [mbYes, mbNo], 0) = mrYes);

//            BreakScene;

            if shouldSave then begin
                // copy current file to backup file
                if toggleCopyToBak then
                    CopyFile(PChar(fileName),PChar(GenerateBackupFileName(Scene.FileName)),false);

                fileExtension := UpperCase(ExtractFileExt(fileName));
                Scene.FileName := filename;
                dir_scenes := ExtractFilePath(fileName);
                if fileExtension='.DXS' then begin
                    xmlSceneWriter := TXMLSceneWriter.Create;
                    try
                        //***********************HERE***********************HERE***********************HERE***********************HERE
                        xmlSceneWriter.WriteToFile(Scene,fileName,ViewPortManager);
                    finally
                        FreeAndNil(xmlSceneWriter);
                    end;
                end else begin
                    dmfSceneWriter := TDMFSceneWriter.Create;
                    try
                        dmfSceneWriter.WriteToFile(Scene,fileName,false);
                    finally
                        FreeAndNil(dmfSceneWriter);
                    end;
                end;
                Scene.HasChanged := FALSE;
                Recentfiles.AddRecentFile(fileName);
                UpdateRecentFileMenu;
                UpdateCaption;
            end
        end;
    finally
        Screen.Cursor := crDefault;
        RepaintForms;
    end;
end;

procedure TfrmMain.actExportPrefabExecute(Sender: TObject);
begin
    if Scene.SelectedPrimitives.Count<>1 then
        MessageDlg('Please select one object to export.', mtWarning, [mbOK], 0)
    else begin
        SaveDialog1.DefaultExt := '.dpf';
        SaveDialog1.InitialDir := dir_CurrentPrefabs;
        SaveDialog1.FileName := '';
        SaveDialog1.Filter := 'DeleD Prefab Files (*.dpf)|*.dpf';
        if SaveDialog1.Execute then begin
            if FileExistsUTF8(SaveDialog1.FileName) then begin
                if MessageDlg(SaveDialog1.FileName+' exists, overwrite?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
                    dir_CurrentPrefabs := ExtractFilePath(SaveDialog1.FileName);
                    Scene.ExportPrefab(SaveDialog1.FileName)
                end;
            end else begin
                dir_CurrentPrefabs := ExtractFilePath(SaveDialog1.FileName);
                Scene.ExportPrefab(SaveDialog1.FileName);
            end;
            frmCreateEdit.UpdateGUI;
        end;
    end;
    RepaintForms;
end;

procedure TfrmMain.actCutExecute(Sender: TObject);
begin
    try
        Screen.Cursor := crHourGlass;
        if editMode=emObject then
            fPrimitiveClipBoard.Cut;
        if editMode=emSkeleton then
            fSkeletonClipBoard.Cut;
    finally
        Screen.Cursor := crDefault;
    end;
    RepaintForms;
end;

procedure TfrmMain.actCopyExecute(Sender: TObject);
begin
    try
        Screen.Cursor := crHourGlass;
        if editMode=emObject then
            fPrimitiveClipBoard.Copy;
        if editMode=emSkeleton then
            fSkeletonClipBoard.Copy;
    finally
        Screen.Cursor := crDefault;
    end;
    RepaintForms;
end;

procedure TfrmMain.actPasteExecute(Sender: TObject);
begin
    try
        Screen.Cursor := crHourGlass;
        if editMode=emObject then
            fPrimitiveClipBoard.Paste;
        if editMode=emSkeleton then
            fSkeletonClipBoard.Paste;
    finally
        Screen.Cursor := crDefault;
    end;
    RepaintForms;
end;

procedure TfrmMain.actCloneExecute(Sender: TObject);
begin
    if editMode=emObject then begin
        if Scene.SelectedPrimitives.Count=0 then
            MessageDlg('Please select one or more objects to clone.',mtWarning,[mbOK],0)
        else begin
            try
                fParamList.Add(CloneOptions,'cloneOptions',true);
                Screen.Cursor := crHourGlass;
                Scene.ToolExecuter.Execute(ptPrimitiveCloner,taAddition,fParamList);
                frmCreateEdit.EditTool := etMove;
            finally
                Screen.Cursor := crDefault;
            end;
        end;
    end;

    if editMode=emSkeleton then begin
        if Scene.SelectedSkeletons.Count=0 then
            MessageDlg('Please select one or more skeletons to clone.',mtWarning,[mbOK],0)
        else begin
            try
                Screen.Cursor := crHourGlass;
                Scene.ToolExecuter.Execute(stSkeletonCloner,taAddition,nil);
                frmCreateEdit.EditTool := etMove;
            finally
                Screen.Cursor := crDefault;
            end;
        end;
    end;

    RepaintForms;
end;

procedure TfrmMain.actSelectallExecute(Sender: TObject);
var viewport: TfrmViewPort;
    material: TMaterial;
begin
    viewport := viewportManager.ActiveViewport;
    if Assigned(viewport) and (viewport.ViewMode = vmUV) then
        material := (viewport as TfrmUVEditor).SelectedMaterial
    else
        material := nil;

    case editMode of
        emObject:
            Scene.PrimitiveSelector.SelectAll;
        emPolygon, emFace:
            Scene.PolygonSelector.SelectAll(material);
        emEdge:
            Scene.EdgeSelector.SelectAll;
        emVertex:
        begin
            if Assigned(material) then
                Scene.UVSelector.SelectAll(material)
            else
                Scene.VertexSelector.SelectAll;
        end;
    end;
    autoSelect := false;
    userSelect := true;
    RepaintForms;
end;

procedure TfrmMain.actDeselectallExecute(Sender: TObject);
begin
    Scene.PrimitiveSelector.DeselectAll;
    autoSelect := true;
//    userSelect := false;
end;

procedure TfrmMain.actToggleStatusbarExecute(Sender: TObject);
begin
    toggleStatusbar := not toggleStatusbar;
    stbMain.Visible := toggleStatusbar;
    StatusbarItem.Checked := toggleStatusbar;
end;

procedure TfrmMain.actToggleCreateEditExecute(Sender: TObject);
begin
    if Assigned(frmCreateEdit) then begin
        toggleCreateEdit := not toggleCreateEdit;
        frmCreateEdit.Visible := toggleCreateEdit;
        CreateEditWindowItem.Checked := toggleCreateEdit;
        RepaintForms;
    end;
end;

procedure TfrmMain.actToggleSceneInspectorExecute(Sender: TObject);
begin
    if Assigned(frmSceneInspector) then begin
        toggleSceneInspector := not toggleSceneInspector;
        frmSceneInspector.Visible := toggleSceneInspector;
        SceneInspectorItem.Checked := toggleSceneInspector;
        RepaintForms;
    end;
end;

procedure TfrmMain.actToggleMaterialPickerExecute(Sender: TObject);
begin
    if Assigned(frmMaterialPicker) then begin
        toggleMaterialPicker := not toggleMaterialPicker;
        frmMaterialPicker.Visible := toggleMaterialPicker;
        MaterialPickerItem.Checked := toggleMaterialPicker;
        RepaintForms;
    end;
end;

// calling Properties on 2D/3D view popupmenu makes the Object Inspector visible
procedure TfrmMain.actToggleObjectInspectorExecute(Sender: TObject);
var pc: TPageControl;
    ts: TTabSheet;
begin
    if Assigned(frmObjectInspector) then begin

        // always make it visible
        toggleObjectInspector := true;
        frmObjectInspector.Visible := toggleObjectInspector;
        ObjectInspectorItem.Checked := toggleObjectInspector;

        // if the Object Inspector is docked, activate its tabsheet
        if frmObjectInspector.IsDocked then begin
            pc := TPageControl(frmObjectInspector.Parent.Parent);
            ts := TTabSheet(frmObjectInspector.Parent);
            pc.ActivePage := ts;
        end;
        RepaintForms;
    end;
end;

procedure TfrmMain.actToggleAnimationEditorExecute(Sender: TObject);
begin
    if Assigned(frmSkeletonAnimationEditor) then begin
        toggleAnimation := not toggleAnimation;
        frmSkeletonAnimationEditor.Visible := toggleAnimation;
        SkeletonAnimationEditorItem.Checked := toggleAnimation;
        RepaintForms;
    end;
end;

// calling the main menu View - Object Inspector option toggles the visibility
// of the Object inspector
procedure TfrmMain.actToggleObjectInspectorViaMainMenuExecute(Sender: TObject);
begin
    if Assigned(frmObjectInspector) then begin
        toggleObjectInspector := not toggleObjectInspector;
        frmObjectInspector.Visible := toggleObjectInspector;
        ObjectInspectorItem.Checked := toggleObjectInspector;
        RepaintForms;
    end;
end;

procedure TfrmMain.actToggleCullingExecute(Sender: TObject);
begin
    RenderOptions.PerformCulling := not RenderOptions.PerformCulling;
    RepaintForms;
end;

procedure TfrmMain.actToggleGizmoExecute(Sender: TObject);
begin
    RenderOptions.RenderGizmo := not RenderOptions.RenderGizmo;
    RepaintForms;
end;

procedure TfrmMain.actToggleLockViewExecute(Sender: TObject);
begin
    toggleLockViews := not toggleLockViews;
end;

procedure TfrmMain.actToggleGridExecute(Sender: TObject);
begin
    RenderOptions.RenderGrid := not RenderOptions.RenderGrid;
    RepaintForms;
end;

procedure TfrmMain.actToggleGrid3DViewExecute(Sender: TObject);
begin
    RenderOptions.RenderPerspectiveGrid := not RenderOptions.RenderPerspectiveGrid;
    RepaintForms;
end;

procedure TfrmMain.actToggleSnapExecute(Sender: TObject);
begin
    toggleSnap := not toggleSnap;
end;

procedure TfrmMain.actToggleSelectionExecute(Sender: TObject);
begin
    toggleSelection := not toggleSelection;
end;

procedure TfrmMain.ActionToggleUVExecute(Sender: TObject);
begin
    RepaintForms;
end;

procedure TfrmMain.actToggleAABBExecute(Sender: TObject);
begin
    RenderOptions.RenderAABB := not RenderOptions.RenderAABB;
    RepaintForms;
end;

procedure TfrmMain.actToggleMouseExecute(Sender: TObject);
begin
    togglemouse := not togglemouse;
    RepaintForms;
end;

procedure TfrmMain.actToggleLightsExecute(Sender: TObject);
begin
    RenderOptions.RenderLights := not RenderOptions.RenderLights;
    RepaintForms;
end;

procedure TfrmMain.actOpenOptionsExecute(Sender: TObject);
var frmOptions: TfrmOptions;
begin
    // The raytracing thread is passed because the raytracing dir option needs to check/modify the potentially running raytracer.
    // Change to a more generic notification/validation system for all options some day. 
    frmOptions := TfrmOptions.Create(nil,Scene,ViewPortManager,RenderOptions,CameraOptions,ControlOptions,CSGOptions,frmRaytracing.Thread);
    try
        frmOptions.ShowModal;
        if frmOptions.ShouldUpdateMaterialPicker then
            frmMaterialPicker.UpdateGUI;
        if frmOptions.ShouldUpdateSkybox then
            ViewPortManager.UpdateSkyBox;
        if frmOptions.ShouldUpdateFOV then
            ViewPortManager.UpdateFOV;
        stbMain.Invalidate;
    finally
        frmOptions.Release;
    end;
    RepaintForms;
end;

procedure TfrmMain.actOpenMaterialEditorExecute(Sender: TObject);
var frmMaterialEditor: TfrmMaterialEditor;
begin
    try
        frmMaterialEditor := TfrmMaterialEditor.Create(nil,Scene);
        try
            //Execute material editor
            frmMaterialEditor.ShowModal;

            //When done, show the changes in the material tab
            frmMaterialPicker.UpdateGUI;
        finally
            frmMaterialEditor.Release;
            // we clear the Undo buffer on purpose; the user might have deleted
            // materials using the Material Editor; the Undo system does not
            // undo the deletion of materials;
            // example: the user has a material assigned to an object and then
            // deletes this material -> the object gets the system material assigned
            // by the FaceMaterialReplacer tool; to undo that tool, the old material
            // has to be available which it isn't -> AV. Therefore, we clear the
            // Undo buffer;
            // it would be nice to be able to insert deleted materials again so
            // we don't need to clear the undo buffer
            Scene.UndoRedoManagerEx.Clear;
        end;
    except
        on E: Exception do showmessage(E.Message);
    end;
end;

procedure TfrmMain.actOpenReplaceMaterialExecute(Sender: TObject);
var frmReplaceMaterials: TfrmReplaceMaterials;
begin
    if Scene.SelectedPrimitives.Count=0 then
        MessageDlg('No object(s) selected.',mtWarning,[mbOK],0)
    else begin
        frmReplaceMaterials := TfrmReplaceMaterials.Create(nil,Scene);
        frmReplaceMaterials.ShowModal;
        frmReplaceMaterials.Release;
    end;
    RepaintForms;
end;

procedure TfrmMain.actZoomAllExecute(Sender: TObject);
begin
    ViewPortManager.FocusCameraOnPrimitives(Scene.Primitives);
    RepaintForms;
end;

procedure TfrmMain.actResetCamerasExecute(Sender: TObject);
begin
    ViewPortManager.ResetCamera;
    RepaintForms;
end;

procedure TfrmMain.actSelectionReverseExecute(Sender: TObject);
begin
    case editMode of
        emObject:
            Scene.PrimitiveSelector.ReverseSelection;
        emPolygon,emFace:
            Scene.PolygonSelector.ReverseSelection;
        emEdge:
            Scene.EdgeSelector.ReverseSelection;
        emVertex:
            Scene.VertexSelector.ReverseSelection;
    end;
    RepaintForms;
end;

procedure TfrmMain.actSelectionGrowExecute(Sender: TObject);
begin
    case editMode of
        emPolygon,emFace:
            begin
                Scene.PolygonSelector.GrowSelection;
            end;
        emEdge:
            begin
                Scene.EdgeSelector.GrowSelection;
            end;
        emVertex:
            begin
                Scene.VertexSelector.GrowSelection;
            end;
    end;
    RepaintForms;
end;

procedure TfrmMain.actSelectionShrinkExecute(Sender: TObject);
begin
    case editMode of
        emPolygon,emFace:
            begin
                Scene.PolygonSelector.ShrinkSelection;
            end;
        emEdge:
            begin
                Scene.EdgeSelector.ShrinkSelection;
            end;
        emVertex:
            begin
                Scene.VertexSelector.ShrinkSelection;
            end;
    end;
    RepaintForms;
end;

procedure TfrmMain.actSelectionEdgeLoopExecute(Sender: TObject);
begin
    if Scene.SelectedEdges.Count=0 then
        MessageDlg('No edges selected.',mtWarning,[mbOK],0)
    else
        Scene.EdgeSelector.SelectLoops;
    RepaintForms;
end;

procedure TfrmMain.actSelectionEdgeRingExecute(Sender: TObject);
begin
    if Scene.SelectedEdges.Count=0 then
        MessageDlg('No edges selected.',mtWarning,[mbOK],0)
    else
        Scene.EdgeSelector.SelectRings;
    RepaintForms;
end;

procedure TfrmMain.actDeleteItemsExecute(Sender: TObject);
begin
    if editContext=ecScene then begin    // only works with scene primitives

        Screen.Cursor := crHourGlass;
        case editMode of
            emSkeleton:
                begin
                    if Scene.SelectedJoints.Count > 0 then
                        actJointsDelete.Execute
                    else if Scene.SelectedAnimations.Count > 0 then
                        actAnimationsDelete.Execute
                    else if Scene.SelectedSkeletons.Count > 0 then
                        actSkeletonsDelete.Execute;

                    Scene.JointGeometryUpdater.Execute(nil);

                    // TODO: implement Undo/Redo for skeleton delete methods
                    Scene.UndoRedoManagerEx.Clear;
                end;
            emObject:
                begin
                    actObjectsDelete.Execute;
                end;
            emPolygon,emFace:
                begin
                    actPolygonDelete.Execute;
                end;
            emEdge:
                begin
                    MessageDlg('Deletion of edges not supported.',mtInformation,[mbOK],0);
                    // deleting edges:
                    //   - merge coplanar polygons using the edge
                    //   - if a vertex of the edge is used by only one other edge,
                    //     delete that vertex (and thus that edge) too
                end;
            emVertex:
                begin
                    Scene.ToolExecuter.Execute(ptVertexRemover,taModification,nil);
                end;
        end;
        Screen.Cursor := crDefault;
    end;
end;

procedure TfrmMain.actObjectsDeleteExecute(Sender: TObject);
begin
    if (editContext=ecScene) then begin    // only works with scene primitives
        if Scene.SelectedPrimitives.Count=0 then
            MessageDlg('No objects selected.',mtWarning,[mbOK],0)
        else begin
            //if MessageDlg('Are you sure you want to delete the selected objects?',mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
                fParamList.Add(true,'doSelection',true);
                Scene.ToolExecuter.Execute(ptPrimitiveRemover,taDeletion,fParamList);
            //end;
        end;
    end;
end;

procedure TfrmMain.actDeleteNonSelectedExecute(Sender: TObject);
begin
    if editContext=ecScene then begin    // only works with scene primitives
        if Scene.SelectedPrimitives.Count=0 then
            MessageDlg('No objects selected.',mtWarning,[mbOK],0)
        else begin
            if MessageDlg('Are you sure you want to delete everything but the selected objects?',mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
                fParamList.Add(false,'doSelection',true);
                Scene.ToolExecuter.Execute(ptPrimitiveRemover,taDeletion,fParamList);
            end;
        end;
    end;
end;

procedure TfrmMain.actPolygonDeleteExecute(Sender: TObject);
begin
    if Scene.SelectedPolygons.Count=0 then
        MessageDlg('No polygons selected.',mtWarning,[mbOK],0)
    else begin
        //if MessageDlg('Are you sure you want to delete the selected polygons?',mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
            fParamList.Add(integer(prmSelected),'polygonRemoveMethod',true);
            Scene.ToolExecuter.Execute(ptPolygonRemover,taModification,fParamList);
        //end;
    end;
end;

procedure TfrmMain.actPolygonDeleteSystemPolygonsExecute(Sender: TObject);
begin
    fParamList.Add(integer(prmSystem),'polygonRemoveMethod',true);
    Scene.ToolExecuter.Execute(ptPolygonRemover,taModification,fParamList);
end;

procedure TfrmMain.actSkeletonsDeleteExecute(Sender: TObject);
var paramList: TParamList;
begin
    // we pass the Scene.Primitives to the SkeletonRemoverTool
    // so that it can unassign primitives from skeletons and
    // give them back to the scene when skeletons are deleted
    paramList := TParamList.Create(false);
    try
        paramList.Add(Scene.Primitives,'primitiveList');
        Scene.ToolExecuter.Execute(stSkeletonRemover,taDeletion,paramList);
    finally
        FreeAndNil(paramList);
    end;
end;

procedure TfrmMain.actJointSplitExecute(Sender: TObject);
var paramList: TParamList;
begin
    paramList := TParamList.Create(false);
    try
        paramList.Add(Scene.MaterialManager,'materialManager');
        Scene.ToolExecuter.Execute(stJointSplitter,taModification,paramList);
    finally
        FreeAndNil(paramList);
    end;

    Scene.UpdateGUI();
end;

procedure TfrmMain.actJointFlipExecute(Sender: TObject);
var paramList: TParamList;
begin
    paramList := TParamList.Create(false);
    try
        paramList.Add(Scene.MaterialManager,'materialManager');
        Scene.ToolExecuter.Execute(stJointFlipper,taModification,paramList);
    finally
        FreeAndNil(paramList);
    end;

    Scene.UpdateGUI();
end;

procedure TfrmMain.actJointsDeleteExecute(Sender: TObject);
var paramList: TParamList;
begin
    // clear any joints selected by the JointSelection tool
    Scene.JointGeometrySelector.Clear;

    paramList := TParamList.Create(false);
    try
        paramList.Add(Scene.Primitives,'primitives');
        Scene.ToolExecuter.Execute(stJointRemover,taModification,paramList);
    finally
        FreeAndNil(paramList);
    end;

    Scene.UpdateGUI();
end;

procedure TfrmMain.actAnimationsDeleteExecute(Sender: TObject);
var paramList: TParamList;
begin
    // we pass the SelectedAnimations to the AnimationRemoverTool
    // so that it can update that collection when animations
    // are removed from skeletons
    paramList := TParamList.Create(false);
    try
        paramList.Add(Scene.SelectedAnimations,'selectedanimations');
        Scene.ToolExecuter.Execute(stAnimationRemover,taModification,paramList);
        frmSceneInspector.UpdateGUI;
        frmSkeletonAnimationEditor.UpdateGUI;
    finally
        FreeAndNil(paramList);
    end;

    Scene.UpdateGUI();
end;

procedure TfrmMain.actObjectsGroupExecute(Sender: TObject);
begin
    if Scene.SelectedPrimitives.Count<2 then
        MessageDlg('Please select two or more objects.',mtWarning,[mbOk],0)
    else begin
        fParamList.Add(true,'doGroup',true);
        Scene.ToolExecuter.Execute(ptPrimitiveGrouper,taModification,fParamList);
    end;
end;

procedure TfrmMain.actObjectsUngroupExecute(Sender: TObject);
begin
    fParamList.Add(false,'doGroup',true);
    Scene.ToolExecuter.Execute(ptPrimitiveGrouper,taModification,fParamList);
end;

procedure TfrmMain.actUndoExecute(Sender: TObject);
begin
    // Undo is disabled if the user has a mouse button down in any view
    // or if any viewport is in a special state (e.g PolyLine creation)
    if (not ViewPortManager.IsMouseDown) and
       (not ViewPortManager.IsAnyViewportInSpecialState) then begin
        Scene.SelectedPrimitives.Clear;
        Scene.UndoRedoManagerEx.Undo;
        Scene.UpdateGUI();
    end;
end;

procedure TfrmMain.actRedoExecute(Sender: TObject);
begin
    // Undo is disabled if the user has a mouse button down in any view
    // or if any viewport is in a special state (e.g PolyLine creation)
    if (not ViewPortManager.IsMouseDown) and
       (not ViewPortManager.IsAnyViewportInSpecialState) then begin
        Scene.SelectedPrimitives.Clear;
        Scene.UndoRedoManagerEx.Redo;
        Scene.UpdateGUI();
    end;
end;

procedure TfrmMain.actHideExecute(Sender: TObject);
begin
    if Scene.SelectedPrimitives.Count=0 then
        MessageDlg('Please select one or more objects.',mtWarning,[mbOK],0)
    else begin
        fParamList.Add(integer(hmHideSelection), 'hideMethod',true);
        Scene.ToolExecuter.Execute(ptPrimitiveHider,taModification,fParamList);
    end;
end;

procedure TfrmMain.actUnhideExecute(Sender: TObject);
begin
    fParamList.Add(integer(hmUnhide), 'hideMethod',true);
    Scene.ToolExecuter.Execute(ptPrimitiveHider,taModification,fParamList);
end;

procedure TfrmMain.actSetDrawModeWireFrameExecute(Sender: TObject);
begin
    SetDrawMode(dmWireframe,true);
end;

procedure TfrmMain.actSetDrawModeSolidExecute(Sender: TObject);
begin
    SetDrawMode(dmSolid,true);
end;

procedure TfrmMain.actSetDrawModeTexturedExecute(Sender: TObject);
begin
    SetDrawMode(dmTextured,true);
end;

procedure TfrmMain.actSetDrawModeLightmappedExecute(Sender: TObject);
begin
    SetDrawMode(dmLightmapped,true);
end;

// ### FILE MENU ###############################################################

procedure TfrmMain.FileNewClick(Sender: TObject);
begin
    actNew.Execute;
end;

procedure TfrmMain.FileOpenClick(Sender: TObject);
begin
    actOpen.Execute;
end;

procedure TfrmMain.FileMergeClick(Sender: TObject);
begin
    actMerge.Execute;
end;

procedure TfrmMain.FileSaveClick(Sender: TObject);
begin
    if Scene.FileName<>'no file' then
        actSave.Execute
    else
        actSaveAs.Execute;
end;

procedure TfrmMain.FileSaveAsClick(Sender: TObject);
begin
    actSaveAs.Execute;
end;

procedure TfrmMain.ExportPrefabClick(Sender: TObject);
begin
    actExportPrefab.Execute;
end;

// ### EDIT MENU ###############################################################

procedure TfrmMain.mnuUndoClick(Sender: TObject);
begin
    actUndo.Execute;
end;

procedure TfrmMain.mnuRedoClick(Sender: TObject);
begin
    actRedo.Execute;
end;

procedure TfrmMain.mnuCutClick(Sender: TObject);
begin
    actCut.Execute;
end;

procedure TfrmMain.mnuCopyClick(Sender: TObject);
begin
    actCopy.Execute;
end;

procedure TfrmMain.mnuPasteClick(Sender: TObject);
begin
    actPaste.Execute;
end;

procedure TfrmMain.mnuCloneClick(Sender: TObject);
begin
    actClone.Execute;
end;

// ### SELECTION MENU ##########################################################

procedure TfrmMain.mnuSelectAllClick(Sender: TObject);
begin
    actSelectall.Execute;
end;

procedure TfrmMain.mnuSelectPolygonsByMaterialClick(Sender: TObject);
begin
    Scene.PolygonSelector.SelectByMaterial;
end;

procedure TfrmMain.mnuDeselectAllClick(Sender: TObject);
begin
    actDeselectall.Execute;
end;

procedure TfrmMain.mnuReverseSelectionClick(Sender: TObject);
begin
    actSelectionReverse.Execute;
end;

procedure TfrmMain.mnuGrowSelectionClick(Sender: TObject);
begin
    actSelectionGrow.Execute;
end;

procedure TfrmMain.mnuShrinkSelectionClick(Sender: TObject);
begin
    actSelectionShrink.Execute;
end;

procedure TfrmMain.mnuSelectEdgeLoopClick(Sender: TObject);
begin
    actSelectionEdgeLoop.Execute;
end;

procedure TfrmMain.mnuSelectEdgeRingClick(Sender: TObject);
begin
    actSelectionEdgeRing.Execute;
end;

// #############################################################################

procedure TfrmMain.mnuDeleteSelectionClick(Sender: TObject);
begin
    actDeleteItems.Execute;
end;

procedure TfrmMain.mnuDeleteNonSelectionClick(Sender: TObject);
begin
    actDeleteNonSelected.Execute;
end;

procedure TfrmMain.mnuDeleteSystemPolygonsClick(Sender: TObject);
begin
    actPolygonDeleteSystemPolygons.Execute;
end;

procedure TfrmMain.GroupObjectsClick(Sender: TObject);
begin
    actObjectsGroup.Execute;
end;

procedure TfrmMain.UngroupObjectsClick(Sender: TObject);
begin
    actObjectsUngroup.Execute;
end;

procedure TfrmMain.RegroupObjectsClick(Sender: TObject);
begin
// not implemented yet
end;

// #############################################################################

procedure TfrmMain.EnablebackfacecullingItemClick(Sender: TObject);
begin
    actToggleCulling.Execute;
end;

// ### VIEW MENU ###############################################################

procedure TfrmMain.mnuAddPerspectiveClick(Sender: TObject);
begin
    AddView(vmPerspective);
end;

procedure TfrmMain.mnuAddTopClick(Sender: TObject);
begin
    AddView(vmTop);
end;

procedure TfrmMain.mnuAddFrontClick(Sender: TObject);
begin
    AddView(vmFront);
end;

procedure TfrmMain.mnuAddSideClick(Sender: TObject);
begin
    AddView(vmSide);
end;

procedure TfrmMain.mnuAddUVClick(Sender: TObject);
begin
    AddView(vmUV);
end;

procedure TfrmMain.mnuPerspectiveViewClick(Sender: TObject);
begin
    ChangeActiveView(vmPerspective);
end;

procedure TfrmMain.mnuTopViewClick(Sender: TObject);
begin
    ChangeActiveView(vmTop);
end;

procedure TfrmMain.mnuFrontViewClick(Sender: TObject);
begin
    ChangeActiveView(vmFront);
end;

procedure TfrmMain.mnuSideViewClick(Sender: TObject);
begin
    ChangeActiveView(vmSide);
end;

procedure TfrmMain.mnuUVViewClick(Sender: TObject);
begin
    ChangeActiveView(vmUV);
end;

procedure TfrmMain.mnuRemoveViewPortClick(Sender: TObject);
begin
    RemoveActiveView;
end;

procedure TfrmMain.mnuLockViewsClick(Sender: TObject);
begin
    actToggleLockView.Execute;
    mnuLockViews.Checked := toggleLockViews;
end;

procedure TfrmMain.TileItemClick(Sender: TObject);
begin
    ViewPortManager.Tile;
end;

procedure TfrmMain.CascadeItemClick(Sender: TObject);
begin
    Cascade;
end;

procedure TfrmMain.WireframeItemClick(Sender: TObject);
begin
    SetDrawMode(dmWireframe);
end;

procedure TfrmMain.SolidItemClick(Sender: TObject);
begin
    SetDrawMode(dmSolid);
end;

procedure TfrmMain.TexturedItemClick(Sender: TObject);
begin
    SetDrawMode(dmTextured);
end;

procedure TfrmMain.LightMappedItemClick(Sender: TObject);
begin
    SetDrawMode(dmLightmapped);
end;

procedure TfrmMain.CreateEditWindowItemClick(Sender: TObject);
begin
    actToggleCreateEdit.Execute;
end;

procedure TfrmMain.SceneInspectorItemClick(Sender: TObject);
begin
    actToggleSceneInspector.Execute;
end;

procedure TfrmMain.MaterialPickerItemClick(Sender: TObject);
begin
    actToggleMaterialPicker.Execute;
end;

procedure TfrmMain.ObjectInspectorItemClick(Sender: TObject);
begin
    actToggleObjectInspectorViaMainMenu.Execute;
end;

procedure TfrmMain.SkeletonAnimationEditorItemClick(Sender: TObject);
begin
    actToggleAnimationEditor.Execute;
end;

procedure TfrmMain.mnuVisibilityToolItemClick(Sender: TObject);
var frmVisibilityTool: TfrmVisibility;
begin
    frmVisibilityTool := TfrmVisibility.Create(nil,Scene);
    frmVisibilityTool.ShowModal;
    frmVisibilityTool.Release;
end;

procedure TfrmMain.StatusbarItemClick(Sender: TObject);
begin
    actToggleStatusbar.Execute;
end;

procedure TfrmMain.MiscTBarClick(Sender: TObject);
begin
    tlbMisc.Visible := not tlbMisc.Visible;
    MiscTBar.Checked := not MiscTBar.Checked;
end;

procedure TfrmMain.ZoomTBarClick(Sender: TObject);
begin
    tlbZoom.Visible := not tlbZoom.Visible;
    ZoomTBar.Checked := not ZoomTBar.Checked;
end;

procedure TfrmMain.XYZUVTBarClick(Sender: TObject);
begin
    tlbXYZUV.Visible := not tlbXYZUV.Visible;
    XYZUVTBar.Checked := not XYZUVTBar.Checked;
end;

procedure TfrmMain.OptionsItemClick(Sender: TObject);
begin
    actOpenOptions.Execute;
end;

// ### INFO MENU ###############################################################

procedure TfrmMain.HelpItemClick(Sender: TObject);
var filename: string;
begin
    fileName := ExtractFilePath(Application.ExeName)+'deled.chm';
    if not FileExists(filename) then
        fileName := dir_doc+'deled.chm';
    if Assigned( HTMLHelp ) then
    begin
        HtmlHelp(0, PChar(filename), HH_DISPLAY_TOPIC, 0);
    end;
end;

procedure TfrmMain.HotkeysItemClick(Sender: TObject);
var frmHotkeys: TfrmHotkeys;
begin
    frmHotkeys := TfrmHotkeys.Create(application);
    try
        frmHotkeys.ShowModal;
    finally
        frmHotkeys.Release;
    end;
end;

procedure TfrmMain.HintsItemClick(Sender: TObject);
var frmHints: TfrmHints;
    hints: THints;
begin
    if not FileExistsUTF8(ExtractFilePath(Application.ExeName) + 'DeleD.ini') then Exit;
    hints := THints.Create(ExtractFilePath(Application.ExeName) + 'DeleD.ini');
    frmHints := hints.GetHintsGUI;
    try
        frmHints.ShowModal;
    finally
        frmHints.Release;
        hints.Free;
    end;
end;

procedure TfrmMain.SupportItemClick(Sender: TObject);
begin
    ShellExecute(0,nil,'http://www.delgine.com/forum',nil,nil,SW_ShowDefault);
end;

procedure TfrmMain.WikiItemClick(Sender: TObject);
begin
    ShellExecute(0,nil,'http://www.delgine.com/wiki',nil,nil,SW_ShowDefault);
end;

procedure TfrmMain.GetDeleDPROitemClick(Sender: TObject);
begin
    ShellExecute(0,nil,'http://www.delgine.com/index.php?filename=product_deled',nil,nil,SW_ShowDefault);
end;

procedure TfrmMain.AboutItemClick(Sender: TObject);
var frmAbout: TfrmAboutBox;
begin
    frmAbout := TfrmAboutBox.Create(application);
    try
        frmAbout.ShowModal;
    finally
        frmAbout.Release;
    end;
end;

// ### VARIOUS FORM FUNCTIONS ##################################################

// primitive event handlers

procedure TfrmMain.OnSelectPrimitiveHandler(Sender: TObject);
begin
    if Assigned(Sender) then begin
        //frmObjectInspector.UpdateGUI;
        UpdateStatusText;
    end;
    RepaintForms;
end;

// scene inspector form event handlers

procedure TfrmMain.OnHideSceneInspectorHandler(Sender: TObject);
begin
    if Assigned(Sender) then begin
        toggleSceneInspector := false;
        SceneInspectorItem.Checked := toggleSceneInspector;
    end;
end;

// create/edit form event handlers

procedure TfrmMain.OnSelectEditModeHandler(Sender: TObject);
begin
    if Sender is TfrmCreateEdit then begin
        SetEditMode(editContext,TfrmCreateEdit(Sender).EditMode,false);         // false to avoid circular reference
        RepaintForms;
    end;
end;

procedure TfrmMain.OnSelectEditCommandHandler(Sender: TObject);
begin
    if Sender is TfrmCreateEdit then
        SetAction(TfrmCreateEdit(Sender).EditTool);
end;

procedure TfrmMain.OnSelectDefaultPrimitiveHandler(Sender: TObject);
begin
    if Sender is TfrmCreateEdit then
        SetPrimitive(TfrmCreateEdit(Sender).DefaultPrimitive);
end;

procedure TfrmMain.OnHideCreateEditHandler(Sender: TObject);
begin
    if Assigned(Sender) then begin
        toggleCreateEdit := false;
        CreateEditWindowItem.Checked := toggleCreateEdit;
    end;
end;

// scene change event handlers

// executed when the Scene.Primitives and Scene.Skeleton collections change
procedure TfrmMain.OnSceneCollectionChangeHandler(Sender: TObject);
begin
    frmSceneInspector.UpdateGUI;
    RepaintForms;
end;

// executed when the Scene.SelectedXXX collections change
procedure TfrmMain.OnSceneSelectionChangeHandler(Sender: TObject);
begin
    frmObjectInspector.UpdateGUI;
    frmSkeletonAnimationEditor.UpdateGUI;
    UpdateStatusText;
    ChangeEditModeForSelection;
    RepaintForms;
end;

// scene inspector form event handlers

procedure TfrmMain.OnSelectSceneItemHandler(Sender: TObject);
var primitive: TBasePrimitive;
    skeleton: TSkeleton;
    joint: TJoint;
    animation: TAnimation;
    //counter: integer;
begin
    if Assigned(Sender) then begin

        // we can select primitives, paths, lights, skeletons, joints, animations
        if Sender is TPrimitive then begin
            primitive := TBasePrimitive(Sender);
            if primitive.Visible then
                Scene.SelectedPrimitives.Add(primitive);
        end;

        if Sender is TPath then
        begin
            Scene.SelectedPrimitives.Add(Sender);
        end;

        if Sender is TLight then begin
            Scene.SelectedPrimitives.Add(Sender);
        end;

        // handle the specific selection for skeletons, joints and animations
        if Sender is TSkeleton then begin
            // a skeleton was selected; add it to the selected skeletons collection
            // and remove its selected animation (we'll be working with the baseframe)
            skeleton := TSkeleton(Sender);
            skeleton.SelectedAnimation := nil;
            Scene.SelectedSkeletons.Add(skeleton);
        end;

        if Sender is TJoint then begin
            // a joint was selected; add it to the SelectedJoints collection of the skeleton
            joint := TJoint(Sender);
            skeleton := TSkeleton(joint.Skeleton);
            skeleton.SelectedJoints.Add(joint);
            Scene.SelectedSkeletons.Add(skeleton);

            // remove selected animations that don't use the joint that was just selected
            {counter := 0;
            while counter<Scene.SelectedAnimations.Count do begin
                animation := Scene.SelectedAnimations[counter];
                if TSkeleton(animation.Skeleton) <> skeleton then
                    Scene.SelectedAnimations.Remove(animation)
                else
                    inc(counter);
            end;  }
        end;

        if Sender is TAnimation then begin
            // an animation was selected; add its skeleton to the selected skeletons collection
            // and set the SelectedAnimation property of that skeleton
            // if only one animation is selected, feed it to the Skeleton Animation Editor
            // NOTE: when a skeleton is added to the Scene.SelectedSkeletons collection,
            // the Scene.SelectedAnimations collection (and others) is updated automatically

            animation := TAnimation(Sender);
            skeleton := TSkeleton(animation.Skeleton);
            skeleton.SelectedAnimation := animation;
            Scene.SelectedSkeletons.Add(skeleton);
        end;

        Scene.JointGeometryUpdater.Execute(nil);
    end;
    //frmObjectInspector.UpdateGUI;
    RepaintForms;
end;

// animation editor form event handlers

procedure TfrmMain.OnSelectFrameHandler(Sender: TObject);
begin
    if Assigned(Sender) then begin
        Scene.JointGeometryUpdater.Execute(nil);
        RepaintForms(TRUE);
    end;
end;

// joint selector event handlers

procedure TfrmMain.OnSelectJointHandler(Sender: TObject);
begin
    RepaintForms;
end;

// material form event handlers

procedure TfrmMain.OnSelectMaterialHandler(Sender: TObject);
var material: TMaterial;
begin
    if Assigned(Sender) then begin
        material := TMaterialFrame(Sender).Material;

        case editMode of
            emPolygon,emFace:
                if Scene.SelectedPolygons.Count>0 then begin
                    fParamList.Add(material,'material',true);
                    fParamList.Add(true,'doSelectionOnly');
                    Scene.ToolExecuter.Execute(ptFaceMaterialSetter,taModification,fParamList);
                end;
            emObject:
                if Scene.SelectedPrimitives.Count>0 then begin
                    fParamList.Add(material,'material',true);
                    fParamList.Add(false,'doSelectionOnly');
                    Scene.ToolExecuter.Execute(ptFaceMaterialSetter,taModification,fParamList);
                end;
        end;
        Scene.MaterialManager.SelectedMaterial := material;
    end;
    RepaintForms;
end;

procedure TfrmMain.OnOpenMaterialHandler(Sender: TObject);
begin
    actOpenMaterialEditor.Execute;
end;

procedure TfrmMain.OnHideMaterialHandler(Sender: TObject);
begin
    if Assigned(frmMaterialPicker) then begin
        toggleMaterialPicker := false;
        MaterialPickerItem.Checked := toggleMaterialPicker;
        if frmMaterialPicker.Parent=panDockBottom then begin
            panDockBottom.Height := 2;
            panBottom.Height := panBottom.Height - MATERIALPICKER_DOCKED_HEIGHT;
        end;
    end;
end;

procedure TfrmMain.OnShowMaterialHandler(Sender: TObject);
begin
    if Assigned(frmMaterialPicker) then begin
        toggleMaterialPicker := true;
        MaterialPickerItem.Checked := toggleMaterialPicker;
        if (frmMaterialPicker.Parent=panDockBottom) and (panDockBottom.Height<>MATERIALPICKER_DOCKED_HEIGHT) then begin
            panDockBottom.Height := MATERIALPICKER_DOCKED_HEIGHT;
            if panBottom.Height < MATERIALPICKER_DOCKED_HEIGHT then
                panBottom.Height := panBottom.Height + MATERIALPICKER_DOCKED_HEIGHT;
        end;
    end;
end;

// animation editor event handlers

procedure TfrmMain.OnHideAnimationEditorHandler(Sender: TObject);
begin
    if Assigned(frmSkeletonAnimationEditor) then begin
        toggleAnimation := false;
        SkeletonAnimationEditorItem.Checked := false;
        if frmSkeletonAnimationEditor.Parent=panDockBottom then begin
            panDockBottom.Height := 2;
            panBottom.Height := panBottom.Height - SKELETONANIMATIONEDITOR_DOCKED_HEIGHT;
        end;
    end;
end;

procedure TfrmMain.OnShowAnimationEditorHandler(Sender: TObject);
begin
    if Assigned(frmSkeletonAnimationEditor) then begin
        toggleAnimation := true;
        SkeletonAnimationEditorItem.Checked := toggleAnimation;
        if (frmSkeletonAnimationEditor.Parent=panDockBottom) and (panDockBottom.Height<>SKELETONANIMATIONEDITOR_DOCKED_HEIGHT) then begin
            panDockBottom.Height := SKELETONANIMATIONEDITOR_DOCKED_HEIGHT;
            if panBottom.Height < SKELETONANIMATIONEDITOR_DOCKED_HEIGHT then
                panBottom.Height := panBottom.Height + SKELETONANIMATIONEDITOR_DOCKED_HEIGHT;
        end;
    end;
end;

// object inspector form event handlers

procedure TfrmMain.OnHideObjectInspectorHandler(Sender: TObject);
begin
    if Assigned(Sender) then begin
        toggleObjectInspector := false;
        ObjectInspectorItem.Checked := toggleObjectInspector;
    end;
end;

procedure TfrmMain.OnHideRaytracingHandler(Sender: TObject);
begin
    if Assigned(Sender) then begin
        toggleRaytracing := false;
        RaytracingItem.Checked := toggleRaytracing;
    end;
end;

procedure TfrmMain.OnUndoRedoChangeHandler(Sender: TObject);
begin
    mnuUndo.Enabled := Scene.UndoRedoManagerEx.UndoCount>0;
    tbUndo.Enabled := Scene.UndoRedoManagerEx.UndoCount>0;
    mnuUndo.Caption := Scene.UndoRedoManagerEx.UndoDescription;
    tbUndo.Hint := Scene.UndoRedoManagerEx.UndoDescription;

    mnuRedo.Enabled := Scene.UndoRedoManagerEx.RedoCount>0;
    tbRedo.Enabled := Scene.UndoRedoManagerEx.RedoCount>0;
    mnuRedo.Caption := Scene.UndoRedoManagerEx.RedoDescription;
    tbRedo.Hint := Scene.UndoRedoManagerEx.RedoDescription;
end;

procedure TfrmMain.OnBeforeExecuteHandler(Sender: TObject);
begin

end;

procedure TfrmMain.OnAfterExecuteHandler(Sender: TObject);
begin
    //frmSceneInspector.UpdateGUI;
    //frmObjectInspector.UpdateGUI;
    frmMaterialPicker.UpdateGUI;
    RepaintForms;
end;

procedure TfrmMain.OnLoadPrefabHandler(Sender: TObject);
begin
    frmMaterialPicker.UpdateGUI;
end;

// TODO: should be part of a global Settings object
procedure TfrmMain.ReadINI;    // read INI file and update data+user interface
var iniFile: TIniFile;
begin
  if not FileExistsUTF8(IniFileName) then exit;
  iniFile := TIniFile.Create(IniFileName);
  try
    Top := iniFile.ReadInteger('State','Top',0);
    Left := iniFile.ReadInteger('State','Left',0);
    Width := iniFile.ReadInteger('State','Width',800);
    Height := iniFile.ReadInteger('State','Height',600);
    dir_doc := iniFile.ReadString('Dirs','documentation',ExtractFilePath(Paramstr(0))+'Help');
    if not DirectoryExistsUTF8(dir_doc) then dir_doc := ExtractFilePath(Paramstr(0))+'Help';
    dir_scenes := iniFile.ReadString('Dirs','scenefiles',ExtractFilePath(Paramstr(0))+'Scenes\');
    if not DirectoryExistsUTF8(dir_scenes) then dir_scenes := ExtractFilePath(Paramstr(0))+'Scenes\';
    dir_x := iniFile.ReadString('Dirs','xfiles',ExtractFilePath(Paramstr(0))+'X Files\');
    if not DirectoryExistsUTF8(dir_x) then dir_x := ExtractFilePath(Paramstr(0))+'X Files\';
    dir_AllPrefabs := iniFile.ReadString('Dirs','allPrefabFiles',ExtractFilePath(Paramstr(0))+'Prefabs\');
    if not DirectoryExistsUTF8(dir_AllPrefabs) then dir_AllPrefabs := ExtractFilePath(Paramstr(0))+'Prefabs\';
    dir_CurrentPrefabs := iniFile.ReadString('Dirs','currentPrefabFiles',dir_AllPrefabs);
    dir_texture := iniFile.ReadString('Dirs','texturefiles',ExtractFilePath(Paramstr(0))+'Textures\');
    if not DirectoryExistsUTF8(dir_texture) then dir_texture := ExtractFilePath(Paramstr(0))+'Textures\';
    dir_picture := iniFile.ReadString('Dirs','picturefiles',ExtractFilePath(Paramstr(0))+'Pictures\');
    if not DirectoryExistsUTF8(dir_picture) then dir_picture := ExtractFilePath(Paramstr(0))+'Pictures\';
    dir_plugin := iniFile.ReadString('Dirs','pluginfiles',ExtractFilePath(Paramstr(0))+'Plugins\');
    if not DirectoryExistsUTF8(dir_plugin) then dir_plugin := ExtractFilePath(Paramstr(0))+'Plugins\';
    dir_raytracing := iniFile.ReadString('Dirs', 'raytracingfiles', ExtractFilePath(ParamStr(0)) + 'Raytracing\');
    if not DirectoryExistsUTF8(dir_raytracing) then dir_raytracing := ExtractFilePath(Paramstr(0))+'Raytracing\';
    defaultheight := iniFile.ReadInteger('Options','DefaultHeight',128);
    defaultwidth := iniFile.ReadInteger('Options','DefaultWidth',128);
    defaultdepth := iniFile.ReadInteger('Options','DefaultDepth',128);
    defaultdivx := iniFile.ReadInteger('Options','DefaultDivX',1);
    defaultdivy := iniFile.ReadInteger('Options','DefaultDivY',1);
    defaultdivz := iniFile.ReadInteger('Options','DefaultDivZ',1);
    defaultRectangleDoubleSided := iniFile.ReadBool('Options','DefaultRectangleDoubleSided',false);
    defaultCylinder := iniFile.ReadInteger('Options','DefaultCylinder',16);
    defaultCylinderSegments := iniFile.ReadInteger('Options','DefaultCylinderSegments',1);
    defaultPolyLineType := TPolyLineType(iniFile.ReadInteger('Options','DefaultPolylineType',1));
    defaultEllipse := iniFile.ReadInteger('Options','DefaultEllipse',16);
    defaultSphereSegments := iniFile.ReadInteger('Options','defaultSphereSegments',20);
    defaultGeoSphere := iniFile.ReadInteger('Options','defaultGeoSphere',80);
    defaultLatheSegments := iniFile.ReadInteger('Options','DefaultLatheSegments',24);
    defaultLatheDegrees := iniFile.ReadInteger('Options','DefaultLatheDegrees',360);
    defaultSmoothScheme := iniFile.Readinteger('Options','DefaultSmoothScheme',1);
    defaultTorusSegments := iniFile.ReadInteger('Options','DefaultTorusSegments',16);
    defaultTorusPolygonsPerSegment := iniFile.ReadInteger('Options','DefaultTorusPolygonsPerSegment',16);
    defaultTorusOuterRadius := iniFile.ReadInteger('Options','DefaultTorusOuterRadius',2);
    defaultTorusInnerRadius := iniFile.ReadInteger('Options','DefaultTorusInnerRadius',1);
    defaultpointsize := iniFile.ReadInteger('Options','DefaultPointSize',3);
    defaultmajorgrid := iniFile.ReadInteger('Options','DefaultMajorGrid',128);
    defaultsnapmethod := iniFile.ReadInteger('Options','DefaultSnappingMethod',1);
    defaultSnapContext := TSnapContext(iniFile.ReadInteger('Options','DefaultSnapContext',1));
    defaultdrawMode := iniFile.ReadInteger('Options','DefaultdrawMode',2);
    defaultsubx := iniFile.ReadInteger('Options','DefaultSubX',5);
    defaultsuby := iniFile.ReadInteger('Options','DefaultSubY',5);
    defaultMoveRelative := iniFile.ReadBool('Options','DefaultMoveRelative',true);
    defaultSplitEdge := iniFile.ReadInteger('Options','DefaultSplitEdge',2);
    if defaultSplitEdge<2 then defaultSplitEdge := 2;
    defaultDooSabinRounding := iniFile.ReadInteger('Options','DefaultDooSabinRounding',100);
    defaultWeldDistance := iniFile.ReadFloat('Options','DefaultWeldDistance',40);
    defaultDoTargetWeld := iniFile.ReadBool('Options','DefaultDoTargetWeld',false);
    defaultExtractRemoveOriginalPolygons := iniFile.ReadBool('Options','DefaultExtractRemoveOriginalPolygons',false);
    defaultHollowDepth := iniFile.ReadInteger('Options','DefaultHollowDepth',30);
    defaultHollowPercentage := iniFile.ReadInteger('Options','DefaultHollowPercentage',90);
    defaultMagnetRange := iniFile.ReadInteger('Options','DefaultMagnetRange',100);
    defaultMagnetType := TMagnetType(iniFile.ReadInteger('Options','DefaultMagnetType',0));
    gridSize := iniFile.ReadInteger('Options','gridSize',8);
    defaultUVScale := iniFile.ReadFloat('Options', 'defaultUVScale', 1);
    defaultCTRLIncrements := iniFile.ReadFloat('Options', 'defaultCTRLIncrements', 0.3);
    zoomspeed := iniFile.ReadInteger('Options','zoomspeed',25);
    defaultNumberOfFrames := iniFile.ReadInteger('Options','DefaultNumberOfFrames',30);
    defaultSkeletonAnimationFPS := iniFile.ReadInteger('Options','defaultSkeletonAnimationFPS',30);
    defaultAssignUnassign := iniFile.ReadBool('Options','DefaultAssignUnassign',true);
    defaultSelectAssignedGeometry := iniFile.ReadBool('Options','DefaultSelectAssignedGeometry',true);
    defaultAutoConnectVertices := iniFile.ReadBool('Options','DefaultAutoConnectVertices',true);

    // default Noise Tool parameters
    defaultNoiseToolUsePerlin   := iniFile.ReadBool('Options','defaultNoiseToolUsePerlin',true);
    defaultNoiseToolSeed        := iniFile.ReadInteger('Options','defaultNoiseToolSeed',123);
    defaultNoiseToolMinimum     := iniFile.ReadFloat('Options','defaultNoiseToolMinimum',-20);
    defaultNoiseToolMaximum     := iniFile.ReadFloat('Options','defaultNoiseToolMaximum',30);
    defaultNoiseToolPersistence := iniFile.ReadFloat('Options','defaultNoiseToolPersistence',0.25);
    defaultNoiseToolFrequency   := iniFile.ReadFloat('Options','defaultNoiseToolFrequency',1);
    defaultNoiseToolOctaves     := iniFile.ReadInteger('Options','defaultNoiseToolOctaves',1);

    with CameraOptions do begin
        FOV := iniFile.ReadFloat('Options','cameraFOV', 60);
        NearClippingPlane := iniFile.ReadFloat('Options','cameraNearClippingPlane', 10);
        FarClippingPlane  := iniFile.ReadFloat('Options','cameraFarClippingPlane', 30000);
    end;

    with ControlOptions do begin
        UseWSAD := iniFile.ReadBool('Options','controlsUseWSAD', FALSE);
    end;

    with RenderOptions do begin
        RenderGrid := iniFile.ReadBool('Options','togglegrid',true);
        RenderGizmo := iniFile.ReadBool('Options','toggleGizmo',true);
        RenderPerspectiveGrid := iniFile.ReadBool('Options','toggleGrid3DView',true);
        RenderAxis := iniFile.ReadBool('Options','toggleaxis',true);
        RenderAABB := iniFile.ReadBool('Options','toggleAABB',true);
        RenderCenter := iniFile.ReadBool('Options','toggledrawcenter',false);
        RenderPolygonCenter := iniFile.ReadBool('Options','toggleDrawPolygonCenter',false);
        RenderLights := iniFile.ReadBool('Options','toggleShowLights',true);
        RenderSkeletons := iniFile.ReadBool('Options','toggleShowSkeletons',true);
        PerformCulling := iniFile.ReadBool('Options','toggleculling',true);
        LightingType := TRenderLightingType(iniFile.ReadInteger('Options','lightingType',1));
        GizmoSize := iniFile.ReadInteger('Options','gizmoSize',100);
    end;

    with AnimationOptions do begin
        Loop := iniFile.ReadBool('Options','loopAnimation',false);
    end;

    toggleSnap := iniFile.ReadBool('Options','toggleSnap',true);
    toggleStatusbar := iniFile.ReadBool('Options','togglestatusbar',true);
//    togglepreserveratio := iniFile.ReadBool('Options','togglepreserveratio',false);
    toggleMouse := iniFile.ReadBool('Options','togglemouse',false);
    toggleLightmapUseAmbientColor := iniFile.ReadBool('lightmaps','toggleLightmapUseAmbientColor',true);
    toggleExtrudeKeepOriginal := iniFile.ReadBool('Options','toggleExtrudeKeepOriginal',false);
    toggleExtrudeFlipOriginal := iniFile.ReadBool('Options','toggleExtrudeFlipOriginal',false);
    toggleExtrudeByRegion := iniFile.ReadBool('Options','toggleExtrudeByRegion',true);
    toggleExtrudeDoubleSided := iniFile.ReadBool('Options','toggleExtrudeDoubleSided',false);
    toggleSelection := iniFile.ReadBool('Options','toggleSelection',false);
    toggleLoadLast := iniFile.ReadBool('Options','toggleLoadLast',false);
    toggleCopyToBak := iniFile.ReadBool('Options','toggleCopyToBak',true);

    toggleLightmapGenerateShadows := iniFile.ReadBool('Lightmaps','toggleLightmapGenerateShadows',true);
    toggleLightmapUseNonSelectedObjects := iniFile.ReadBool('Lightmaps','toggleLightmapUseNonSelectedObjects',true);
    lightmapNrBlurFilterPasses := iniFile.ReadInteger('Lightmaps','lightmapNrBlurFilterPasses',0);
    lightmapCreaseAngle := iniFile.ReadInteger('Lightmaps','lightmapCreaseAngle',71);
    lightmapSize := iniFile.ReadInteger('Lightmaps','lightmapSize',512);
    lightmapMinTextureSize := iniFile.ReadInteger('Lightmaps','lightmapMinTextureSize',8);
    lightmapMaxTextureSize := iniFile.ReadInteger('Lightmaps','lightmapMaxTextureSize',128);
    lightmapFileFormat := iniFile.ReadString('Lightmaps','lightmapFileFormat','bmp');
    lightmapCompressionQuality := iniFile.ReadInteger('Lightmaps','lightmapCompressionQuality',75);

    defaultMaterialList := iniFile.ReadString('Options','DefaultMaterialList','default.dml');

    // screenshot settings
    with ScreenshotOptions do begin
        ScreenshotWatermarkOpacity := iniFile.ReadInteger('Screenshots', 'watermarkOpacity', 70);
        ScreenshotWidth := iniFile.ReadInteger('Screenshots', 'width', -1);
        ScreenshotHeight := iniFile.ReadInteger('Screenshots', 'height', -1);
        ScreenshotMaintainAspectRatio := iniFile.ReadBool('Screenshots', 'maintainAspectRatio', TRUE);
        ScreenshotWatermarkColor := iniFile.ReadInteger('Screenshots', 'watermarkColor', $FFFFFF);
        ScreenshotCompressionQuality := iniFile.ReadInteger('Screenshots', 'compressionQuality', 75);
        UseSuperSampling := iniFile.ReadBool('Screenshots','toggleSupersampling',TRUE);
    end;

    // Environment settings
    environmentFogMode := TFogMode(iniFile.ReadInteger('Environment', 'fogMode', Ord(fmExponential)));
    environmentFogDensity := iniFile.ReadFloat('Environment', 'fogDensity', 0.001);
    environmentFogStart := iniFile.ReadFloat('Environment', 'fogStart', 0);
    environmentFogEnd := iniFile.ReadFloat('Environment', 'fogEnd', 3000);
    environmentFogColor := iniFile.ReadInteger('Environment', 'fogColor', $CCCCCC);
    toggleEnvironmentShowFog := iniFile.ReadBool('Environment','toggleShowFog',FALSE);
    toggleEnvironmentShowSkybox := iniFile.ReadBool('Environment','toggleShowSkybox', FALSE);
    environmentSkyboxTextureNames[skyFront] := iniFile.ReadString('Environment','skyboxFront', '');
    environmentSkyboxTextureNames[skyBack] := iniFile.ReadString('Environment','skyboxBack', '');
    environmentSkyboxTextureNames[skyLeft] := iniFile.ReadString('Environment','skyboxLeft', '');
    environmentSkyboxTextureNames[skyRight] := iniFile.ReadString('Environment','skyboxRight', '');
    environmentSkyboxTextureNames[skyUp] := iniFile.ReadString('Environment','skyboxUp', '');
    environmentSkyboxTextureNames[skyDown] := iniFile.ReadString('Environment','skyboxDown', '');

    // Create/Edit form
    topCreateEdit := iniFile.ReadInteger('Options','topCreateEdit',0);
    leftCreateEdit := iniFile.ReadInteger('Options','leftCreateEdit',0);
    heightCreateEdit := iniFile.ReadInteger('Options','heightCreateEdit',750);
    widthCreateEdit := iniFile.ReadInteger('Options','widthCreateEdit',218);
    toggleCreateEdit := iniFile.ReadBool('Options','toggleCreateEdit',true);
    dockCreateEdit := iniFile.ReadString('Options','dockCreateEdit','pcRight');

    // Scene Inspector form
    topSceneInspector := iniFile.ReadInteger('Options','topSceneInspector',0);
    leftSceneInspector := iniFile.ReadInteger('Options','leftSceneInspector',0);
    heightSceneInspector := iniFile.ReadInteger('Options','heightSceneInspector',250);
    widthSceneInspector := iniFile.ReadInteger('Options','widthSceneInspector',200);
    toggleSceneInspector := iniFile.ReadBool('Options','toggleSceneInspector',true);
    dockSceneInspector := iniFile.ReadString('Options','dockSceneInspector','pcLeft');

    // Material Picker form
    topMaterialPicker := iniFile.ReadInteger('Options','topMaterialPicker',0);
    leftMaterialPicker := iniFile.ReadInteger('Options','leftMaterialPicker',0);
    heightMaterialPicker := iniFile.ReadInteger('Options','heightMaterialPicker',400);
    widthMaterialPicker := iniFile.ReadInteger('Options','widthMaterialPicker',200);
    toggleMaterialPicker := iniFile.ReadBool('Options','toggleMaterialPicker',true);
    dockMaterialPicker := iniFile.ReadString('Options','dockMaterialPicker','pcRight');

    // Animation form
    topAnimation := iniFile.ReadInteger('Options','topAnimation',0);
    leftAnimation := iniFile.ReadInteger('Options','leftAnimation',0);
    heightAnimation := iniFile.ReadInteger('Options','heightAnimation',25);
    widthAnimation := iniFile.ReadInteger('Options','widthAnimation',200);
    toggleAnimation := iniFile.ReadBool('Options','toggleAnimation',true);
    dockAnimation := iniFile.ReadString('Options','dockAnimation','panDockBottom');

    // Object Inspector form
    topObjectInspector := iniFile.ReadInteger('Options','topObjectInspector',0);
    leftObjectInspector := iniFile.ReadInteger('Options','leftObjectInspector',0);
    heightObjectInspector := iniFile.ReadInteger('Options','heightObjectInspector',250);
    widthObjectInspector := iniFile.ReadInteger('Options','widthObjectInspector',200);
    toggleObjectInspector := iniFile.ReadBool('Options','toggleObjectInspector',true);
    dockObjectInspector := iniFile.ReadString('Options','dockObjectInspector','pcRight');

    // Raytracing form
    heightRaytracing := iniFile.ReadInteger('Options','topRaytracing',0);
    leftRaytracing := iniFile.ReadInteger('Options','leftRaytracing',0);
    heightRaytracing := iniFile.ReadInteger('Options','heightRaytracing',250);
    widthRaytracing := iniFile.ReadInteger('Options','widthRaytracing',200);
    toggleRaytracing := iniFile.ReadBool('Options','toggleRaytracing',true);
    dockRaytracing := iniFile.ReadString('Options','dockRaytracing','pcRight');

    // recent files
    Recentfiles.Clear;
    Recentfiles.Add(iniFile.ReadString('Files','RecentFile1',''));
    Recentfiles.Add(iniFile.ReadString('Files','RecentFile2',''));
    Recentfiles.Add(iniFile.ReadString('Files','RecentFile3',''));
    Recentfiles.Add(iniFile.ReadString('Files','RecentFile4',''));
    Recentfiles.Add(iniFile.ReadString('Files','RecentFile5',''));

    // material preview
    materialPreviewLUTIndex := iniFile.ReadInteger('MaterialPreview','materialPreviewLUTIndex',1);
    toggleMaterialPreviewShowSpecular := iniFile.ReadBool('MaterialPreview','toggleMaterialPreviewShowSpecular',true);

    // CSG
    CSGOptions.MinAmountOfPolygonsForProgressForm := iniFile.ReadInteger('CSG','CSGMinAmountPolygons',0);
    CSGOptions.KeepOperator := iniFile.ReadBool('CSG','CSGKeepOperator',false);
    CSGOptions.AutoOptimize := iniFile.ReadBool('CSG','CSGAutoOptimize',false);

    // colors
    color_viewportback.r := iniFile.ReadFloat('Colors','viewportbackR',0.8);
    color_viewportback.g := iniFile.ReadFloat('Colors','viewportbackG',0.8);
    color_viewportback.b := iniFile.ReadFloat('Colors','viewportbackB',0.8);
    color_majorgrid.r := iniFile.ReadFloat('Colors','majorgridR',0.7);
    color_majorgrid.g := iniFile.ReadFloat('Colors','majorgridG',0.7);
    color_majorgrid.b := iniFile.ReadFloat('Colors','majorgridB',0.0);
    color_minorgrid.r := iniFile.ReadFloat('Colors','minorgridR',0.7);
    color_minorgrid.g := iniFile.ReadFloat('Colors','minorgridG',0.7);
    color_minorgrid.b := iniFile.ReadFloat('Colors','minorgridB',0.7);
    color_frozenobject.r := iniFile.ReadFloat('Colors','freezedobjectR',0.56);
    color_frozenobject.g := iniFile.ReadFloat('Colors','freezedobjectG',0.66);
    color_frozenobject.b := iniFile.ReadFloat('Colors','freezedobjectB',0.98);
    color_object.r := iniFile.ReadFloat('Colors','objectR',0.5);
    color_object.g := iniFile.ReadFloat('Colors','objectG',0.5);
    color_object.b := iniFile.ReadFloat('Colors','objectB',0.5);

    color_joint.r := iniFile.ReadFloat('Colors','jointR',0.5);
    color_joint.g := iniFile.ReadFloat('Colors','jointG',0.5);
    color_joint.b := iniFile.ReadFloat('Colors','jointB',0.5);
    color_selectedjoint.r := iniFile.ReadFloat('Colors','selectedjointR',1);
    color_selectedjoint.g := iniFile.ReadFloat('Colors','selectedjointG',0.0);
    color_selectedjoint.b := iniFile.ReadFloat('Colors','selectedjointB',0.0);
    color_bone.r := iniFile.ReadFloat('Colors','boneR',0.68);
    color_bone.g := iniFile.ReadFloat('Colors','boneG',0.6);
    color_bone.b := iniFile.ReadFloat('Colors','boneB',0.6);
    color_selectedskeleton.r := iniFile.ReadFloat('Colors','selectedskeletonR',0.65);
    color_selectedskeleton.g := iniFile.ReadFloat('Colors','selectedskeletonG',0.5);
    color_selectedskeleton.b := iniFile.ReadFloat('Colors','selectedskeletonB',0.5);
    color_selectedchilds.r := iniFile.ReadFloat('Colors','selectedchildsR',0.65);
    color_selectedchilds.g := iniFile.ReadFloat('Colors','selectedchildsG',0.3);
    color_selectedchilds.b := iniFile.ReadFloat('Colors','selectedchildsB',0.1);
    color_assignedprimitive.r := iniFile.ReadFloat('Colors','assignedprimitiveR',0.1);
    color_assignedprimitive.g := iniFile.ReadFloat('Colors','assignedprimitiveG',0.1);
    color_assignedprimitive.b := iniFile.ReadFloat('Colors','assignedprimitiveB',0.9);
    color_assignedvertex.r := iniFile.ReadFloat('Colors','assignedvertexR',0.45);
    color_assignedvertex.g := iniFile.ReadFloat('Colors','assignedvertexG',0.45);
    color_assignedvertex.b := iniFile.ReadFloat('Colors','assignedvertexB',1);

    color_light.r := iniFile.ReadFloat('Colors','lightR',0.5);
    color_light.g := iniFile.ReadFloat('Colors','lightG',0.5);
    color_light.b := iniFile.ReadFloat('Colors','lightB',0.5);
    color_selectedobject.r := iniFile.ReadFloat('Colors','selectedobjectR',1.0);
    color_selectedobject.g := iniFile.ReadFloat('Colors','selectedobjectG',0.0);
    color_selectedobject.b := iniFile.ReadFloat('Colors','selectedobjectB',0.0);
    color_selectedpolygon.r := iniFile.ReadFloat('Colors','selectedpolygonR',1.0);
    color_selectedpolygon.g := iniFile.ReadFloat('Colors','selectedpolygonG',1.0);
    color_selectedpolygon.b := iniFile.ReadFloat('Colors','selectedpolygonB',1.0);
    color_edge.r := iniFile.ReadFloat('Colors','edgeeditR',1.0);
    color_edge.g := iniFile.ReadFloat('Colors','edgeeditG',1.0);
    color_edge.b := iniFile.ReadFloat('Colors','edgeeditB',1.0);
    color_edgeselected.r := iniFile.ReadFloat('Colors','edgeselectedR',0.5);
    color_edgeselected.g := iniFile.ReadFloat('Colors','edgeselectedG',1.0);
    color_edgeselected.b := iniFile.ReadFloat('Colors','edgeselectedB',0.5);
    color_vertex.r := iniFile.ReadFloat('Colors','vertexeditR',1.0);
    color_vertex.g := iniFile.ReadFloat('Colors','vertexeditG',1.0);
    color_vertex.b := iniFile.ReadFloat('Colors','vertexeditB',1.0);
    color_vertexselected.r := iniFile.ReadFloat('Colors','vertexselectedR',1.0);
    color_vertexselected.g := iniFile.ReadFloat('Colors','vertexselectedG',1.0);
    color_vertexselected.b := iniFile.ReadFloat('Colors','vertexselectedB',1.0);
    color_vertexhighlighted.r := 1.0;
    color_vertexhighlighted.g := 0.0;
    color_vertexhighlighted.b := 0.0;
    color_objectcenter.r := iniFile.ReadFloat('Colors','objectcenterR',1.0);
    color_objectcenter.g := iniFile.ReadFloat('Colors','objectcenterG',1.0);
    color_objectcenter.b := iniFile.ReadFloat('Colors','objectcenterB',1.0);
    color_polygoncenter.r := iniFile.ReadFloat('Colors','polygoncenterR',1.0);
    color_polygoncenter.g := iniFile.ReadFloat('Colors','polygoncenterG',1.0);
    color_polygoncenter.b := iniFile.ReadFloat('Colors','polygoncenterB',1.0);

    colorTransparencyGrid1 := iniFile.ReadInteger('Colors', 'transparencyGrid1', $FFFFFF);
    colorTransparencyGrid2 := iniFile.ReadInteger('Colors', 'transparencyGrid2', $BBBBBB);
    // newfileformat options

    save_Load_Backgrounds:= iniFile.ReadBool('FileFormatOptions','saveLoadBackgrounds',true);
    save_Load_Cameras := iniFile.ReadBool('FileFormatOptions','saveLoadCameras',true);
  finally
    iniFile.Free;
  end;
end;

procedure TfrmMain.WriteINI;                                                    // update INI file
var iniFile: TIniFile;
begin
  if not FileExistsUTF8(ExtractFilePath(Application.ExeName) + 'DeleD.ini') then exit;
  iniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'DeleD.ini');
  try
    iniFile.WriteInteger('State','Top',Top);
    iniFile.WriteInteger('State','Left',Left);
    iniFile.WriteInteger('State','Width',Width);
    iniFile.WriteInteger('State','Height',Height);
    iniFile.WriteInteger('Options','DefaultHeight',defaultheight);
    iniFile.WriteInteger('Options','DefaultWidth',defaultwidth);
    iniFile.WriteInteger('Options','DefaultDepth',defaultdepth);
    iniFile.WriteInteger('Options','DefaultDivX',defaultdivx);
    iniFile.WriteInteger('Options','DefaultDivY',defaultdivy);
    iniFile.WriteInteger('Options','DefaultDivZ',defaultdivz);
    iniFile.WriteBool('Options','DefaultRectangleDoubleSided',defaultRectangleDoubleSided);
    iniFile.WriteInteger('Options','DefaultCylinder',defaultcylinder);
    iniFile.WriteInteger('Options','DefaultCylinderSegments',defaultcylindersegments);
    iniFile.WriteInteger('Options','DefaultPolylineType',integer(defaultPolyLineType));
    iniFile.WriteInteger('Options','DefaultEllipse',defaultEllipse);
    iniFile.WriteInteger('Options','defaultSphereSegments',defaultSphereSegments);
    iniFile.WriteInteger('Options','DefaultGeoSphere',defaultGeoSphere);
    iniFile.WriteInteger('Options','DefaultLatheSegments',defaultLatheSegments);
    iniFile.WriteInteger('Options','DefaultLatheDegrees',defaultLatheDegrees);
    iniFile.WriteInteger('Options','DefaultSmoothScheme',defaultSmoothScheme);
    iniFile.WriteInteger('Options','DefaultTorusSegments',defaultTorusSegments);
    iniFile.WriteInteger('Options','DefaultTorusPolygonsPerSegment',defaultTorusPolygonsPerSegment);
    iniFile.WriteInteger('Options','DefaultTorusOuterRadius',defaultTorusOuterRadius);
    iniFile.WriteInteger('Options','DefaultTorusInnerRadius',defaultTorusInnerRadius);
    iniFile.WriteInteger('Options','DefaultPointSize',defaultpointsize);
    iniFile.WriteInteger('Options','DefaultMajorGrid',defaultmajorgrid);
    iniFile.WriteInteger('Options','DefaultSnappingMethod',defaultsnapmethod);
    iniFile.WriteInteger('Options','DefaultSnapContext',integer(defaultSnapContext));
    iniFile.WriteInteger('Options','DefaultdrawMode',defaultdrawMode);
    iniFile.WriteInteger('Options','DefaultSubX',defaultsubx);
    iniFile.WriteInteger('Options','DefaultSubY',defaultsuby);
    iniFile.WriteBool('Options','DefaultMoveRelative',defaultMoveRelative);
    iniFile.WriteInteger('Options','DefaultSplitEdge',defaultSplitEdge);
    iniFile.WriteInteger('Options','DefaultDooSabinRounding',defaultDooSabinRounding);
    iniFile.WriteFloat('Options','DefaultWeldDistance',defaultWeldDistance);
    iniFile.WriteBool('Options','DefaultDoTargetWeld',defaultDoTargetWeld);
    iniFile.WriteBool('Options','DefaultExtractRemoveOriginalPolygons',defaultExtractRemoveOriginalPolygons);
    iniFile.WriteInteger('Options','DefaultHollowDepth',defaultHollowDepth);
    iniFile.WriteInteger('Options','DefaultHollowPercentage',defaultHollowPercentage);
    iniFile.WriteInteger('Options','DefaultMagnetRange',defaultMagnetRange);
    iniFile.WriteInteger('Options','DefaultMagnetType',integer(defaultMagnetType));
    iniFile.WriteFloat('Options', 'defaultUVScale', defaultUVScale);
    iniFile.WriteFloat('Options', 'defaultCtrlIncrements', defaultCTRLIncrements);
    iniFile.WriteInteger('Options','gridSize',gridSize);
    iniFile.WriteInteger('Options','zoomspeed',zoomspeed);
    iniFile.WriteInteger('Options','DefaultNumberOfFrames',defaultNumberOfFrames);
    iniFile.WriteInteger('Options','DefaultSkeletonAnimationFPS',defaultSkeletonAnimationFPS);
    iniFile.WriteBool('Options','DefaultAssignUnassign',defaultAssignUnassign);
    iniFile.WriteBool('Options','DefaultSelectAssignedGeometry',defaultSelectAssignedGeometry);
    iniFile.WriteBool('Options','DefaultAutoConnectVertices',defaultAutoConnectVertices);

    // default Noise Tool parameters
    iniFile.WriteBool('Options','defaultNoiseToolUsePerlin',defaultNoiseToolUsePerlin);
    iniFile.WriteInteger('Options','defaultNoiseToolSeed',defaultNoiseToolSeed);
    iniFile.WriteFloat('Options','defaultNoiseToolMinimum',defaultNoiseToolMinimum);
    iniFile.WriteFloat('Options','defaultNoiseToolMaximum',defaultNoiseToolMaximum);
    iniFile.WriteFloat('Options','defaultNoiseToolPersistence',defaultNoiseToolPersistence);
    iniFile.WriteFloat('Options','defaultNoiseToolFrequency',defaultNoiseToolFrequency);
    iniFile.WriteInteger('Options','defaultNoiseToolOctaves',defaultNoiseToolOctaves);

    with CameraOptions do begin
        iniFile.WriteFloat('Options','cameraFOV', FOV);
        iniFile.WriteFloat('Options','cameraNearClippingPlane', NearClippingPlane);
        iniFile.WriteFloat('Options','cameraFarClippingPlane', FarClippingPlane);
    end;

    With ControlOptions do begin
        iniFile.WriteBool('Options','controlsUseWSAD', UseWSAD);
    end;

    with RenderOptions do begin
        iniFile.WriteBool('Options','toggleAABB',RenderAABB);
        iniFile.WriteBool('Options','toggleGrid',RenderGrid);
        iniFile.WriteBool('Options','toggleGizmo',RenderGizmo);
        iniFile.WriteBool('Options','toggleGrid3DView',RenderPerspectiveGrid);
        iniFile.WriteBool('Options','toggleAxis',RenderAxis);
        iniFile.WriteBool('Options','toggleDrawCenter',RenderCenter);
        iniFile.WriteBool('Options','toggleDrawPolygonCenter',RenderPolygonCenter);
        iniFile.WriteBool('Options','toggleShowLights',RenderLights);
        iniFile.WriteBool('Options','toggleShowSkeletons',RenderSkeletons);
        iniFile.WriteBool('Options','toggleCulling',PerformCulling);
        iniFile.WriteInteger('Options','lightingType',Ord(LightingType));
        iniFile.WriteInteger('Options','gizmoSize',GizmoSize);
    end;

    with AnimationOptions do begin
        iniFile.WriteBool('Options','loopAnimation',AnimationOptions.Loop);
    end;

    iniFile.WriteBool('Options','toggleSnap',toggleSnap);
    iniFile.WriteBool('Options','toggleLoadLast',toggleLoadLast);
    iniFile.WriteBool('Options','toggleCopyToBak',toggleCopyToBak);
    iniFile.WriteBool('Options','toggleStatusbar',togglestatusbar);
//    iniFile.WriteBool('Options','togglepreserveratio',togglepreserveratio);
    iniFile.WriteBool('Options','toggleMouse',togglemouse);
    iniFile.WriteBool('Options','toggleExtrudeKeepOriginal',toggleExtrudeKeepOriginal);
    iniFile.WriteBool('Options','toggleExtrudeFlipOriginal',toggleExtrudeFlipOriginal);
    iniFile.WriteBool('Options','toggleExtrudeByRegion',toggleExtrudeByRegion);
    iniFile.WriteBool('Options','toggleExtrudeDoubleSided',toggleExtrudeDoubleSided);
    iniFile.WriteBool('Options','toggleSelection',toggleSelection);

    // Lightmap form
    iniFile.WriteBool('Lightmaps','toggleLightmapUseAmbientColor',toggleLightmapUseAmbientColor);
    iniFile.WriteBool('Lightmaps','toggleLightmapGenerateShadows',toggleLightmapGenerateShadows);
    iniFile.WriteBool('Lightmaps','toggleLightmapUseNonSelectedObjects',toggleLightmapUseNonSelectedObjects);
    iniFile.WriteInteger('Lightmaps','lightmapNrBlurFilterPasses', lightmapNrBlurFilterPasses);
    iniFile.WriteInteger('Lightmaps','lightmapCreaseAngle', lightmapCreaseAngle);
    iniFile.WriteInteger('Lightmaps','lightmapSize',lightmapSize);
    iniFile.WriteInteger('Lightmaps','lightmapMinTextureSize',lightmapMinTextureSize);
    iniFile.WriteInteger('Lightmaps','lightmapMaxTextureSize',lightmapMaxTextureSize);
    iniFile.WriteString('Lightmaps','lightmapFileFormat',lightmapFileFormat);
    iniFile.WriteInteger('Lightmaps','lightmapCompressionQuality',lightmapCompressionQuality);

    iniFile.WriteString('Options','DefaultMaterialList',defaultMaterialList);

    // Create/Edit form
    iniFile.WriteInteger('Options','topCreateEdit',frmCreateEdit.Top);
    iniFile.WriteInteger('Options','leftCreateEdit',frmCreateEdit.Left);
    iniFile.WriteInteger('Options','heightCreateEdit',frmCreateEdit.Height);
    iniFile.WriteInteger('Options','widthCreateEdit',frmCreateEdit.Width);
    iniFile.WriteBool('Options','toggleCreateEdit',toggleCreateEdit);
    if Assigned(frmCreateEdit.Parent) then
        iniFile.WriteString('Options','dockCreateEdit',frmCreateEdit.Parent.Parent.Name)
    else
        iniFile.WriteString('Options','dockCreateEdit','');

    // Scene Inspector form
    iniFile.WriteInteger('Options','topSceneInspector',frmSceneInspector.Top);
    iniFile.WriteInteger('Options','leftSceneInspector',frmSceneInspector.Left);
    iniFile.WriteInteger('Options','heightSceneInspector',frmSceneInspector.Height);
    iniFile.WriteInteger('Options','widthSceneInspector',frmSceneInspector.Width);
    iniFile.WriteBool('Options','toggleSceneInspector',toggleSceneInspector);
    if Assigned(frmSceneInspector.Parent) then
        iniFile.WriteString('Options','dockSceneInspector',frmSceneInspector.Parent.Parent.Name)
    else
        iniFile.WriteString('Options','dockSceneInspector','');

    // Material Picker form
    iniFile.WriteInteger('Options','topMaterialPicker',frmMaterialPicker.Top);
    iniFile.WriteInteger('Options','leftMaterialPicker',frmMaterialPicker.Left);
    iniFile.WriteInteger('Options','heightMaterialPicker',frmMaterialPicker.Height);
    iniFile.WriteInteger('Options','widthMaterialPicker',frmMaterialPicker.Width);
    iniFile.WriteBool('Options','toggleMaterialPicker',toggleMaterialPicker);
    if Assigned(frmMaterialPicker.Parent) then begin
        if frmMaterialPicker.Parent.Name='' then        // parent=tab -> it is docked in a pagecontrol; go 1 step higher to obtain the name of the pagecontrol
            iniFile.WriteString('Options','dockMaterialPicker',frmMaterialPicker.Parent.Parent.Name)
        else
            iniFile.WriteString('Options','dockMaterialPicker',frmMaterialPicker.Parent.Name); // docked in panel, get name
    end else
        iniFile.WriteString('Options','dockMaterialPicker','');

    // Animation form
    iniFile.WriteInteger('Options','topAnimation',frmSkeletonAnimationEditor.Top);
    iniFile.WriteInteger('Options','leftAnimation',frmSkeletonAnimationEditor.Left);
    iniFile.WriteInteger('Options','heightAnimation',frmSkeletonAnimationEditor.Height);
    iniFile.WriteInteger('Options','widthAnimation',frmSkeletonAnimationEditor.Width);
    iniFile.WriteBool('Options','toggleAnimation',toggleAnimation);
    if Assigned(frmSkeletonAnimationEditor.Parent) then
        iniFile.WriteString('Options','dockAnimation',frmSkeletonAnimationEditor.Parent.Name) // docked in panel, get name
    else
        iniFile.WriteString('Options','dockAnimation','');

    // Object Inspector form
    iniFile.WriteInteger('Options','topObjectInspector',frmObjectInspector.Top);
    iniFile.WriteInteger('Options','leftObjectInspector',frmObjectInspector.Left);
    iniFile.WriteInteger('Options','heightObjectInspector',frmObjectInspector.Height);
    iniFile.WriteInteger('Options','widthObjectInspector',frmObjectInspector.Width);
    iniFile.WriteBool('Options','toggleObjectInspector',toggleObjectInspector);
    if Assigned(frmObjectInspector.Parent) then
        iniFile.WriteString('Options','dockObjectInspector',frmObjectInspector.Parent.Parent.Name)
    else
        iniFile.WriteString('Options','dockObjectInspector','');

    // Raytracing form
    iniFile.WriteInteger('Options','topRaytracing',frmRaytracing.Top);
    iniFile.WriteInteger('Options','leftRaytracing',frmRaytracing.Left);
    iniFile.WriteInteger('Options','heightRaytracing',frmRaytracing.Height);
    iniFile.WriteInteger('Options','widthRaytracing',frmRaytracing.Width);
    iniFile.WriteBool('Options','toggleRaytracing',toggleRaytracing);
    if Assigned(frmRaytracing.Parent) then begin
        if frmRaytracing.Parent.Name='' then        // parent=tab -> it is docked in a pagecontrol; go 1 step higher to obtain the name of the pagecontrol
            iniFile.WriteString('Options','dockRaytracing',frmRaytracing.Parent.Parent.Name)
        else
            iniFile.WriteString('Options','dockRaytracing',frmRaytracing.Parent.Name); // docked in panel, get name
    end else
        iniFile.WriteString('Options','dockRaytracing','');

    // CSG
    iniFile.WriteInteger('CSG','CSGMinAmountPolygons',CSGOptions.MinAmountOfPolygonsForProgressForm);
    iniFile.WriteBool('CSG','CSGKeepOperator',CSGOptions.KeepOperator);
    iniFile.WriteBool('CSG','CSGAutoOptimize',CSGOptions.AutoOptimize);

    // recent files
    iniFile.WriteString('Files','RecentFile1',Recentfiles.Strings[0]);
    iniFile.WriteString('Files','RecentFile2',Recentfiles.Strings[1]);
    iniFile.WriteString('Files','RecentFile3',Recentfiles.Strings[2]);
    iniFile.WriteString('Files','RecentFile4',Recentfiles.Strings[3]);
    iniFile.WriteString('Files','RecentFile5',Recentfiles.Strings[4]);

    // screenshot settings
    with ScreenshotOptions do begin
        iniFile.WriteInteger('Screenshots', 'width', screenshotWidth);
        iniFile.WriteInteger('Screenshots', 'height', screenshotHeight);
        iniFile.WriteBool('Screenshots', 'maintainAspectRatio', screenshotMaintainAspectRatio);
        iniFile.WriteInteger('Screenshots', 'watermarkColor', screenshotWatermarkColor);
        iniFile.WriteInteger('Screenshots', 'watermarkOpacity', screenshotWatermarkOpacity);
        iniFile.WriteInteger('Screenshots', 'compressionQuality', screenshotCompressionQuality);
        iniFile.WriteBool('Screenshots', 'toggleSupersampling', UseSupersampling);
    end;

    // Environment settings
    iniFile.WriteInteger('Environment', 'fogMode', Ord(environmentFogMode));
    iniFile.WriteFloat('Environment', 'fogDensity', environmentFogDensity);
    iniFile.WriteFloat('Environment', 'fogStart', environmentFogStart);
    iniFile.WriteFloat('Environment', 'fogEnd', environmentFogEnd);
    iniFile.WriteInteger('Environment', 'fogColor', environmentFogColor);
    iniFile.WriteBool('Environment', 'toggleShowFog',toggleEnvironmentShowFog);
    iniFile.WriteBool('Environment','toggleShowSkybox', toggleEnvironmentShowSkybox);
    iniFile.WriteString('Environment','skyboxFront', environmentSkyboxTextureNames[skyFront]);
    iniFile.WriteString('Environment','skyboxBack', environmentSkyboxTextureNames[skyBack]);
    iniFile.WriteString('Environment','skyboxLeft', environmentSkyboxTextureNames[skyLeft]);
    iniFile.WriteString('Environment','skyboxRight', environmentSkyboxTextureNames[skyRight]);
    iniFile.WriteString('Environment','skyboxUp', environmentSkyboxTextureNames[skyUp]);
    iniFile.WriteString('Environment','skyboxDown', environmentSkyboxTextureNames[skyDown]);

    // colors
    iniFile.WriteFloat('Colors','viewportbackR',color_viewportback.r);
    iniFile.WriteFloat('Colors','viewportbackG',color_viewportback.g);
    iniFile.WriteFloat('Colors','viewportbackB',color_viewportback.b);
    iniFile.WriteFloat('Colors','majorgridR',color_majorgrid.r);
    iniFile.WriteFloat('Colors','majorgridG',color_majorgrid.g);
    iniFile.WriteFloat('Colors','majorgridB',color_majorgrid.b);
    iniFile.WriteFloat('Colors','minorgridR',color_minorgrid.r);
    iniFile.WriteFloat('Colors','minorgridG',color_minorgrid.g);
    iniFile.WriteFloat('Colors','minorgridB',color_minorgrid.b);
    iniFile.WriteFloat('Colors','objectR',color_object.r);
    iniFile.WriteFloat('Colors','objectG',color_object.g);
    iniFile.WriteFloat('Colors','objectB',color_object.b);

    iniFile.WriteFloat('Colors','jointR',color_joint.r);
    iniFile.WriteFloat('Colors','jointG',color_joint.g);
    iniFile.WriteFloat('Colors','jointB',color_joint.b);
    iniFile.WriteFloat('Colors','selectedjointR',color_selectedjoint.r);
    iniFile.WriteFloat('Colors','selectedjointG',color_selectedjoint.g);
    iniFile.WriteFloat('Colors','selectedjointB',color_selectedjoint.b);
    iniFile.WriteFloat('Colors','boneR',color_bone.r);
    iniFile.WriteFloat('Colors','boneG',color_bone.g);
    iniFile.WriteFloat('Colors','boneB',color_bone.b);
    iniFile.WriteFloat('Colors','selectedskeletonR',color_selectedskeleton.r);
    iniFile.WriteFloat('Colors','selectedskeletonG',color_selectedskeleton.g);
    iniFile.WriteFloat('Colors','selectedskeletonB',color_selectedskeleton.b);
    iniFile.WriteFloat('Colors','selectedchildsR',color_selectedchilds.r);
    iniFile.WriteFloat('Colors','selectedchildsG',color_selectedchilds.g);
    iniFile.WriteFloat('Colors','selectedchildsB',color_selectedchilds.b);
    iniFile.WriteFloat('Colors','assignedprimitiveR',color_assignedprimitive.r);
    iniFile.WriteFloat('Colors','assignedprimitiveG',color_assignedprimitive.g);
    iniFile.WriteFloat('Colors','assignedprimitiveB',color_assignedprimitive.b);
    iniFile.WriteFloat('Colors','assignedvertexR',color_assignedvertex.r);
    iniFile.WriteFloat('Colors','assignedvertexG',color_assignedvertex.g);
    iniFile.WriteFloat('Colors','assignedvertexB',color_assignedvertex.b);
    
    iniFile.WriteFloat('Colors','lightR',color_light.r);
    iniFile.WriteFloat('Colors','lightG',color_light.g);
    iniFile.WriteFloat('Colors','lightB',color_light.b);
    iniFile.WriteFloat('Colors','selectedobjectR',color_selectedobject.r);
    iniFile.WriteFloat('Colors','selectedobjectG',color_selectedobject.g);
    iniFile.WriteFloat('Colors','selectedobjectB',color_selectedobject.b);
    iniFile.WriteFloat('Colors','freezedobjectR',color_frozenobject.r);
    iniFile.WriteFloat('Colors','freezedobjectG',color_frozenobject.g);
    iniFile.WriteFloat('Colors','freezedobjectB',color_frozenobject.b);
    iniFile.WriteFloat('Colors','selectedpolygonR',color_selectedpolygon.r);
    iniFile.WriteFloat('Colors','selectedpolygonG',color_selectedpolygon.g);
    iniFile.WriteFloat('Colors','selectedpolygonB',color_selectedpolygon.b);
    iniFile.WriteFloat('Colors','edgeeditR',color_edge.r);
    iniFile.WriteFloat('Colors','edgeeditG',color_edge.g);
    iniFile.WriteFloat('Colors','edgeeditB',color_edge.b);
    iniFile.WriteFloat('Colors','edgeselectedR',color_edgeselected.r);
    iniFile.WriteFloat('Colors','edgeselectedG',color_edgeselected.g);
    iniFile.WriteFloat('Colors','edgeselectedB',color_edgeselected.b);
    iniFile.WriteFloat('Colors','vertexeditR',color_vertex.r);
    iniFile.WriteFloat('Colors','vertexeditG',color_vertex.g);
    iniFile.WriteFloat('Colors','vertexeditB',color_vertex.b);
    iniFile.WriteFloat('Colors','vertexselectedR',color_vertexselected.r);
    iniFile.WriteFloat('Colors','vertexselectedG',color_vertexselected.g);
    iniFile.WriteFloat('Colors','vertexselectedB',color_vertexselected.b);
    iniFile.WriteFloat('Colors','objectcenterR',color_objectcenter.r);
    iniFile.WriteFloat('Colors','objectcenterG',color_objectcenter.g);
    iniFile.WriteFloat('Colors','objectcenterB',color_objectcenter.b);
    iniFile.WriteFloat('Colors','polygoncenterR',color_polygoncenter.r);
    iniFile.WriteFloat('Colors','polygoncenterG',color_polygoncenter.g);
    iniFile.WriteFloat('Colors','polygoncenterB',color_polygoncenter.b);

    iniFile.WriteString('Dirs','documentation',dir_doc);
    iniFile.WriteString('Dirs','scenefiles',dir_scenes);
    iniFile.WriteString('Dirs','xfiles',dir_x);
    iniFile.WriteString('Dirs','allPrefabFiles',dir_AllPrefabs);
    iniFile.WriteString('Dirs','currentPrefabFiles',dir_CurrentPrefabs);
    iniFile.WriteString('Dirs','texturefiles',dir_texture);
    iniFile.WriteString('Dirs','picturefiles',dir_picture);
    iniFile.WriteString('Dirs','pluginfiles',dir_plugin);
    iniFile.WriteString('Dirs','raytracingfiles',dir_raytracing);
    iniFile.WriteInteger('MaterialPreview','materialPreviewLUTIndex',materialPreviewLUTIndex);
    iniFile.WriteBool('MaterialPreview','toggleMaterialPreviewShowSpecular',toggleMaterialPreviewShowSpecular);

    iniFile.WriteInteger('Colors', 'transparencyGrid1', colorTransparencyGrid1);
    iniFile.WriteInteger('Colors', 'transparencyGrid2', colorTransparencyGrid2);

    // newfileformat options

    iniFile.WriteBool('FileFormatOptions','saveLoadBackgrounds', save_Load_Backgrounds);
    iniFile.WriteBool('FileFormatOptions','saveLoadCameras',save_Load_Cameras);
  finally
    iniFile.Free;
  end;
end;

function TfrmMain.GetComponent(AParent: TComponent; AControlName: string): TComponent;
var i: integer;
begin
// {$O-}
    Result := nil;
    for i := 0 to AParent.ComponentCount - 1 do begin
        if AParent.Components[i].Name = AControlName then begin
            Result := AParent.Components[i];
            Break;
        end
        else if ControlExists(AParent.Components[i],AControlName) then begin
           Result := AParent.Components[i];
           Break;
        end else
           Result := nil;
    end;
end;

// searches for a control within a control
function TfrmMain.ControlExists(AParent: TComponent; AControl: string): boolean;
var i: integer;
begin
// {$O-}
    Result := false;
    for i := 0 to AParent.ComponentCount - 1 do begin
        if AParent.Components[i].Name = AControl then begin
            Result := true;
            Break;
        end
        else if ControlExists(AParent.Components[i],AControl) then begin
           Result := true;
           Break;
        end else
           Result := false;
    end;
end;

procedure TfrmMain.DockForm(AForm: TForm; ADockSite: string);
begin
    if ControlExists(self,ADockSite) and Assigned(AForm) then
        AForm.ManualDock(TWinControl(GetComponent(self,ADockSite)),nil,alClient);
end;

// docks Create/Edit, Materials, Scene, Object forms if needed
// TODO: make sure they're docking in the exact same order as they were when
// the user closed DeleD
procedure TfrmMain.DockForms;
begin
    if Trim(dockCreateEdit)<>'' then begin
        DockForm(frmCreateEdit,dockCreateEdit);
        frmCreateEdit.ReloadPrefabGUI;
    end;

    if Trim(dockSceneInspector)<>'' then
        DockForm(frmSceneInspector,dockSceneInspector);

    if Trim(dockAnimation)<>'' then
        DockForm(frmSkeletonAnimationEditor,dockAnimation);

    if Trim(dockMaterialPicker)<>'' then begin
        // only dock materialpicker if its docking station differs from
        // the docking station of the animation form
        if Trim(dockMaterialPicker)<> Trim(dockAnimation) then
            DockForm(frmMaterialPicker,dockMaterialPicker);
    end;

    if Trim(dockObjectInspector)<>'' then
        DockForm(frmObjectInspector,dockObjectInspector);

    if Trim(dockRaytracing)<>'' then
        DockForm(frmRaytracing,dockRaytracing);
end;

procedure TfrmMain.RepaintForms(AImmediatePaint: boolean);
begin
    ViewPortManager.Draw(AImmediatePaint);
end;

procedure TfrmMain.LoadDefaultMaterialList;
var dmlReader: TDMLReader;
begin
    // bit of a hack, to improve status feedback on splash screen
    if not fHasDisplayedLoadingMaterialsMessage then begin
        SetSplashScreenStatus( 'Loading default materials...' );
        fHasDisplayedLoadingMaterialsMessage := TRUE;
    end;

    // load default materials and upload them to 3D view (via Scene object which uses local MaterialManager object)
    dmlReader := TDMLReader.Create;
    try
        dmlReader.Load(dir_texture+defaultMaterialList,Scene,nil);
    finally
        FreeAndNil(dmlReader);
    end;
end;

procedure TfrmMain.SetDefaultMaterials;
begin
    Scene.MaterialManager.SelectedMaterial := Scene.MaterialManager.Materials[0];

    frmMaterialPicker.UpdateGUI;        // do this FIRST, so the material picker can determine the FRAME of the selected material
    frmMaterialPicker.SelectedMaterial := Scene.MaterialManager.Materials[0];
end;

// clears the entire scene (primitives, materials etc) and resets the GUI
procedure TfrmMain.ResetScene;
begin
    Scene.Clear;
    UpdateCaption;
    ViewPortManager.ResetCamera;
    SetEditMode(ecScene,emObject);
    frmCreateEdit.EditTool := etMove;
    SetDrawMode(TDrawMode(defaultdrawMode));
    SetPrimitive(otCube);
    //frmSceneInspector.UpdateGUI;
    fPrimitiveClipBoard.Clear;
    fSkeletonClipBoard.Clear;
    fAnimationFrameClipBoard.Clear;
    RepaintForms;
end;

procedure TfrmMain.UpdateRecentFileMenu;
var i: integer;
begin
    for i := 0 to Recentfiles.Count - 1 do begin
        MainMenu1.Items[0].Items[i+8].Visible := Recentfiles.Strings[i]<>'';
        MainMenu1.Items[0].Items[i+8].Caption := '&' + IntToStr(i+1) + ' ' + Recentfiles.Strings[i];
    end;
end;

function TfrmMain.GenerateBackupFileName(AFileName: string): string;
var extension: string;
begin
    extension := ExtractFileExt(AFileName);
    extension := '.~'+RightStr(extension,Length(extension)-1);
    Result := ChangeFileExt(AFileName,extension);
end;

function TfrmMain.SaveFile: integer;
begin
    Result := mrNo;
    if Scene.HasChanged then begin
        Result := MessageDlg('Do you want to save your scene?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
        if Result = mrYes then
            actSave.Execute;
    end;
end;

procedure TfrmMain.OpenFile(AFileName: string; AShouldMerge: boolean);
var fileExtension: string;
    dmfSceneReader: TDMFSceneReader;
    xmlSceneReader: TXMLSceneReader;
begin
    try
        fileExtension := UpperCase(ExtractFileExt(AFilename));

        if (fileExtension<>'.DXS') and (fileExtension<>'.DMF') then
            raise Exception.Create('Wrong fileformat.');

        if not FileExistsUTF8(AFileName) then
            raise Exception.Create('File not found.');

        Scene.ClearCollectionHandlers;

        if not AShouldMerge then
            ResetScene;

        if fileExtension='.DXS' then begin
            xmlSceneReader := TXMLSceneReader.Create;
            try
                xmlSceneReader.ShouldShowProgress := true;
                // xmlSceneReader.ReadFromFile(AFilename, Scene);  *************HERE*************HERE*************HERE*************HERE*************HERE
                xmlSceneReader.ReadFromFile(AFilename, Scene,viewportmanager);
            finally
                FreeAndNil(xmlSceneReader);
            end;
        end else begin
            dmfSceneReader := TDMFSceneReader.Create;
            try
                dmfSceneReader.ReadFromFile(AFilename, Scene);
            finally
                FreeAndNil(dmfSceneReader);
            end;
        end;

        Scene.SetCollectionHandlers;

        if Scene.MaterialManager.Count=0 then   // no materials available, load default materials
            LoadDefaultMaterialList;

        SetDefaultMaterials;

        if not AShouldMerge then begin
            Scene.FileName := AFilename;
            Scene.HasChanged := FALSE;
            Recentfiles.AddRecentFile(AFileName);
        end;

        UpdateRecentFileMenu;
        UpdateCaption;
        frmSceneInspector.UpdateGUI;

        // Quickly add all skeletons to the collection of selected skeletons
        // and update their geometry. This is used to reflect the JointSize
        // specified by the Skeletons.
        Scene.SelectedSkeletons.AddList(Scene.Skeletons);
        Scene.JointGeometryUpdater.Execute(nil);
        Scene.SelectedSkeletons.Clear;

        RepaintForms;
    except
        on E: Exception do begin
            ResetScene;
            LoadDefaultMaterialList;
            SetDefaultMaterials;
            MessageDlg(Format( 'An error occured while loading "%s". %s', [AFilename, e.Message]), mtError, [mbOK],0);
        end;
    end;
end;

procedure TfrmMain.SetDimension(AnEditDimension: TEditDimension);
begin
    if AnEditDimension=editDimension then
        editDimension := edAll
    else
        editDimension := AnEditDimension;
    case editDimension of
        edX:    tbX.Down := true;
        edY:    tbY.Down := true;
        edZ:    tbZ.Down := true;
        else    begin
                    tbX.Down := false;
                    tbY.Down := false;
                    tbZ.Down := false;
                end;
    end;
end;

procedure TfrmMain.SetUVDimension(const anEditUVDimension: TEditUVDimension);
begin
    if editUVDimension = anEditUVDimension then
        editUVDimension := edBoth
    else
        editUVDimension := anEditUVDimension;
    tbU.Down := (editUVDimension = edU);
    tbV.Down := (editUVDimension = edV);
end;

procedure TfrmMain.SetDrawMode(ADrawMode: TDrawMode; ADoAllPerspectiveViews: boolean = false);
begin
    if ADoAllPerspectiveViews then
        ViewPortManager.SetPerspectiveDrawModes(ADrawMode)
    else begin
        if ViewPortManager.ActiveViewPort is Tfrm3d then
            Tfrm3d(ViewPortManager.ActiveViewPort).DrawMode := ADrawMode;
    end;

    case ADrawMode of
        dmWireframe:
            begin
                WireframeItem.Checked := true;
                SolidItem.Checked := false;
                TexturedItem.Checked := false;
                LightmappedItem.Checked := false;
            end;
        dmSolid:
            begin
                WireframeItem.Checked := false;
                SolidItem.Checked := true;
                TexturedItem.Checked := false;
                LightmappedItem.Checked := false;
            end;
        dmTextured:
            begin
                WireframeItem.Checked := false;
                SolidItem.Checked := false;
                TexturedItem.Checked := true;
                LightmappedItem.Checked := false;
            end;
        dmLightMapped:
            begin
                WireframeItem.Checked := false;
                SolidItem.Checked := false;
                TexturedItem.Checked := false;
                LightmappedItem.Checked := true;
            end;
    end;
    RepaintForms;
end;

// this procedure is executed when the frmCreateEdit form sends the OnSelectEditCommandHandler
// event; it sets the global editTool variable, updates the Main Form GUI and in some cases,
// executes the actual command itself too; this way of doing things needs to be improved...
procedure TfrmMain.SetAction(AnEditTool: TEditTool; ASetting: integer = -1);
begin
    editTool := AnEditTool;

    case AnEditTool of
        etMerge:
            begin
                case editMode of
                    emPolygon: actPolygonMerge.Execute;
                    emObject:  actObjectsMerge.Execute;
                end;
            end;

        etDeleteItems:
            actDeleteItems.Execute;

        etDeleteNonSelected:
            actDeleteNonSelected.Execute;

        etDeletesystempolygons:
            actPolygonDeleteSystemPolygons.Execute;


        etSplit:
            begin
                if editMode = emSkeleton then
                    actJointSplit.Execute;
            end;

        etFlip:
            begin
                if editMode = emSkeleton then
                    actJointFlip.Execute;
            end;

        {
        ecGroup:
            actObjectsGroup.Execute;

        ecObjectsUngroup:
            actObjectsUngroup.Execute;       }

        etTurn:
            actEdgeTurn.Execute;

        etConnect:
            actConnect.Execute;

        etAverage:
            actAverage.Execute;

        etFill:
            actFill.Execute;

        etOptimize:
            actObjectsOptimize.Execute;

        etFlatten:
            actPolygonFlatten.Execute;

        etAssign:
            begin
                // provide the selected joints to the JointGeometrySelecting tool


            end;
    end;
end;

procedure TfrmMain.SetEditMode(AnEditContext: TEditContext; AEditMode: TEditMode; AUpdateGUI: boolean = true);
var suggestedEditMode: TEditMode;
begin
    // the UndoRedoManagerEx is not available for background images
    //Scene.UndoRedoManagerEx.Enabled := AnEditContext<>ecBackground;

    // TODO: handle going to and from skeleton- or animation mode here. Need to reset certain collections here...
    if (AEditMode = emSkeleton) {and (AEditMode <> editMode)} then
        Scene.SelectedPrimitives.Clear()
    else
        Scene.SelectedSkeletons.Clear;

    // select items based on new editmode; e.g going from edge to vertex mode:
    // if edges were selected, now select the vertices of those edges
    if AEditMode<>editMode then begin
        //Scene.JointSelector.Clear;
        Scene.PrimitiveSelector.SelectByEditMode(editMode,AEditMode,toggleSelection);
    end;

    // if we had stuff selected for assigning geometry to skeletons, clear it here
    // because if we don't and the selected geometry is altered (e.g deleted) we
    // get AV's all over the place 
    Scene.JointGeometrySelector.Clear;

    // we might want autoSelect to be a property...
    autoSelect := Scene.HasSelection;
    userSelect := not autoSelect;

    // set new values
    editContext := AnEditContext;
    editMode := AEditMode;

    // if editmode does not support editcontext, pick one that does
    if not (AnEditContext in ALLOWED_EDIT_CONTEXTS[editMode]) then begin
        for suggestedEditMode := Low(TEditMode) to High(TEditMode) do begin
            if AnEditContext in ALLOWED_EDIT_CONTEXTS[suggestedEditMode] then begin
                editMode := suggestedEditMode;
                break;
            end;
        end;
    end;

    // update Create/Edit userinterface
    if Assigned(frmCreateEdit) and (AUpdateGUI) then begin
        frmCreateEdit.EditMode := editMode;
        frmCreateEdit.EditContext := editContext;
        frmCreateEdit.EditTool := editTool;
    end;

    // update menu
    UpdateMenuBasedOnEditMode;

    // update Object Inspector
    frmObjectInspector.UpdateGUI;
end;

procedure TfrmMain.SetPrimitive(AObjectType: TObjectType);
begin
    Scene.PrimitiveSelector.DeselectAll;

    if (AObjectType<>otAnimation) and (AObjectType<>otJoint) then
        Scene.SelectedSkeletons.Clear;

    defaultPrimitive := AObjectType;

    case AObjectType of
        otJoint:
            begin
                SetEditMode(ecScene,emSkeleton);
                editTool := etCreateJoint;
            end;
        otAnimation:
            begin
                SetEditMode(ecScene,emSkeleton);
            end;
        else begin
                SetEditMode(ecScene,emObject);
            end;
    end;
end;

procedure TfrmMain.AddView(AView: TViewMode);
begin
    if toggleLockViews then
        MessageDlg('Cannot add view when views are locked.',mtWarning,[mbOK],0)
    else begin
        case AView of
            vmPerspective:              // perspective views get different parameters when added
                ViewPortManager.AddViewPort(vmPerspective,Scene,RenderOptions,CameraOptions,ControlOptions);

            else
                ViewPortManager.AddViewPort(AView,Scene,RenderOptions);
        end;
    end;
end;

// invoked via TfrmViewPortForm popupmenu and the toolbar
procedure TfrmMain.ChangeActiveView(AView: TViewMode);
begin
    if toggleLockViews then
        MessageDlg('Cannot change views when views are locked.',mtWarning,[mbOK],0)
    else begin
        case TViewMode(AView) of
            vmPerspective:
                ViewPortManager.ChangeActiveViewPort(vmPerspective,Scene,RenderOptions,CameraOptions,ControlOptions);

            else
                ViewPortManager.ChangeActiveViewPort(AView,Scene,RenderOptions);
        end;
    end;
end;

procedure TfrmMain.RemoveActiveView;
begin
    if toggleLockViews then
        MessageDlg('Cannot remove view when views are locked.',mtWarning,[mbOK],0)
    else
        ViewPortManager.RemoveActiveViewPort;
end;

procedure TfrmMain.ctlBar_ToolbarsGetSiteInfo(Sender: TObject; DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
begin
    CanDock := DockClient is TToolbar;
end;

// If application is in error state, any of these form globals might not be set yet.
// A good example of this would be an error message because of wrong directory settings
procedure TfrmMain.OnIdleHandler(Sender: TObject; var Done: Boolean); // AppEventsActivate(Sender: TObject);
var i: integer;
    frmOGL: TOGLForm;
begin
    if InitialShowToolWin then
    begin
        // set Create/Edit visibility
        if Assigned(frmCreateEdit) then begin
            frmCreateEdit.Visible := toggleCreateEdit;
            CreateEditWindowItem.Checked := toggleCreateEdit;
        end;

        // set scene inspector visibility
        if Assigned(frmSceneInspector) then begin
            frmSceneInspector.Visible := toggleSceneInspector;
            SceneInspectorItem.Checked := toggleSceneInspector;
        end;

        // set materials visibility
        if Assigned(frmMaterialPicker) then begin
            frmMaterialPicker.Visible := toggleMaterialPicker;   // does not generate Hide event if set to false
            if not toggleMaterialPicker then
                frmMaterialPicker.OnHide(nil);
            MaterialPickerItem.Checked := toggleMaterialPicker;
        end;

        // set animation visibility
        if Assigned(frmSkeletonAnimationEditor) then begin
            frmSkeletonAnimationEditor.Visible := toggleAnimation;
            if not toggleAnimation then
                frmSkeletonAnimationEditor.OnHide(nil);
            SkeletonAnimationEditorItem.Checked := toggleAnimation;
        end;

        // set object inspector visibility
        if Assigned(frmObjectInspector) then begin
            frmObjectInspector.Visible := toggleObjectInspector;
            ObjectInspectorItem.Checked := toggleObjectInspector;
        end;

        // set raytracing form visibility;
        if Assigned(frmRaytracing) then begin
            frmRaytracing.Visible := toggleRaytracing;
            raytracingItem.Checked := toggleRaytracing;
        end;

        // tile forms on onload if needed
        if not ViewPortManager.LoadedFromIniFile then
            ViewPortManager.Tile;

        // do all this only once at startup
        InitialShowToolWin := false;
    end;
    //RepaintForms;

    // Originally from AppEventsIdle
    Done := true;
    RepaintForms(TRUE);
    for i := 0 to MDIChildCount-1 do begin
        frmOGL := TOGLForm(MDIChildren[i]);
        if frmOGL.DoPaint then
            frmOGL.glDraw;
    end;
    if Assigned(frmCreateEdit) then
        frmCreateEdit.UpdatePrefabGUI;
end;

procedure TfrmMain.PluginInformationItemClick(Sender: TObject);
var frmPlugins: TfrmPlugins;
begin
    frmPlugins := TfrmPlugins.Create(nil, PluginManager);
    try
        frmPlugins.ShowModal;
    finally
        frmPlugins.Release;
    end;
end;

procedure TfrmMain.DownloadMoreItemClick(Sender: TObject);
begin
    ShellExecute(0,nil,'http://www.delgine.com/plugins/viewPluginCategories.php',nil,nil,SW_ShowDefault);
end;

// TODO: move code to better place
procedure TfrmMain.mnuSetKeyFrameClick(Sender: TObject);
var selectedAnimation: TAnimation;
    selectedAnimationFrame: TAnimationFrame;
begin
    if Scene.SelectedAnimations.Count=1 then begin
        selectedAnimation := Scene.SelectedAnimations[0];
        selectedAnimationFrame := selectedAnimation.SelectedFrame;
        selectedAnimationFrame.IsKeyFrame := true;
        selectedAnimation.HasChanged := true;
        Scene.JointGeometryUpdater.Execute(nil);
    end;
end;

procedure TfrmMain.mnuCutKeyFrameClick(Sender: TObject);
begin
    frmSkeletonAnimationEditor.UpdateGUI;
end;

procedure TfrmMain.mnuCopyKeyFrameClick(Sender: TObject);
begin
    fAnimationFrameClipBoard.Animation := nil;
    if Scene.SelectedAnimations.Count=1 then begin
        fAnimationFrameClipBoard.Animation := Scene.SelectedAnimations[0];
        fAnimationFrameClipBoard.Copy;
    end;
end;

procedure TfrmMain.mnuPasteKeyFrameBeforeClick(Sender: TObject);
begin
    fAnimationFrameClipBoard.PasteBefore;
    frmSkeletonAnimationEditor.UpdateGUI;
    Scene.JointGeometryUpdater.Execute(nil);
end;

procedure TfrmMain.mnuPasteKeyFrameAfterClick(Sender: TObject);
begin
    fAnimationFrameClipBoard.PasteAfter;
    frmSkeletonAnimationEditor.UpdateGUI;
    Scene.JointGeometryUpdater.Execute(nil);
end;

// TODO: move code to better place
procedure TfrmMain.mnuResetKeyFrameClick(Sender: TObject);
var selectedAnimation: TAnimation;
    selectedAnimationFrame: TAnimationFrame;
begin
    if Scene.SelectedAnimations.Count=1 then begin
        selectedAnimation := Scene.SelectedAnimations[0];
        selectedAnimationFrame := selectedAnimation.SelectedFrame;
        if not selectedAnimationFrame.IsKeyFrame then
            MessageDlg('This is not a keyframe.',mtInformation,[mbOK],0)
        else begin
            selectedAnimationFrame.IsKeyFrame := false;
            selectedAnimation.HasChanged := true;
            Scene.JointGeometryUpdater.Execute(nil);
        end;
    end;
end;

procedure TfrmMain.mnuInsertframesClick(Sender: TObject);
var frmInsertFrames: TfrmInsertFrames;
begin
    frmInsertFrames := TfrmInsertFrames.Create(Scene);
    try
        frmInsertFrames.ShowModal;
        // force an update of the SAE
        frmSkeletonAnimationEditor.UpdateGUI(true);
    finally
        frmInsertFrames.Release;
    end;
end;

procedure TfrmMain.mnuDeleteFramesClick(Sender: TObject);
var frmDeleteFrames: TfrmDeleteFrames;
begin
    frmDeleteFrames := TfrmDeleteFrames.Create(Scene);
    try
        frmDeleteFrames.ShowModal;
        // force an update of the SAE
        frmSkeletonAnimationEditor.UpdateGUI(true);
    finally
        frmDeleteFrames.Release;
    end;
end;

procedure TfrmMain.mnuLightmapSelectionClick(Sender: TObject);
var lightMapper: TLightMapper;
begin
    if Scene.SelectedPrimitives.Count>0 then begin
        try
            lightMapper := TLightMapper.Create(Scene, true);
            lightMapper.Process;
        finally
            FreeAndNil(lightMapper);
        end;
        SetDrawMode(dmLightMapped);
    end;
end;

procedure TfrmMain.mnuLightmapSceneClick(Sender: TObject);
var lightMapper: TLightMapper;
begin
    if Scene.Primitives.Count>0 then begin
        lightMapper := TLightMapper.Create(Scene, false);
        try
            lightMapper.Process;
        finally
            FreeAndNil(lightMapper);
        end;
        SetDrawMode(dmLightMapped);
    end;
end;

procedure TfrmMain.mnuRemoveLightmapsClick(Sender: TObject);
var lightMapper: TLightMapper;
begin
    if MessageDlg('This will remove all lightmaps from the scene and delete the ' +
        'corresponding files from disk. Are you sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
        lightMapper := TLightMapper.Create(Scene, true);
        try
            lightMapper.RemoveLightmaps;
        finally
            FreeAndNil(lightMapper);
        end;
        SetDrawMode(dmTextured);
    end;
end;

procedure TfrmMain.UpdateCaption;
begin
  Caption := 'DeleD ' + _versionstring + ' - ' + Scene.filename;
end;

// called when activating an MDI child (2D/3D/UV views)
procedure TfrmMain.UpdateEditContext;
var viewPort: TfrmViewport;
    viewMode: TViewMode;
begin
    viewPort := ViewPortManager.ActiveViewPort;
    if Assigned(viewPort) then begin
        viewMode := viewPort.ViewMode;
        // UV viewports might be initialized at startup when other windows
        // (like the Object Inspector) might not exist yet; we cannot change
        // editmodes in those cases, hence the use of "onload" here
        if not InitialShowToolWin then begin
            if viewMode = vmUV then begin
                if (editContext <> ecUV) then       // if we're in an UV view, we need
                    SetEditMode(ecUV, editMode);    // to have a simular edit context
            end
            else if (editContext = ecUV) then       // if we're not in an UV view, we
                SetEditMode(ecScene, editMode);     // set the edit context accordingly
        end;
    end;
end;

procedure TfrmMain.UpdateViewToolbar;
var viewPort: TfrmViewPort;
    viewMode: TViewMode;
begin
    viewPort := ViewPortManager.ActiveViewPort;
    if Assigned(viewPort) then begin
        viewMode := viewPort.ViewMode;

        tbPerspectiveView.Down := (viewMode = vmPerspective);
        tbTopView.Down := (viewMode = vmTop);
        tbFrontView.Down := (viewMode = vmFront);
        tbSideView.Down := (viewMode = vmSide);
        tbUVEditor.Down := (viewMode = vmUV);

        tbPerspectiveView.Enabled := tbPerspectiveView.Down or viewPort.SupportsViewMode(vmPerspective);
        tbTopView.Enabled := tbTopView.Down or viewPort.SupportsViewMode(vmTop);
        tbFrontView.Enabled := tbFrontView.Down or viewPort.SupportsViewMode(vmFront);
        tbSideView.Enabled := tbSideView.Down or viewPort.SupportsViewMode(vmSide);
        tbUVEditor.Enabled := tbUVEditor.Down or viewPort.SupportsViewMode(vmUV);
    end
    else begin
        tbPerspectiveView.Down := false;
        tbTopView.Down := false;
        tbFrontView.Down := false;
        tbSideView.Down := false;
        tbUVEditor.Down := false;

        tbPerspectiveView.Enabled := false;
        tbTopView.Enabled := false;
        tbFrontView.Enabled := false;
        tbSideView.Enabled := false;
        tbUVEditor.Enabled := false;
    end;

    // Synch toolbar buttons and actions (hotkeys). PJ: Why doesn't disabling the action not disable the menu item?
    actChangeToTopView.Enabled := tbTopView.Enabled;
    actChangeToFrontView.Enabled := tbFrontView.Enabled;
    actChangeToSideView.Enabled := tbSideView.Enabled;
    actChangeToPerspectiveView.Enabled := tbPerspectiveView.Enabled;
    actChangeToUVView.Enabled := tbUVEditor.Enabled;
end;

// TODO: we should think about using the statusbar to explain each (geometry) command in some short terms
procedure TfrmMain.UpdateStatusText;
begin
    if Scene.SelectedPrimitives.Count=0 then
        stbMain.Panels.Items[stbMain.Panels.Count-1].Text := 'Use SHIFT(+CTRL)+leftmouse to select (multiple) items in any view.'
    else begin
        if ViewPortManager.ActiveViewPort is TfrmFlatViewPort then
            stbMain.Panels.Items[stbMain.Panels.Count-1].Text := 'Rightmouse=move camera   SHIFT+rightmouse=zooming.'
        else
            stbMain.Panels.Items[stbMain.Panels.Count-1].Text := 'Rightmouse=rotate camera   SHIFT+rightmouse=zoom camera   CTRL+rightmouse=move camera   CTRL+ALT+rightmouse=rotate world';
    end;
end;

procedure TfrmMain.UpdateMenuBasedOnEditMode;
var canEdit: boolean;
begin
    // set menu items
    canEdit := (editMode in [emObject,emSkeleton]) and (editContext = ecScene);               // set to false by default (only set to true if mode is emObject)
    mnuCut.Enabled := canEdit;
    mnuCopy.Enabled := canEdit;
    mnuPaste.Enabled := canEdit;
    tbCut.Enabled := canEdit;
    tbCopy.Enabled := canEdit;
    tbPaste.Enabled := canEdit;
    actClone.Enabled := canEdit;
    tbMaterialReplace.Enabled := ((editMode = emPolygon) or (editMode = emFace)) and (editContext = ecScene);
    mnuSelectPolygonsByMaterial.Enabled := ((editMode = emPolygon) or (editMode = emFace)) and (editContext = ecScene);
    mnuGrowSelection.Enabled := ((editMode = emVertex) or (editMode = emEdge) or (editMode = emPolygon)) and (editContext = ecScene);
    mnuShrinkSelection.Enabled := ((editMode = emVertex) or (editMode = emEdge) or (editMode = emPolygon)) and (editContext = ecScene);
    mnuSelectEdgeLoop.Enabled := (editMode = emEdge) and (editContext = ecScene);
    mnuSelectEdgeRing.Enabled := (editMode = emEdge) and (editContext = ecScene);
    mnuLightmapSelection.Enabled := (editContext = ecScene);
    mnuSelectAll.Enabled := (editContext <> ecBackground);
    mnuDeselectAll.Enabled := (editContext <> ecBackground);
    mnuAnimation.Enabled := (editMode = emSkeleton);
end;

procedure TfrmMain.ChangeEditModeForSelection;
begin
    // if we select an animation, we would like the Skeleton mode to be automatically selected if no primitives were selected
    // if we select primitives, we want the Object mode to be automatically selected if no skeletons were selected

    // does not work yet because SetEditMode clears SelectedXXX collections too which causes
    // this method (via events) to be called over and over again
    {if (Scene.SelectedPrimitives.Count>0) and (Scene.SelectedSkeletons.Count=0) and (editMode=emSkeleton) then
        SetEditMode(ecScene,emObject);

    if (Scene.SelectedPrimitives.Count=0) and (Scene.SelectedSkeletons.Count>0) and (editMode<>emSkeleton) then
        SetEditMode(ecScene,emSkeleton);}
end;

procedure TfrmMain.actToggleSkyBoxExecute(Sender: TObject);
begin
    toggleEnvironmentShowSkyBox := not toggleEnvironmentShowSkyBox;
    RepaintForms;
end;

procedure TfrmMain.actToggleFogExecute(Sender: TObject);
begin
    toggleEnvironmentShowFog := not toggleEnvironmentShowFog;
    RepaintForms;
end;

function GetStartVertex(vertex: TVertice; polygon: TPolygon): TVertice;
var i: integer;
    vector,startVertex: TVertice;
    length,distance: double;
begin
    // Return the vertex of "polygon" that has the shortest distance to "vertex".
    distance := 999999999;
    startVertex := nil;
    for i := 0 to polygon.NumVertices-1 do begin
        vector := vectorSub(vertex,polygon.VerticeList[i]);
        length := vector.Length;
        if length < distance then begin
            distance := length;
            startVertex := polygon.VerticeList[i];
        end;
        FreeAndNil(vector);
    end;
    result := startVertex;
end;

(*
procedure TfrmMain.Test1;
var
  primitive: TBasePrimitive;
  polygon1,polygon2,newPolygon: TPolygon;
  vertices: TVerticeList;
  i,index: integer;
  outerStartVertex, outerCurrentVertex: TVertice;
  innerStartVertex, innerCurrentVertex, innerNextVertex: TVertice;
  hasSameOrientation, continue: boolean;
begin
    primitive := Scene.Primitives[0];
    polygon1 := primitive.SelectedPolygons[0];
    polygon2 := primitive.SelectedPolygons[1];

    outerStartVertex := polygon1.VerticeList[0];

    innerStartVertex := GetStartVertex(outerStartVertex, polygon2);
    index := polygon2.VerticeList.IndexOf(innerStartVertex);
    innerCurrentVertex := innerStartVertex;

    continue := true;
    for i := 0 to polygon1.NumVertices-1 do begin
        hasSameOrientation := true;
        outerCurrentVertex := polygon1.VerticeList[i];

        while (hasSameOrientation) and (continue) do begin
            innerNextVertex := polygon2.VerticeList[(index+1) mod polygon2.VerticeList.Count];

            vertices := TVerticeList.Create(false,true);
            vertices.Add(innerNextVertex);
            vertices.Add(innerCurrentVertex);
            vertices.Add(outerCurrentVertex);

            hasSameOrientation := vertices.Normal.Equals(polygon1.Normal);
            if hasSameOrientation then begin
                newPolygon := TPolygon.Create;
                primitive.Polygon_AddVertex(newPolygon,innerNextVertex);
                primitive.Polygon_AddVertex(newPolygon,innerCurrentVertex);
                primitive.Polygon_AddVertex(newPolygon,outerCurrentVertex);

                newPolygon.Material := polygon1.Material;
                primitive.Polygon_Add(newPolygon);

                innerCurrentVertex := innerNextVertex;
                continue := innerCurrentVertex <> innerStartVertex;
                index := index + 1;
            end;

            FreeAndNil(vertices);
        end;

        newPolygon := TPolygon.Create;
        primitive.Polygon_AddVertex(newPolygon,polygon1.VerticeList[(i+1) mod polygon1.VerticeList.Count]);
        primitive.Polygon_AddVertex(newPolygon,innerCurrentVertex);
        primitive.Polygon_AddVertex(newPolygon,outerCurrentVertex);
        newPolygon.Material := polygon1.Material;
        primitive.Polygon_Add(newPolygon);

    end;

    primitive.SelectedPolygons.Clear;
    primitive.Polygon_Remove(polygon1);
end;  *)
(*
procedure TfrmMain.Test2;
var
  primitive,primitive2: TBasePrimitive;
  polygon,polygon2: TPolygon;
  center1, center2, vectorA, vectorB: TVertice;
  axis,vertex,polygon2InverseNormal: TVertice;
  angle,x,y,z: double;
  matrix: TMatrix;
  i: integer;
begin
    primitive := Scene.Primitives[0];
    polygon := primitive.Polygons[0];
    center1 := polygon.Center.Copy;

    primitive2 := Scene.Primitives[1];
    polygon2 := primitive2.Polygons[0];
    center2 := polygon2.Center.Copy;

    vectorA := vectorSub(polygon.Center,polygon.VerticeList[0]);
    vectorA.Normalize;
    vectorB := crossproduct(polygon.Normal, vectorA);
    vectorB.Normalize;

    for i := 0 to polygon.VerticeList.Count-1 do
        polygon.VerticeList[i].Subtract(center1);

    for i := 0 to polygon2.VerticeList.Count-1 do
        polygon2.VerticeList[i].Subtract(center2);




    matrix := TMatrix.Create(3,3);
    matrix.Cell[0,0] := polygon.Normal.x;
    matrix.Cell[1,0] := vectorA.x;
    matrix.Cell[2,0] := vectorB.x;

    matrix.Cell[0,1] := polygon.Normal.y;
    matrix.Cell[1,1] := vectorA.y;
    matrix.Cell[2,1] := vectorB.y;

    matrix.Cell[0,2] := polygon.Normal.z;
    matrix.Cell[1,2] := vectorA.z;
    matrix.Cell[2,2] := vectorB.z;

    for i := 0 to polygon2.VerticeList.Count-1 do begin
        vertex := polygon2.VerticeList[i];
        x := (vertex.x*matrix[0,0])+(vertex.y*matrix[0,1])+(vertex.z*matrix[0,2]);
        y := (vertex.x*matrix[1,0])+(vertex.y*matrix[1,1])+(vertex.z*matrix[1,2]);
        z := (vertex.x*matrix[2,0])+(vertex.y*matrix[2,1])+(vertex.z*matrix[2,2]);
        vertex.x := x;
        vertex.y := y;
        vertex.z := z;
    end;
    FreeAndNil(matrix);
    FreeAndNil(vectorA);
    FreeAndNil(vectorB);

    {
    polygon2InverseNormal := polygon.Normal.Copy;

    angle := vectorAngle(polygon2.Normal,polygon2InverseNormal);
    while (angle>1) and (angle<179.9999) do begin
        axis := crossproduct(polygon2InverseNormal,polygon2.Normal);
        matrix := MatrixArbAxisSetup(axis,polygon2.Center,angle);

        for i := 0 to polygon.VerticeList.Count-1 do begin
            vertex := polygon.VerticeList[i];
            ///vertex.x := vertex.x-center1.x;
            //vertex.y := vertex.y-center1.y;
            //vertex.z := vertex.z-center1.z;
            x := (vertex.x*matrix[0,0])+(vertex.y*matrix[0,1])+(vertex.z*matrix[0,2]);//+matrix[3,0];
            y := (vertex.x*matrix[1,0])+(vertex.y*matrix[1,1])+(vertex.z*matrix[1,2]);//+matrix[3,1];
            z := (vertex.x*matrix[2,0])+(vertex.y*matrix[2,1])+(vertex.z*matrix[2,2]);//+matrix[3,2];
            vertex.x := x;
            vertex.y := y;
            vertex.z := z;
        end;
        FreeAndNil(axis);
        FreeAndNil(matrix);
        FreeAndNil(polygon2InverseNormal);
        polygon2InverseNormal := polygon.Normal.Copy;
        angle := vectorAngle(polygon2.Normal,polygon2InverseNormal);
    end;
    FreeAndNil(polygon2InverseNormal);    }

    for i := 0 to polygon.VerticeList.Count-1 do
        polygon.VerticeList[i].Add(center1);

    for i := 0 to polygon2.VerticeList.Count-1 do
        polygon2.VerticeList[i].Add(center2);

    FreeAndNil(center1);
    FreeAndNil(center2);
end; *)
    {

procedure TfrmMain.Test2;
var
  primitive: TBasePrimitive;
  polygon,targetPolygon: TPolygon;
  center, first, second, last, n, u, v, vertice: TVertice; // Orthonormal Base
  i: Integer;
  matrix: TMatrix;
  x,y,z,dot: double;
begin
    primitive := Scene.Primitives[0];
    polygon := primitive.Polygons[0];

    primitive := Scene.Primitives[1];
    targetPolygon := primitive.Polygons[0];

    center := polygon.Center;
    for i := 0 to polygon.VerticeList.Count-1 do
        polygon.VerticeList[i].Subtract(center);

    center := targetPolygon.Center;
    for i := 0 to polygon.VerticeList.Count-1 do
        targetPolygon.VerticeList[i].Subtract(center);

    first := targetPolygon.VerticeList[0];
    second := targetPolygon.VerticeList[1];
    last := targetPolygon.VerticeList[targetPolygon.NumVertices-1];

    n := vectorSub(second,first);
    n.Normalize;

    v := vectorSub(last,first);
    dot := dotproduct(V,N);
    v.x := v.x - (dot * N.x);
    v.y := v.y - (dot * N.y);
    v.z := v.z - (dot * N.z);
    v.Normalize;

    u := crossproduct(v,n);

    matrix := TMatrix.Create(3,3);
    matrix.Cell[0,0] := n.x;
    matrix.Cell[1,0] := n.y;
    matrix.Cell[2,0] := n.z;

    matrix.Cell[0,1] := u.x;
    matrix.Cell[1,1] := u.y;
    matrix.Cell[2,1] := u.z;

    matrix.Cell[0,2] := v.x;
    matrix.Cell[1,2] := v.y;
    matrix.Cell[2,2] := v.z;

    for i := 0 to polygon.VerticeList.Count-1 do begin
        vertice := polygon.VerticeList[i];
        x := (vertice.x*matrix[0,0])+(vertice.y*matrix[0,1])+(vertice.z*matrix[0,2]);
        y := (vertice.x*matrix[1,0])+(vertice.y*matrix[1,1])+(vertice.z*matrix[1,2]);
        z := (vertice.x*matrix[2,0])+(vertice.y*matrix[2,1])+(vertice.z*matrix[2,2]);
        vertice.x := x;
        vertice.y := y;
        vertice.z := z;
    end;
    FreeAndNil(matrix);
    FreeAndNil(n);
    FreeAndNil(u);
    FreeAndNil(v);
end;   }

procedure TfrmMain.Test2;
var
  primitive: TBasePrimitive;
  polygon,targetPolygon: TPolygon;
  i: Integer;
  matrix: TMatrix;
  axis,vertice,center: TVertice;
  angle: Extended;
  x,y,z: Extended;
begin
    primitive := Scene.Primitives[0];
    polygon := primitive.Polygons[0];

    primitive := Scene.Primitives[1];
    targetPolygon := primitive.Polygons[0];

    center := polygon.Center;
    for i := 0 to polygon.VerticeList.Count-1 do
        polygon.VerticeList[i].Subtract(center);

    center := targetPolygon.Center;
    for i := 0 to targetPolygon.VerticeList.Count-1 do
        targetPolygon.VerticeList[i].Subtract(center);
{
    center := polygon.Center;
    for i := 0 to polygon.VerticeList.Count-1 do
        polygon.VerticeList[i].Subtract(center);

    center := targetPolygon.Center;
    for i := 0 to polygon.VerticeList.Count-1 do
        targetPolygon.VerticeList[i].Subtract(center);  }

    axis := crossproduct(polygon.Normal, targetPolygon.Normal);
    angle := dotproduct(polygon.Normal, targetPolygon.Normal);
    angle := arccos(angle)*(180/pi);
    matrix := MatrixArbAxisSetup(axis, targetPolygon.Center, angle);

    for i := 0 to polygon.VerticeList.Count-1 do begin
        vertice := polygon.VerticeList[i];
        x := (vertice.x*matrix[0,0])+(vertice.y*matrix[0,1])+(vertice.z*matrix[0,2]);
        y := (vertice.x*matrix[1,0])+(vertice.y*matrix[1,1])+(vertice.z*matrix[1,2]);
        z := (vertice.x*matrix[2,0])+(vertice.y*matrix[2,1])+(vertice.z*matrix[2,2]);
        vertice.x := x;
        vertice.y := y;
        vertice.z := z;
    end;
    FreeAndNil(matrix);
    FreeAndNil(axis);

end;

procedure TfrmMain.mnuTestClick(Sender: TObject);
begin
    Test2;
    RepaintForms;
end;

procedure TfrmMain.pcLeftGetSiteInfo(Sender: TObject; DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
var i: integer;
begin
    CanDock := (DockClient is TfrmDockable) or
               (DockClient is TfrmSceneInspector) or
               (DockClient is TfrmInspector) or
               (DockClient is TfrmMaterials);

    if CanDock then begin       // check if similar form already is docked
        with Sender as TPageControl do begin
            for i := 0 to PageCount-1 do begin
                if Pages[i].ContainsControl(DockClient) then begin
                    CanDock := false;
                    exit;
                end;
            end;
        end;
    end;
end;

procedure TfrmMain.pcLeftDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
begin
    with Sender as TPageControl do begin
        if DockClientCount > 0 then
            Width := 218;
    end;
end;

// using the UnDock event: do NOT set the MinWidth property of controls that are docked
// as that will overrule setting the width of the docksite (!) here

// tabbed forms that are being hiden do not fire an OnHide event of their own;
// instead, the resize event of the pagecontrol is triggered; thus, a check
// to see if we need to hide the pagecontrol completely is done right here
procedure TfrmMain.pcLeftResize(Sender: TObject);
var i: integer;
    mustHide: boolean;
begin
    with Sender as TPageControl do begin

        mustHide := true;
        for i := 0 to DockClientCount-1 do begin
            if DockClients[i].Visible then begin
                mustHide := false;
                break;
            end;
        end;

        {
        //if DockClientCount > 0 then begin
            if PageCount >= 1 then begin
                for i := 0 to PageCount-1 do begin
                    if Pages[i].TabVisible then begin
                        mustHide := false;
                        break;
                    end;
                end;
            end;
        //end;}

        if mustHide then
            Width := 1
        else
            Width := 218;
    end;
end;

procedure TfrmMain.panDockBottomGetSiteInfo(Sender: TObject; DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
begin
    CanDock := ((DockClient is TfrmMaterials) or (DockClient is TfrmSkeletonAnimationEditor)) and (panDockBottom.DockClientCount=0);
end;

procedure TfrmMain.panDockBottomDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
var name: string;
    height: integer;
begin
    if panDockBottom.DockClientCount = 1 then begin
        name := Source.Control.Name;
        if name = 'frmSkeletonAnimationEditor' then
            height := SKELETONANIMATIONEDITOR_DOCKED_HEIGHT
        else
            height := SKELETONANIMATIONEDITOR_DOCKED_HEIGHT;

        panDockBottom.Height := height;
        if panBottom.Height < height then
            panBottom.Height := panBottom.Height + height;
    end;

    {
    if panDockBottom.DockClientCount = 1 then begin
        panDockBottom.Height := 142;
        if panBottom.Height < 142 then
            panBottom.Height := panBottom.Height + 142;
    end;
    }
end;

procedure TfrmMain.panDockBottomUnDock(Sender: TObject; Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
begin
    if panDockBottom.VisibleDockClientCount = 1 then begin
        panBottom.Height := panBottom.Height - panDockBottom.Height;
        panDockBottom.Height := 2;
    end;
    {
    if panDockBottom.VisibleDockClientCount = 1 then begin
        panDockBottom.Height := 2;
        panBottom.Height := panBottom.Height - 142;
    end;
    }
end;

procedure TfrmMain.actChangeToTopViewExecute(Sender: TObject);
begin
    ChangeActiveView(vmTop);
end;

procedure TfrmMain.actChangeToFrontViewExecute(Sender: TObject);
begin
    ChangeActiveView(vmFront);
end;

procedure TfrmMain.actChangeToSideViewExecute(Sender: TObject);
begin
    ChangeActiveView(vmSide);
end;

procedure TfrmMain.actChangeToPerspectiveViewExecute(Sender: TObject);
begin
    ChangeActiveView(vmPerspective);
end;

procedure TfrmMain.actChangeToUVViewExecute(Sender: TObject);
begin
    ChangeActiveView(vmUV);
end;

procedure TfrmMain.actSnapSceneExecute(Sender: TObject);
begin
    if MessageDlg('Vertex snap will be used for all objects. Are you sure you want to snap the entire scene to the current grid?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
        fParamList.Add(gridSize,'snapValue',true);
        fParamList.Add(integer(editMode),'editMode');
        fParamList.Add(true,'doAllPrimitives');
        Scene.ToolExecuter.Execute(ptPrimitiveSnapper,taModification, fParamList);
    end;
end;

procedure TfrmMain.actSnapSelectionExecute(Sender: TObject);
begin
    fParamList.Add(gridSize,'snapValue',true);
    fParamList.Add(integer(editMode),'editMode');
    fParamList.Add(false,'doAllPrimitives');
    Scene.ToolExecuter.Execute(ptPrimitiveSnapper,taModification, fParamList);
end;

function TfrmMain.IsShortCut(var aMessage: TWMKey): boolean;
begin
  if ((Screen.ActiveControl is TValueListEditor) or (Screen.ActiveControl is TEdit)) and
     ((GetKeyState(VK_CONTROL) and 128 = 0) and (GetKeyState(VK_MENU) and 128 = 0)) then begin
     result := false;
  end
//!!!  else
//!!!      result := inherited IsShortCut( aMessage )
end;

procedure TfrmMain.actToggleRaytracingExecute(Sender: TObject);
begin
    toggleRaytracing := not toggleRaytracing;
    frmRaytracing.Visible := toggleRaytracing;
    RaytracingItem.Checked := toggleRaytracing;
    RepaintForms;
end;

procedure TfrmMain.RaytracingItemClick(Sender: TObject);
begin
    actToggleRaytracing.Execute;
end;

procedure TfrmMain.actAverageExecute(Sender: TObject);
begin
    if editContext = ecUV then
        Scene.ToolExecuter.Execute(ptFaceAverager,taModification, nil);
    frmObjectInspector.UpdateGUI;
end;

procedure TfrmMain.ScriptingIDEItemClick(Sender: TObject);
begin
    if fScriptingIDE = nil then
        fScriptingIDE := TfrmScriptMain.Create(nil);
    fScriptingIDE.ShowModal;
end;

procedure TfrmMain.OrthographicDistanceShadingItemClick(Sender: TObject);
begin
  if (OrthographicDistanceShadingItem.Checked)
  then OrthographicDistanceShadingItem.Checked := false
  else OrthographicDistanceShadingItem.Checked := true;
  toggleOrthographicDistanceShading := OrthographicDistanceShadingItem.Checked;
end;

end.

