{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
{$WARN UNIT_PLATFORM OFF}    // for FileCtrl: for Windows platform only

unit frmOptionsForm;

{$MODE Delphi}

interface

uses
  Windows, LCLType, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, MaskEdit, FileCtrl, FileUtil,
  unit_Enums,
  unit_Variables,
  unit_Options,
  unit_Functions,
  unit_Scene,
  unit_ViewPortManager,
  unit_ColorDialog,
  unit_Types,
  unit_TrackBarControl,
  unit_RaytracingThread;

type
  TfrmOptions = class(TForm)
    panBottom: TPanel;
    Image1: TImage;
    btnOK: TButton;
    btnApply: TButton;
    panTop: TPanel;
    lblTitle: TLabel;
    Image2: TImage;
    pcOptions: TPageControl;
    tsDefaults: TTabSheet;
    GroupBox8: TGroupBox;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    edFOV: TEdit;
    edNearClippingPlane: TEdit;
    edFarClippingPlane: TEdit;
    GroupBox1: TGroupBox;
    lblDefaultSM: TLabel;
    lblDefaultML: TLabel;
    Label23: TLabel;
    chkSnapObjects: TCheckBox;
    cboSnappingMethod: TComboBox;
    cboDefaultML: TComboBox;
    edUVScale: TEdit;
    GroupBox7: TGroupBox;
    Label31: TLabel;
    chkMaterialPreviewShowSpecular: TCheckBox;
    pnlPreviewImage: TPanel;
    GroupBox3: TGroupBox;
    Label21: TLabel;
    chkLoadLast: TCheckBox;
    cboDrawmode: TComboBox;
    GroupBox4: TGroupBox;
    Label17: TLabel;
    Label9: TLabel;
    Label19: TLabel;
    Label12: TLabel;
    chkDrawGrid: TCheckBox;
    chkDoCulling: TCheckBox;
    chkLockViews: TCheckBox;
    edZoomSpeed: TEdit;
    udZoomSpeed: TUpDown;
    edPointSize: TEdit;
    udPointSize: TUpDown;
    chkAABB: TCheckBox;
    chkInvertMouse: TCheckBox;
    chkDrawCenter: TCheckBox;
    chkDrawAxis: TCheckBox;
    chkLights: TCheckBox;
    chkDrawPolygonCenter: TCheckBox;
    chkDrawGrid3DView: TCheckBox;
    edMajorGridSize: TEdit;
    udMajorGridSize: TUpDown;
    edMinorGridSize: TEdit;
    udMinorGridSize: TUpDown;
    tsColors: TTabSheet;
    gbColorsPreview: TGroupBox;
    pnlPreviewColors: TPanel;
    shView_1: TShape;
    Shape3: TShape;
    shObjectGeometry: TShape;
    shObjectSelection: TShape;
    shPolygonSelection: TShape;
    lblMajorGrid: TLabel;
    lblMinorGrid: TLabel;
    lblObject: TLabel;
    lblSelectObject: TLabel;
    lblPolygon: TLabel;
    shMajorGrid4: TShape;
    shMajorGrid3: TShape;
    shMajorGrid2: TShape;
    shMajorGrid1: TShape;
    shMajorGrid5: TShape;
    Shape10: TShape;
    shEdge1: TShape;
    lblEdge: TLabel;
    shEdge2: TShape;
    shEdge3: TShape;
    Shape16: TShape;
    shVertex1: TShape;
    shVertex2: TShape;
    shVertex4: TShape;
    shVertex3: TShape;
    lblVertex: TLabel;
    lblSelectedVertex: TLabel;
    lblSelectedEdge: TLabel;
    shCenter1: TShape;
    lblCenter: TLabel;
    shPolygonCenter1: TShape;
    lblpolygoncenter: TLabel;
    shMajorGrid6: TShape;
    shObjectFrozen: TShape;
    lblFrozenObject: TLabel;
    GroupBox2: TGroupBox;
    lblBackground: TLabel;
    shView_0: TShape;
    lblMajorGridUI: TLabel;
    shMajor: TShape;
    lblMinorGridUI: TLabel;
    shMinor: TShape;
    lblObjectUI: TLabel;
    shObject: TShape;
    lblSelectedObjectUI: TLabel;
    shSelection: TShape;
    lblSelectedPolygonUI: TLabel;
    shPolygon: TShape;
    lblEdgeGripUI: TLabel;
    shEdge: TShape;
    lblVertexUI: TLabel;
    shVertex: TShape;
    shSelectedVertex: TShape;
    lblSelectedVertexGripUI: TLabel;
    lblSelectedEdgeGripUI: TLabel;
    shSelectedEdge: TShape;
    shCenter: TShape;
    lblObjectCenterUI: TLabel;
    lblPolygonCenterUI: TLabel;
    shPolygonCenter: TShape;
    lblFreezedObjectUI: TLabel;
    shFrozen: TShape;
    btnResetColors: TButton;
    GroupBox9: TGroupBox;
    imgTransparencyGrid: TImage;
    imgGridColor1: TImage;
    imgGridColor2: TImage;
    Label36: TLabel;
    cbTransparencyGridColors: TComboBox;
    tsLightMaps: TTabSheet;
    GroupBox6: TGroupBox;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label32: TLabel;
    chkUseNonSelectedObjects: TCheckBox;
    chkGenerateShadows: TCheckBox;
    cboLightmapSize: TComboBox;
    cboMinTextureSize: TComboBox;
    cboMaxTextureSize: TComboBox;
    edNumBlurFilterPasses: TEdit;
    udNumBlurFilterPasses: TUpDown;
    chkUseAmbientColor: TCheckBox;
    edCreaseAngle: TEdit;
    udCreaseAngle: TUpDown;
    tsCSG: TTabSheet;
    GroupBox11: TGroupBox;
    Label37: TLabel;
    edNumPolygonsCSGProgress: TEdit;
    tsEnviroment: TTabSheet;
    GroupBox5: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    Label20: TLabel;
    Label11: TLabel;
    Label22: TLabel;
    Label26: TLabel;
    edMapDir: TEdit;
    edPrefabDir: TEdit;
    edTextureDir: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    edXFileDir: TEdit;
    Button4: TButton;
    edPictureDir: TEdit;
    Button5: TButton;
    edPluginDir: TEdit;
    Button6: TButton;
    GroupBox12: TGroupBox;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    chkShowSkybox: TCheckBox;
    edSkyboxFront: TEdit;
    btnSkyboxFrontBrowse: TButton;
    edSkyboxBack: TEdit;
    btnSkyboxBackBrowse: TButton;
    edSkyboxLeft: TEdit;
    btnSkyboxLeftBrowse: TButton;
    edSkyboxRight: TEdit;
    btnSkyboxRightBrowse: TButton;
    edSkyboxUp: TEdit;
    btnSkyboxUpBrowse: TButton;
    edSkyboxDown: TEdit;
    btnSkyboxDownBrowse: TButton;
    GroupBox10: TGroupBox;
    Label38: TLabel;
    cboFogMode: TComboBox;
    chkShowFog: TCheckBox;
    pnlFogLinear: TPanel;
    Label39: TLabel;
    Label40: TLabel;
    edFogStart: TEdit;
    edFogEnd: TEdit;
    pnlFogExponential: TPanel;
    Label41: TLabel;
    edFogDensity: TEdit;
    pnlFogColor: TPanel;
    Label42: TLabel;
    imgFogColor: TImage;
    chkAutoSelect: TCheckBox;
    chkKeepOperator: TCheckBox;
    Label18: TLabel;
    cb3DCameraControl: TComboBox;
    lblLightUI: TLabel;
    shLight: TShape;
    shLightGeometry: TShape;
    lblLight: TLabel;
    chkAutoOptimizeCSG: TCheckBox;
    GroupBox13: TGroupBox;
    chkCopyToBackup: TCheckBox;
    gbLightmapFileFormat: TGroupBox;
    lblLightmapFileFormat: TLabel;
    cboLightmapFileFormat: TComboBox;
    pnlLightmapCompressionQuality: TPanel;
    lblLightmapCompressionQuality: TLabel;
    tbLightmapCompressionQuality: TTrackBar;
    lblLossyWarning: TLabel;
    lbl0: TLabel;
    lbl100: TLabel;
    chkLighting: TCheckBox;
    Label1: TLabel;
    edGizmoSize: TEdit;
    udGizmoSize: TUpDown;
    chkDrawGizmo: TCheckBox;
    Label2: TLabel;
    lblJointUI: TLabel;
    shJoint: TShape;
    lblSelectedJointUI: TLabel;
    shSelectedJoint: TShape;
    lblBoneUI: TLabel;
    shBone: TShape;
    lblAssignedPrimitives: TLabel;
    shAssignedPrimitives: TShape;
    Label3: TLabel;
    shAssignedVertices: TShape;
    Label4: TLabel;
    shSelectedSkeleton: TShape;
    lblSelectedChildItems: TLabel;
    shSelectedChildItems: TShape;
    Label5: TLabel;
    edRaytracingDir: TEdit;
    btnRaytracingDir: TButton;
    TabSheet1: TTabSheet;
    GroupBox14: TGroupBox;
    ChkSaveCameras: TCheckBox;
    ChkSaveBackgrounds: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure chkSnapObjectsClick(Sender: TObject);
    procedure shView_0MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shMajorMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shMinorMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shObjectMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shSelectionMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shPolygonMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shEdgeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shVertexMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btnCancelClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnResetColorsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure shSelectedVertexMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shSelectedEdgeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure chkDrawGridClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pcOptionsChange(Sender: TObject);
    procedure chkAABBClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure chkLockViewsClick(Sender: TObject);
    procedure chkDoCullingClick(Sender: TObject);
    procedure edZoomSpeedChange(Sender: TObject);
    procedure edPointSizeChange(Sender: TObject);
    procedure chkLoadLastClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure chkInvertMouseClick(Sender: TObject);
    procedure shCenterMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure chkDrawCenterClick(Sender: TObject);
    procedure cboSnappingMethodClick(Sender: TObject);
    procedure chkDrawAxisClick(Sender: TObject);
    procedure cboDrawmodeClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure chkGenerateShadowsClick(Sender: TObject);
    procedure chkUseNonSelectedObjectsClick(Sender: TObject);
    procedure cboLightmapSizeChange(Sender: TObject);
    procedure cboMaxTextureSizeChange(Sender: TObject);
    procedure cboMinTextureSizeChange(Sender: TObject);
    procedure edNumBlurFilterPassesChange(Sender: TObject);
    procedure chkLightsClick(Sender: TObject);
    procedure chkUseAmbientColorClick(Sender: TObject);
    procedure chkMaterialPreviewShowSpecularClick(Sender: TObject);
    procedure cboDefaultMLClick(Sender: TObject);
    procedure shPolygonCenterMouseown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shJointMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shSelectedJointMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shBoneMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shSelectedSkeletonMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shSelectedChildItemsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shAssignedPrimitivesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure shAssignedVerticesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure chkDrawPolygonCenterClick(Sender: TObject);
    procedure chkDrawGrid3DViewClick(Sender: TObject);
    procedure edCreaseAngleChange(Sender: TObject);
    procedure edNearClippingPlaneChange(Sender: TObject);
    procedure edFOVChange(Sender: TObject);
    procedure edFarClippingPlaneChange(Sender: TObject);
    procedure edMajorGridSizeChange(Sender: TObject);
    procedure edMinorGridSizeChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure imgGridColor1Click(Sender: TObject);
    procedure imgGridColor2Click(Sender: TObject);
    procedure cbTransparencyGridColorsDrawItem(aControl: TWinControl; anIndex: Integer; aRect: TRect; aState: TOwnerDrawState);
    procedure cbTransparencyGridColorsSelect(Sender: TObject);
    procedure edNumPolygonsCSGProgressChange(Sender: TObject);
    procedure edNumPolygonsCSGProgressKeyPress(Sender: TObject; var Key: Char);
    procedure shFrozenMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure cboFogModeSelect(Sender: TObject);
    procedure imgFogColorClick(Sender: TObject);
    procedure chkShowFogClick(Sender: TObject);
    procedure edFogDensityChange(Sender: TObject);
    procedure edFogEndChange(Sender: TObject);
    procedure edFogStartChange(Sender: TObject);
    procedure edUVScaleChange(Sender: TObject);
    procedure btnSkyboxFrontBrowseClick(Sender: TObject);
    procedure btnSkyboxBackBrowseClick(Sender: TObject);
    procedure btnSkyboxLeftBrowseClick(Sender: TObject);
    procedure btnSkyboxRightBrowseClick(Sender: TObject);
    procedure btnSkyboxUpBrowseClick(Sender: TObject);
    procedure btnSkyboxDownBrowseClick(Sender: TObject);
    procedure chkKeepOperatorClick(Sender: TObject);
    procedure chkAutoSelectClick(Sender: TObject);
    procedure chkShowSkyboxClick(Sender: TObject);
    procedure cb3DCameraControlChange(Sender: TObject);
    procedure shLightMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure chkAutoOptimizeCSGClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure chkCopyToBackupClick(Sender: TObject);
    procedure cboLightmapFileFormatChange(Sender: TObject);
    procedure chkLightingClick(Sender: TObject);
    procedure edGizmoSizeChange(Sender: TObject);
    procedure chkDrawGizmoClick(Sender: TObject);
    procedure btnRaytracingDirClick(Sender: TObject);
    procedure ChkSaveCamerasClick(Sender: TObject);
    procedure ChkSaveBackgroundsClick(Sender: TObject);
  private
    oglcolors: array[0..20] of TRGBColor;
    fScene: TScene;
    fViewportManager: TViewPortManager;
    fShouldUpdateMaterialPicker: boolean;
    fShouldUpdateSkybox: boolean;
    fShouldUpdateFOV: boolean;
    fTransparencyGridColor1: TColor;
    fTransparencyGridColor2: TColor;
    fColorDialog: TColorDialogEx;
    fRenderOptions: TRenderOptions;
    fCameraOptions: TCameraOptions;
    fControlOptions: TControlOptions;
    fCSGOptions: TCSGOptions;
    fCompressionQualityControl: TTrackBarControl;
    fRaytracingThread: TRaytracingThread;

    procedure SetColor(var ARGBColor: TRGBColor; r,g,b: double);
    procedure SaveOGLColorToArray(const aColorArrayID: integer; aColorDialog: TColorDialogEx);
    procedure CopyColorToColor(var ASourceRGBColor, ADestinationRGBColor: TRGBColor);

    function GetColorDialog: TColorDialogEx;
    procedure ApplyColorsToControls;
    procedure SetColors;
    procedure ApplyColors;
    procedure ResetColors;
    procedure UpdateMaterialLists(searchdirectory: string);
    function BrowseTexture(const aTitle, aCurrentValue: string): string;
    procedure UpdateTransparencyGrid;
    procedure UpdateLightmapSizes;
    procedure UpdateMinTextureSizes;
    procedure UpdateMaxTextureSizes;
    procedure UpdateTextureSizes(const aComboBox: TComboBox; const aMaxSize: Integer);
    procedure InitializeLightmapFileFormats;
    procedure UpdateFogColor;
    procedure UpdateFogPanels;
    procedure UpdateSkyboxSettings;
    procedure UpdateLightMapFileFormatFields;
    procedure DrawSmallGrid(aLeft, aTop: Integer; const aCanvas: TCanvas; aColor1, aColor2: Integer);
    function IndexForIntegerInArray(const anInteger: Integer; const anArray: Array of Integer): Integer;
    function IndexForLightmapFileFormat( const aFileFormat: string ): Integer;
    procedure InitializeIntegerField(const aField: TEdit);
    procedure InitializeFloatField(const aField: TEdit);
    procedure InitializeTransparencyGridColors;
    procedure HandleSelectPreviewImage(aSender: TObject);
    procedure HandleIntegerFieldKeyPress(aSender: TObject; var aKey: Char);
    procedure HandleFloatFieldKeyPress(aSender: TObject; var aKey: Char);
    procedure HandleSkyboxChange(aSender: TObject);
  protected
    property ColorDialog: TColorDialogEx read GetColorDialog;
  public
    constructor Create(AOwner: TComponent;
                       AScene: TScene;
                       AViewportManager: TViewPortManager;          // although passed to the Options form, it isn't used yet
                       ARenderOptions: TRenderOptions;
                       ACameraOptions: TCameraOptions;
                       AControlOptions: TControlOptions;
                       ACSGOptions: TCSGOptions;
                       ARaytracingThread: TRaytracingThread); reintroduce;
    property Scene: TScene read fScene write fScene;
    property ViewportManager: TViewportManager read fViewportManager write fViewportManager;
    property RenderOptions: TRenderOptions read fRenderOptions write fRenderOptions;
    property CameraOptions: TCameraOptions read fCameraOptions write fCameraOptions;
    property ControlOptions: TControlOptions read fControlOptions write fControlOptions;
    property CSGOptions: TCSGOptions read fCSGOptions write fCSGOptions;
    property ShouldUpdateMaterialPicker: boolean read fShouldUpdateMaterialPicker write fShouldUpdateMaterialPicker;
    property ShouldUpdateSkybox: boolean read fShouldUpdateSkybox;
    property ShouldUpdateFOV: boolean read fShouldUpdateFOV write fShouldUpdateFOV;
  end;

implementation

uses
    math,
    frmTopView,
    frmFrontView,
    frmSideView,
    frm3dView,
    fraMaterial,
    unit_Constants,
    unit_TextureLoader, frmMainForm;

type
    TTransparencyGridStyle = record
        Name: String;
        Color1: TColor;
        Color2: TColor;
    end;

    TLightmapFileFormat = record
        Description: String;
        Extension: String;
        Warning: String;
        Lossy: boolean; 
    end;

const
    LIGHTMAP_SIZES: array[0..5] of Integer = ( 128, 256, 512, 1024, 2048, 4096 );
    LIGHTMAP_TEXTURE_SIZES: array[0..6] of Integer = ( 8, 16, 32, 64, 128, 256, 512 );
    LIGHTMAP_FILEFORMATS: array[0..2] of TLightmapFileFormat = (
        ( Description: 'Bitmap (*.bmp)'; Extension: 'bmp' ),
        ( Description: 'JPEG (*.jpg)'; Extension: 'jpg'; Lossy: true ),
        ( Description: 'TARGA (*.tga)'; Extension: 'tga' )
    );

    TRANSPARENCY_GRID_STYLES: array[0..6] of TTransparencyGridStyle = (
        ( Name: 'Custom'; Color1: $FFFFFF; Color2: $FFFFFF; ),
        ( Name: 'Light';  Color1: $FFFFFF; Color2: $BBBBBB; ),
        ( Name: 'Medium'; Color1: $A0A0A0; Color2: $555555; ),
        ( Name: 'Dark';   Color1: $555555; Color2: $111111; ),
        ( Name: 'Red';    Color1: $FFFFFF; Color2: $CCCCFF; ),
        ( Name: 'Green';  Color1: $FFFFFF; Color2: $CCFFCC; ),
        ( Name: 'Blue';   Color1: $FFFFFF; Color2: $FFCCCC; )
    );

    SKYBOX_EDIT_NAMES: array[TSkyboxSide] of string = (
        'edSkyboxFront',
        'edSkyboxBack',
        'edSkyboxLeft',
        'edSkyboxRight',
        'edSkyboxUp',
        'edSkyboxDOwn'
    );


{$R *.lfm}

procedure TfrmOptions.SetColor(var ARGBColor: TRGBColor; r,g,b: double);
begin
    ARGBColor.r := r;
    ARGBColor.g := g;
    ARGBColor.b := b;
end;

function TfrmOptions.GetColorDialog: TColorDialogEx;
begin
    if not Assigned(fColorDialog) then begin
        fColorDialog := TColorDialogEx.Create;
    end;

    result := fColorDialog;
end;

procedure TfrmOptions.ApplyColorsToControls;
var c: TColor;
begin
    c := RGBToColor(color_viewportback);
    shView_0.Brush.Color := c;
    shView_1.Brush.Color := c;

    c := RGBToColor(color_majorgrid);
    lblMajorGrid.Font.Color := c;
    shMajor.Brush.Color := c;
    shMajorGrid1.Pen.Color := c;
    shMajorGrid2.Pen.Color := c;
    shMajorGrid3.Pen.Color := c;
    shMajorGrid4.Pen.Color := c;
    shMajorGrid5.Pen.Color := c;
    shMajorGrid6.Pen.Color := c;

    c := RGBToColor(color_minorgrid);
    lblMinorGrid.Font.Color := c;
    shMinor.Brush.Color := c;
    Shape3.Brush.Color := c;

    c := RGBToColor(color_object);
    lblObject.Font.Color := c;
    shObject.Pen.Color := c;
    shObjectGeometry.Pen.Color := c;

    c := RGBToColor(color_light);
    lblLight.Font.Color := c;
    shLight.Pen.Color := c;
    shLightGeometry.Pen.Color := c;

    c := RGBToColor(color_selectedobject);
    lblSelectObject.Font.Color := c;
    shSelection.Pen.Color := c;
    shObjectSelection.Pen.Color := c;

    c := RGBToColor(color_selectedpolygon);
    lblPolygon.Font.Color := c;
    shPolygon.Pen.Color := c;
    shPolygonSelection.Pen.Color := c;

    c := RGBToColor(color_edge);
    lblEdge.Font.Color := c;
    shEdge.Brush.Color := c;
    shEdge1.Brush.Color := c;
    shEdge3.Brush.Color := c;

    c := RGBToColor(color_edgeselected);
    lblSelectedEdge.Font.Color := c;
    shSelectedEdge.Brush.Color := c;
    shEdge2.Brush.Color := c;

    c := RGBToColor(color_vertex);
    lblVertex.Font.Color := c;
    shVertex.Brush.Color := c;
    shVertex1.Brush.Color := c;
    shVertex2.Brush.Color := c;
    shVertex3.Brush.Color := c;

    c := RGBToColor(color_vertexselected);
    lblSelectedVertex.Font.Color := c;
    shSelectedVertex.Brush.Color := c;
    shVertex4.Brush.Color := c;

    c := RGBToColor(color_objectcenter);
    lblCenter.Font.Color := c;
    shCenter.Brush.Color := c;
    shCenter1.Brush.Color := c;

    c := RGBToColor(color_polygoncenter);
    lblpolygoncenter.Font.Color := c;
    shPolygonCenter.Brush.Color := c;
    shPolygonCenter1.Brush.Color := c;

    c := RGBToColor(color_frozenobject);
    lblFrozenObject.Font.Color := c;
    shFrozen.Pen.Color := c;
    shObjectFrozen.Pen.Color := c;

    c := RGBToColor(color_joint);
    shJoint.Pen.Color := c;

    c := RGBToColor(color_selectedjoint);
    shSelectedJoint.Pen.Color := c;

    c := RGBToColor(color_bone);
    shBone.Pen.Color := c;

    c := RGBToColor(color_selectedskeleton);
    shSelectedSkeleton.Pen.Color := c;

    c := RGBToColor(color_selectedchilds);
    shSelectedChildItems.Pen.Color := c;

    c := RGBToColor(color_assignedprimitive);
    shAssignedPrimitives.Pen.Color := c;

    c := RGBToColor(color_assignedvertex);
    shAssignedVertices.Pen.Color := c;
end;

// TODO: change the color management into something better someday
procedure TfrmOptions.SetColors;
begin
    CopyColorToColor(color_viewportback, oglcolors[0]);
    CopyColorToColor(color_majorgrid, oglcolors[1]);
    CopyColorToColor(color_minorgrid, oglcolors[2]);
    CopyColorToColor(color_object, oglcolors[3]);
    CopyColorToColor(color_selectedobject, oglcolors[4]);
    CopyColorToColor(color_selectedpolygon, oglcolors[5]);
    CopyColorToColor(color_edge, oglcolors[6]);
    CopyColorToColor(color_edgeselected, oglcolors[7]);
    CopyColorToColor(color_vertex, oglcolors[8]);
    CopyColorToColor(color_vertexselected, oglcolors[9]);
    CopyColorToColor(color_objectcenter, oglcolors[10]);
    CopyColorToColor(color_polygoncenter, oglcolors[11]);
    CopyColorToColor(color_frozenobject, oglcolors[12]);
    CopyColorToColor(color_light, oglcolors[13]);
    CopyColorToColor(color_joint, oglcolors[14]);
    CopyColorToColor(color_selectedjoint, oglcolors[15]);
    CopyColorToColor(color_bone, oglcolors[16]);
    CopyColorToColor(color_selectedskeleton, oglcolors[17]);
    CopyColorToColor(color_selectedchilds,oglcolors[18]);
    CopyColorToColor(color_assignedprimitive, oglcolors[19]);
    CopyColorToColor(color_assignedvertex, oglcolors[20]);

    fTransparencyGridColor1 := colorTransparencyGrid1;
    fTransparencyGridColor2 := colorTransparencyGrid2;
end;

procedure TfrmOptions.ApplyColors;
begin
    CopyColorToColor(oglcolors[0],color_viewportback);
    CopyColorToColor(oglcolors[1],color_majorgrid);
    CopyColorToColor(oglcolors[2],color_minorgrid);
    CopyColorToColor(oglcolors[3],color_object);
    CopyColorToColor(oglcolors[4],color_selectedobject);
    CopyColorToColor(oglcolors[5],color_selectedpolygon);
    CopyColorToColor(oglcolors[6],color_edge);
    CopyColorToColor(oglcolors[7],color_edgeselected);
    CopyColorToColor(oglcolors[8],color_vertex);
    CopyColorToColor(oglcolors[9],color_vertexselected);
    CopyColorToColor(oglcolors[10],color_objectcenter);
    CopyColorToColor(oglcolors[11],color_polygoncenter);
    CopyColorToColor(oglcolors[12],color_frozenobject);
    CopyColorToColor(oglcolors[13],color_light);
    CopyColorToColor(oglcolors[14],color_joint);
    CopyColorToColor(oglcolors[15],color_selectedjoint);
    CopyColorToColor(oglcolors[16],color_bone);
    CopyColorToColor(oglcolors[17],color_selectedskeleton);
    CopyColorToColor(oglcolors[18],color_selectedchilds);
    CopyColorToColor(oglcolors[19],color_assignedprimitive);
    CopyColorToColor(oglcolors[20],color_assignedvertex);

    colorTransparencyGrid1 := fTransparencyGridColor1;
    colorTransparencyGrid2 := fTransparencyGridColor2;

    SendMessage(handle_main,WM_PAINT,0,0);
end;

procedure TfrmOptions.ResetColors;
begin
    SetColor(color_viewportback,0.95,0.95,0.95);
    SetColor(color_majorgrid,0.53,0.53,0.66);
    SetColor(color_minorgrid,0.7,0.7,0.7);
    SetColor(color_object,0.5,0.5,0.5);
    SetColor(color_light,0.8,0,0);
    SetColor(color_selectedobject,0,0,0);
    SetColor(color_frozenobject,0.56,0.66,0.98);
    SetColor(color_selectedpolygon,1,0,0);
    SetColor(color_edge,0,0,1);
    SetColor(color_edgeselected,0.5,0.5,1.0);
    SetColor(color_vertex,1.0,1.0,0);
    SetColor(color_vertexselected,1.0,0.5,0);
    SetColor(color_objectcenter,0.8,0.6,0.4);
    SetColor(color_polygoncenter,1.0,0,1);
    SetColor(color_joint,0.5,0.5,0.5);
    SetColor(color_selectedjoint,1,0,0);
    SetColor(color_bone,0.68,0.6,0.6);
    SetColor(color_selectedskeleton,0.65,0.5,0.5);
    SetColor(color_selectedchilds,0.65,0.3,0.1);
    SetColor(color_assignedprimitive,0.1,0.1,0.9);
    SetColor(color_assignedvertex,0.45,0.45,1);

    SetColors;

    SendMessage(handle_main,WM_PAINT,0,0);
end;

procedure TfrmOptions.FormCreate(Sender: TObject);
var materialFrame: TMaterialFrame;
begin
    fCompressionQualityControl := TTrackBarControl.Create( tbLightmapCompressionQuality, 0, 100 );

    InitializeIntegerField(edZoomSpeed);
    InitializeIntegerField(edPointSize);
    InitializeIntegerField(edMajorGridSize);
    InitializeIntegerFIeld(edMinorGridSize);
    InitializeIntegerField(edCreaseAngle);
    InitializeFloatField(edFOV);
    InitializeFloatField(edNearClippingPlane);
    InitializeFloatField(edFarClippingPlane);
    InitializeFloatField(edUVScale);
    InitializeFloatField(edFogDensity);
    InitializeFloatField(edFogStart);
    InitializeFloatField(edFogEnd);

    edSkyboxFront.OnChange := HandleSkyboxChange;
    edSkyboxBack.OnChange := HandleSkyboxChange;
    edSkyboxLeft.OnChange := HandleSkyboxChange;
    edSkyboxRight.OnChange := HandleSkyboxChange;
    edSkyboxUp.OnChange := HandleSkyboxChange;
    edSkyboxDown.OnChange := HandleSkyboxChange;                               

    InitializeTransparencyGridColors;

    udPointSize.Position := defaultPointSize;
    udZoomSpeed.Position := zoomSpeed;
    udMajorGridSize.Position := defaultMajorGrid;
    udMinorGridSize.Position := gridSize;
    udGizmoSize.Position := RenderOptions.GizmoSize;
    chkLoadLast.Checked := toggleLoadLast;
    chkCopyToBackup.Checked := toggleCopyToBak;

    with RenderOptions do begin
        chkDrawGizmo.Checked := RenderGizmo;
        chkAABB.Checked := RenderAABB;
        chkDrawGrid.Checked := RenderGrid;
        chkDrawGrid3DView.Checked := RenderPerspectiveGrid;
        chkDrawAxis.Checked := RenderAxis;
        chkDrawCenter.Checked := RenderCenter;
        chkDrawPolygonCenter.Checked := RenderPolygonCenter;
        chkLights.Checked := RenderLights;
        chkDoCulling.Checked := PerformCulling;
        chkLighting.Checked := (LightingType = rltCamera);
    end;

    chkLockViews.Checked := toggleLockViews;
    chkSnapObjects.Checked := toggleSnap;
    chkAutoSelect.Checked := toggleSelection;
    chkInvertMouse.Checked := toggleMouse;
    edMapDir.Text := dir_scenes;
    edPrefabDir.Text := dir_AllPrefabs;
    edTextureDir.Text := dir_texture;
    edXFileDir.Text := dir_x;
    edPictureDir.Text := dir_picture;
    edPluginDir.Text := dir_plugin;
    edRaytracingDir.Text := dir_raytracing;

    with CameraOptions do begin
        edFOV.Text := FloatToStrF(FOV, ffGeneral, 7, 7);
        edNearClippingPlane.Text := FloatToStrF(NearClippingPlane, ffGeneral, 7, 7);
        edFarClippingPlane.Text := FloatToStrF(FarClippingPlane, ffGeneral, 7, 7);
    end;

    with ControlOptions do begin
        if UseWSAD then
            cb3DCameraControl.ItemIndex := 1
        else
            cb3DCameraControl.ItemIndex := 0;
    end;

    SetColors;
    ApplyColorsToControls;
    pcOptions.ActivePageIndex := 1;

    // Lightmapper tab
    UpdateLightmapSizes;
    UpdateMinTextureSizes;
    UpdateMaxTextureSizes;
    InitializeLightmapFileFormats;

    udNumBlurFilterPasses.Position := lightmapNrBlurFilterPasses;
    udCreaseAngle.Position := lightmapCreaseAngle;
    chkGenerateShadows.Checked := toggleLightmapGenerateShadows;
    chkUseNonSelectedObjects.Checked := toggleLightmapUseNonSelectedObjects;
    cboLightmapSize.ItemIndex := IndexForIntegerInArray( lightmapSize, LIGHTMAP_SIZES );
    cboMinTextureSize.ItemIndex := IndexForIntegerInArray( lightmapMinTextureSize, LIGHTMAP_TEXTURE_SIZES );
    cboMaxTextureSize.ItemIndex := IndexForIntegerInArray( lightmapMaxTextureSize, LIGHTMAP_TEXTURE_SIZES );
    chkUseAmbientColor.Checked := toggleLightmapUseAmbientColor;
    cboLightmapFileFormat.ItemIndex := IndexForLightmapFileFormat( lightmapFileFormat );
    fCompressionQualityControl.Position := lightmapCompressionQuality;

    UpdateLightMapFileFormatFields;

    edUVScale.Text := FLoatToStrF(defaultUVScale, ffGeneral, 7, 7);

    // CSG tab
    edNumPolygonsCSGProgress.Text := IntToStr(CSGOptions.MinAmountOfPolygonsForProgressForm);
    chkKeepOperator.Checked := CSGOptions.KeepOperator;
    chkAutoOptimizeCSG.Checked := CSGOptions.AutoOptimize;

    // Environment Tab
    chkShowFog.Checked := toggleEnvironmentShowFog;
    cboFogMode.ItemIndex := ord(environmentFogMode);
    edFogDensity.Text := FloatToStrF(environmentFogDensity, ffGeneral, 7, 7);
    edFogStart.Text := FloatToStrF(environmentFogStart, ffGeneral, 7, 7);
    edFogEnd.Text := FloatToStrF(environmentFogEnd, ffGeneral, 7, 7);
    UpdateFogColor;
    UpdateFogPanels;
    chkShowSkybox.Checked := toggleEnvironmentShowSkybox;
    edSkyboxFront.Text := environmentSkyboxTextureNames[skyFront];
    edSkyboxBack.Text := environmentSkyboxTextureNames[skyBack];
    edSkyboxLeft.Text := environmentSkyboxTextureNames[skyLeft];
    edSkyboxRight.Text := environmentSkyboxTextureNames[skyRight];
    edSkyboxUp.Text := environmentSkyboxTextureNames[skyUp];
    edSkyboxDown.Text := environmentSkyboxTextureNames[skyDown];

    UpdateMaterialLists(dir_texture);
    cboDefaultML.ItemIndex := SearchCBOIndex(cboDefaultML, defaultMaterialList);

    chkMaterialPreviewShowSpecular.Checked := toggleMaterialPreviewShowSpecular;
    materialFrame := TMaterialFrame.Create(pnlPreviewImage);
    materialFrame.OnSelect := HandleSelectPreviewImage;
    materialFrame.Name := 'MaterialPreviewFrame';
    materialFrame.Material := Scene.MaterialManager.SelectedMaterial;
    materialFrame.Parent := pnlPreviewImage;
    materialFrame.Cursor := crHandPoint;
    materialFrame.UpdateGUI;

    UpdateTransparencyGrid;
    // misc tab

    ChkSaveCameras.Checked := save_Load_Cameras;
    ChkSaveBackgrounds.Checked := save_Load_Backgrounds;
end;

procedure TfrmOptions.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    SendMessage(handle_main,WM_PAINT,0,0);
end;

procedure TfrmOptions.FormShow(Sender: TObject);
begin
    cboSnappingMethod.ItemIndex := defaultsnapmethod;
    cboDrawmode.ItemIndex := defaultdrawmode;
end;

procedure TfrmOptions.btnApplyClick(Sender: TObject);
begin
    ApplyColors;
    SendMessage(handle_main,WM_PAINT,0,0);
end;

procedure TfrmOptions.btnResetColorsClick(Sender: TObject);
begin
    ResetColors;
    ApplyColorsToControls;
    SendMessage(handle_main,WM_PAINT,0,0);
end;

procedure TfrmOptions.btnCancelClick(Sender: TObject);
begin
    Close;
end;

procedure TfrmOptions.btnOKClick(Sender: TObject);
begin
    ApplyColors;
    ApplyColorsToControls;
    UpdateSkyboxSettings;
    lightmapCompressionQuality := tbLightmapCompressionQuality.Position;
    Close;
end;

procedure TfrmOptions.shView_0MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shView_0.Brush.Color;
    if ColorDialog.Execute then begin
        shView_0.Brush.Color := ColorDialog.Color;
        shView_1.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(0,ColorDialog);
    end;
end;

procedure TfrmOptions.shMajorMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shMajor.Brush.Color;
    if ColorDialog.Execute then begin
        lblMajorGrid.Font.Color := ColorDialog.Color;
        shMajor.Brush.Color := ColorDialog.Color;
        shMajorGrid1.Pen.Color := ColorDialog.Color;
        shMajorGrid2.Pen.Color := ColorDialog.Color;
        shMajorGrid3.Pen.Color := ColorDialog.Color;
        shMajorGrid4.Pen.Color := ColorDialog.Color;
        shMajorGrid5.Pen.Color := ColorDialog.Color;
        shMajorGrid6.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(1,ColorDialog);
    end;
end;

procedure TfrmOptions.shMinorMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shMinor.Brush.Color;
    if ColorDialog.Execute then begin
        lblMinorGrid.Font.Color := ColorDialog.Color;
        shMinor.Brush.Color := ColorDialog.Color;
        Shape3.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(2,ColorDialog);
    end;
end;

procedure TfrmOptions.shObjectMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shObject.Pen.Color;
    if ColorDialog.Execute then begin
        lblObject.Font.Color := ColorDialog.Color;
        shObject.Pen.Color := ColorDialog.Color;
        shObjectGeometry.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(3,ColorDialog);
    end;
end;

procedure TfrmOptions.shSelectionMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shSelection.Pen.Color;
    if ColorDialog.Execute then begin
        lblSelectObject.Font.Color := ColorDialog.Color;
        shSelection.Pen.Color := ColorDialog.Color;
        shObjectSelection.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(4,ColorDialog);
    end;
end;

procedure TfrmOptions.shPolygonMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shPolygon.Pen.Color;
    if ColorDialog.Execute then begin
        lblPolygon.Font.Color := ColorDialog.Color;
        shPolygon.Pen.Color := ColorDialog.Color;
        shPolygonSelection.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(5,ColorDialog);
    end;
end;

procedure TfrmOptions.shEdgeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shEdge.Brush.Color;
    if ColorDialog.Execute then begin
        lblEdge.Font.Color := ColorDialog.Color;
        shEdge.Brush.Color := ColorDialog.Color;
        shEdge1.Brush.Color := ColorDialog.Color;
        shEdge3.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(6,ColorDialog);
    end;
end;

procedure TfrmOptions.shSelectedEdgeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shSelectedEdge.Brush.Color;
    if ColorDialog.Execute then begin
        lblSelectedEdge.Font.Color := ColorDialog.Color;
        shSelectedEdge.Brush.Color := ColorDialog.Color;
        shEdge2.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(7,ColorDialog);
    end;
end;

procedure TfrmOptions.shVertexMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shVertex.Brush.Color;
    if ColorDialog.Execute then begin
        lblVertex.Font.Color := ColorDialog.Color;
        shVertex.Brush.Color := ColorDialog.Color;
        shVertex1.Brush.Color := ColorDialog.Color;
        shVertex2.Brush.Color := ColorDialog.Color;
        shVertex3.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(8,ColorDialog);
    end;
end;

procedure TfrmOptions.shSelectedVertexMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shSelectedVertex.Brush.Color;
    if ColorDialog.Execute then begin
        lblSelectedVertex.Font.Color := ColorDialog.Color;
        shSelectedVertex.Brush.Color := ColorDialog.Color;
        shVertex4.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(9,ColorDialog);
    end;
end;


procedure TfrmOptions.shCenterMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shCenter.Brush.Color;
    if ColorDialog.Execute then begin
        lblCenter.Font.Color := ColorDialog.Color;
        shCenter.Brush.Color := ColorDialog.Color;
        shCenter1.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(10,ColorDialog);
    end;
end;


procedure TfrmOptions.shPolygonCenterMouseown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shPolygonCenter.Brush.Color;
    if ColorDialog.Execute then begin
        lblPolygonCenter.Font.Color := ColorDialog.Color;
        shPolygonCenter.Brush.Color := ColorDialog.Color;
        shPolygonCenter1.Brush.Color := ColorDialog.Color;
        SaveOGLColorToArray(11,ColorDialog);
    end;
end;

procedure TfrmOptions.shFrozenMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shFrozen.Pen.Color;
    if ColorDialog.Execute then begin
        lblFrozenObject.Font.Color := ColorDialog.Color;
        shFrozen.Pen.Color := ColorDialog.Color;
        shObjectFrozen.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(12,ColorDialog);
    end;
end;

procedure TfrmOptions.shLightMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shObject.Pen.Color;
    if ColorDialog.Execute then begin
        lblLight.Font.Color := ColorDialog.Color;
        shLight.Pen.Color := ColorDialog.Color;
        shLightGeometry.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(13,ColorDialog);
    end;
end;

procedure TfrmOptions.shJointMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shJoint.Brush.Color;
    if ColorDialog.Execute then begin
        shJoint.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(14,ColorDialog);
    end;
end;

procedure TfrmOptions.shSelectedJointMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shSelectedJoint.Brush.Color;
    if ColorDialog.Execute then begin
        shSelectedJoint.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(15,ColorDialog);
    end;
end;

procedure TfrmOptions.shBoneMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shBone.Brush.Color;
    if ColorDialog.Execute then begin
        shBone.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(16,ColorDialog);
    end;
end;

procedure TfrmOptions.shSelectedSkeletonMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shSelectedSkeleton.Brush.Color;
    if ColorDialog.Execute then begin
        shSelectedSkeleton.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(17,ColorDialog);
    end;
end;

procedure TfrmOptions.shSelectedChildItemsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shSelectedChildItems.Brush.Color;
    if ColorDialog.Execute then begin
        shSelectedChildItems.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(18,ColorDialog);
    end;
end;

procedure TfrmOptions.shAssignedPrimitivesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shAssignedPrimitives.Brush.Color;
    if ColorDialog.Execute then begin
        shAssignedPrimitives.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(19,ColorDialog);
    end;
end;

procedure TfrmOptions.shAssignedVerticesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    ColorDialog.Color := shAssignedVertices.Brush.Color;
    if ColorDialog.Execute then begin
        shAssignedVertices.Pen.Color := ColorDialog.Color;
        SaveOGLColorToArray(20,ColorDialog);
    end;
end;

// ### default viewport behavior ###############################################

procedure TfrmOptions.edZoomSpeedChange(Sender: TObject);
begin
    if length(edZoomSpeed.Text)>0 then
        zoomspeed := strtoint(edZoomSpeed.Text);
end;

procedure TfrmOptions.chkAABBClick(Sender: TObject);
begin
    RenderOptions.RenderAABB := chkAABB.Checked;
end;

procedure TfrmOptions.chkLightsClick(Sender: TObject);
begin
    RenderOptions.RenderLights := chkLights.Checked;
end;

procedure TfrmOptions.chkInvertMouseClick(Sender: TObject);
begin
    togglemouse := chkInvertMouse.Checked;
end;

procedure TfrmOptions.chkDrawCenterClick(Sender: TObject);
begin
    RenderOptions.RenderCenter := chkDrawCenter.Checked;
end;

procedure TfrmOptions.chkDrawPolygonCenterClick(Sender: TObject);
begin
    RenderOptions.RenderPolygonCenter := chkDrawPolygonCenter.Checked;
end;

procedure TfrmOptions.chkDrawAxisClick(Sender: TObject);
begin
    RenderOptions.RenderAxis := chkDrawAxis.Checked;
end;

procedure TfrmOptions.chkLoadLastClick(Sender: TObject);
begin
    toggleLoadLast := chkLoadLast.Checked;
end;

procedure TfrmOptions.chkCopyToBackupClick(Sender: TObject);
begin
    toggleCopyToBak := chkCopyToBackup.Checked;
end;

procedure TfrmOptions.cboDrawmodeClick(Sender: TObject);
begin
    defaultdrawmode := cboDrawmode.ItemIndex;
    // call SetDrawmode here
end;

procedure TfrmOptions.chkDrawGizmoClick(Sender: TObject);
begin
    RenderOptions.RenderGizmo := chkDrawGizmo.Checked;
end;

procedure TfrmOptions.chkDoCullingClick(Sender: TObject);
begin
    RenderOptions.PerformCulling := chkDoCulling.Checked;
end;

procedure TfrmOptions.chkLockViewsClick(Sender: TObject);
begin
    toggleLockViews := chkLockViews.Checked;
end;

procedure TfrmOptions.chkDrawGridClick(Sender: TObject);
begin
    RenderOptions.RenderGrid := chkDrawGrid.Checked;
end;

procedure TfrmOptions.chkDrawGrid3DViewClick(Sender: TObject);
begin
    RenderOptions.RenderPerspectiveGrid := chkDrawGrid3DView.Checked;
end;

procedure TfrmOptions.cboSnappingMethodClick(Sender: TObject);
begin
    defaultsnapmethod := cboSnappingMethod.ItemIndex;
end;

procedure TfrmOptions.edPointSizeChange(Sender: TObject);
begin
    if length(edPointSize.Text)>0 then
        defaultpointsize := strtoint(edPointSize.Text);
end;

// ### default editing #########################################################

procedure TfrmOptions.chkAutoSelectClick(Sender: TObject);
begin
    toggleSelection := chkAutoSelect.Checked;
    frmMain.stbMain.Invalidate;      // TODO: notify main form in a different manner
end;

procedure TfrmOptions.chkSnapObjectsClick(Sender: TObject);
begin
    toggleSnap := chkSnapObjects.Checked;
end;

procedure TfrmOptions.cboDefaultMLClick(Sender: TObject);
begin
    defaultMaterialList := cboDefaultML.Text;
end;

procedure TfrmOptions.pcOptionsChange(Sender: TObject);
begin
    case pcOptions.ActivePageIndex of
        0:  lblTitle.Caption := 'Enviroment';
        1:  lblTitle.Caption := 'User Preferences';
        2:  lblTitle.Caption := 'Color Settings';
        3:  lblTitle.Caption := 'Lightmapper';
        4:  lblTitle.Caption := 'CSG';
    end;
end;

procedure TfrmOptions.Button1Click(Sender: TObject);
var dir: string;
begin
    dir := dir_scenes;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        edMapDir.Text := dir+'\';
        dir_scenes := dir+'\';
    end;
end;

procedure TfrmOptions.Button2Click(Sender: TObject);
var dir: string;
begin
    dir := dir_AllPrefabs;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        edPrefabDir.Text := dir+'\';
        dir_AllPrefabs := dir+'\';
    end;
end;

procedure TfrmOptions.Button3Click(Sender: TObject);
var dir: string;
begin
    dir := dir_texture;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        edTextureDir.Text := dir+'\';
        dir_texture := dir+'\';
    end;
end;

procedure TfrmOptions.Button4Click(Sender: TObject);
var dir: string;
begin
    dir := dir_x;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        edXFileDir.Text := dir+'\';
        dir_x := dir+'\';
    end;
end;

procedure TfrmOptions.Button5Click(Sender: TObject);
var dir: string;
begin
    dir := dir_picture;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        edPictureDir.Text := dir+'\';
        dir_picture := dir+'\';
    end;
end;

procedure TfrmOptions.Button6Click(Sender: TObject);
var dir: string;
begin
    dir := dir_plugin;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        edPluginDir.Text := dir+'\';
        dir_plugin := dir+'\';
    end;
end;

procedure TfrmOptions.btnRaytracingDirClick(Sender: TObject);
var dir: string;
begin
    dir := dir_raytracing;
    if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],1000) then begin
        fRaytracingThread.Stop;
        edRaytracingDir.Text := dir+'\';
        dir_raytracing := dir+'\';
        fRaytracingThread.Start;
    end;
end;

// ### Lightmapping options ##################################################

procedure TfrmOptions.chkGenerateShadowsClick(Sender: TObject);
begin
    toggleLightmapGenerateShadows := chkGenerateShadows.Checked;
end;

procedure TfrmOptions.chkUseNonSelectedObjectsClick(Sender: TObject);
begin
    toggleLightmapUseNonSelectedObjects := chkUseNonSelectedObjects.Checked;
end;

procedure TfrmOptions.UpdateMaterialLists(searchdirectory: string);
var srTexture: TSearchRec;
    tdir,extension: string;
begin
    cboDefaultML.Items.Clear;

    tdir := searchdirectory+'\*.*';
    if FindFirstUTF8(tdir,0,srTexture) = 0 then begin
        repeat
            extension := UpperCase(ExtractFileExt(srTexture.Name));
            if (extension='.DML') then begin
                cboDefaultML.Items.Add(srTexture.Name);
            end;
        until FindNextUTF8(srTexture) <> 0;
        FindCloseUTF8(srTexture);
    end;
end;

procedure TfrmOptions.SaveOGLColorToArray(const aColorArrayID: integer; aColorDialog: TColorDialogEx);
begin
    oglcolors[aColorArrayID].r := aColorDialog.R / 255;
    oglcolors[aColorArrayID].g := aColorDialog.G / 255;
    oglcolors[aColorArrayID].b := aColorDialog.B / 255;
end;

procedure TfrmOptions.CopyColorToColor(var ASourceRGBColor, ADestinationRGBColor: TRGBColor);
begin
    ADestinationRGBColor.r := ASourceRGBColor.r;
    ADestinationRGBColor.g := ASourceRGBColor.g;
    ADestinationRGBColor.b := ASourceRGBColor.b;
end;

function TfrmOptions.BrowseTexture(const aTitle, aCurrentValue: string): string;
var openDialog: TOpenDialog;
begin
    result := aCurrentValue;

    openDialog := TOpenDialog.Create(nil);
    try
        if aTitle <> '' then
            openDialog.Title := aTitle
        else
            openDialog.Title := 'Select texture';

        openDialog.Filter := TTextureLoader.SupportedFilesMask;

        if openDialog.Execute then
            result := openDialog.FileName;
    finally
        FreeAndNil(openDialog);
    end;
end;

procedure TfrmOptions.UpdateTransparencyGrid;
const GRID_SIZE = 8;
var x, y: integer;
begin
    imgGridColor1.Canvas.Brush.Color := fTransparencyGridColor1;
    imgGridColor1.Canvas.Pen.Color := clBlack;
    imgGridColor1.Canvas.Rectangle(imgGridColor1.ClientRect);
    imgGridColor1.Invalidate;

    imgGridColor2.Canvas.Brush.Color := fTransparencyGridColor2;
    imgGridColor1.Canvas.Pen.Color := clBlack;
    imgGridColor2.Canvas.Rectangle(imgGridColor2.ClientRect);
    imgGridColor2.Invalidate;

    imgTransparencyGrid.Canvas.Brush.Color := fTransparencyGridColor1;
    for y := 0 to imgTransparencyGrid.Height div GRID_SIZE - 1 do begin
        for x := 0 to imgTransparencyGrid.Width div GRID_SIZE - 1 do begin
            if (((x + y) mod 2) = 0) then begin
                imgTransparencyGrid.Canvas.FillRect(Rect(
                    x * GRID_SIZE, y * GRID_SIZE, (x+1) * GRID_SIZE, (y+1) * GRID_SIZE ));
            end;
        end;
    end;
    imgTransparencyGrid.Canvas.Brush.Color := fTransparencyGridColor2;
    for y := 0 to imgTransparencyGrid.Height div GRID_SIZE - 1 do begin
        for x := 0 to imgTransparencyGrid.Width div GRID_SIZE - 1 do begin
            if ((x + y) mod 2 = 1) then begin
                imgTransparencyGrid.Canvas.FillRect(Rect(
                    x * GRID_SIZE, y * GRID_SIZE, (x+1) * GRID_SIZE, (y+1) * GRID_SIZE ));
            end;
        end;
    end;
    imgTransparencyGrid.Canvas.Brush.Color := clBlack;
    imgTransparencyGrid.Canvas.FrameRect(imgTransparencyGrid.ClientRect);
    imgTransparencyGrid.Invalidate;
end;

procedure TfrmOptions.UpdateLightmapSizes;
var index,size: integer;
begin
    cboLightmapSize.Items.Clear;
    for index := Low( LIGHTMAP_SIZES ) to High( LIGHTMAP_SIZES ) do begin
        size := LIGHTMAP_SIZES[index];
        cboLightmapSize.Items.AddObject( Format ( '%dx%d', [size, size] ), TObject( size ));
    end;
end;

procedure TfrmOptions.InitializeLightmapFileFormats;
var i: integer;
    fileFormat: TLightmapFileFormat;
    description: string;
begin
    cboLightmapFileFormat.Items.Clear;
    for i := Low(LIGHTMAP_FILEFORMATS) to High(LIGHTMAP_FILEFORMATS) do begin
        fileFormat := LIGHTMAP_FILEFORMATS[i];
        description := fileFormat.description;

        cboLightmapFileFormat.Items.Add( description );
    end;
end;

procedure TfrmOptions.UpdateMinTextureSizes;
var maxSize: integer;
begin
    if cboLightmapSize.ItemIndex <> -1 then
    begin
        maxSize := Integer( cboLightmapSize.Items.Objects[cboLightmapSize.ItemIndex] );
    end
    else
        maxSize := 999999;

    if cboMaxTextureSize.ItemIndex <> -1 then
    begin
        maxSize := Min( maxSize, Integer( cboMaxTextureSize.Items.Objects[cboMaxTextureSize.ItemIndex] ));
    end;

    UpdateTextureSizes( cboMinTextureSize, maxSize );
end;

procedure TfrmOptions.UpdateMaxTextureSizes;
var maxSize: integer;
begin
    if cboLightmapSize.ItemIndex <> -1 then
    begin
        maxSize := Integer( cboLightmapSize.Items.Objects[cboLightmapSize.ItemIndex] );
    end
    else
        maxSize := 999999;

    UpdateTextureSizes( cboMaxTextureSize, maxSize );
end;

procedure TfrmOptions.UpdateTextureSizes( const aComboBox: TComboBox; const aMaxSize: Integer );
var itemIndex, nrItems, index, size: integer;
    description: string;
begin
    itemIndex := aCombobox.ItemIndex;

    nrItems := 0;
    while (nrItems <= High(LIGHTMAP_TEXTURE_SIZES)) and (LIGHTMAP_TEXTURE_SIZES[nrItems] <= aMaxSize) do begin
        nrItems := nrItems + 1;
    end;

    aCombobox.Items.Clear;

    for index := 0 to nrItems - 1 do begin
        size := LIGHTMAP_TEXTURE_SIZES[index];
        description := Format('%dx%d', [size, size]);
        aComboBox.Items.AddObject( description, TObject( size ));
    end;

    if itemIndex < nrItems then
        aComboBox.ItemIndex := itemIndex
    else
        aComboBox.ItemIndex := nrItems - 1;
end;

procedure TfrmOptions.UpdateFogColor;
begin
    imgFogColor.Canvas.Brush.Color := environmentFogColor;
    imgFogColor.Canvas.Pen.Color := clBlack;
    imgFogColor.Canvas.Rectangle(imgFogColor.ClientRect);
    imgFogColor.Invalidate;
end;

procedure TfrmOptions.UpdateFogPanels;
begin
  if TFogMode(cboFogMode.ItemIndex) = fmLinear then begin
      pnlFogLinear.Visible := TRUE;
      pnlFogExponential.Visible := FALSE;
      pnlFogColor.Top := 115;
  end
  else begin
      pnlFogLinear.Visible := FALSE;
      pnlFogExponential.Visible := TRUE;
      pnlFogColor.Top := 93;
  end;
end;

procedure TfrmOptions.DrawSmallGrid(aLeft, aTop: Integer; const aCanvas: TCanvas; aColor1, aColor2: Integer);
var x, y: integer;
begin
    for y := 0 to 2 do begin
        for x := 0 to 2 do begin
            if (((x + y) mod 2) = 0) then
                aCanvas.Brush.Color := aColor1
            else
                aCanvas.Brush.Color := aColor2;

            aCanvas.FillRect(Rect(aLeft + 1 + x * 4, aTop + 1 + y * 4, aLeft + 1 + (x+1) * 4, aTop + 1 + (y+1) * 4));
        end;
    end;
    aCanvas.Brush.Color := clBlack;
    aCanvas.FrameRect(Rect(aLeft, aTop, aLeft + 14, aTop + 14));
end;

procedure TfrmOptions.cboLightmapSizeChange(Sender: TObject);
begin
    lightmapSize := LIGHTMAP_SIZES[cboLightmapSize.ItemIndex];

    UpdateMaxTextureSizes;
    UpdateMinTextureSizes;
end;

procedure TfrmOptions.cboMinTextureSizeChange(Sender: TObject);
begin
    lightmapMinTextureSize := LIGHTMAP_TEXTURE_SIZES[cboMinTextureSize.ItemIndex];

    UpdateMinTextureSizes;
end;

procedure TfrmOptions.cboMaxTextureSizeChange(Sender: TObject);
begin
    lightmapMaxTextureSize := LIGHTMAP_TEXTURE_SIZES[cboMaxTextureSize.ItemIndex];

    UpdateMinTextureSizes;
end;

function TfrmOptions.IndexForIntegerInArray( const anInteger: Integer; const anArray: Array of Integer ): integer;
var index: Integer;
begin
    result := -1;
    for index := Low(anArray) to High(anArray) do begin
        if anArray[index] = anInteger then begin
            result := index;
            break;
        end;
    end;
end;

function TfrmOptions.IndexForLightmapFileFormat( const aFileFormat: string ): Integer;
var i: integer;
begin
    result := 0;

    for i := Low(LIGHTMAP_FILEFORMATS) to High(LIGHTMAP_FILEFORMATS) do begin
        if LIGHTMAP_FILEFORMATS[i].Extension = aFileFormat then begin
            result := i;
            break;
        end;
    end;
end;

procedure TfrmOptions.InitializeIntegerField(const aField: TEdit);
begin
    aField.OnKeyPress := HandleIntegerFieldKeyPress;
end;

procedure TfrmOptions.InitializeFloatField(const aField: TEdit);
begin
    aField.OnKeyPress := HandleFloatFieldKeyPress;
end;

procedure TfrmOptions.InitializeTransparencyGridColors;
var index: integer;
begin
    cbTransparencyGridColors.Clear;
    for index := Low(TRANSPARENCY_GRID_STYLES) to High(TRANSPARENCY_GRID_STYLES) do begin
        cbTransparencyGridColors.Items.Add(TRANSPARENCY_GRID_STYLES[index].Name);
    end;
    cbTransparencyGridColors.ItemIndex := 0;
end;

procedure TfrmOptions.HandleSelectPreviewImage(aSender: TObject);
var materialFrame: TMaterialFrame;
begin
    materialPreviewLUTIndex := materialPreviewLUTIndex + 1;
    if materialPreviewLUTIndex > High(MATERIAL_PREVIEW_LUT_NAMES) then
        materialPreviewLUTIndex := Low(MATERIAL_PREVIEW_LUT_NAMES);

    materialPreviewLUT := LoadLUTFromResource(MATERIAL_PREVIEW_LUT_NAMES[materialPreviewLUTIndex]);

    materialFrame := aSender as TMaterialFrame;
    materialFrame.Selected := false;
    materialFrame.UpdateGUI;

    ShouldUpdateMaterialPicker := true;
end;

procedure TfrmOptions.HandleIntegerFieldKeyPress(aSender: TObject; var aKey: Char);
begin
    if not (aKey in ['0'..'9', Chr(VK_BACK)]) then aKey := #0;
end;

procedure TfrmOptions.HandleFloatFieldKeyPress(aSender: TObject; var aKey: Char);
var edit: TEdit;
begin
    if aKey in ['0'..'9', '.', Chr(VK_BACK)] then begin
        if aKey = '.' then begin
            edit := aSender as TEdit;

            if Pos('.', edit.Text) <> 0 then begin                              
                aKey := #0;
            end;
        end;
    end
    else
        aKey := #0;
end;

procedure TfrmOptions.HandleSkyboxChange(aSender: TObject);
var edit: TEdit;
begin
    // Focus on right end of input (right side of text is most important)
    edit := aSender as TEdit;
    if not edit.Focused then begin
        edit.SelStart := Length(edit.Text);
    end;
end;

procedure TfrmOptions.edNumBlurFilterPassesChange(Sender: TObject);
begin
    lightmapNrBlurFilterPasses := udNumBlurFilterPasses.Position;
end;

procedure TfrmOptions.chkUseAmbientColorClick(Sender: TObject);
begin
    toggleLightmapUseAmbientColor := chkUseAmbientColor.Checked;
end;

procedure TfrmOptions.chkMaterialPreviewShowSpecularClick(Sender: TObject);
var materialFrame: TMaterialFrame;
begin
    materialFrame := pnlPreviewImage.FindComponent( 'MaterialPreviewFrame' ) as TMaterialFrame;
    if Assigned(materialFrame) then // OnClick could have been generated before frame is created
    begin
        toggleMaterialPreviewShowSpecular := chkMaterialPreviewShowSpecular.Checked;
        materialFrame.UpdateGUI;
        ShouldUpdateMaterialPicker := true;
    end;
end;

procedure TfrmOptions.ChkSaveBackgroundsClick(Sender: TObject);
begin
    save_Load_Backgrounds := ChkSaveBackgrounds.Checked;
end;

procedure TfrmOptions.ChkSaveCamerasClick(Sender: TObject);
begin
    save_Load_Cameras:= ChkSaveCameras.Checked;
end;

procedure TfrmOptions.edCreaseAngleChange(Sender: TObject);
begin
    lightmapCreaseAngle := udCreaseAngle.Position;
end;

procedure TfrmOptions.edFOVChange(Sender: TObject);
begin
    if IsNumeric(edFOV.Text) then begin
        CameraOptions.FOV := StrToFloat(edFOV.Text);
        ShouldUpdateFOV := true;
    end;
end;

procedure TfrmOptions.edNearClippingPlaneChange(Sender: TObject);
begin
    if IsNumeric(edNearClippingPlane.Text) then
        CameraOptions.NearClippingPlane := StrToFloat(edNearClippingPlane.Text);
end;

procedure TfrmOptions.edFarClippingPlaneChange(Sender: TObject);
begin
    if IsNumeric(edFarClippingPlane.Text) then
        CameraOptions.FarClippingPlane := StrToFloat(edFarClippingPlane.Text);
end;

procedure TfrmOptions.edMajorGridSizeChange(Sender: TObject);
begin
    if length(edMajorGridSize.Text)>0 then
        defaultMajorGrid := StrToInt(edMajorGridSize.Text);
end;

procedure TfrmOptions.edMinorGridSizeChange(Sender: TObject);
begin
    if length(edMinorGridSize.Text)>0 then begin
        gridSize := StrToInt(edMinorGridSize.Text);
        // Note, PJ: The reference to main is a bit of a hack, change some day...
        frmMain.stbMain.Panels[3].Text := 'GRIDSIZE: '+IntToStr(gridSize);
    end;
end;

procedure TfrmOptions.edNumPolygonsCSGProgressChange(Sender: TObject);
begin
    if IsNumeric(edNumPolygonsCSGProgress.Text) then
        CSGOptions.MinAmountOfPolygonsForProgressForm := StrToInt(edNumPolygonsCSGProgress.Text);
end;

procedure TfrmOptions.chkKeepOperatorClick(Sender: TObject);
begin
    CSGOptions.KeepOperator := chkKeepOperator.Checked;
end;

procedure TfrmOptions.chkAutoOptimizeCSGClick(Sender: TObject);
begin
    CSGOptions.AutoOptimize := chkAutoOptimizeCSG.Checked;
end;

procedure TfrmOptions.edNumPolygonsCSGProgressKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in ['0'..'9', Chr(VK_BACK)]) then Key := #0;
end;

procedure TfrmOptions.FormDestroy(Sender: TObject);
begin
    FreeAndNil(fCompressionQualityControl);
    FreeAndNil(fColorDialog);
end;

procedure TfrmOptions.imgGridColor1Click(Sender: TObject);
begin
    ColorDialog.Color := fTransparencyGridColor1;
    if ColorDialog.Execute then begin
        fTransparencyGridColor1 := ColorDialog.Color;
        cbTransparencyGridColors.ItemIndex := 0;
    end;
    UpdateTransparencyGrid;
end;

procedure TfrmOptions.imgGridColor2Click(Sender: TObject);
begin
    ColorDialog.Color := fTransparencyGridColor2;
    if ColorDialog.Execute then begin
        fTransparencyGridColor2 := ColorDialog.Color;
        cbTransparencyGridColors.ItemIndex := 0;
    end;
    UpdateTransparencyGrid;
end;

procedure TfrmOptions.cbTransparencyGridColorsDrawItem(aControl: TWinControl;
  anIndex: Integer; aRect: TRect; aState: TOwnerDrawState);
var offset: integer;
    backgroundColor, color: TColor;
begin
    if odFocused in aState then begin
        backgroundColor := clHighLight;
        color := clWindow;
    end
    else begin
        backgroundColor := clWindow;
        color := clWindowText;
    end;

    cbTransparencyGridColors.Canvas.Brush.Color := backgroundColor;
    cbTransparencyGridColors.Canvas.FillRect(aRect);

    if anIndex <> 0 then begin
        offset := 26;
        DrawSmallGrid(aRect.Left + 2, aRect.Top + 1, cbTransparencyGridColors.Canvas,
            TRANSPARENCY_GRID_STYLES[anIndex].Color1,
            TRANSPARENCY_GRID_STYLES[anIndex].Color2);
    end
    else
        offset := 6;

    cbTransparencyGridColors.Canvas.Brush.Color := backgroundColor;
    cbTransparencyGridColors.Canvas.Brush.Style := bsSolid;
    cbTransparencyGridColors.Canvas.Pen.Color := color;
    cbTransparencyGridColors.Canvas.TextOut(aRect.Left + offset, aRect.Top + 1, TRANSPARENCY_GRID_STYLES[anIndex].Name);
    cbTransparencyGridColors.Canvas.Brush.Style := bsClear;
end;

procedure TfrmOptions.cbTransparencyGridColorsSelect(Sender: TObject);
begin
    if cbTransparencyGridColors.ItemIndex > 0 then begin
        with TRANSPARENCY_GRID_STYLES[cbTransparencyGridColors.ItemIndex] do begin
            fTransparencyGridColor1 := Color1;
            fTransparencyGridColor2 := Color2;
        end;
        UpdateTransparencyGrid;
    end;
end;

procedure TfrmOptions.cboFogModeSelect(Sender: TObject);
begin
    environmentFogMode := TFogMode(cboFogMode.ItemIndex);

    UpdateFogPanels;
end;

procedure TfrmOptions.imgFogColorClick(Sender: TObject);
begin
    ColorDialog.Color := environmentFogColor;
    if ColorDialog.Execute then  begin
        environmentFogColor := ColorDialog.Color;
    end;

    UpdateFogColor;
end;

procedure TfrmOptions.chkShowFogClick(Sender: TObject);
begin
    toggleEnvironmentShowFog := chkShowFog.Checked;
end;

procedure TfrmOptions.edFogDensityChange(Sender: TObject);
begin
    if IsNumeric(edFogDensity.Text) then
        environmentFogDensity := StrToFloat(edFogDensity.Text);
end;

procedure TfrmOptions.edFogStartChange(Sender: TObject);
begin
    if IsNumeric(edFogStart.Text) then
        environmentFogStart := StrToFloat(edFogStart.Text);
end;

procedure TfrmOptions.edFogEndChange(Sender: TObject);
begin
    if IsNumeric(edFogEnd.Text) then
        environmentFogEnd := StrToFloat(edFogEnd.Text);
end;

procedure TfrmOptions.edUVScaleChange(Sender: TObject);
begin
    if IsNumeric(edUVScale.Text) then
        defaultUVScale := StrToFloat(edUVScale.Text);
end;

constructor TfrmOptions.Create(AOwner: TComponent;
                               AScene: TScene;
                               AViewportManager: TViewPortManager;
                               ARenderOptions: TRenderOptions;
                               ACameraOptions: TCameraOptions;
                               AControlOptions: TControlOptions;
                               ACSGOptions: TCSGOptions;
                               ARaytracingThread: TRaytracingThread);
begin
    inherited Create(AOwner);
    Scene := AScene;
    ViewportManager := AViewportManager;
    RenderOptions := ARenderOptions;
    CameraOptions := ACameraOptions;
    ControlOptions := AControlOptions;
    CSGOptions := ACSGOptions;
    fRaytracingThread := ARaytracingThread;
end;

procedure TfrmOptions.chkShowSkyboxClick(Sender: TObject);
begin
    toggleEnvironmentShowSkyBox := chkShowSkybox.Checked;
end;

procedure TfrmOptions.btnSkyboxFrontBrowseClick(Sender: TObject);
begin
    edSkyboxFront.Text := BrowseTexture( 'Select Skybox Front Texture', edSkyboxFront.Text );
end;

procedure TfrmOptions.btnSkyboxBackBrowseClick(Sender: TObject);
begin
    edSkyboxBack.Text := BrowseTexture( 'Select Skybox Back Texture', edSkyboxBack.Text );
end;

procedure TfrmOptions.btnSkyboxLeftBrowseClick(Sender: TObject);
begin
    edSkyboxLeft.Text := BrowseTexture( 'Select Skybox Left Texture', edSkyboxLeft.Text );
end;

procedure TfrmOptions.btnSkyboxRightBrowseClick(Sender: TObject);
begin
    edSkyboxRight.Text := BrowseTexture( 'Select Skybox Right Texture', edSkyboxRight.Text );
end;

procedure TfrmOptions.btnSkyboxUpBrowseClick(Sender: TObject);
begin
    edSkyboxUp.Text := BrowseTexture( 'Select Skybox Up Texture', edSkyboxUp.Text );
end;

procedure TfrmOptions.btnSkyboxDownBrowseClick(Sender: TObject);
begin
    edSkyboxDown.Text := BrowseTexture( 'Select Skybox Down Texture', edSkyboxDown.Text );
end;

// Eventually, all settings should be set through a similar construction (only when OK is pressed).
// Note JC: maybe we should consider a Settings object with an Apply method or something
procedure TfrmOptions.UpdateSkyboxSettings;
var side: TSkyboxSide;
    edit: TEdit;
begin
    toggleEnvironmentShowSkyBox := chkShowSkybox.Checked;

    for side := Low(TSkyboxSide) to High(TSkyboxSide) do
    begin
        edit := FindComponent(SKYBOX_EDIT_NAMES[side]) as TEdit;
        if edit.Text <> environmentSkyboxTextureNames[side] then
        begin
            environmentSkyboxTextureNames[side] := edit.Text;

            fShouldUpdateSkybox := TRUE;
        end;
    end;
end;

procedure TfrmOptions.cb3DCameraControlChange(Sender: TObject);
begin
    ControlOptions.UseWSAD := ( cb3DCameraControl.ItemIndex = 1 );
end;

procedure TfrmOptions.FormKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then Close;
end;

procedure TfrmOptions.cboLightmapFileFormatChange(Sender: TObject);
var fileFormat: TLightmapFileFormat;
begin
    fileFormat := LIGHTMAP_FILEFORMATS[cboLightmapFileFormat.ItemIndex];

    UpdateLightMapFileFormatFields;

    lightmapFileFormat := fileFormat.extension;
end;

procedure TfrmOptions.UpdateLightMapFileFormatFields;
var warning: string;
    compressionEnabled: boolean;
    fileFormat: TLightmapFileFormat;
begin
    warning := '';
    compressionEnabled := false;

    if cboLightmapFileFormat.ItemIndex <> -1 then begin
        fileFormat := LIGHTMAP_FILEFORMATS[cboLightmapFileFormat.ItemIndex];

        if fileFormat.Lossy then begin
            compressionEnabled := true;
            warning := Format( 'Warning: Using a lossy fileformat like %s to store lightmap information ' +
                'may cause visible lighting artifacts. ', [fileFormat.description] );
        end;
    end;

    lblLossyWarning.Caption := warning;

    pnlLightmapCompressionQuality.Visible := compressionEnabled;
end;

procedure TfrmOptions.chkLightingClick(Sender: TObject);
begin
    // INFO, PJ: This will be changed into a combobox some day.
    if chkLighting.Checked then
        RenderOptions.LightingType := rltCamera
    else
        RenderOptions.LightingType := rltNone;
end;

procedure TfrmOptions.edGizmoSizeChange(Sender: TObject);
begin
    if Length(edGizmoSize.Text)>0 then
        RenderOptions.GizmoSize := StrToInt(edGizmoSize.Text);
end;



end.

