{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit frmPluginsForm;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Graphics,
  unit_Plugins,
  unit_PluginManager;

type
  TfrmPlugins = class(TForm)
    panTop: TPanel;
    lblTitle: TLabel;
    Image2: TImage;
    panBottom: TPanel;
    Image3: TImage;
    btnOK: TButton;
    lvPlugins: TListView;
    lblPlugins: TLabel;
    lblPluginLog: TLabel;
    memPluginLog: TMemo;
    btnClearLog: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnClearLogClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    fPluginManager: TPluginManager;
  public
    constructor Create(AOwner: TComponent; APluginManager: TPluginManager); reintroduce;
  end;

implementation

{$R *.lfm}

constructor TfrmPlugins.Create(AOwner: TComponent; APluginManager: TPluginManager);
begin
    inherited Create(AOwner);
    fPluginManager := APluginManager;
end;

procedure TfrmPlugins.FormCreate(Sender: TObject);
var i: integer;
    plugin: TPlugin;
    listitem: TListItem;
begin
    // load plugin info into listview
    for i := 0 to fPluginManager.Count-1 do begin
        plugin := fPluginManager.Plugins[i]; // .GetPlugin(i);
        listitem := lvPlugins.Items.Add;
        listitem.Caption := plugin.DLLname;
        listitem.SubItems.Add(plugin.Name);
        listitem.SubItems.Add(plugin.VersionPlugin);
        listitem.SubItems.Add(plugin.VersionDeleD);
        listitem.SubItems.Add(plugin.Description);
        listitem.SubItems.Add(plugin.Author);
        listitem.SubItems.Add(plugin.Email);
    end;

    // load logfile into memo
    memPluginLog.Lines.LoadFromFile(fPluginManager.Log.Filename);
end;

procedure TfrmPlugins.btnClearLogClick(Sender: TObject);
begin
    fPluginManager.Log.ClearLog(DateTimeToStr(Now)+': Plugin logfile created.');
    memPluginLog.Lines.LoadFromFile(fPluginManager.Log.Filename);
end;

procedure TfrmPlugins.btnOKClick(Sender: TObject);
begin
    Close;
end;

end.
