{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit frmStandardDialogForm;

{$MODE Delphi}

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
     Buttons, ExtCtrls;

type
  TfrmStandardDialog = class(TForm)
    panTop: TPanel;
    lblTitle: TLabel;
    panBottom: TPanel;
    Image3: TImage;
    OKButton: TButton;
    Image2: TImage;
  private
  protected
    procedure InitializeFloatField(const aField: TEdit);
    procedure HandleFloatFieldKeyPress(aSender: TObject; var aKey: Char);       
  public
  end;

implementation

{$R *.lfm}


procedure TfrmStandardDialog.HandleFloatFieldKeyPress(aSender: TObject; var aKey: Char);
var edit: TEdit;
begin
    if aKey in ['0'..'9', '.', Chr(VK_BACK)] then begin
        if aKey = '.' then begin
            edit := aSender as TEdit;

            if Pos('.', edit.Text) <> 0 then begin
                aKey := #0;
            end;
        end;
    end
    else
        aKey := #0;
end;


procedure TfrmStandardDialog.InitializeFloatField(const aField: TEdit);
begin
    aField.OnKeyPress := HandleFloatFieldKeyPress;
end;

end.

