{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesAlign;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Enums, ExtCtrls;

type
  TfraCommandPropAlign = class(TfraCommandPropDefault)
    rbutAlignX: TRadioButton;
    rbutAlignY: TRadioButton;
    rbutAlignZ: TRadioButton;
    Panel1: TPanel;
    rbSpaceEqually: TRadioButton;
    rbAlignCenters: TRadioButton;
    procedure Button1Click(Sender: TObject);
  private
  protected
  public
  end;

implementation

uses
  unit_Variables,
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropAlign.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    if Scene.SelectedPrimitives.Count=0 then
        MessageDlg('Please select one or more objects to align.',mtWarning,[mbOk],0)
    else begin
        paramList := TParamList.Create(false);
        paramList.Add(rbSpaceEqually.Checked,'doSpaceEqually',true);
        if rbutAlignX.Checked then paramList.Add(integer(adAlignX),'alignDimension');
        if rbutAlignY.Checked then paramList.Add(integer(adAlignY),'alignDimension');
        if rbutAlignZ.Checked then paramList.Add(integer(adAlignZ),'alignDimension');
        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
        FreeAndNil(paramList);
    end;
    inherited;
end;

end.


