{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesAverage;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Enums,
  unit_Variables;

type
  TfraCommandPropAverage = class(TfraCommandPropDefault)
    rbutAllDimensions: TRadioButton;
    rbutActiveView: TRadioButton;
    procedure Button1Click(Sender: TObject);
  private
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropAverage.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    paramList := TParamList.Create;
    if Scene.SelectedVertices.Count<2 then
        MessageDlg('Please select two or more vertices to average.',mtWarning,[mbOk],0)
    else begin
        if rbutActiveView.Checked then
            paramList.Add(integer(active_viewmode),'viewMode',true)
        else
            paramList.Add(integer(vmPerspective),'viewMode',true)
    end;
    Scene.ToolExecuter.Execute(editTool,editMode,paramList);
    FreeAndNil(paramList);
    inherited;
end;

end.
