{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesClone;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls;

type
  TfraCommandPropClone = class(TfraCommandPropDefault)
    lblNumber: TLabel;
    edNumberOfCopies: TEdit;
    lblTranslateOffsetX: TLabel;
    lblTranslateOffsetY: TLabel;
    lblTranslateOffsetZ: TLabel;
    edTranslateX: TEdit;
    edTranslateY: TEdit;
    edTranslateZ: TEdit;
    lblRotateOffsetX: TLabel;
    lblRotateOffsetY: TLabel;
    lblRotateOffsetZ: TLabel;
    edRotateX: TEdit;
    edRotateY: TEdit;
    edRotateZ: TEdit;
    btnReset: TButton;
    procedure btnResetClick(Sender: TObject);
    procedure edNumberOfCopiesChange(Sender: TObject);
    procedure edNumberOfCopiesKeyPress(Sender: TObject; var Key: Char);
    procedure edTranslateXKeyPress(Sender: TObject; var Key: Char);
    procedure edTranslateYKeyPress(Sender: TObject; var Key: Char);
    procedure edTranslateZKeyPress(Sender: TObject; var Key: Char);
    procedure edRotateXKeyPress(Sender: TObject; var Key: Char);
    procedure edRotateYKeyPress(Sender: TObject; var Key: Char);
    procedure edRotateZKeyPress(Sender: TObject; var Key: Char);
    procedure edTranslateXChange(Sender: TObject);
    procedure edTranslateYChange(Sender: TObject);
    procedure edTranslateZChange(Sender: TObject);
    procedure edRotateXChange(Sender: TObject);
    procedure edRotateYChange(Sender: TObject);
    procedure edRotateZChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public

  end;

implementation

uses
  unit_Enums,
  unit_Variables,
  unit_Functions,
  unit_Options,
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropClone.btnResetClick(Sender: TObject);
begin
    edNumberOfCopies.Text := '1';
    edTranslateX.Text := '0';
    edTranslateY.Text := '0';
    edTranslateZ.Text := '0';
    edRotateX.Text := '0';
    edRotateY.Text := '0';
    edRotateZ.Text := '0';
end;

procedure TfraCommandPropClone.Initialize;
begin
    inherited;
    with CloneOptions do begin
        edNumberOfCopies.Text := IntToStr(numberofcopies);
        edTranslateX.Text := IntToStr(translateoffsetX);
        edTranslateY.Text := IntToStr(translateoffsetY);
        edTranslateZ.Text := IntToStr(translateoffsetZ);
        edRotateX.Text := IntToStr(rotateoffsetX);
        edRotateY.Text := IntToStr(rotateoffsetY);
        edRotateZ.Text := IntToStr(rotateoffsetZ);
    end;
end;

procedure TfraCommandPropClone.edNumberOfCopiesKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCommandPropClone.edTranslateXKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),'-']) then Key := #0;
end;

procedure TfraCommandPropClone.edTranslateYKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),'-']) then Key := #0;
end;

procedure TfraCommandPropClone.edTranslateZKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),'-']) then Key := #0;
end;

procedure TfraCommandPropClone.edRotateXKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),'-']) then Key := #0;
end;

procedure TfraCommandPropClone.edRotateYKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),'-']) then Key := #0;
end;

procedure TfraCommandPropClone.edRotateZKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),'-']) then Key := #0;
end;

procedure TfraCommandPropClone.edNumberOfCopiesChange(Sender: TObject);
begin
    if IsNumeric(edNumberOfCopies.Text) then
        CloneOptions.numberofcopies := strtoint(edNumberOfCopies.Text)
    else
        CloneOptions.numberofcopies := 1;
end;

procedure TfraCommandPropClone.edTranslateXChange(Sender: TObject);
begin
    if IsNumeric(edTranslateX.Text) then
        CloneOptions.translateoffsetX := strtoint(edTranslateX.Text)
    else
        CloneOptions.translateoffsetX := 0;
end;

procedure TfraCommandPropClone.edTranslateYChange(Sender: TObject);
begin
    if IsNumeric(edTranslateY.Text) then
        CloneOptions.translateoffsetY := strtoint(edTranslateY.Text)
    else
        CloneOptions.translateoffsetY := 0;
end;

procedure TfraCommandPropClone.edTranslateZChange(Sender: TObject);
begin
    if IsNumeric(edTranslateZ.Text) then
        CloneOptions.translateoffsetZ := strtoint(edTranslateZ.Text)
    else
        CloneOptions.translateoffsetZ := 0;
end;

procedure TfraCommandPropClone.edRotateXChange(Sender: TObject);
begin
    if IsNumeric(edRotateX.Text) then
        CloneOptions.rotateoffsetX := strtoint(edRotateX.Text)
    else
        CloneOptions.rotateoffsetX := 0;
end;

procedure TfraCommandPropClone.edRotateYChange(Sender: TObject);
begin
    if IsNumeric(edRotateY.Text) then
        CloneOptions.rotateoffsetY := strtoint(edRotateY.Text)
    else
        CloneOptions.rotateoffsetY := 0;
end;

procedure TfraCommandPropClone.edRotateZChange(Sender: TObject);
begin
    if IsNumeric(edRotateZ.Text) then
        CloneOptions.rotateoffsetZ := strtoint(edRotateZ.Text)
    else
        CloneOptions.rotateoffsetZ := 0;
end;

procedure TfraCommandPropClone.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    paramList := TParamList.Create(false);
    try
        paramList.Add(CloneOptions,'cloneOptions',true);
        Screen.Cursor := crHourGlass;
        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
    finally
        FreeAndNil(paramList);
        Screen.Cursor := crDefault;
    end;
    inherited;
end;

end.
