{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesExtract;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls;

type
  TfraCommandPropExtract = class(TfraCommandPropDefault)
    chkRemoveOriginalPolygons: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure chkRemoveOriginalPolygonsClick(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  end;

implementation

uses
  unit_Variables,
  unit_Enums,
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropExtract.Initialize;
begin
    inherited;
    chkRemoveOriginalPolygons.Checked := defaultExtractRemoveOriginalPolygons;
end;

procedure TfraCommandPropExtract.chkRemoveOriginalPolygonsClick(Sender: TObject);
begin
    defaultExtractRemoveOriginalPolygons := chkRemoveOriginalPolygons.Checked;
end;

procedure TfraCommandPropExtract.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    if Scene.SelectedPrimitives.Count=0 then
        MessageDlg('Please select one or more polygons.',mtError,[mbOK],0)
    else begin
        paramList := TParamList.Create(true);
        paramList.Add(defaultExtractRemoveOriginalPolygons,'removeFromScene',true);
        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
        FreeAndNil(paramList);
    end;
    inherited;
end;

end.
 
