{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesExtrude;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  fraCommandPropertiesDefault,
  unit_Variables;

type
  TfraCommandPropExtrude = class(TfraCommandPropDefault)
    chkKeepOriginal: TCheckBox;
    chkFlipOriginal: TCheckBox;
    chkByRegion: TCheckBox;
    procedure chkKeepOriginalClick(Sender: TObject);
    procedure chkFlipOriginalClick(Sender: TObject);
    procedure chkByRegionClick(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public
  end;

implementation

{$R *.lfm}

procedure TfraCommandPropExtrude.chkKeepOriginalClick(Sender: TObject);
begin
    toggleExtrudeKeepOriginal := chkKeepOriginal.Checked;
    if toggleExtrudeKeepOriginal then
        chkFlipOriginal.Enabled := true
    else
        chkFlipOriginal.Enabled := false;
end;

procedure TfraCommandPropExtrude.chkFlipOriginalClick(Sender: TObject);
begin
    toggleExtrudeFlipOriginal := chkFlipOriginal.Checked;
end;

procedure TfraCommandPropExtrude.chkByRegionClick(Sender: TObject);
begin
    toggleExtrudeByRegion := chkByRegion.Checked;
end;

procedure TfraCommandPropExtrude.Initialize;
begin
    inherited;
    chkKeepOriginal.Checked := toggleExtrudeKeepOriginal;
    chkFlipOriginal.Checked := toggleExtrudeFlipOriginal;
    chkFlipOriginal.Enabled := toggleExtrudeKeepOriginal;
    chkByRegion.Checked := toggleExtrudeByRegion;
end;



end.
