{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesHollow;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,  fraCommandPropertiesDefault, StdCtrls,
  unit_Enums,
  unit_Variables;

type
  TfraCommandPropHollow = class(TfraCommandPropDefault)
    lblDepth: TLabel;
    edDepth: TEdit;
    chkSegmented: TRadioButton;
    chkMerged: TRadioButton;
    lblPercentage: TLabel;
    edPercentage: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure edDepthKeyPress(Sender: TObject; var Key: Char);
    procedure edPercentageExit(Sender: TObject);
    procedure edDepthExit(Sender: TObject);
    procedure chkSegmentedClick(Sender: TObject);
    procedure chkMergedClick(Sender: TObject);
    procedure edPercentageKeyPress(Sender: TObject; var Key: Char);
  protected
    procedure Initialize; override;
  private
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropHollow.Initialize;
begin
    edDepth.Text := IntToStr(defaultHollowDepth);
    edPercentage.Text := IntToStr(defaultHollowPercentage);
    chkMergedClick(nil);
end;

procedure TfraCommandPropHollow.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    paramList := TParamList.Create(true);
    if chkSegmented.Checked then begin
        paramList.Add(true,'doHollowByUnits',true);
        paramList.Add(Longint(-defaultHollowDepth),'integerValue');
    end else begin
        paramList.Add(false,'doHollowByUnits',true);
        paramList.Add(defaultHollowPercentage,'integerValue');
    end;

    Scene.ToolExecuter.Execute(editTool,editMode,paramList);

    FreeAndNil(paramList);
    inherited;
end;

procedure TfraCommandPropHollow.edDepthKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCommandPropHollow.edPercentageKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCommandPropHollow.edPercentageExit(Sender: TObject);
begin
    if length(edPercentage.Text)>0 then begin
        defaultHollowPercentage := StrToInt(edPercentage.Text);
        if defaultHollowPercentage>99 then begin
            defaultHollowPercentage := 99;
            edPercentage.Text := IntToStr(defaultHollowPercentage);
        end;
    end else begin
        defaultHollowPercentage := 90;
        edPercentage.Text := IntToStr(defaultHollowPercentage);
    end;
end;

procedure TfraCommandPropHollow.edDepthExit(Sender: TObject);
begin
    if length(edDepth.Text)>0 then
        defaultHollowDepth := StrToInt(edDepth.Text)
    else begin
        defaultHollowDepth := 30;
        edDepth.Text := IntToStr(defaultHollowDepth);
    end;
end;

procedure TfraCommandPropHollow.chkSegmentedClick(Sender: TObject);
begin
    lblDepth.Enabled := true;
    edDepth.Enabled := true;
    lblPercentage.Enabled := false;
    edPercentage.Enabled := false;
end;

procedure TfraCommandPropHollow.chkMergedClick(Sender: TObject);
begin
    lblDepth.Enabled := false;
    edDepth.Enabled := false;
    lblPercentage.Enabled := true;
    edPercentage.Enabled := true;
end;



end.
