{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesInset;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls, ComCtrls,
  unit_Types,
  unit_Enums,
  unit_Variables;

type
  TfraCommandPropInset = class(TfraCommandPropDefault)
    lblRecursive: TLabel;
    lblScale: TLabel;
    edRecursive: TEdit;
    edScalePerc: TEdit;
    udRecursive: TUpDown;
    udScale: TUpDown;
    procedure Button1Click(Sender: TObject);
  private
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropInset.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    try
        if Scene.SelectedPrimitives.Count=0 then
            MessageDlg('Please select one or more polygons.',mtWarning,[mbOk],0)
        else begin
            if edRecursive.Text='' then edRecursive.Text := '1';
            if edScalePerc.Text='' then edScalePerc.Text := '1';

            paramList := TParamList.Create(false);
            paramList.Add(StrToInt(edRecursive.Text),'recursiveCalls',true);
            paramList.Add(StrToInt(edScalePerc.Text),'scalePercentage');

            // parameters for scaling; used by the Execute method of the PolygonInsetter tool
            paramList.Add(TVertice.Create(1,1,1),'deltaVector',false,true);
            paramList.Add(true,'doIndividualScale');

            Scene.ToolExecuter.Execute(editTool,editMode,paramList);
            FreeAndNil(paramList);
        end;
    except
        on E: EConvertError do
            MessageDlg(E.Message,mtError,[mbOK],0);
    end;
    inherited;
end;

end.
