{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesLathe;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Variables,
  unit_Enums;

type
  TfraCommandPropLathe = class(TfraCommandPropDefault)
    lblSegments: TLabel;
    edSegments: TEdit;
    lblDegrees: TLabel;
    edDegrees: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure edSegmentsKeyPress(Sender: TObject; var Key: Char);
    procedure edSegmentsChange(Sender: TObject);
    procedure edDegreesChange(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropLathe.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    if Scene.SelectedPrimitives.Count>1 then
        MessageDlg('Can only perform Lathe on an object with a single polygon. Try using a PolyLine object.',mtError,[mbOK],0)
    else begin
        paramList := TParamList.Create(true);
        paramList.Add(defaultLatheSegments,'numberOfSegments',true);
        paramList.Add(defaultLatheDegrees,'amountOfDegrees');
        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
        FreeAndNil(paramList);
    end;
    inherited;
end;

procedure TfraCommandPropLathe.edSegmentsKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCommandPropLathe.Initialize;
begin
    inherited;
    edSegments.Text := IntToStr(defaultLatheSegments);
    edDegrees.Text := IntToStr(defaultLatheDegrees);
end;

procedure TfraCommandPropLathe.edSegmentsChange(Sender: TObject);
begin
    if Trim(edSegments.Text)<>'' then begin
        defaultLatheSegments := StrToInt(edSegments.Text);
        if defaultLatheSegments<1 then begin
            defaultLatheSegments := 1;
            edSegments.Text := IntToStr(defaultLatheSegments);
        end;
    end;
end;

procedure TfraCommandPropLathe.edDegreesChange(Sender: TObject);
begin
    if Trim(edDegrees.Text)<>'' then begin
        defaultLatheDegrees := StrToInt(edDegrees.Text);
        if defaultLatheDegrees<1 then begin
            defaultLatheDegrees := 360;
            edDegrees.Text := IntToStr(defaultLatheDegrees);
        end;
    end;
end;

end.
