{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesMagnet;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls, Buttons, ImgList,
  ComCtrls, ToolWin;

type
  TfraCommandPropMagnet = class(TfraCommandPropDefault)
    edMagnetRange: TEdit;
    lblMagnetRange: TLabel;
    tbMagnetTypes: TToolBar;
    tbHill: TToolButton;
    tbSmooth: TToolButton;
    tbSharp: TToolButton;
    tbLinear: TToolButton;
    ToolButton8: TToolButton;
    ImageList1: TImageList;
    procedure edMagnetRangeChange(Sender: TObject);
    procedure edMagnetRangeKeyPress(Sender: TObject; var Key: Char);
    procedure tbHillClick(Sender: TObject);
    procedure tbSmoothClick(Sender: TObject);
    procedure tbSharpClick(Sender: TObject);
    procedure tbLinearClick(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public
  end;

implementation

uses unit_Variables, unit_Enums;

{$R *.lfm}


procedure TfraCommandPropMagnet.Initialize;
begin
    edMagnetRange.Text := IntToStr(defaultMagnetRange);

    case defaultMagnetType of
        mtHill:
            tbHill.Down := true;
        mtSmooth:
            tbSmooth.Down := true;
        mtSharp:
            tbSharp.Down := true;
        mtLinear:
            tbLinear.Down := true;
    end;
end;

procedure TfraCommandPropMagnet.edMagnetRangeChange(Sender: TObject);
begin
    if edMagnetRange.Text <> '' then
        defaultMagnetRange := StrToInt(edMagnetRange.Text);
end;

procedure TfraCommandPropMagnet.edMagnetRangeKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCommandPropMagnet.tbHillClick(Sender: TObject);
begin
    defaultMagnetType := mtHill;
end;

procedure TfraCommandPropMagnet.tbSmoothClick(Sender: TObject);
begin
    defaultMagnetType := mtSmooth;
end;

procedure TfraCommandPropMagnet.tbSharpClick(Sender: TObject);
begin
    defaultMagnetType := mtSharp;
end;

procedure TfraCommandPropMagnet.tbLinearClick(Sender: TObject);
begin
    defaultMagnetType := mtLinear;
end;

end.
