{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesMirror;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,
  fraCommandPropertiesDefault;

type
  TfraCommandPropMirror = class(TfraCommandPropDefault)
    rbutMirrorX: TRadioButton;
    rbutMirrorY: TRadioButton;
    rbutMirrorZ: TRadioButton;
    procedure Button1Click(Sender: TObject);
  private
  public
  end;

implementation

uses
  unit_ParamList,
  unit_Enums,
  unit_Variables;

{$R *.lfm}

procedure TfraCommandPropMirror.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    if Scene.SelectedPrimitives.Count=0 then
        MessageDlg('Please select one or more objects to mirror.',mtWarning,[mbOk],0)
    else begin
        paramList := TParamList.Create(true);
        if rbutMirrorX.Checked then paramList.Add(integer(mmMirrorX),'mirrorMethod');
        if rbutMirrorY.Checked then paramList.Add(integer(mmMirrorY),'mirrorMethod');
        if rbutMirrorZ.Checked then paramList.Add(integer(mmMirrorZ),'mirrorMethod');

        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
        FreeAndNil(paramList);
    end;
    inherited;
end;

end.
