{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }

{******************************************************************************
                              Added by Fik
  Seemed a shame as functionality there to move polygon by face normal not to
  use it. But would have made General move frame to messy. So this seemed best
  idea to seperate as done with UV's

*******************************************************************************}

unit fraCommandPropertiesMovePolygon;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Types,
  unit_Enums,
  unit_Scene,
  unit_Variables,
  unit_ParamList;

type
  TfraCommandPropMovePolygon = class(TfraCommandPropDefault)
    edZvalue: TEdit;
    edYvalue: TEdit;
    edXvalue: TEdit;
    LabelX: TLabel;
    LabelY: TLabel;
    LabelZ: TLabel;
    btnReset: TButton;
    rbMoveRelative: TRadioButton;
    rbMoveNormal: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure edXvalueKeyPress(Sender: TObject; var Key: Char);
    procedure btnResetClick(Sender: TObject);
    procedure rbMoveRelativeClick(Sender: TObject);
    procedure rbMoveNormalClick(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public
    procedure Invalidate; override;
  end;

implementation

{$R *.lfm}

procedure TfraCommandPropMovePolygon.Initialize;
begin
    if defaultMoveRelative then
        rbMoveRelative.Checked := true
    else
        rbMoveRelative.Enabled := true;


end;

procedure TfraCommandPropMovePolygon.Invalidate;
begin
    inherited;
    // what here

end;

procedure TfraCommandPropMovePolygon.rbMoveRelativeClick(Sender: TObject);
begin
    defaultMoveRelative := True;
    labelX.Caption := 'X translation:';
    labelY.Visible := True;
    edYvalue.Visible := True;
    labelZ.Visible := True;
    edZvalue.Visible := True;
end;

procedure TfraCommandPropMovePolygon.rbMoveNormalClick(Sender: TObject);
begin
    defaultMoveRelative := True;
    labelX.Caption := 'translation:';
    labelY.Visible := False;
    edYvalue.Visible := False;
    labelZ.Visible := False;
    edZvalue.Visible := False;
end;

procedure TfraCommandPropMovePolygon.Button1Click(Sender: TObject);
var d: TVertice;
    x,y,z: double;
    paramList: TParamList;
begin
    try
        if Scene.SelectedPrimitives.Count=0 then
            MessageDlg('Please select one or more objects.',mtWarning,[mbOk],0)
        else begin
            if edXvalue.Text='' then edXvalue.Text := '0';
            if edYvalue.Text='' then edYvalue.Text := '0';
            if edZvalue.Text='' then edZvalue.Text := '0';
            x := -StrToFloat(edXvalue.Text);
            y := -StrToFloat(edYvalue.Text);
            z := -StrToFloat(edZvalue.Text);
            if  not(rbMoveNormal.Checked) then
                Begin
                case editdimension  of
                    edX:    begin
                            y := 0;
                            z := 0;
                    end;
                    edY:    begin
                            x := 0;
                            z := 0;
                    end;
                    edZ:    begin
                            x := 0;
                            y := 0;
                    end;
                end;
            End;
            d := TVertice.Create(x,y,z);
            paramList := TParamList.Create(true);
            paramList.Add(d.copy,'deltaVector',true,false);
            paramList.Add(not(rbMoveRelative.Checked),'moveByNormal');
            Scene.ToolExecuter.Execute(ptPolygonMover,taModification,paramList);
            FreeAndNil(paramList);
            FreeAndNil(d);
        end;
    except
        on E: EConvertError do
            MessageDlg(E.Message,mtError,[mbOK],0);
    end;
    inherited;
end;

procedure TfraCommandPropMovePolygon.edXvalueKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['-','0'..'9','.',Chr(VK_BACK)]) then Key := #0;
    if (key = '.') and (Pos(key, (Sender as TEdit).Text) > 0) then Key := #0;
    if ((sender as tEdit).SelStart<>0) and (key = '-') then key := #0;

end;

procedure TfraCommandPropMovePolygon.btnResetClick(Sender: TObject);
begin
    edXvalue.Text := '0';
    edYvalue.Text := '0';
    edZvalue.Text := '0';
end;




end.
