{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesMoveUV;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Types,
  unit_Enums,
  unit_Scene,
  unit_Variables;

type
  TfraCommandPropMoveUV = class(TfraCommandPropDefault)
    lblU: TLabel;
    edUvalue: TEdit;
    lblV: TLabel;
    edVvalue: TEdit;
    btnReset: TButton;
    procedure Button1Click(Sender: TObject);
    procedure edUvalueKeyPress(Sender: TObject; var Key: Char);
    procedure btnResetClick(Sender: TObject);
  private
  public
  end;

implementation

{$R *.lfm}

uses
  unit_ParamList,
  unit_Math;

procedure TfraCommandPropMoveUV.Button1Click(Sender: TObject);
var fParamList: TParamList;
    deltaUV: TUVCoordinate;
begin
    try
        if Scene.SelectedPrimitives.Count=0 then
            MessageDlg('Please select one or more objects.',mtWarning,[mbOk],0)
        else begin
            if edUvalue.Text='' then edUvalue.Text := '0';
            if edVvalue.Text='' then edVvalue.Text := '0';

            deltaUV := UVCoordinate(-StrtoFloat(edUvalue.Text), -StrToFloat(edVvalue.Text));

            fParamList := TParamList.Create();
            fParamList.Add(deltaUV,'delta',true);
            fParamList.Add(integer(esRelative),'editStyle');
            fParamList.Add(Scene.SelectedUVCoordinates,'uvSelection',false,false);
            Scene.ToolExecuter.Execute(ptFaceMover,taModification,fParamList);
            FreeAndNil(fParamList);
        end;
    except
        on E: EConvertError do
            MessageDlg(E.Message,mtError,[mbOK],0);
    end;
    inherited;
end;

procedure TfraCommandPropMoveUV.edUvalueKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['-','0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCommandPropMoveUV.btnResetClick(Sender: TObject);
begin
    edUvalue.Text := '0';
    edVvalue.Text := '0';
end;



end.
 
