{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesScaleUV;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Types,
  unit_Enums,
  unit_Scene,
  unit_Variables;  

type
  TfraCommandPropScaleUV = class(TfraCommandPropDefault)
    lblU: TLabel;
    edUvalue: TEdit;
    edVvalue: TEdit;
    lblV: TLabel;
    btnReset: TButton;
    procedure edUvalueKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
  private
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropScaleUV.edUvalueKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['-','0'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCommandPropScaleUV.Button1Click(Sender: TObject);
var delta: TUVCoordinate;
    fParamList: TParamList;
begin
    if Scene.SelectedPrimitives.Count=0 then
        MessageDlg('Please select one or more objects.',mtWarning,[mbOk],0)
    else begin
        if edUvalue.Text='' then edUvalue.Text := '100';
        if edVvalue.Text='' then edVvalue.Text := '100';

        delta.U := StrToFloat(edUvalue.Text) / 100;
        delta.V := StrToFloat(edVValue.Text ) / 100;

        fParamList := TParamList.Create();
        fParamList.Add(delta,'delta',true);
        fParamList.Add(false,'useLocalPivotPoint');
        fParamList.Add(editMode=emVertex,'doSelectionOnly');
        fParamList.Add(Scene.SelectedUVCoordinates,'uvSelection',false,false);
        Scene.ToolExecuter.Execute(ptFaceScaler,taModification,fParamList);
        FreeAndNil(fParamList);
    end;
    inherited;
end;

procedure TfraCommandPropScaleUV.btnResetClick(Sender: TObject);
begin
    edUValue.Text := IntToStr(100);
    edVValue.Text := IntToStr(100);
end;

end.
