{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesSmooth;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Variables,
  unit_Enums;

type
  TfraCommandPropSmooth = class(TfraCommandPropDefault)
    rbCatmullClark: TRadioButton;
    rbDooSabin: TRadioButton;
    lblRoundingPercentage: TLabel;
    edRoundingPercentage: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure rbCatmullClarkClick(Sender: TObject);
    procedure rbDooSabinClick(Sender: TObject);
    procedure edRoundingPercentageKeyPress(Sender: TObject; var Key: Char);
    procedure edRoundingPercentageChange(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropSmooth.Initialize;
begin
    if editMode = emObject then begin
        rbCatmullClark.Enabled := true;
        if defaultSmoothScheme=0 then begin
            rbCatmullClark.Checked := true;
            lblRoundingPercentage.Enabled := false;
            edRoundingPercentage.Enabled := false;
        end else begin
            rbDooSabin.Checked := true;
            lblRoundingPercentage.Enabled := true;
            edRoundingPercentage.Enabled := true;
        end;
    end else begin
        rbCatmullClark.Checked := false;
        rbCatmullClark.Enabled := false;
        rbDooSabin.Checked := true;
        lblRoundingPercentage.Enabled := true;
        edRoundingPercentage.Enabled := true;
    end;
    edRoundingPercentage.Text := IntToStr(defaultDooSabinRounding);
end;

procedure TfraCommandPropSmooth.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    if defaultDooSabinRounding>100 then begin
        defaultDooSabinRounding := 100;
        edRoundingPercentage.Text := '100';
    end;

    Screen.Cursor := crHourGlass;
    try
        paramList := TParamList.Create(true);
        paramList.Add(rbCatmullClark.Checked, 'catMullClark', true);
        paramList.Add(defaultDooSabinRounding, 'dooSabinRounding');
        paramList.Add(integer(editMode), 'editMode');
        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
        FreeAndNil(paramList);
        Scene.UpdateGUI;
    finally
        Screen.Cursor := crDefault;
    end;
    inherited;
end;

procedure TfraCommandPropSmooth.rbCatmullClarkClick(Sender: TObject);
begin
    defaultSmoothScheme := integer(ssCatmullClark);
    lblRoundingPercentage.Enabled := false;
    edRoundingPercentage.Enabled := false;
end;

procedure TfraCommandPropSmooth.rbDooSabinClick(Sender: TObject);
begin
    defaultSmoothScheme := integer(ssDooSabin);
    lblRoundingPercentage.Enabled := true;
    edRoundingPercentage.Enabled := true;
end;

procedure TfraCommandPropSmooth.edRoundingPercentageKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in ['0'..'9',Char(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCommandPropSmooth.edRoundingPercentageChange(Sender: TObject);
begin
    if Length(edRoundingPercentage.Text) > 0 then
        defaultDooSabinRounding := StrToInt(edRoundingPercentage.Text);
end;

end.
