{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesSnap;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls;

type
  TfraCommandPropSnap = class(TfraCommandPropDefault)
    rbScene: TRadioButton;
    rbSelection: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure rbSceneClick(Sender: TObject);
    procedure rbSelectionClick(Sender: TObject);
  private
  protected
    procedure Initialize; override;
  public
  end;

implementation

{$R *.lfm}

uses
  unit_Scene,
  unit_Variables,
  unit_Enums,
  unit_ParamList;

procedure TfraCommandPropSnap.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    paramList := TParamList.Create(false);
    try
        paramList.Add(gridSize,'snapValue',true);
        paramList.Add(integer(editMode),'editMode');

        if rbScene.Checked then begin
            if MessageDlg('Vertex snap will be used for all objects. Are you sure you want to snap the entire scene to the current grid?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
                paramList.Add(true,'doAllPrimitives');
            end;
        end else begin
            paramList.Add(false,'doAllPrimitives');
        end;

        Scene.ToolExecuter.Execute(ptPrimitiveSnapper,taModification, paramList);
    finally
        FreeAndNil(paramList);
    end;
    inherited;
end;

procedure TfraCommandPropSnap.Initialize;
begin
    case defaultSnapContext of
        scScene:
            rbScene.Checked := true;
        scSelection:
            rbSelection.Checked := true;
    end;
end;

procedure TfraCommandPropSnap.rbSceneClick(Sender: TObject);
begin
    defaultSnapContext := scScene;
end;

procedure TfraCommandPropSnap.rbSelectionClick(Sender: TObject);
begin
    defaultSnapContext := scSelection;
end;

end.
 
