{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesSplitEdge;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls,
  unit_Enums,
  unit_ParamList,
  unit_Variables;

type
  TfraCommandPropSplitEdge = class(TfraCommandPropDefault)
    LabelX: TLabel;
    edNumOfSplits: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure edNumOfSplitsKeyPress(Sender: TObject; var Key: Char);
    procedure edNumOfSplitsExit(Sender: TObject);
  protected
    procedure Initialize; override;
  private
  public
  end;

implementation

{$R *.lfm}

procedure TfraCommandPropSplitEdge.Initialize;
begin
    edNumOfSplits.Text := IntToStr(defaultSplitEdge);
end;

procedure TfraCommandPropSplitEdge.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    if Scene.SelectedEdges.Count=0 then
        MessageDlg('Please select one or more edges.',mtWarning,[mbOk],0)
    else begin
        if (edNumOfSplits.Text='') or (edNumOfSplits.Text='1') then
            MessageDlg('Please choose a value higher than one.',mtWarning,[mbOk],0)
        else begin
            try
                paramList := TParamList.Create(true);
                paramList.Add(defaultSplitEdge, 'splitEdge');
                Scene.ToolExecuter.Execute(editTool,editMode,paramList);
                FreeAndNil(paramList);
            except
                on E:Exception do MessageDlg(E.Message,mtError,[mbOK],0);
            end;
        end;
    end;
    inherited;
end;

procedure TfraCommandPropSplitEdge.edNumOfSplitsKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCommandPropSplitEdge.edNumOfSplitsExit(Sender: TObject);
begin
    if length(edNumOfSplits.Text)>0 then
        if defaultSplitEdge<2 then begin
            defaultSplitEdge := 2;
            edNumOfSplits.Text := IntToStr(defaultSplitEdge);
        end else
            defaultSplitEdge := StrToInt(edNumOfSplits.Text)
    else begin
        defaultSplitEdge := 2;
        edNumOfSplits.Text := IntToStr(defaultSplitEdge);
    end;
end;

end.
