{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCommandPropertiesTriangulate;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCommandPropertiesDefault, StdCtrls, ExtCtrls,
  unit_Enums,
  unit_Variables;

type
  TfraCommandPropTriangulate = class(TfraCommandPropDefault)
    rbutCentroid: TRadioButton;
    rbutNormal: TRadioButton;
    chkAllPolygons: TCheckBox;
    procedure Button1Click(Sender: TObject);
  private
  protected
     procedure Initialize; override;
  public
  end;

implementation

uses
  unit_ParamList;

{$R *.lfm}

procedure TfraCommandPropTriangulate.Button1Click(Sender: TObject);
var paramList: TParamList;
begin
    try
        Screen.Cursor := crHourGlass;

        paramList := TParamList.Create(false);
        paramList.Add(rbutCentroid.Checked,'doCentriodTriangulation',true);
        paramList.Add(not chkAllPolygons.Checked,'doSelectionOnly');
        Scene.ToolExecuter.Execute(editTool,editMode,paramList);
        FreeAndNil(paramList);

        Screen.Cursor := crDefault;
    except
        on E:Exception do
            MessageDlg('Error during triangulation: invalid geometry. Please restart DeleD.',mtError,[mbOK],0);
    end;
    inherited;
end;

procedure TfraCommandPropTriangulate.Initialize;
begin
    inherited;
    chkAllPolygons.Checked := editMode=emObject;
end;

end.
