{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesCube;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  fraCreatePropertiesDefault,
  unit_Variables;

type
  TfraCreatePropCube = class(TfraCreatePropDefault)
    Label2: TLabel;
    edDivX: TEdit;
    Label3: TLabel;
    edDivY: TEdit;
    Label4: TLabel;
    edDivZ: TEdit;
    UDdivX: TUpDown;
    UDdivY: TUpDown;
    UDdivZ: TUpDown;
    Label12: TLabel;
    Label13: TLabel;
    Label10: TLabel;
    edHeight: TEdit;
    edDepth: TEdit;
    edWidth: TEdit;
    UDHeight: TUpDown;
    UDDepth: TUpDown;
    UDWidth: TUpDown;
    procedure edDivXKeyPress(Sender: TObject; var Key: Char);
    procedure edHeightKeyPress(Sender: TObject; var Key: Char);
    procedure UDHeightClick(Sender: TObject; Button: TUDBtnType);
    procedure UDDepthClick(Sender: TObject; Button: TUDBtnType);
    procedure UDWidthClick(Sender: TObject; Button: TUDBtnType);
    procedure UDdivXClick(Sender: TObject; Button: TUDBtnType);
    procedure UDdivYClick(Sender: TObject; Button: TUDBtnType);
    procedure UDdivZClick(Sender: TObject; Button: TUDBtnType);
    procedure edHeightChange(Sender: TObject);
    procedure edDepthChange(Sender: TObject);
    procedure edWidthChange(Sender: TObject);
    procedure edDivXChange(Sender: TObject);
    procedure edDivYChange(Sender: TObject);
    procedure edDivZChange(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

constructor TfraCreatePropCube.Create(AOwner: TComponent);
begin
    inherited;
    UDHeight.Position := defaultheight;
    UDDepth.Position := defaultdepth;
    UDWidth.Position := defaultwidth;
    UDdivX.Position := defaultdivx;
    UDdivY.Position := defaultdivy;
    UDdivZ.Position := defaultdivz;
end;

procedure TfraCreatePropCube.edDivXKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['1'..'9',Chr(VK_BACK)]) then Key := #0;
end;

procedure TfraCreatePropCube.edHeightKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),Chr(VK_DELETE)]) then Key := #0;
end;

procedure TfraCreatePropCube.edHeightChange(Sender: TObject);
begin
    if Trim(edHeight.Text)<>'' then begin               // JC: we're doing this multiple times: we should inherite from some general frame in these cases
        defaultHeight := StrToInt(edHeight.Text);
        if defaultHeight<1 then begin
            defaultHeight := 1;
            edHeight.Text := IntToStr(defaultHeight);
        end;
    end;
end;

procedure TfraCreatePropCube.edDepthChange(Sender: TObject);
begin
    if Trim(edDepth.Text)<>'' then begin
        defaultDepth := StrToInt(edDepth.Text);
        if defaultDepth<1 then begin
            defaultDepth := 1;
            edDepth.Text := IntToStr(defaultDepth);
        end;
    end;
end;

procedure TfraCreatePropCube.edWidthChange(Sender: TObject);
begin
    if Trim(edWidth.Text)<>'' then begin
        defaultWidth := StrToInt(edWidth.Text);
        if defaultWidth<1 then begin
            defaultWidth := 1;
            edWidth.Text := IntToStr(defaultWidth);
        end;
    end;
end;

procedure TfraCreatePropCube.edDivXChange(Sender: TObject);
begin
    if Trim(edDivX.Text)<>'' then begin
        defaultDivX := StrToInt(edDivX.Text);
        if defaultDivX<1 then begin
            defaultDivX := 1;
            edDivX.Text := IntToStr(defaultDivX);
        end;
    end;
end;

procedure TfraCreatePropCube.edDivYChange(Sender: TObject);
begin
    if Trim(edDivY.Text)<>'' then begin
        defaultDivY := StrToInt(edDivY.Text);
        if defaultDivY<1 then begin
            defaultDivY := 1;
            edDivY.Text := IntToStr(defaultDivY);
        end;
    end;
end;

procedure TfraCreatePropCube.edDivZChange(Sender: TObject);
begin
    if Trim(edDivZ.Text)<>'' then begin
        defaultDivZ := StrToInt(edDivZ.Text);
        if defaultDivZ<1 then begin
            defaultDivZ := 1;
            edDivZ.Text := IntToStr(defaultDivZ);
        end;
    end;
end;

procedure TfraCreatePropCube.UDHeightClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultHeight := UDHeight.Position;
end;

procedure TfraCreatePropCube.UDDepthClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultDepth := UDDepth.Position;
end;

procedure TfraCreatePropCube.UDWidthClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultWidth := UDWidth.Position;
end;

procedure TfraCreatePropCube.UDdivXClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultDivX := UDdivX.Position;
end;

procedure TfraCreatePropCube.UDdivYClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultDivY := UDdivY.Position;
end;

procedure TfraCreatePropCube.UDdivZClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultDivZ := UDdivZ.Position;
end;

end.
