{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesCylinder;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls,
  fraCreatePropertiesDefault,
  unit_Variables;

type
  TfraCreatePropCylinder = class(TfraCreatePropDefault)
    Label2: TLabel;
    edSides: TEdit;
    UDSides: TUpDown;
    Label3: TLabel;
    edSegments: TEdit;
    UDSegments: TUpDown;
    Label12: TLabel;
    Label13: TLabel;
    Label10: TLabel;
    edHeight: TEdit;
    edDepth: TEdit;
    edWidth: TEdit;
    UDHeight: TUpDown;
    UDDepth: TUpDown;
    UDWidth: TUpDown;
    procedure edSidesKeyPress(Sender: TObject; var Key: Char);
    procedure UDHeightClick(Sender: TObject; Button: TUDBtnType);
    procedure UDDepthClick(Sender: TObject; Button: TUDBtnType);
    procedure UDWidthClick(Sender: TObject; Button: TUDBtnType);
    procedure UDSidesClick(Sender: TObject; Button: TUDBtnType);
    procedure UDSegmentsClick(Sender: TObject; Button: TUDBtnType);
    procedure edSidesChange(Sender: TObject);
    procedure edSegmentsChange(Sender: TObject);
    procedure edHeightChange(Sender: TObject);
    procedure edDepthChange(Sender: TObject);
    procedure edWidthChange(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

constructor TfraCreatePropCylinder.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    UDHeight.Position := defaultHeight;
    UDDepth.Position := defaultDepth;
    UDWidth.Position := defaultWidth;
    UDSides.Position := defaultCylinder;
    UDSegments.Position := defaultCylinderSegments;
end;

procedure TfraCreatePropCylinder.edSidesKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCreatePropCylinder.edHeightChange(Sender: TObject);
begin
    if Trim(edHeight.Text)<>'' then begin
        defaultHeight := StrToInt(edHeight.Text);
        if defaultHeight<1 then begin
            defaultHeight := 1;
            edHeight.Text := IntToStr(defaultHeight);
        end;
    end;
end;

procedure TfraCreatePropCylinder.edDepthChange(Sender: TObject);
begin
    if Trim(edDepth.Text)<>'' then begin
        defaultDepth := StrToInt(edDepth.Text);
        if defaultDepth<1 then begin
            defaultDepth := 1;
            edDepth.Text := IntToStr(defaultDepth);
        end;
    end;
end;

procedure TfraCreatePropCylinder.edWidthChange(Sender: TObject);
begin
    if Trim(edWidth.Text)<>'' then begin
        defaultWidth := StrToInt(edWidth.Text);
        if defaultWidth<1 then begin
            defaultWidth := 1;
            edWidth.Text := IntToStr(defaultWidth);
        end;
    end;
end;

procedure TfraCreatePropCylinder.edSidesChange(Sender: TObject);
var tempValue: integer;
begin
    if Trim(edSides.Text)<>'' then begin
        tempValue := StrToInt(edSides.Text);
        if tempValue>2 then
            defaultCylinder := tempValue
    end;
end;

procedure TfraCreatePropCylinder.edSegmentsChange(Sender: TObject);
begin
    if Trim(edSegments.Text)<>'' then begin
        defaultCylinderSegments := StrToInt(edSegments.Text);
        if defaultCylindersegments<1 then begin
            defaultCylindersegments := 1;
            edSegments.Text := IntToStr(defaultCylindersegments);
        end;
    end;
end;

procedure TfraCreatePropCylinder.UDHeightClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultHeight := UDHeight.Position;
end;

procedure TfraCreatePropCylinder.UDDepthClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultDepth := UDDepth.Position;
end;

procedure TfraCreatePropCylinder.UDWidthClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultWidth := UDWidth.Position;
end;

procedure TfraCreatePropCylinder.UDSidesClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultCylinder := UDSides.Position;
end;

procedure TfraCreatePropCylinder.UDSegmentsClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultCylinderSegments := UDSegments.Position;
end;


end.
