{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesEllipse;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls,
  fraCreatePropertiesDefault,
  unit_Variables;

type
  TfraCreatePropEllipse = class(TfraCreatePropDefault)
    Label2: TLabel;
    edSides: TEdit;
    UDSides: TUpDown;
    procedure edSidesKeyPress(Sender: TObject; var Key: Char);
    procedure UDSidesClick(Sender: TObject; Button: TUDBtnType);
    procedure edSidesChange(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

constructor TfraCreatePropEllipse.Create(AOwner: TComponent);
begin
    inherited;
    UDSides.Position := defaultEllipse;
end;

procedure TfraCreatePropEllipse.edSidesKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCreatePropEllipse.UDSidesClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultEllipse := UDSides.Position;
end;

procedure TfraCreatePropEllipse.edSidesChange(Sender: TObject);
begin
    if edSides.Text<>'' then 
        defaultEllipse := StrToInt(edSides.Text);
end;

end.
