{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesGrid;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCreatePropertiesDefault, ComCtrls, StdCtrls;

type
  TfraCreatePropGrid = class(TfraCreatePropDefault)
    edSubx: TEdit;
    edSubY: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    udSubx: TUpDown;
    udSubY: TUpDown;
    procedure edSubxKeyPress(Sender: TObject; var Key: Char);
    procedure udSubxClick(Sender: TObject; Button: TUDBtnType);
    procedure udSubYClick(Sender: TObject; Button: TUDBtnType);
    procedure edSubxChange(Sender: TObject);
    procedure edSubYChange(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses
  unit_Variables;

{$R *.lfm}

constructor TfraCreatePropGrid.Create(AOwner: TComponent);
begin
    inherited;
    udSubx.Position := defaultSubX;
    udSuby.Position := defaultSubY;
end;

procedure TfraCreatePropGrid.edSubxKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCreatePropGrid.udSubxClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultSubX := udSubx.Position;
end;

procedure TfraCreatePropGrid.udSubYClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultSubY := udSubY.Position;
end;

procedure TfraCreatePropGrid.edSubxChange(Sender: TObject);
begin
    if edSubx.Text<>'' then begin
        defaultSubX := StrToInt(edSubx.Text);
        if defaultSubX<1 then begin
            defaultSubX := 1;
            edSubx.Text := IntToStr(defaultSubX);
        end;
    end;
end;

procedure TfraCreatePropGrid.edSubYChange(Sender: TObject);
begin
    if edSubY.Text<>'' then begin
        defaultSubY := StrToInt(edSubY.Text);
        if defaultSubY<1 then begin
            defaultSubY := 1;
            edSubY.Text := IntToStr(defaultSubY);
        end;
    end;
end;

end.
