{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesPath;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  fraCreatePropertiesDefault,
  unit_Variables,
  unit_Enums;

type
  TfraCreatePropPath = class(TfraCreatePropDefault)
    Label2: TLabel;
    cbPathType: TComboBox;
    cbPathIsClosed: TCheckBox;
    procedure cbPathTypeChange(Sender: TObject);
    procedure cbPathIsClosedClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

var
  fraCreatePropPath: TfraCreatePropPath;

implementation

{$R *.lfm}

uses
  unit_Paths;
  
constructor TfraCreatePropPath.Create(AOwner: TComponent);
begin
  inherited;

  defaultPathType := TPathType(cbPathType.ItemIndex);
  defaultPathIsClosed := cbPathIsClosed.Checked;
end;

procedure TfraCreatePropPath.cbPathTypeChange(Sender: TObject);
begin
  defaultPathType := TPathType(cbPathType.ItemIndex);
end;

procedure TfraCreatePropPath.cbPathIsClosedClick(Sender: TObject);
begin
  defaultPathIsClosed := cbPathIsClosed.Checked;
end;

end.
