{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesPolyline;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  fraCreatePropertiesDefault,
  unit_Variables,
  unit_Enums;

type
  TfraCreatePropPolyline = class(TfraCreatePropDefault)
    rbutTriangulate: TRadioButton;
    rbutConvexionate: TRadioButton;
    rbutDoNotDivide: TRadioButton;
    procedure rbutTriangulateClick(Sender: TObject);
    procedure rbutConvexionateClick(Sender: TObject);
    procedure rbutDoNotDivideClick(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

constructor TfraCreatePropPolyline.Create(AOwner: TComponent);
begin
    inherited;
    case defaultPolyLineType of
        ptTriangulated:
            rbutTriangulate.Checked := true;
        ptConvexionated:
            rbutConvexionate.Checked := true;
        ptNotDivided:
            rbutDoNotDivide.Checked := true;
    end;
end;

procedure TfraCreatePropPolyline.rbutTriangulateClick(Sender: TObject);
begin
    defaultPolyLineType := ptTriangulated;
end;

procedure TfraCreatePropPolyline.rbutConvexionateClick(Sender: TObject);
begin
    defaultPolyLineType := ptConvexionated;
end;

procedure TfraCreatePropPolyline.rbutDoNotDivideClick(Sender: TObject);
begin
    defaultPolyLineType := ptNotDivided;
end;

end.
