{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesPyramid;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  fraCreatePropertiesDefault,
  unit_Variables;

type
  TfraCreatePropPyramid = class(TfraCreatePropDefault)
    Label12: TLabel;
    Label13: TLabel;
    Label10: TLabel;
    edHeight: TEdit;
    edDepth: TEdit;
    edWidth: TEdit;
    UDHeight: TUpDown;
    UDDepth: TUpDown;
    UDWidth: TUpDown;
    procedure edHeightKeyPress(Sender: TObject; var Key: Char);
    procedure UDHeightClick(Sender: TObject; Button: TUDBtnType);
    procedure UDDepthClick(Sender: TObject; Button: TUDBtnType);
    procedure UDWidthClick(Sender: TObject; Button: TUDBtnType);
    procedure edHeightChange(Sender: TObject);
    procedure edDepthChange(Sender: TObject);
    procedure edWidthChange(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

constructor TfraCreatePropPyramid.Create(AOwner: TComponent);
begin
    inherited;
    UDHeight.Position := defaultHeight;
    UDDepth.Position := defaultDepth;
    UDWidth.Position := defaultWidth;
end;

procedure TfraCreatePropPyramid.edHeightKeyPress(Sender: TObject; var Key: Char);
begin
    if not (key in ['0'..'9',Chr(VK_BACK),Chr(VK_DELETE)]) then Key := #0;
end;

procedure TfraCreatePropPyramid.UDHeightClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultHeight := UDHeight.Position;
end;

procedure TfraCreatePropPyramid.UDDepthClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultDepth := UDDepth.Position;
end;

procedure TfraCreatePropPyramid.UDWidthClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultWidth := UDWidth.Position;
end;

procedure TfraCreatePropPyramid.edHeightChange(Sender: TObject);
begin
    if Trim(edHeight.Text)<>'' then begin
        defaultHeight := StrToInt(edHeight.Text);
        if defaultHeight<1 then begin
            defaultHeight := 1;
            edHeight.Text := IntToStr(defaultHeight);
        end;
    end;
end;

procedure TfraCreatePropPyramid.edDepthChange(Sender: TObject);
begin
    if Trim(edDepth.Text)<>'' then begin
        defaultDepth := StrToInt(edDepth.Text);
        if defaultDepth<1 then begin
            defaultDepth := 1;
            edDepth.Text := IntToStr(defaultDepth);
        end;
    end;
end;

procedure TfraCreatePropPyramid.edWidthChange(Sender: TObject);
begin
    if Trim(edWidth.Text)<>'' then begin
        defaultWidth := StrToInt(edWidth.Text);
        if defaultWidth<1 then begin
            defaultWidth := 1;
            edWidth.Text := IntToStr(defaultWidth);
        end;
    end;
end;

end.
