{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesSphere;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCreatePropertiesDefault, ComCtrls, StdCtrls, ExtCtrls,
  unit_Variables;

type
  TfraCreatePropSphere = class(TfraCreatePropDefault)
    rbSphere: TRadioButton;
    rbGeoSphere: TRadioButton;
    rgGeosphere: TRadioGroup;
    gbSphere: TGroupBox;
    lblSegments: TLabel;
    edSegments: TEdit;
    procedure rbSphereClick(Sender: TObject);
    procedure rbGeoSphereClick(Sender: TObject);
    procedure edSegmentsKeyPress(Sender: TObject; var Key: Char);
    procedure rgGeosphereClick(Sender: TObject);
    procedure edSegmentsChange(Sender: TObject);
    procedure edSegmentsClick(Sender: TObject);
    procedure edSegmentsEnter(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

constructor TfraCreatePropSphere.Create(AOwner: TComponent);
begin
    inherited;
    defaultSphereType := 0;     // 0=sphere, 1=geosphere
    case defaultGeoSphere of
        80:     rgGeosphere.ItemIndex := 0;
        320:    rgGeosphere.ItemIndex := 1;
        else    rgGeosphere.ItemIndex := 0;
    end;
    if defaultSphereSegments < 3 then defaultSphereSegments := 3;
    edSegments.Text := IntToStr(defaultSphereSegments);
    rbSphereClick(nil);
end;

procedure TfraCreatePropSphere.rbSphereClick(Sender: TObject);
begin
    defaultSphereType := 0;
    gbSphere.Enabled := true;
    lblSegments.Enabled := true;
    edSegments.Enabled := true;
    rgGeosphere.Enabled := false;
end;

procedure TfraCreatePropSphere.rbGeoSphereClick(Sender: TObject);
begin
    defaultSphereType := 1;
    gbSphere.Enabled := false;
    lblSegments.Enabled := false;
    edSegments.Enabled := false;
    rgGeosphere.Enabled := true;
end;

procedure TfraCreatePropSphere.edSegmentsKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in ['0'..'9',Chr(VK_BACK)]) then
        Key := #0;
end;

procedure TfraCreatePropSphere.rgGeosphereClick(Sender: TObject);
begin
    case rgGeosphere.ItemIndex of
        0:  defaultGeoSphere := 80;
        1:  defaultGeoSphere := 320;
    end;
end;

procedure TfraCreatePropSphere.edSegmentsChange(Sender: TObject);
begin
    defaultSphereSegments := 3;
    if edSegments.Text<>'' then
        defaultSphereSegments := StrToInt(edSegments.Text);
    if defaultSphereSegments < 3 then defaultSphereSegments := 3;
end;

procedure TfraCreatePropSphere.edSegmentsClick(Sender: TObject);
begin
    if defaultSphereSegments < 3 then defaultSphereSegments := 3;
    edSegments.Text := IntToStr(defaultSphereSegments);
end;

procedure TfraCreatePropSphere.edSegmentsEnter(Sender: TObject);
begin
    if defaultSphereSegments < 3 then defaultSphereSegments := 3;
    edSegments.Text := IntToStr(defaultSphereSegments);
end;

end.
