{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraCreatePropertiesTorus;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fraCreatePropertiesDefault, StdCtrls,
  unit_Variables, ComCtrls;

type
  TfraCreatePropTorus = class(TfraCreatePropDefault)
    lblSegments: TLabel;
    edSegments: TEdit;
    UDSegments: TUpDown;
    Label2: TLabel;
    edOuterRadius: TEdit;
    UDOuterRadius: TUpDown;
    Label3: TLabel;
    edInnerRadius: TEdit;
    UDInnerRadius: TUpDown;
    Label4: TLabel;
    edPolygonsPerSegment: TEdit;
    UDPolygonsPerSegment: TUpDown;
    procedure UDSegmentsClick(Sender: TObject; Button: TUDBtnType);
    procedure UDPolygonsPerSegmentClick(Sender: TObject; Button: TUDBtnType);
    procedure UDOuterRadiusClick(Sender: TObject; Button: TUDBtnType);
    procedure UDInnerRadiusClick(Sender: TObject; Button: TUDBtnType);
    procedure edSegmentsChange(Sender: TObject);
    procedure edPolygonsPerSegmentChange(Sender: TObject);
    procedure edOuterRadiusChange(Sender: TObject);
    procedure edInnerRadiusChange(Sender: TObject);
  private
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.lfm}

// ### TfraCreatePropTorus #####################################################

constructor TfraCreatePropTorus.Create(AOwner: TComponent);
begin
    inherited;
    if defaultTorusSegments<4 then
        defaultTorusSegments := 4;
    if defaultTorusPolygonsPerSegment<2 then
        defaultTorusPolygonsPerSegment := 2;
    if defaultTorusOuterRadius<2 then
        defaultTorusOuterRadius := 2;
    if defaultTorusInnerRadius<1 then
        defaultTorusInnerRadius := 1;
    UDSegments.Position := defaultTorusSegments;
    UDPolygonsPerSegment.Position := defaultTorusPolygonsPerSegment;
    UDOuterRadius.Position := defaultTorusOuterRadius;
    UDInnerRadius.Position := defaultTorusInnerRadius;
end;

procedure TfraCreatePropTorus.UDSegmentsClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultTorusSegments := UDSegments.Position;
end;

procedure TfraCreatePropTorus.UDPolygonsPerSegmentClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultTorusPolygonsPerSegment := UDPolygonsPerSegment.Position;
end;

procedure TfraCreatePropTorus.UDOuterRadiusClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultTorusOuterRadius := UDOuterRadius.Position;
    if defaultTorusOuterRadius<=defaultTorusInnerRadius then begin
        defaultTorusInnerRadius := defaultTorusOuterRadius-1;
        UDInnerRadius.Position := defaultTorusInnerRadius;
    end;
end;

procedure TfraCreatePropTorus.UDInnerRadiusClick(Sender: TObject; Button: TUDBtnType);
begin
    defaultTorusInnerRadius := UDInnerRadius.Position;
    if defaultTorusInnerRadius>=defaultTorusOuterRadius then begin
        defaultTorusOuterRadius := defaultTorusInnerRadius+1;
        UDOuterRadius.Position := defaultTorusOuterRadius;
    end;
end;

procedure TfraCreatePropTorus.edSegmentsChange(Sender: TObject);
begin
    if Trim(edSegments.Text)<>'' then
        defaultTorusSegments := StrToInt(edSegments.Text);
end;

procedure TfraCreatePropTorus.edPolygonsPerSegmentChange(Sender: TObject);
begin
    if Trim(edPolygonsPerSegment.Text)<>'' then
        defaultTorusPolygonsPerSegment := StrToInt(edPolygonsPerSegment.Text);
end;

procedure TfraCreatePropTorus.edOuterRadiusChange(Sender: TObject);
begin
    if Trim(edOuterRadius.Text)<>'' then begin
        defaultTorusOuterRadius := StrToInt(edOuterRadius.Text);
        if defaultTorusOuterRadius<2 then begin
            defaultTorusOuterRadius := 2;
            defaultTorusInnerRadius := 1;
            UDOuterRadius.Position := defaultTorusOuterRadius;
            UDInnerRadius.Position := defaultTorusInnerRadius;
        end else begin
            if defaultTorusOuterRadius<=defaultTorusInnerRadius then begin
                defaultTorusInnerRadius := defaultTorusOuterRadius-1;
                UDInnerRadius.Position := defaultTorusInnerRadius;
            end;
        end;
    end;
end;

procedure TfraCreatePropTorus.edInnerRadiusChange(Sender: TObject);
begin
    if Trim(edInnerRadius.Text)<>'' then begin
        defaultTorusInnerRadius := StrToInt(edInnerRadius.Text);
        if defaultTorusInnerRadius<1 then begin
            defaultTorusInnerRadius := 1;
            UDInnerRadius.Position := defaultTorusInnerRadius;
        end else begin
            if defaultTorusInnerRadius>=defaultTorusOuterRadius then begin
                defaultTorusOuterRadius := defaultTorusInnerRadius+1;
                UDOuterRadius.Position := defaultTorusOuterRadius;
            end;
        end;
    end;
end;

end.
