{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit fraInspectorDefault;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Types,
  unit_PrimitiveList,
  unit_Functions,
  unit_Types;

type
  TfraInspectorDefaultFrame = class(TFrame)
  private
    fPrimitives: TPrimitiveList;
  protected
    nowUpdating: boolean;
    procedure UpdateVertice(const aVertice: TVertice; const aValue: String);
  public
    function StringToBoolean(value: string): boolean;
    procedure UpdateInspector; virtual; abstract;
    property Primitives: TPrimitiveList read fPrimitives write fPrimitives;
  end;

implementation

{$R *.lfm}

function TfraInspectorDefaultFrame.StringToBoolean(value: string): boolean;
begin
    Result := Uppercase(value)='TRUE';
end;

procedure TfraInspectorDefaultFrame.UpdateVertice(const aVertice: TVertice; const aValue: String);
var values: TStringDynArray;
begin
    values := SubDivideString(aValue, ',');

    if (Length(values) = 3) and
       IsNumeric(values[0]) and
       IsNumeric(values[1]) and
       IsNumeric(values[2]) then
    begin
        aVertice.X := StrToFloat(values[0]);
        aVertice.Y := StrToFloat(values[1]);
        aVertice.Z := StrToFloat(values[2]);
    end;
end;

end.
