{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTLambertianBRDFCl;

{$MODE Delphi}

{ ----------------------------------------------------------------------------
  Perfect Diffuse BRDF
  ---------------------------------------------------------------------------- }
interface

uses
  RTGenericLambertianBRDFCl, RTMiscTp;

type
  TRTLambertianBRDF = class( TRTGenericLambertianBRDF )
  private
      fCd: TRGBColor;

  public
      function F( const aShadeRec: TRTShadeRec; const aWI, aWO: TRTVector3D ): TRGBColor; override;
      function Rho( const aShadeRec: TRTShadeRec; const aWO: TRTVector3D ): TRGBColor; override;

      property DiffuseColor: TRGBColor read fCd write fCd;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMathFn, RTMiscCn;

function TRTLambertianBRDF.F( const aShadeRec: TRTShadeRec; const aWI, aWO: TRTVector3D ): TRGBColor;
begin
  result := ColorMultiply( fCd, Kd / PI );
end;

// ----------------------------------------------------------------------------

function TRTLambertianBRDF.Rho( const aShadeRec: TRTShadeRec; const aWO: TRTVector3D ): TRGBColor;
begin
  result := ColorMultiply( fCd, Kd );
end;

end.
