{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTPerfectSpecularBRDFCl;

{$MODE Delphi}

interface

uses
  RTBRDFCl, RTMiscTp;

type
  TRTPerfectSpecularBRDF = class( TRTBRDF )
  private
      fKr: Single;
      fCr: TRGBColor;

  public
      function SampleF( const aShadeRec: TRTShadeRec; const aWO: TRTVector3D; out aWI: TRTVector3D ): TRGBColor; override;

      property Reflection: Single read fKr write fKr;
      property Color: TRGBColor read fCr write fCr;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMathFn;

function TRTPerfectSpecularBRDF.SampleF( const aShadeRec: TRTShadeRec; const aWO: TRTVector3D; out aWI: TRTVector3D ): TRGBColor;
var
  nDotWo: Single;

begin
  nDotWo := VectorDotProduct( aShadeRec.Normal, aWO );
  aWi := VectorSubtract( VectorMultiply( aShadeRec.Normal, 2 * nDotWo ), aWO );

  result := ColorMultiply( fCr, fKr / VectorDotProduct( aShadeRec.Normal, aWI ));
end;

end.
 
