{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTAmbientLightCl;

{$MODE Delphi}

interface

uses
  RTLightCl, RTMiscTp;

type
  TRTAmbientLight = class( TRTLight )
  private
      fLs: Single;

  public
      constructor Create;

      function MakeDirection( const aShadeRec: TRTShadeRec ): TRTVector3D; override;
      function L( const aShadeRec: TRTShadeRec ): TRGBColor; override;

      property RadianceScale: Single read fLs write fLs;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMathFn;
  
constructor TRTAmbientLight.Create;
begin
  inherited Create;

  fLs := 1;
end;

// ----------------------------------------------------------------------------

function TRTAmbientLight.MakeDirection( const aShadeRec: TRTShadeRec ): TRTVector3D; 
begin
  result := Vector( 0 );
end;

// ----------------------------------------------------------------------------

function TRTAmbientLight.L( const aShadeRec: TRTShadeRec ): TRGBColor; 
begin
  result := ColorMultiply( Color, fLs );
end;

// ----------------------------------------------------------------------------

end.
 
