{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTEmissiveMaterialCl;

{$MODE Delphi}

interface

uses
  RTMaterialCl, RTMiscTp;

type
  TRTEmissiveMaterial = class( TRTMaterial )
  private
      fLs: Single;
      fCe: TRGBColor;

  public
      constructor Create;

      function Shade( const aShadeRec: TRTShadeRec ): TRGBColor; override;

      property RadianceScale: Single read fLs write fLs;
      property Color: TRGBColor read fCe write fCe;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMiscCn, RTMathFn;

constructor TRTEmissiveMaterial.Create;
begin
  inherited Create;

  fLs := 1;
  fCe := COLOR_WHITE;
end;

// ----------------------------------------------------------------------------

function TRTEmissiveMaterial.Shade( const aShadeRec: TRTShadeRec ): TRGBColor;
begin
  if VectorDotProduct( aShadeRec.Normal, aShadeRec.Ray.Direction ) < 0 then
  begin
      result :=
          ColorMultiply( Color, RadianceScale )
  end
  else
      result := COLOR_BLACK;
end;

// ----------------------------------------------------------------------------

end.
