{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTMultiJitteredSampler3DCl;

{$MODE Delphi}

// INFO, PJ: Not yet functional!

interface

uses
  RTSampler3DCl;

type
  TRTMultiJitteredSampler3D = class( TRTSampler3D )
  public
      constructor Create( const aNumSamples: Integer; const aNumSets: Integer = 83 );

      procedure GenerateSamples; override;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  Math,
  RTMiscTp;


constructor TRTMultiJitteredSampler3D.Create( const aNumSamples: Integer; const aNumSets: Integer = 83 );
var
  numSamples: Integer;

begin
  // INFO, PJ: We correct the number of samples to the nearest power of three.
  numSamples := Trunc( Power( Trunc( Power( aNumSamples, 1 / 3 )) + 1, 3 ));

  inherited Create( numSamples );
end;

// ----------------------------------------------------------------------------

procedure TRTMultiJitteredSampler3D.GenerateSamples;
var
  n, i, j, k, p: Integer;
  subcellWidth: Single;
  // temp: Single;
  point: TRTVector3D;

begin
  n := Trunc( Power( NumSamples, 1/2 ));
  subcellWidth := 1 / Numsamples;

  // INFO, PJ: Fill the array with fill points to allow for the Samples[] approach
  for p := 0 to NumSets - 1 do
  begin
      for i := 0 to n - 1 do
      begin
          for j := 0 to n - 1 do
          begin
              for k := 0 to n - 1 do
              begin
                  point.X := ( i * n + j ) * subcellWidth + subcellWidth * random;
                  point.Y := ( j * n + i ) * subcellWidth + subcellWidth * random;
                  Samples.Add( point );
              end;
          end;
      end;
  end;
{
  // INFO, PJ: Shuffle X coordinates
  for p := 0 to NumSets - 1 do
  begin
      for i := 0 to n - 1 do
      begin
          for j := 0 to n - 1 do
          begin
              k := random( n - j ) + j;
              temp := Samples[i * n + j + p * NumSamples].X;
              Samples[i * n + j + p * NumSamples].X := Samples[i * n + k + p * NumSamples].X;
              Samples[i * n + k + p * NumSamples].X := temp;
          end;
      end;
  end;

  // INFO, PJ: Shuffle Y coordinates
  for p := 0 to NumSets - 1 do
  begin
      for i := 0 to n - 1 do
      begin
          for j := 0 to n - 1 do
          begin
              k := random( n - j ) + j;
              temp := Samples[j * n + i + p * NumSamples].Y;
              Samples[j * n + i + p * NumSamples].Y := Samples[k * n + i + p * NumSamples].Y;
              Samples[k * n + i + p * NumSamples].Y := temp;
          end;
      end;
  end;

}
end;

end.

