{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTHammersleySamplerCl;

{$MODE Delphi}

interface

uses
  RTSamplerCl;

type
  TRTHammersleySampler = class( TRTSampler )
  private
      function Phi( const aValue: Integer ): Double;

  public
      procedure GenerateSamples; override;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMiscTp;

procedure TRTHammersleySampler.GenerateSamples;
var
  p, j: Integer;
  point: TRTPoint2D;

begin
  for p := 0 to NumSets - 1 do
  begin
      for j := 0 to NumSamples - 1 do
      begin
          point.X := j / NumSamples;
          point.Y := phi( j );
          Samples.Add( point );
      end;
  end;
end;

// ----------------------------------------------------------------------------

function TRTHammersleySampler.Phi( const aValue: Integer ): Double;
var
  f: Double;
  j: Integer;
  
begin
  result := 0;
  f := 0.5;
  j := aValue;

  while j <> 0 do
  begin
      result := result + f * ( j and 1 );
      j := j shr 1;

      f := f * 0.5
  end;
end;

end.

