{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTNRooksSamplerCl;

{$MODE Delphi}

interface

uses
  RTSamplerCl;

type
  TRTNRooksSampler = class( TRTSampler )
  private
      procedure ShuffleCoordinates;

  public
      procedure GenerateSamples; override;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMiscTp;

procedure TRTNRooksSampler.GenerateSamples;
var
  p, j: Integer;
  point: TRTPoint2D;

begin
  for p := 0 to NumSets - 1 do
  begin
      for j := 0 to NumSamples - 1 do
      begin
          point.X := ( j + random ) / NumSamples;
          point.Y := ( j + random ) / NumSamples;
          Samples.Add( point );
      end;
  end;

  ShuffleCoordinates;
end;

// ----------------------------------------------------------------------------

procedure TRTNRooksSampler.ShuffleCoordinates;
var
  p, i, j, sourceIndex, targetIndex: Integer;
  temp: Double;

begin
  // INFO, PJ: Shuffles X, then Y coordinates
  for p := 0 to NumSets - 1 do
  begin
      for j := 0 to 1 do
      begin
          for i := 0 to NumSamples - 2 do
          begin
              sourceIndex := p * NumSamples + i + 1;
              targetIndex := p * NumSamples + Random( NumSamples ); 

              temp := Samples[sourceIndex].Elements[j];
              Samples[sourceIndex].Elements[j] := Samples[targetIndex].Elements[j];
              Samples[targetIndex].Elements[j] := temp;
          end;
      end;
  end;
end;

end.

