{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTRandomSamplerCl;

{$MODE Delphi}

interface

uses
  RTSamplerCl;

type
  TRTRandomSampler = class( TRTSampler )
  public
      procedure GenerateSamples; override;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMiscTp;

procedure TRTRandomSampler.GenerateSamples;
var
  n, p, j, k: Integer;
  point: TRTPoint2D;
  
begin
  n := Trunc( Sqrt( NumSamples ));

  for p := 0 to NumSets - 1 do
  begin
      for j := 0 to n - 1 do
      begin
          for k := 0 to n - 1 do
          begin
              point.X := random;
              point.Y := random;

              Samples.Add( point );
          end;
      end;
  end;
end;

end.

