{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RT2DFunctionTracerCl;

{$MODE Delphi}

interface

uses
  RTWorldTracerCl, RTMiscTp;

type
  TRT2DFunctionTracer = class( TRTWorldTracer )
  public
      function TraceRay( const aRay: TRTRay ): TRGBColor; override;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


implementation

function TRT2DFunctionTracer.TraceRay( const aRay: TRTRay ): TRGBColor;
var
  x, y: Single;
  color: Single;

begin
  x := 10.83 *( aRay.Origin.X + 256 ) / 512;
  y := 10.83 *( aRay.Origin.Y + 256 ) / 512;
  color := 0.5 * ( 1 + Sin( x * x * y * y ));

  result := RGBColor( color );
end;

end.
