{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTTracerCl;

{$MODE Delphi}

{ ----------------------------------------------------------------------------
  Abstract tracing base class to avoid circular reference with world.
  When writing actual raytracing classes, inherit from RTWorldTracerT
  ---------------------------------------------------------------------------- }

interface

uses
  RTMiscTp;

type
  TRTTracer = class( TObject )
  public
      function TraceRay( const aRay: TRTRay ): TRGBColor; overload; virtual;
      function TraceRay( const aRay: TRTRay; const aDepth: Integer ): TRGBColor;  overload; virtual;
      function TraceRay( const aRay: TRTRay; const aTMin: Single; const aDepth: Integer ): TRGBColor; overload; virtual; 
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

uses
  RTMiscCn;

function TRTTracer.TraceRay( const aRay: TRTRay ): TRGBColor;
begin
  result := COLOR_BLACK;
end;

// ----------------------------------------------------------------------------

function TRTTracer.TraceRay( const aRay: TRTRay; const aDepth: Integer ): TRGBColor;
begin
  result := COLOR_BLACK;
end;

// ----------------------------------------------------------------------------

function TRTTracer.TraceRay( const aRay: TRTRay; const aTMin: Single; const aDepth: Integer ): TRGBColor;
begin
  result := COLOR_BLACK;
end;

end.
