{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTAABoundingBoxCl;

{$MODE Delphi}

interface

uses
  RTMiscTp;

type
  TRTAABoundingBox = class( TObject )
  private
      fMin: TRTPoint3D;
      fMax: TRTPoint3D;

  public
      constructor Create( const aMin, aMax: TRTPoint3D );

      function Contains( const aPoint: TRTPoint3D ): Boolean;

      property Min: TRTPoint3D read fMin;
      property Max: TRTPoint3D read fMax;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

constructor TRTAABoundingBox.Create( const aMin, aMax: TRTPoint3D );
begin
  inherited Create;

  fMin := aMin;
  fMax := aMax;
end;

// ----------------------------------------------------------------------------

function TRTAABoundingBox.Contains( const aPoint: TRTPoint3D ): Boolean;
begin
  result :=
      ( aPoint.X > fMin.X ) and ( aPoint.X < fMax.X ) and
      ( aPoint.Y > fMin.Y ) and ( aPoint.Y < fMax.Y ) and
      ( aPoint.Z > fMin.Z ) and ( aPoint.Z < fMax.Z );
end;

end.
