{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTIntegerListCl;

{$MODE Delphi}

interface

uses
  Classes;

type
  TRTIntegerList = class( TList )
  private
      function GetInteger( const anIndex: Integer ): Integer;
      procedure SetInteger( const anIndex, aValue: Integer );

  public
      procedure Add( const anInteger: Integer );

      procedure Shuffle;

      property Items[const anIndex: Integer]: Integer read GetInteger write SetInteger; default;
  end;

implementation

function TRTIntegerList.GetInteger( const anIndex: Integer ): Integer;
begin
  result := Integer( Get( anIndex ));
end;

// ----------------------------------------------------------------------------

procedure TRTIntegerList.SetInteger( const anIndex, aValue: Integer );
begin
  Put( anIndex, Pointer( aValue ));
end;

// ----------------------------------------------------------------------------

procedure TRTIntegerList.Add( const anInteger: Integer );
begin
  inherited Add( Pointer( anInteger ));
end;

// ----------------------------------------------------------------------------

procedure TRTIntegerList.Shuffle;
var
  i, targetIndex, tmp: Integer;
  
begin
  for i := 0 to Count - 1 do
  begin
      targetIndex := Random( Count );
      tmp := Items[i];
      Items[i] := Items[targetIndex];
      Items[targetIndex] := tmp;
  end;
end;

end.
