{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTTextFileStreamCl;

{$MODE Delphi}

interface

uses
  RTBufferedFileStreamCl;

type
  TRTTextFileStream = class( TRTBufferedFileStream )
  private
      fLineSize: Integer; // PERF, PJ: Expected Line size...

  public
      function ReadLine: String;

      property LineSize: Integer read fLineSize write fLineSize;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

function TRTTextFileStream.ReadLine: String;
var
  character: Char;
  numCharacters: Integer;

begin
  if fLineSize > 0 then
  begin
      SetLength( result, fLineSize );
  end
  else
      result := '';

  numCharacters := 0;

  character := ReadChar;
  while (Position < Size) and not (character in [#13, #10]) do
  begin
      if numCharacters < fLineSize then
      begin
          result[numCharacters + 1] := character;
      end
      else
          result := result + character;

      numCharacters := numCharacters + 1;

      //numRead := Read( character, 1 );
      character := readChar;
  end;

  if fLineSize > 0 then
  begin
      SetLength( result, numCharacters );
  end;
end;

end.
 
