{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit RTVector3DListCl;

{$MODE Delphi}

interface

uses
  classes,
  RTMiscTp;

type
  TRTVector3DList = class( TList )
  private
      function GetPoint( const anIndex: Integer ): PRTVector3D;

  protected
      procedure Notify( aPointer: Pointer; anAction: TListNotification ); override;

  public
      procedure Add( const aPoint: TRTVector3D );

      property Items[const anIndex: Integer]: PRTVector3D read GetPoint; default;
  end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

implementation

function TRTVector3DList.GetPoint( const anIndex: Integer ): PRTVector3D;
begin
  result := PRTVector3D( Get( anIndex ));
end;

// ----------------------------------------------------------------------------

procedure TRTVector3DList.Add( const aPoint: TRTVector3D );
var
  point: PRTVector3D;
  
begin
  New( point );
  point^ := aPoint;

  inherited Add( point );
end;

// ----------------------------------------------------------------------------

procedure TRTVector3DList.Notify( aPointer: Pointer; anAction: TListNotification );
begin
  if anAction in [lnExtracted, lnDeleted] then
  begin
      Dispose( aPointer );
  end;
end;


end.
 
