{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_AnimationRemoverTool;

{$MODE Delphi}

interface

uses
  unit_SkeletonTool,
  unit_ParamList,
  unit_Joint,
  unit_Skeleton;

type
  TAnimationRemoverTool = class(TSkeletonTool)
  private
  public
    procedure DoPrepare(AParamList: TParamList); override;
    procedure DoExecute(AParamList: TParamList); override;
  end;

implementation

uses
  SysUtils,
  unit_Types,
  unit_Enums,
  unit_Animation;

// ### TAnimationRemoverTool ###################################################

procedure TAnimationRemoverTool.DoPrepare(AParamList: TParamList);
begin
    
end;

procedure TAnimationRemoverTool.DoExecute(AParamList: TParamList);
var i: integer;
    selectedAnimations: TAnimationList;
    animation: TAnimation;
    skeleton: TSkeleton;
begin
    selectedAnimations := TAnimationList(AParamList.NamedParameters['selectedanimations']);

    // remove selected animations from their skeletons
    for i := 0 to selectedAnimations.Count-1 do begin
        animation := selectedAnimations[i];
        skeleton := TSkeleton(animation.Skeleton);
        skeleton.Animations.Remove(animation);
        skeleton.SelectedAnimation := nil;
    end;

    // now clear the selection of animations
    selectedAnimations.Clear;
end;


end.

