{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_ColorDialog;

{$MODE Delphi}

interface

uses
    unit_GenericColorDialog;

type
    TColorDialogEx = class( TGenericColorDialog )
    protected
        procedure RestoreCustomColors; override;
        procedure StoreCustomColors; override;
    end;

implementation

uses
    IniFiles,
    SysUtils,
    Forms,
    unit_Functions;

procedure TColorDialogEx.RestoreCustomColors;
var index: integer;
    inifile: TIniFile;
begin
    try
        inifile := TIniFile.Create(IniFileName);

        for index := 0 to 31 do 
            CustomColors[index] := inifile.ReadInteger('ColorDialog', 'CustomColor' + IntToStr(index), CustomColors[index]);
    finally
        FreeAndNil(inifile);
    end;
end;

// ----------------------------------------------------------------------------

procedure TColorDialogEx.StoreCustomColors;
var index: integer;
    inifile: TIniFile;
begin
    inifile := TIniFile.Create(IniFileName);
    try
        for index := 0 to 31 do
            inifile.WriteInteger('ColorDialog', 'CustomColor' + IntToStr(index), CustomColors[index]);
    finally
        FreeAndNil(inifile);
    end;
end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

end.

