{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_DMLReader;

{$MODE Delphi}

interface

uses
  frmProgressForm,
  unit_Scene;

type
  TDMLReader = class(TObject)
  private
  public
    procedure Load(aFileName: string; aScene: TScene; aProgressForm: TfrmProgress);    // NOTE: could make this a static method instead
  end;

implementation

uses
  Classes, SysUtils,
  unit_Functions,
  unit_DMFSceneReader;

procedure TDMLReader.Load(aFileName: string; aScene: TScene; aProgressForm: TfrmProgress);
var txtSeperated: string;
    strings,values: TStringlist;
    nummaterials: integer;
    dmfSceneReader: TDMFSceneReader;
begin
    try
        strings := TStringList.Create;
        try
            strings.LoadFromFile(aFileName);            // load the DML file into a stringlist
            txtSeperated := FastReplace(strings.Text,#13#10,'');
        finally
            FreeAndNil(strings);
        end;

        values := TStringList.Create;
        try
            SubdivideStringToList2(txtSeperated,';',values);

            // read material information
            nummaterials := StrToInt(values[2]);

            dmfSceneReader := TDMFSceneReader.Create;
            try
                dmfSceneReader.SetMaterials('091',nummaterials,values,2,aScene,aProgressForm,nil);
            finally
                FreeAndNil(dmfSceneReader);
            end;

        finally
            FreeAndNil(values);
        end;

    except
        on E: Exception do raise Exception.Create('TScene.LoadDML091: '+E.Message);
    end;
end;

end.
 
