{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_DMLWriter;

{$MODE Delphi}

interface

uses
  unit_MaterialList,
  unit_Scene;

type
  TDMLWriter = class(TObject)
  private
  public
    procedure Save(AFileName: string; AScene: TScene; AMaterialList: TMaterialList);
  end;

implementation

uses
  Classes, SysUtils,
  unit_DMFSceneWriter;

procedure TDMLWriter.Save(AFileName: string; AScene: TScene; AMaterialList: TMaterialList);
var strings: TStringList;
    dmfSceneWriter: TDMFSceneWriter;
begin
    strings := TStringList.Create;
    try
        strings.Add('DeleD Material List;');
        strings.Add('Version 1.0;');
        strings.Add(IntToStr(AMaterialList.Count)+';');
        dmfSceneWriter := TDMFSceneWriter.Create;
        try
            dmfSceneWriter.GetMaterials(AMaterialList,'091',false, strings)
        finally
            FreeAndNil(dmfSceneWriter);
        end;
        strings.SaveToFile(AFileName);
    finally
        FreeAndNil(strings);
    end;
end;

end.
