{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_JointBuilder;

{$MODE Delphi}

interface

uses SysUtils,
    unit_Types,
    unit_Variables,
    unit_Joint,
    unit_ParamList;

type
  TJointBuilder = class(TObject)
  private
  public
    function Build(AParamList: TParamList): TJoint;
  end;

implementation

uses
  unit_Primitives,
  unit_MaterialManager,
  unit_DPFLoader;

// ### TJointBuilder ###########################################################

function TJointBuilder.Build(AParamList: TParamList): TJoint;
var center: TVertice;
    materialManager: TMaterialManager;
    joint: TJoint;
    dpfLoader: TDPFLoader;
begin
    center := TVertice(AParamList[0]);
    materialManager := TMaterialManager(AParamList[1]);

    joint := TJoint.Create;

    dpfLoader := TDPFLoader.Create;
    dpfLoader.LoadDPF('joint',true,dir_Texture,center,materialManager,TPrimitive(joint));
    FreeAndNil(dpfLoader);

    joint.SetupOriginalVertices(center);
    joint.InitializeNormals( 66 );

    Result := joint;
end;

end.
