{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_PluginVars;

{$MODE Delphi}

interface

type
  TCallBackRecord = record          // callback data passed between plugins and DeleD
   	RequestID: Cardinal;            // reason for executing callback (0,1 or 2)
    RequestXML: PChar;              // XML data coming from the plugin
    ResponseXML: PChar;             // XML data as responded by DeleD
    ResponseSize: Cardinal;         // size of the response XML data in bytes
  end;

  TCallBack = function(var ACallBackRecord: TCallBackRecord): Cardinal; stdcall;
  PCallBack = ^TCallBack;

const
    // plugin request ID values
    PR_GETMEM = 0;
    PR_GETDATA = 1;
    PR_SETDATA = 2;

    // plugin errors
    PE_NOERROR = 0;
    PE_NODATA = 1;
    PE_INVALIDVERSION = 2;
    PE_INVALIDMEM = 3;
    PE_INVALIDGET = 4;
    PE_INVALIDSET = 5;
    PE_INVALIDDATASTRING = 7;
    PE_INVALIDDATAPROPERTY = 8;
    PE_OBJECTDATA = 11;
    PE_LIGHTDATA = 12;
    PE_MATERIALDATA = 13;
    PE_INSUFFICIENT_DATASIZE = 14;
    PE_UNKNOWNREQUEST = 98;
    PE_UNKNOWNERROR = 99;

implementation

end.
