{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_PointLightBuilder;

{$MODE Delphi}

interface

uses SysUtils,
    unit_Types,
    unit_Variables,
    unit_ParamList,
    unit_Lights;

type
  TPointLightBuilder = class(TObject)
  private
  public
    function Build(AParamList: TParamList): TPointLight;
  end;

implementation

uses unit_Primitives,
    unit_MaterialManager,
    unit_DPFLoader;

// ### TPointLightBuilder ######################################################

function TPointLightBuilder.Build(AParamList: TParamList): TPointLight;
var aCenter: TVertice;
    aMaterialManager: TMaterialManager;
    aPointLight: TPointLight;
    aDPFLoader: TDPFLoader;
begin
    aCenter := TVertice(AParamList[0]);
    aMaterialManager := TMaterialManager(AParamList[1]);

    aPointLight := TPointLight.Create;
    aPointLight.Position.Assign(aCenter);

    aDPFLoader := TDPFLoader.Create;
    aDPFLoader.LoadDPF('pointlight',true,dir_Texture,aCenter,aMaterialManager,TPrimitive(aPointLight));  //MaterialManager
    FreeAndNil(aDPFLoader);

    Result := aPointLight;
end;

end.
