{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_PrimitiveDefinition;

{$MODE Delphi}

interface

const
    Rectangle: array[0..0,0..3] of integer =
        ((0,1,2,3));

{
    Hexahedron: array[0..5,0..3] of integer =      // cube: polygons clockwise on the outside
        ((0,1,2,3),         // top
         (4,5,6,7),         // bottom
         (3,2,6,7),         // right
         (0,3,7,4),         // front
         (1,0,4,5),         // left
         (2,1,5,6));        // back
}

{    Hexahedron: array[0..5,0..3] of integer =      // cube: polygons clockwise on the outside
        ((0,1,2,3),         // top
         (4,7,6,5),         // bottom
         (3,2,6,7),         // right
         (0,3,7,4),         // front
         (1,0,4,5),         // left
         (2,1,5,6));        // back}

    Hexahedron_Quads: array[0..5,0..3] of integer =      // cube: polygons clockwise on the outside
        ((0,1,2,3),         // top
         (5,4,7,6),         // bottom
         (3,2,6,7),         // right
         (0,3,7,4),         // front
         (1,0,4,5),         // left
         (2,1,5,6));        // back}

    Hexahedron_size = 0.5;

    Hexahedron_Vertices: array[0..7,0..2] of double =         // cube
        ((-Hexahedron_size, Hexahedron_size, Hexahedron_size),
         (-Hexahedron_size, Hexahedron_size,-Hexahedron_size),
         ( Hexahedron_size, Hexahedron_size,-Hexahedron_size),
         ( Hexahedron_size, Hexahedron_size, Hexahedron_size),
         (-Hexahedron_size,-Hexahedron_size, Hexahedron_size),
         (-Hexahedron_size,-Hexahedron_size,-Hexahedron_size),
         ( Hexahedron_size,-Hexahedron_size,-Hexahedron_size),
         ( Hexahedron_size,-Hexahedron_size, Hexahedron_size));

    Hexahedron_Triangles: array[0..11,0..2] of integer =
        ((0,1,2),
         (0,2,3),
         (0,3,7),
         (0,7,4),
         (0,4,5),
         (0,5,1),
         (6,2,1),
         (6,1,5),
         (6,3,2),
         (6,7,3),
         (6,4,5),
         (6,7,4));

     Pyramid_size = 0.5;

     Pyramid_Vertices: array[0..4,0..2] of double =
        ((-Pyramid_size,-Pyramid_size,-Pyramid_size),
         ( Pyramid_size,-Pyramid_size,-Pyramid_size),
         ( Pyramid_size,-Pyramid_size, Pyramid_size),
         (-Pyramid_size,-Pyramid_size, Pyramid_size),
         (0,Pyramid_size,0));

     Pyramid_Triangles: array[0..5,0..2] of integer =         // normal pyramid
        ((1,0,2),
         (0,3,2),
         (0,4,3),
         (3,4,2),
         (2,4,1),
         (1,4,0));

    IcoX = 0.525731112119133606;
    IcoZ = 0.850650808352039932;

    Icosahedron_Vertices: array[0..11,0..2] of double =        // diamond
        ((-IcoX, 0.0, IcoZ),
         (IcoX, 0.0, IcoZ),
         (-IcoX, 0.0, -IcoZ),
         (IcoX, 0.0, -IcoZ),
         (0.0, IcoZ, IcoX),
         (0.0, IcoZ, -IcoX),
         (0.0, -IcoZ, IcoX),
         (0.0, -IcoZ, -IcoX),
         (IcoZ, IcoX, 0.0),
         (-IcoZ, IcoX, 0.0),
         (IcoZ, -IcoX, 0.0),
         (-IcoZ, -IcoX, 0.0));

    Icosahedron_Triangles: array[0..19,0..2] of integer =
        ((0,4,1),
         (0,9,4),
         (9,5,4),
         (4,5,8),
         (4,8,1),
         (8,10,1),
         (8,3,10),
         (5,3,8),
         (5,2,3),
         (2,7,3),
         (7,10,3),
         (7,6,10),
         (7,11,6),
         (11,0,6),
         (0,1,6),
         (6,1,10),
         (9,0,11),
         (9,11,2),
         (9,2,5),
         (7,2,11));

    Tetrahedron: array[0..3,0..2] of integer =     // triangular pyramid
        ((0,1,2),
         (0,2,3),
         (0,3,1),
         (1,3,2));

    Octahedron: array[0..7,0..2] of integer =      // 4-sided mirrored pyramid
        ((4,0,2),
         (4,2,1),
         (4,1,3),
         (4,3,0),
         (5,2,0),
         (5,1,2),
         (5,3,1),
         (5,0,3));

implementation

end.
