{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_PrimitiveGrouperTool;

{$MODE Delphi}

interface

uses
  Windows, SysUtils, Classes, Contnrs, StrUtils, Dialogs,
  unit_Types,
  unit_Enums,
  unit_Math,
  unit_Primitives,
  unit_ParamList,
  unit_Lights,
  unit_PrimitiveTool,
  unit_PrimitiveList;

type
  TPrimitiveGrouper = class(TPrimitiveTool)
  private
    function GetHighestGroupID: integer;
    procedure Group;
    procedure Ungroup;
  public
    procedure DoPrepare(AParamList: TParamList); override;
    procedure DoExecute(AParamList: TParamList); override;
  end;

implementation

// ### TPrimitiveGrouper #######################################################

function TPrimitiveGrouper.GetHighestGroupID: integer;
var i,groupID: integer;
    primitive: TBasePrimitive;
begin
    groupID := 0;
    for i := 0 to ScenePrimitives.Count-1 do begin
        primitive := ScenePrimitives[i];
        if primitive.groupID > groupID then
            groupID := primitive.groupID;
    end;
    Result := groupID;
end;

procedure TPrimitiveGrouper.Group;
var i, groupID: integer;
    primitive: TBasePrimitive;
begin
    groupID := GetHighestGroupID+1;
    for i := 0 to SelectedPrimitives.Count-1 do begin
        primitive := SelectedPrimitives[i];
        primitive.GroupID := groupID;
    end;
end;

procedure TPrimitiveGrouper.Ungroup;
var i: integer;
    primitive: TBasePrimitive;
begin
    for i := 0 to SelectedPrimitives.Count-1 do begin
        primitive := SelectedPrimitives[i];
        primitive.GroupID := -1;
    end;
end;

procedure TPrimitiveGrouper.DoPrepare(AParamList: TParamList);
begin
    
end;

procedure TPrimitiveGrouper.DoExecute(AParamList: TParamList);
var doGroup: boolean;
begin
    doGroup := TBooleanObject(AParamList.GetObjectByName('doGroup')).Value;

    if doGroup then
        Group
    else
        Ungroup;
end;


end.

