{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_RecentFiles;

{$MODE Delphi}

interface

uses Classes;

type
  TRecentFiles = class(TStringList)
  private
    fMaxRecentFiles: integer;
  public
    constructor Create;
    procedure AddRecentFile(ARecentFile: string);
  end;

implementation

// ### TRecentFiles ############################################################

procedure TRecentFiles.AddRecentFile(ARecentFile: string);
var index: integer;
begin
    index := IndexOf(ARecentFile);
    if index <> -1 then begin                                                   // string found, reorder the list
        Delete(index);
        Insert(0,ARecentFile);
    end else begin                                                              // string not found, insert at beginning of list
        Insert(0,ARecentFile);
        Delete(fMaxRecentFiles);
    end;
end;

constructor TRecentFiles.Create;
begin
    inherited Create;
    fMaxRecentFiles := 5;
end;


end.
 
