{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_SkeletonTool;

{$MODE Delphi}

interface

uses
  unit_Skeleton,
  unit_BaseTool;

type
  // TODO: we might want to pass the SelectedJoints and SelectedAnimations to
  // a SkeletonTool by default as well...
  // Or even not pass anything by default and pass collections to be used explicitly...
  TSkeletonTool = class(TBaseTool)
  private
    fSkeletons: TSkeletonList;
    fSelectedSkeletons: TSkeletonList;
  protected
    procedure PrepareUndoForModification; override;
  public
    procedure Undo; override;
    procedure Redo; override;
    property Skeletons: TSkeletonList read fSkeletons write fSkeletons;
    property SelectedSkeletons: TSkeletonList read fSelectedSkeletons write fSelectedSkeletons;
  end;

implementation

// ### TSkeletonTool ###########################################################

procedure TSkeletonTool.PrepareUndoForModification;
begin

end;

procedure TSkeletonTool.Undo;
begin
    // general undo functionality for skeleton tools can go here;
end;

procedure TSkeletonTool.Redo;
begin

end;

end.
