{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
// Unit:    unit_versioninfo
// Purpose: contains version information in double & string formats
// Note:    Version info is taken from the project (Project Options, Version Info),
//          make sure to keep it up to date.

unit unit_VersionInfo;

{$MODE Delphi}

interface

uses SysUtils;

var _versionnumber: currency;
    _versionstring: string;             // set in initialization section
    _versionshortstring: string;        // without LITE or PRO behind version number

implementation

uses
    Windows, Math;

function ReadVersionNumber: currency;
var info: PVSFixedFileInfo;
    infoSize: Cardinal;
    handle: DWord;
    bufferSize, numDigits: integer;
    buffer: pointer;
    minor, major: word;
begin
    result := 0;
    
    bufferSize := GetFileVersionInfoSize( PChar(ParamStr(0)), handle);
    GetMem(buffer, bufferSize);
    try
        if not GetFileVersionInfo(PChar(ParamStr(0)), handle, bufferSize, buffer) then
            raise Exception.Create( 'No version information found in file.' );

        VerQueryValue(Buffer, '\', Pointer(Info), InfoSize);

        major := HiWord(Info^.dwFileVersionMS);
        minor := LoWord(Info^.dwFileVersionMS);

        // We convert major.minor to a currency for easy comparisons
        numDigits := Floor(Log10(minor)) + 1;
        result := major + minor / Power(10, numDigits);

    finally
        FreeMem(buffer, bufferSize);
    end;
end;


initialization
    DecimalSeparator := '.';                                                    // set later on as well, but we need it here and now
    {$IFNDEF DELED_TEST}
    _versionNumber := ReadVersionNumber;
    {$ENDIF}
    _versionshortstring := FormatFloat('0.0#', _versionnumber);

    _versionString := _versionshortstring + ' Lazarus Port';
end.
