{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
unit unit_XMLSceneConstants;

{$MODE Delphi}

interface

uses unit_Enums, unit_Lights;

type
    TXMLLightClassInfo = record
        Name: string;
        Prefab: string;
        LightClass: TLightClass;
    end;

const
    XML_LAYER_TYPE_LIGHTMAP = 'lightmap';
    XML_MATERIAL_LAYER_TYPES: Array[TMaterialLayerType] of String = ( 'texture', 'color' );
    XML_BLEND_OPERATIONS: Array[TBlendOperation] of String = ( 'ignore', 'replace', 'add', 'modulate', 'alphablend', 'normalmap' );
    XML_PRIMITIVE_TYPES: Array[TObjectType] of String = (
        'rectangle', 'cube', 'pyramid', 'cylinder', 'polyline', 'vertice', 'sphere',
        'torus', 'plane', 'userdefined', 'prefab', 'undefined', 'grid',
        'pointlight', 'directionallight', 'spotlight', 'primitive', 'light',
        'ellipse', 'text', 'joint', 'animation','path');
    XML_SNAP_METHODS: Array[TSnapMethod] of String = ( 'none', 'vertex', 'center', 'location' );

    XML_LIGHT_CLASS_INFOS: Array[0..2] of TXMLLightClassInfo = (
        ( Name: 'point'; Prefab: 'pointlight'; lightClass: TPointLight ),
        ( Name: 'directional'; Prefab: 'directionallight'; lightClass: TDirectionalLight ),
        ( Name: 'spot'; Prefab: 'spotlight'; lightClass: TSpotLight )
    );

implementation

end.
 
