{ ----------------------------------------------------------------------------
    Copyright (C) 2005-2010 Jeroen Commandeur and Paul-Jan Pauptit

    This file is part of DeleD CE (Community Edition)

    DeleD CE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Deled CE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Deled CE. If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------------- }
program deled;

{$MODE Delphi}

uses
  Windows, Forms, Dialogs, Interfaces, FileUtil, SysUtils, dglOpenGL,
  MZLib in 'Units\MZLib.pas',
  frmViewPortForm in 'Forms\frmViewPortForm.pas' {frmViewPort},
  frmOGLContextForm in 'Forms\frmOGLContextForm.pas' {frmOGLContext},
  frmOGLForm in 'Forms\frmOGLForm.pas',
  frmAboutForm in 'Forms\frmAboutForm.pas' {frmAboutBox},
  frmCommentsForm in 'Forms\frmCommentsForm.pas' {frmComments},
  frmCreatePropertiesText in 'Forms\frmCreatePropertiesText.pas' {frmCreatePropText},
  frmCreateSceneForm in 'Forms\frmCreateSceneForm.pas' {frmCreateScene},
  frmDockableForm in 'Forms\frmDockableForm.pas' {frmDockable},
  frmExportUVMapOptionsForm in 'Forms\frmExportUVMapOptionsForm.pas' {frmExportUVMapOptions},
  frmHintsForm in 'Forms\frmHintsForm.pas' {frmHints},
  frmHotKeysForm in 'Forms\frmHotKeysForm.pas' {frmHotkeys},
  frmInspectorForm in 'Forms\frmInspectorForm.pas' {frmInspector},
  frmMainForm in 'Forms\frmMainForm.pas' {frmMain},
  frmMaterialEditorForm in 'Forms\frmMaterialEditorForm.pas' {frmMaterialEditor},
  frmMaterialsForm in 'Forms\frmMaterialsForm.pas' {frmMaterials},
  frmOGLValidationForm in 'Forms\frmOGLValidationForm.pas' {frmOGLValidation},
  frmOptionsForm in 'Forms\frmOptionsForm.pas' {frmOptions},
  frmPluginsForm in 'Forms\frmPluginsForm.pas' {frmPlugins},
  frmPrefabForm in 'Forms\frmPrefabForm.pas' {frmPrefab},
  frmProgressForm in 'Forms\frmProgressForm.pas' {frmProgress},
  frmPropertiesForm in 'Forms\frmPropertiesForm.pas' {frmProperties},
  frmRaytracingForm in 'Forms\frmRaytracingForm.pas' {frmRaytracing},
  frmRaytracingOptionsForm in 'Forms\frmRaytracingOptionsForm.pas' {frmRaytracingOptions},
  frmRaytracingProgressForm in 'Forms\frmRaytracingProgressForm.pas' {frmRaytracingProgress},
  frmRM in 'Forms\frmRM.pas' {frmReplaceMaterials},
  frmSceneInspectorForm in 'Forms\frmSceneInspectorForm.pas' {frmSceneInspector},
  frmScreenshotForm in 'Forms\frmScreenshotForm.pas' {ScreenshotForm},
  frmScreenshotOptionsForm in 'Forms\frmScreenshotOptionsForm.pas' {frmScreenshotOptions},
  frmSplashScreenForm in 'Forms\frmSplashScreenForm.pas' {SplashScreenForm},
  frmStandardDialogForm in 'Forms\frmStandardDialogForm.pas' {frmStandardDialog},
  frmTextureBrowserForm in 'Forms\frmTextureBrowserForm.pas' {frmTextureBrowser},
  frmUVEditorForm in 'Forms\frmUVEditorForm.pas' {frmUVEditor},
  frmVisibilityForm in 'Forms\frmVisibilityForm.pas' {frmVisibility},
  frmFlatViewPortForm in 'Forms\frmFlatViewPortForm.pas' {frmFlatViewPort},
  frmTopView in 'Forms\frmTopView.pas' {frmTop},
  frmSideView in 'Forms\frmSideView.pas' {frmSide},
  frmFrontView in 'Forms\frmFrontView.pas' {frmFront},
  frm3dView in 'Forms\frm3dView.pas' {frm3d},
  frmCreateEditForm in 'Forms\frmCreateEditForm.pas' {frmCreateEdit},
  frmAdvancedTrackbarForm in 'Forms\frmAdvancedTrackbarForm.pas' {frmAdvancedTrackbar},
  frmDeleteFramesForm in 'Forms\frmDeleteFramesForm.pas' {frmDeleteFrames},
  frmInsertFramesForm in 'Forms\frmInsertFramesForm.pas' {frmInsertFrames},
  frmScriptingMain in 'Forms\frmScriptingMain.pas' {frmScriptMain},
  frmSkeletonAnimationEditorForm in 'Forms\frmSkeletonAnimationEditorForm.pas' {frmSkeletonAnimationEditor},
  fraCommandPropertiesAlign in 'Frames\fraCommandPropertiesAlign.pas',
  fraCommandPropertiesAverage in 'Frames\fraCommandPropertiesAverage.pas',
  fraCommandPropertiesBevel in 'Frames\fraCommandPropertiesBevel.pas',
  fraCommandPropertiesClone in 'Frames\fraCommandPropertiesClone.pas',
  fraCommandPropertiesConnect in 'Frames\fraCommandPropertiesConnect.pas',
  fraCommandPropertiesCycle in 'Frames\fraCommandPropertiesCycle.pas',
  fraCommandPropertiesDefault in 'Frames\fraCommandPropertiesDefault.pas' {fraCommandPropDefault: TFrame},
  fraCommandPropertiesExtract in 'Frames\fraCommandPropertiesExtract.pas' {fraCommandPropExtract: TFrame},
  fraCommandPropertiesExtrude in 'Frames\fraCommandPropertiesExtrude.pas' {fraCommandPropExtrude: TFrame},
  fraCommandPropertiesExtrudeEdge in 'Frames\fraCommandPropertiesExtrudeEdge.pas' {fraCommandPropExtrudeEdge: TFrame},
  fraCommandPropertiesFlip in 'Frames\fraCommandPropertiesFlip.pas' {fraCommandPropFlip: TFrame},
  fraCommandPropertiesGenerateUV in 'Frames\fraCommandPropertiesGenerateUV.pas' {fraCommandPropGenerateUV: TFrame},
  fraCommandPropertiesHollow in 'Frames\fraCommandPropertiesHollow.pas' {fraCommandPropHollow: TFrame},
  fraCommandPropertiesInset in 'Frames\fraCommandPropertiesInset.pas' {fraCommandPropInset: TFrame},
  fraCommandPropertiesLathe in 'Frames\fraCommandPropertiesLathe.pas' {fraCommandPropLathe: TFrame},
  fraCommandPropertiesMagnet in 'Frames\fraCommandPropertiesMagnet.pas' {fraCommandPropMagnet: TFrame},
  fraCommandPropertiesMirror in 'Frames\fraCommandPropertiesMirror.pas' {fraCommandPropMirror: TFrame},
  fraCommandPropertiesMove in 'Frames\fraCommandPropertiesMove.pas' {fraCommandPropMove: TFrame},
  fraCommandPropertiesMovePolygon in 'Frames\fraCommandPropertiesMovePolygon.pas' {fraCommandPropMovePolygon: TFrame},
  fraCommandPropertiesMoveUV in 'Frames\fraCommandPropertiesMoveUV.pas' {fraCommandPropMoveUV: TFrame},
  fraCommandPropertiesNone in 'Frames\fraCommandPropertiesNone.pas' {fraCommandPropNone: TFrame},
  fraCommandPropertiesRotate in 'Frames\fraCommandPropertiesRotate.pas' {fraCommandPropRotate: TFrame},
  fraCommandPropertiesRotateUV in 'Frames\fraCommandPropertiesRotateUV.pas' {fraCommandPropRotateUV: TFrame},
  fraCommandPropertiesScale in 'Frames\fraCommandPropertiesScale.pas' {fraCommandPropScale: TFrame},
  fraCommandPropertiesScaleUV in 'Frames\fraCommandPropertiesScaleUV.pas' {fraCommandPropScaleUV: TFrame},
  fraCommandPropertiesSmooth in 'Frames\fraCommandPropertiesSmooth.pas' {fraCommandPropSmooth: TFrame},
  fraCommandPropertiesSnap in 'Frames\fraCommandPropertiesSnap.pas' {fraCommandPropSnap: TFrame},
  fraCommandPropertiesSplitEdge in 'Frames\fraCommandPropertiesSplitEdge.pas' {fraCommandPropSplitEdge: TFrame},
  fraCommandPropertiesTriangulate in 'Frames\fraCommandPropertiesTriangulate.pas' {fraCommandPropTriangulate: TFrame},
  fraCommandPropertiesWeld in 'Frames\fraCommandPropertiesWeld.pas' {fraCommandPropWeld: TFrame},
  fraCommands in 'Frames\fraCommands.pas' {fraCommandButtons: TFrame},
  fraCreatePropertiesCube in 'Frames\fraCreatePropertiesCube.pas',
  fraCreatePropertiesCylinder in 'Frames\fraCreatePropertiesCylinder.pas',
  fraCreatePropertiesDefault in 'Frames\fraCreatePropertiesDefault.pas' {fraCreatePropDefault: TFrame},
  fraCreatePropertiesEllipse in 'Frames\fraCreatePropertiesEllipse.pas' {fraCreatePropEllipse: TFrame},
  fraCreatePropertiesGrid in 'Frames\fraCreatePropertiesGrid.pas' {fraCreatePropGrid: TFrame},
  fraCreatePropertiesNone in 'Frames\fraCreatePropertiesNone.pas' {fraCreatePropNone: TFrame},
  fraCreatePropertiesPolyline in 'Frames\fraCreatePropertiesPolyline.pas' {fraCreatePropPolyline: TFrame},
  fraCreatePropertiesPyramid in 'Frames\fraCreatePropertiesPyramid.pas' {fraCreatePropPyramid: TFrame},
  fraCreatePropertiesRectangle in 'Frames\fraCreatePropertiesRectangle.pas' {fraCreatePropRectangle: TFrame},
  fraCreatePropertiesSphere in 'Frames\fraCreatePropertiesSphere.pas' {fraCreatePropSphere: TFrame},
  fraCreatePropertiesTorus in 'Frames\fraCreatePropertiesTorus.pas' {fraCreatePropTorus: TFrame},
  fraCSGCommands in 'Frames\fraCSGCommands.pas' {fraCSGCommandButtons: TFrame},
  fraInspectorDefault in 'Frames\fraInspectorDefault.pas' {fraInspectorDefaultFrame: TFrame},
  fraInspectorLight in 'Frames\fraInspectorLight.pas' {fraInspectorLights: TFrame},
  fraInspectorPointlight in 'Frames\fraInspectorPointlight.pas' {fraInspectorPointlights: TFrame},
  fraInspectorPrimitive in 'Frames\fraInspectorPrimitive.pas' {fraInspectorPrimitives: TFrame},
  fraInspectorSpotlight in 'Frames\fraInspectorSpotlight.pas' {fraInspectorSpotlights: TFrame},
  fraLightInspector in 'Frames\fraLightInspector.pas' {fraLightsInspector: TFrame},
  fraMaterial in 'Frames\fraMaterial.pas' {MaterialFrame: TFrame},
  fraMaterialLayer in 'Frames\fraMaterialLayer.pas' {MaterialLayerFrame: TFrame},
  fraTexture in 'Frames\fraTexture.pas' {TextureFrame: TFrame},
  fraInspectorDirlight in 'Frames\fraInspectorDirlight.pas' {fraInspectorDirlights: TFrame},
  fraInspectorJoint in 'Frames\fraInspectorJoint.pas' {fraInspectorJoints: TFrame},
  fraCommandPropertiesAssign in 'Frames\fraCommandPropertiesAssign.pas' {fraCommandPropAssign: TFrame},
  fraInspectorAnimation in 'Frames\fraInspectorAnimation.pas' {fraInspectorAnimations: TFrame},
  fraCreatePropertiesAnimation in 'Frames\fraCreatePropertiesAnimation.pas' {fraCreatePropAnimation: TFrame},
  fraInspectorSkeleton in 'Frames\fraInspectorSkeleton.pas' {fraInspectorSkeletons: TFrame},
  fraCreatePropertiesPath in 'Frames\fraCreatePropertiesPath.pas' {fraCreatePropPath: TFrame},
  fraCommandPropertiesInsert in 'Frames\fraCommandPropertiesInsert.pas' {fraCommandPropInsert: TFrame},
  fraCommandPropertiesNoiseTool in 'Frames\fraCommandPropertiesNoiseTool.pas' {fraCommandPropNoiseTool: TFrame},
  fraInspectorPath in 'Frames\fraInspectorPath.pas' {fraInspectorPaths: TFrame},
  unit_AABB in 'Units\unit_AABB.pas',
  unit_Allowances in 'Units\unit_Allowances.pas',
  unit_AnimationFrame in 'Units\unit_AnimationFrame.pas',
  unit_Animation in 'Units\unit_Animation.pas',
  unit_AnimationBuilder in 'Units\unit_AnimationBuilder.pas',
  unit_AnimationFramesInterpolatorTool in 'Units\unit_AnimationFramesInterpolatorTool.pas',
  unit_attenuationgraph in 'Units\unit_attenuationgraph.pas',
  unit_BaseTool in 'Units\unit_BaseTool.pas',
  unit_Bone in 'Units\unit_Bone.pas',
  unit_BoneList in 'Units\unit_BoneList.pas',
  unit_BoneBuilder in 'Units\unit_BoneBuilder.pas',
  unit_BoneTransformerTool in 'Units\unit_BoneTransformerTool.pas',
  unit_BSP in 'Units\unit_BSP.pas',
  unit_BufferedFileStream in 'Units\unit_BufferedFileStream.pas',
  unit_BufferedStringStream in 'Units\unit_BufferedStringStream.pas',
  unit_Cameras in 'Units\unit_Cameras.pas',
  unit_ColorDialog in 'Units\unit_ColorDialog.pas',
  unit_Constants in 'Units\unit_Constants.pas',
  unit_DirectionalLightBuilder in 'Units\unit_DirectionalLightBuilder.pas',
  unit_DMFSceneReader in 'Units\unit_DMFSceneReader.pas',
  unit_DMFSceneWriter in 'Units\unit_DMFSceneWriter.pas',
  unit_DMLReader in 'Units\unit_DMLReader.pas',
  unit_DMLWriter in 'Units\unit_DMLWriter.pas',
  unit_DPFLoader in 'Units\unit_DPFLoader.pas',
  unit_DDSSupport in 'Units\unit_DDSSupport.pas',
  unit_EdgeBevellerTool in 'Units\unit_EdgeBevellerTool.pas',
  unit_EdgeConnectorTool in 'Units\unit_EdgeConnectorTool.pas',
  unit_EdgeExtruderTool in 'Units\unit_EdgeExtruderTool.pas',
  unit_EdgeFillTool in 'Units\unit_EdgeFillTool.pas',
  unit_EdgeSplitterTool in 'Units\unit_EdgeSplitterTool.pas',
  unit_EdgeTurnerTool in 'Units\unit_EdgeTurnerTool.pas',
  unit_Enums in 'Units\unit_Enums.pas',
  unit_Functions in 'Units\unit_Functions.pas',
  unit_GenericColorDialog in 'Units\unit_GenericColorDialog.pas',
  unit_Generics in 'Units\unit_Generics.pas',
  unit_GLInfo in 'Units\unit_GLInfo.pas',
  unit_HashedList in 'Units\unit_HashedList.pas',
  unit_HtmlHelp in 'Units\unit_HtmlHelp.pas',
  unit_IntegerList in 'Units\unit_IntegerList.pas',
  unit_Joint in 'Units\unit_Joint.pas',
  unit_JointLocation in 'Units\unit_JointLocation.pas',
  unit_JointGeometryUpdatingTool in 'Units\unit_JointGeometryUpdatingTool.pas',
  unit_JointBuilder in 'Units\unit_JointBuilder.pas',
  unit_JointSelector in 'Units\unit_JointSelector.pas',
  unit_JointLocationMoverTool in 'Units\unit_JointLocationMoverTool.pas',
  unit_JointRemoverTool in 'Units\unit_JointRemoverTool.pas',
  unit_JointLocationRotatorTool in 'Units\unit_JointLocationRotatorTool.pas',
  unit_JointGeometryAssigningTool in 'Units\unit_JointGeometryAssigningTool.pas',
  unit_JointGeometrySelectingTool in 'Units\unit_JointGeometrySelectingTool.pas',
  unit_LightMapper in 'Units\unit_LightMapper.pas',
  unit_LightMapRenderSystem in 'Units\unit_LightMapRenderSystem.pas',
  unit_Lights in 'Units\unit_Lights.pas',
  unit_Log in 'Units\unit_Log.pas',
  unit_MaterialList in 'Units\unit_MaterialList.pas',
  unit_MaterialLoader in 'Units\unit_MaterialLoader.pas',
  unit_MaterialManager in 'Units\unit_MaterialManager.pas',
  unit_MaterialMatcher in 'Units\unit_MaterialMatcher.pas',
  unit_Materials in 'Units\unit_Materials.pas',
  unit_Math in 'Units\unit_Math.pas',
  unit_Messages in 'Units\unit_Messages.pas',
  unit_Octree in 'Units\unit_Octree.pas',
  unit_Options in 'Units\unit_Options.pas',
  unit_ParamList in 'Units\unit_ParamList.pas',
  unit_PerlinNoise in 'Units\unit_PerlinNoise.pas',
  unit_PluginManager in 'Units\unit_PluginManager.pas',
  unit_Plugins in 'Units\unit_Plugins.pas',
  unit_PluginVars in 'Units\unit_PluginVars.pas',
  unit_PNGSupport in 'Units\unit_PNGSupport.pas',
  unit_PolygonByPlaneSplitterTool in 'Units\unit_PolygonByPlaneSplitterTool.pas',
  unit_PolygonByVerticesSplitterTool in 'Units\unit_PolygonByVerticesSplitterTool.pas',
  unit_PolygonFlattenerTool in 'Units\unit_PolygonFlattenerTool.pas',
  unit_PolygonMergerTool in 'Units\unit_PolygonMergerTool.pas',
  unit_PointLightBuilder in 'Units\unit_PointLightBuilder.pas',
  unit_PrimitiveSelector in 'Units\unit_PrimitiveSelector.pas',
  unit_PrimitiveTool in 'Units\unit_PrimitiveTool.pas',
  unit_PrimitiveCatmullClarkSubdividerTool in 'Units\unit_PrimitiveCatmullClarkSubdividerTool.pas',
  unit_PrimitiveDefinition in 'Units\unit_PrimitiveDefinition.pas',
  unit_PrimitiveDooSabinSubdividerTool in 'Units\unit_PrimitiveDooSabinSubdividerTool.pas',
  unit_PrimitiveList in 'Units\unit_PrimitiveList.pas',
  unit_Primitives in 'Units\unit_Primitives.pas',
  unit_PrimitiveSliceTool in 'Units\unit_PrimitiveSliceTool.pas',
  unit_RaytraceManager in 'Units\unit_RaytraceManager.pas',
  unit_RaytracingThread in 'Units\unit_RaytracingThread.pas',
  unit_RecentFiles in 'Units\unit_RecentFiles.pas',
  unit_RenderQueue in 'Units\unit_RenderQueue.pas',
  unit_Scene in 'Units\unit_Scene.pas',
  unit_screenshotManager in 'Units\unit_screenshotManager.pas',
  unit_SpotLightBuilder in 'Units\unit_SpotLightBuilder.pas',
  unit_Skeleton in 'Units\unit_Skeleton.pas',
  unit_SkeletonBuilder in 'Units\unit_SkeletonBuilder.pas',
  unit_SkeletonTool in 'Units\unit_SkeletonTool.pas',
  unit_Selector in 'Units\unit_Selector.pas',
  unit_StringDictionary in 'Units\unit_StringDictionary.pas',
  unit_TextureLoader in 'Units\unit_TextureLoader.pas',
  unit_TextureManipulator in 'Units\unit_TextureManipulator.pas',
  unit_Textures in 'Units\unit_Textures.pas',
  unit_TextureTypes in 'Units\unit_TextureTypes.pas',
  unit_TextureWriter in 'Units\unit_TextureWriter.pas',
  unit_TGALoader in 'Units\unit_TGALoader.pas',
  unit_Tiler in 'Units\unit_Tiler.pas',
  unit_TrackBarControl in 'Units\unit_TrackBarControl.pas',
  unit_Types in 'Units\unit_Types.pas',
  unit_Variables in 'Units\unit_Variables.pas',
  unit_VersionInfo in 'Units\unit_VersionInfo.pas',
  unit_VertexBevellerTool in 'Units\unit_VertexBevellerTool.pas',
  unit_VertexConnectorTool in 'Units\unit_VertexConnectorTool.pas',
  unit_VertexFillerTool in 'Units\unit_VertexFillerTool.pas',
  unit_VertexInserterTool in 'Units\unit_VertexInserterTool.pas',
  unit_VertexMagnetTool in 'Units\unit_VertexMagnetTool.pas',
  unit_VertexMoverTool in 'Units\unit_VertexMoverTool.pas',
  unit_VertexRemoverTool in 'Units\unit_VertexRemoverTool.pas',
  unit_VertexSelector in 'Units\unit_VertexSelector.pas',
  unit_VertexWelderTool in 'Units\unit_VertexWelderTool.pas',
  unit_ViewPortManager in 'Units\unit_ViewPortManager.pas',
  unit_XMLDataReader in 'Units\unit_XMLDataReader.pas',
  unit_XMLDataWriter in 'Units\unit_XMLDataWriter.pas',
  unit_XMLPluginReader in 'Units\unit_XMLPluginReader.pas',
  unit_XMLPluginWriter in 'Units\unit_XMLPluginWriter.pas',
  unit_XMLReader in 'Units\unit_XMLReader.pas',
  unit_XMLSceneConstants in 'Units\unit_XMLSceneConstants.pas',
  unit_XMLSceneReader in 'Units\unit_XMLSceneReader.pas',
  unit_XMLSceneWriter in 'Units\unit_XMLSceneWriter.pas',
  unit_XMLWriter in 'Units\unit_XMLWriter.pas',
  RTMiscTp in 'Units\Raytracer\Utitilies\RTMiscTp.pas',
  RTMathFn in 'Units\Raytracer\Utitilies\RTMathFn.pas',
  RTGeometricObjectCl in 'Units\Raytracer\GeometricObjects\RTGeometricObjectCl.pas',
  RTWorldCl in 'Units\Raytracer\World\RTWorldCl.pas',
  RTPlaneCl in 'Units\Raytracer\GeometricObjects\RTPlaneCl.pas',
  RTSphereCl in 'Units\Raytracer\GeometricObjects\RTSphereCl.pas',
  RTMiscCn in 'Units\Raytracer\Utitilies\RTMiscCn.pas',
  RTViewPlaneCl in 'Units\Raytracer\World\RTViewPlaneCl.pas',
  RTTracerCl in 'Units\Raytracer\Tracers\RTTracerCl.pas',
  RTSingleSphereTracerCl in 'Units\Raytracer\Tracers\RTSingleSphereTracerCl.pas',
  RTWorldTracerCl in 'Units\Raytracer\Tracers\RTWorldTracerCl.pas',
  RTMultipleObjectsTracerCl in 'Units\Raytracer\Tracers\RTMultipleObjectsTracerCl.pas',
  RT2DFunctionTracerCl in 'Units\Raytracer\Tracers\RT2DFunctionTracerCl.pas',
  RTSamplerCl in 'Units\Raytracer\Samplers\RTSamplerCl.pas',
  RTPoint2DListCl in 'Units\Raytracer\Utitilies\RTPoint2DListCl.pas',
  RTIntegerListCl in 'Units\Raytracer\Utitilies\RTIntegerListCl.pas',
  RTJitteredSamplerCl in 'Units\Raytracer\Samplers\RTJitteredSamplerCl.pas',
  RTMultiJitteredSamplerCl in 'Units\Raytracer\Samplers\RTMultiJitteredSamplerCl.pas',
  RTRegularSamplerCl in 'Units\Raytracer\Samplers\RTRegularSamplerCl.pas',
  RTNRooksSamplerCl in 'Units\Raytracer\Samplers\RTNRooksSamplerCl.pas',
  RTRandomSamplerCl in 'Units\Raytracer\Samplers\RTRandomSamplerCl.pas',
  RTHammersleySamplerCl in 'Units\Raytracer\Samplers\RTHammersleySamplerCl.pas',
  RTVector3DListCl in 'Units\Raytracer\Utitilies\RTVector3DListCl.pas',
  RTCameraCl in 'Units\Raytracer\Cameras\RTCameraCl.pas',
  RTOrthographicCameraCl in 'Units\Raytracer\Cameras\RTOrthographicCameraCl.pas',
  RTPinholeCameraCl in 'Units\Raytracer\Cameras\RTPinholeCameraCl.pas',
  RTThinLensCameraCl in 'Units\Raytracer\Cameras\RTThinLensCameraCl.pas',
  RTFisheyeCameraCl in 'Units\Raytracer\Cameras\RTFisheyeCameraCl.pas',
  RTSphericalCameraCl in 'Units\Raytracer\Cameras\RTSphericalCameraCl.pas',
  RTStereoCameraCl in 'Units\Raytracer\Cameras\RTStereoCameraCl.pas',
  RTBoxCl in 'Units\Raytracer\GeometricObjects\RTBoxCl.pas',
  RTTriangleCl in 'Units\Raytracer\GeometricObjects\RTTriangleCl.pas',
  RTCylindricalCameraCl in 'Units\Raytracer\Cameras\RTCylindricalCameraCl.pas',
  RTBRDFCl in 'Units\Raytracer\BRDFs\RTBRDFCl.pas',
  RTLambertianBRDFCl in 'Units\Raytracer\BRDFs\RTLambertianBRDFCl.pas',
  RTLightCl in 'Units\Raytracer\Lights\RTLightCl.pas',
  RTAmbientLightCl in 'Units\Raytracer\Lights\RTAmbientLightCl.pas',
  RTPointLightCl in 'Units\Raytracer\Lights\RTPointLightCl.pas',
  RTMaterialCl in 'Units\Raytracer\Materials\RTMaterialCl.pas',
  RTRayCastTracerCl in 'Units\Raytracer\Tracers\RTRayCastTracerCl.pas',
  RTWhittedTracerCl in 'Units\Raytracer\Tracers\RTWhittedTracerCl.pas',
  RTAreaLightingTracerCl in 'Units\Raytracer\Tracers\RTAreaLightingTracerCl.pas',
  RTPathTracerCl in 'Units\Raytracer\Tracers\RTPathTracerCl.pas',
  RTMatteMaterialCl in 'Units\Raytracer\Materials\RTMatteMaterialCl.pas',
  RTDirectionalLightCl in 'Units\Raytracer\Lights\RTDirectionalLightCl.pas',
  RTOpenCylinderCl in 'Units\Raytracer\GeometricObjects\RTOpenCylinderCl.pas',
  RTDiscCl in 'Units\Raytracer\GeometricObjects\RTDiscCl.pas',
  RTGlossySpecularBRDFCl in 'Units\Raytracer\BRDFs\RTGlossySpecularBRDFCl.pas',
  RTPhongMaterialCl in 'Units\Raytracer\Materials\RTPhongMaterialCl.pas',
  RTGenericMaterialCl in 'Units\Raytracer\Materials\RTGenericMaterialCl.pas',
  RTTorusCl in 'Units\Raytracer\GeometricObjects\RTTorusCl.pas',
  RTAmbientOcclusionLightCl in 'Units\Raytracer\Lights\RTAmbientOcclusionLightCl.pas',
  RTRectangleCl in 'Units\Raytracer\GeometricObjects\RTRectangleCl.pas',
  RTEmissiveMaterialCl in 'Units\Raytracer\Materials\RTEmissiveMaterialCl.pas',
  RTFakeSphericalLightCl in 'Units\Raytracer\Lights\RTFakeSphericalLightCl.pas',
  RTSampler3DCl in 'Units\Raytracer\Samplers\3D\RTSampler3DCl.pas',
  RTMultiJitteredSampler3DCl in 'Units\Raytracer\Samplers\3D\RTMultiJitteredSampler3DCl.pas',
  RTEnvironmentLightCl in 'Units\Raytracer\Lights\RTEnvironmentLightCl.pas',
  RTCompoundObjectCl in 'Units\Raytracer\GeometricObjects\RTCompoundObjectCl.pas',
  RTSolidCylinderCl in 'Units\Raytracer\GeometricObjects\RTSolidCylinderCl.pas',
  RTInstanceCl in 'Units\Raytracer\GeometricObjects\RTInstanceCl.pas',
  RTGridCl in 'Units\Raytracer\GeometricObjects\RTGridCl.pas',
  RTAABoundingBoxCl in 'Units\Raytracer\Utitilies\RTAABoundingBoxCl.pas',
  RTMeshCl in 'Units\Raytracer\Utitilies\RTMeshCl.pas',
  RTMeshTriangleCl in 'Units\Raytracer\GeometricObjects\RTMeshTriangleCl.pas',
  RTMeshLoaderCl in 'Units\Raytracer\Utitilies\MeshLoaders\RTMeshLoaderCl.pas',
  RTPLYMeshLoaderCl in 'Units\Raytracer\Utitilies\MeshLoaders\RTPLYMeshLoaderCl.pas',
  RTTextFileStreamCl in 'Units\Raytracer\Utitilies\RTTextFileStreamCl.pas',
  RTBufferedFileStreamCl in 'Units\Raytracer\Utitilies\RTBufferedFileStreamCl.pas',
  RTReflectiveMaterialCl in 'Units\Raytracer\Materials\RTReflectiveMaterialCl.pas',
  RTPerfectSpecularBRDFCl in 'Units\Raytracer\BRDFs\RTPerfectSpecularBRDFCl.pas',
  RTRenderWorldCl in 'Units\Raytracer\World\RTRenderWorldCl.pas',
  RTTextureCl in 'Units\Raytracer\Materials\RTTextureCl.pas',
  RTGenericLambertianBRDFCl in 'Units\Raytracer\BRDFs\RTGenericLambertianBRDFCl.pas',
  frmRaytracingPreviewForm in 'Forms\frmRaytracingPreviewForm.pas' {frmRaytracingPreview},
  RTTexturedLambertianBRDFCl in 'Units\Raytracer\BRDFs\RTTexturedLambertianBRDFCl.pas',
  RTSpotLightCl in 'Units\Raytracer\Lights\RTSpotLightCl.pas',
  RTBVHCl in 'Units\Raytracer\GeometricObjects\RTBVHCl.pas',
  RTTransparentMaterialCl in 'Units\Raytracer\Materials\RTTransparentMaterialCl.pas',
  RTPerfectBRTFCl in 'Units\Raytracer\BRTFs\RTPerfectBRTFCl.pas',
  RTBRTFCl in 'Units\Raytracer\BRTFs\RTBRTFCl.pas',
  unit_ColorControl in 'Units\unit_ColorControl.pas',
  unit_JointGeometryUnassigningTool in 'Units\unit_JointGeometryUnassigningTool.pas',
  unit_AnimationPlayer in 'Units\unit_AnimationPlayer.pas',
  unit_FloatTextureWriter in 'Units\unit_FloatTextureWriter.pas',
  unit_FloatTextureLoader in 'Units\unit_FloatTextureLoader.pas',
  unit_SkeletonRemoverTool in 'Units\unit_SkeletonRemoverTool.pas',
  unit_AnimationRemoverTool in 'Units\unit_AnimationRemoverTool.pas',
  unit_PrimitiveMoverTool in 'Units\unit_PrimitiveMoverTool.pas',
  unit_PrimitiveScalerTool in 'Units\unit_PrimitiveScalerTool.pas',
  unit_PrimitiveRotatorTool in 'Units\unit_PrimitiveRotatorTool.pas',
  unit_EdgeMoverTool in 'Units\unit_EdgeMoverTool.pas',
  unit_EdgeScalerTool in 'Units\unit_EdgeScalerTool.pas',
  unit_EdgeSelector in 'Units\unit_EdgeSelector.pas',
  unit_PolygonSelector in 'Units\unit_PolygonSelector.pas',
  unit_PrimitiveClipBoard in 'Units\unit_PrimitiveClipBoard.pas',
  unit_PrimitiveSnapperTool in 'Units\unit_PrimitiveSnapperTool.pas',
  unit_PrimitiveGrouperTool in 'Units\unit_PrimitiveGrouperTool.pas',
  unit_PrimitiveRemoverTool in 'Units\unit_PrimitiveRemoverTool.pas',
  unit_PrimitiveMergerTool in 'Units\unit_PrimitiveMergerTool.pas',
  unit_PrimitiveHollowerTool in 'Units\unit_PrimitiveHollowerTool.pas',
  unit_PolygonExtruderTool in 'Units\unit_PolygonExtruderTool.pas',
  unit_PolygonMoverTool in 'Units\unit_PolygonMoverTool.pas',
  unit_PolygonTriangulatorTool in 'Units\unit_PolygonTriangulatorTool.pas',
  unit_PolygonFlipperTool in 'Units\unit_PolygonFlipperTool.pas',
  unit_VertexAveragerTool in 'Units\unit_VertexAveragerTool.pas',
  unit_PrimitiveClonerTool in 'Units\unit_PrimitiveClonerTool.pas',
  unit_PrimitiveOptimizerTool in 'Units\unit_PrimitiveOptimizerTool.pas',
  unit_PolygonConvexionaterTool in 'Units\unit_PolygonConvexionaterTool.pas',
  unit_PrimitiveAlignerTool in 'Units\unit_PrimitiveAlignerTool.pas',
  unit_PolygonInsetterTool in 'Units\unit_PolygonInsetterTool.pas',
  unit_PolygonScalerTool in 'Units\unit_PolygonScalerTool.pas',
  unit_PolygonExtractorTool in 'Units\unit_PolygonExtractorTool.pas',
  unit_PolygonRemoverTool in 'Units\unit_PolygonRemoverTool.pas',
  unit_PolygonAlongEdgeScalerTool in 'Units\unit_PolygonAlongEdgeScalerTool.pas',
  unit_PrimitiveLatherTool in 'Units\unit_PrimitiveLatherTool.pas',
  unit_PrimitiveHiderTool in 'Units\unit_PrimitiveHiderTool.pas',
  unit_PrimitiveFreezerTool in 'Units\unit_PrimitiveFreezerTool.pas',
  unit_PrimitiveMirroringTool in 'Units\unit_PrimitiveMirroringTool.pas',
  unit_VertexScalerTool in 'Units\unit_VertexScalerTool.pas',
  unit_VertexRotatorTool in 'Units\unit_VertexRotatorTool.pas',
  unit_UVSelector in 'Units\unit_UVSelector.pas',
  unit_FaceMapperTool in 'Units\unit_FaceMapperTool.pas',
  unit_FaceFlipperTool in 'Units\unit_FaceFlipperTool.pas',
  unit_FaceRotatorTool in 'Units\unit_FaceRotatorTool.pas',
  unit_FaceScalerTool in 'Units\unit_FaceScalerTool.pas',
  unit_FaceMoverTool in 'Units\unit_FaceMoverTool.pas',
  unit_FaceAveragerTool in 'Units\unit_FaceAveragerTool.pas',
  unit_FaceMaterialSetterTool in 'Units\unit_FaceMaterialSetterTool.pas',
  unit_FaceMaterialReplacerTool in 'Units\unit_FaceMaterialReplacerTool.pas',
  unit_ToolFactory in 'Units\unit_ToolFactory.pas',
  unit_UndoRedoManager in 'Units\unit_UndoRedoManager.pas',
  unit_ToolStack in 'Units\unit_ToolStack.pas',
  unit_ToolExecuter in 'Units\unit_ToolExecuter.pas',
  unit_PrimitiveSmoother in 'Units\unit_PrimitiveSmoother.pas',
  unit_PrimitiveCubeCreationTool in 'Units\unit_PrimitiveCubeCreationTool.pas',
  unit_JointCreatorTool in 'Units\unit_JointCreatorTool.pas',
  unit_PrimitiveGridCreationTool in 'Units\unit_PrimitiveGridCreationTool.pas',
  unit_PrimitiveRectangleCreationTool in 'Units\unit_PrimitiveRectangleCreationTool.pas',
  unit_PrimitivePyramidCreationTool in 'Units\unit_PrimitivePyramidCreationTool.pas',
  unit_PrimitiveEllipseCreationTool in 'Units\unit_PrimitiveEllipseCreationTool.pas',
  unit_PrimitiveCylinderCreationTool in 'Units\unit_PrimitiveCylinderCreationTool.pas',
  unit_PrimitiveSphereCreationTool in 'Units\unit_PrimitiveSphereCreationTool.pas',
  unit_PrimitiveTorusCreationTool in 'Units\unit_PrimitiveTorusCreationTool.pas',
  unit_PrimitiveTextCreationTool in 'Units\unit_PrimitiveTextCreationTool.pas',
  unit_PrimitivePolylineCreationTool in 'Units\unit_PrimitivePolylineCreationTool.pas',
  unit_CSGTool in 'Units\unit_CSGTool.pas',
  unit_CSGSubtractorTool in 'Units\unit_CSGSubtractorTool.pas',
  unit_CSGUnitorTool in 'Units\unit_CSGUnitorTool.pas',
  unit_CSGIntersectorTool in 'Units\unit_CSGIntersectorTool.pas',
  unit_CSGSplitterTool in 'Units\unit_CSGSplitterTool.pas',
  unit_AnimationFrameClipboard in 'Units\unit_AnimationFrameClipboard.pas',
  unit_SkeletonClonerTool in 'Units\unit_SkeletonClonerTool.pas',
  unit_SkeletonClipBoard in 'Units\unit_SkeletonClipBoard.pas',
  unit_PrimitivePrefabImporterTool in 'Units\unit_PrimitivePrefabImporterTool.pas',
  unit_PrimitiveLightCreatorTool in 'Units\unit_PrimitiveLightCreatorTool.pas',
  unit_SkeletonUndoItem in 'Units\unit_SkeletonUndoItem.pas',
  unit_PolygonConnectorTool in 'Units\unit_PolygonConnectorTool.pas',
  unit_JointFlipperTool in 'Units\unit_JointFlipperTool.pas',
  unit_JointSplitterTool in 'Units\unit_JointSplitterTool.pas',
  unit_PrimitivePathCreationTool in 'Units\unit_PrimitivePathCreationTool.pas',
  unit_NoiseTool in 'Units\unit_NoiseTool.pas',
  unit_Interpolation in 'Units\unit_Interpolation.pas',
  unit_Paths in 'Units\unit_Paths.pas',
  unit_Vectors in 'Units\unit_Vectors.pas',
  unit_PathList in 'Units\unit_PathList.pas',
  unit_PathControlPointList in 'Units\unit_PathControlPointList.pas',
  unit_PathSelector in 'Units\unit_PathSelector.pas',
  unit_PathControlPointSelector in 'Units\unit_PathControlPointSelector.pas',
  unit_BasePathTool in 'Units\unit_BasePathTool.pas',
  unit_PathCreatorTool in 'Units\unit_PathCreatorTool.pas',
  unit_PathRenderer in 'Units\unit_PathRenderer.pas',
  unit_PathCreationRoutines in 'Units\unit_PathCreationRoutines.pas';

procedure ValidateOpenGL;
var validationForm: TfrmOGLValidation;
    isOK: boolean;
begin
    validationForm := TfrmOGLValidation.Create( nil );
    try
        isOK := validationForm.Validate;

    finally
        FreeAndNil( validationForm );
    end;

    if not isOK then
        halt( 1 );
end;

{$R *.res}

begin
    // Delphi 6 RTL leaks... grrrrr.
    {$IFDEF VER140}
    RegisterExpectedMemoryLeak(36, 1); // TWinHelpViewer x 1
    RegisterExpectedMemoryLeak(20, 3); // TObjectList x 3
    RegisterExpectedMemoryLeak(52, 1); // THelpManager x 1
    {$ENDIF}

    Application.Initialize;
    // INFO, PJ: This should be the very first thing we do. Any other action might
    // cause visual refreshes, and those need the OpenGL methods to be bound.
    InitOpenGL;
    ValidateOpenGL;

    Randomize;
    ShowSplashScreen;
    SetSplashScreenStatus( 'Initializing...' );

    Application.CreateForm(TfrmMain, frmMain);
    Application.Title := 'DeleD 3D Editor';
    DecimalSeparator := '.';
    Application.UpdateFormatSettings := false;
    handle_main := frmMain.Handle;
    if not FileExistsUTF8(dir_texture+'default.dml') then begin
      messagedlg('Texture directory and/or default.dml not found!'+#13#13
        +'You should alter or remove these values in INI file.',mtError,[mbOK],0);
        exit;
    end;
    Application.Run;
end.
